Package: biogeom
Type: Package
Title: Biological Geometries
Version: 1.5.1
Date: 2026-04-16
Authors@R: c(person(given="Peijian", family="Shi", email="pjshi@njfu.edu.cn", role=c("aut", "cre")),
        person(given=c("Johan"), family="Gielis", email="johan.gielis@uantwerpen.be", role=c("aut")),
        person(given=c("Brady K."), family="Quinn", email="brady.quinn@dfo-mpo.gc.ca", role=c("aut")))
Author: Peijian Shi [aut, cre],
  Johan Gielis [aut],
  Brady K. Quinn [aut]
Maintainer: Peijian Shi <pjshi@njfu.edu.cn>
Imports: bmp (>= 0.3), spatstat.geom (>= 2.4-0)
Description: Is used to simulate and fit biological geometries. 'biogeom' incorporates several novel universal parametric equations that can generate the profiles of bird eggs, flowers, linear and lanceolate leaves, seeds, starfish, and tree-rings (Gielis (2003) <doi:10.3732/ajb.90.3.333>; Shi et al. (2020) <doi:10.3390/sym12040645>), three growth-rate curves representing the ontogenetic growth trajectories of animals and plants against time, and the axially symmetrical and integral forms of all these functions (Shi et al. (2017) <doi:10.1016/j.ecolmodel.2017.01.012>; Shi et al. (2021) <doi:10.3390/sym13081524>). The optimization method proposed by Nelder and Mead (1965) <doi:10.1093/comjnl/7.4.308> was used to estimate model parameters. 'biogeom' includes several real data sets of the boundary coordinates of natural shapes, including avian eggs, fruit, lanceolate and ovate leaves, tree rings, seeds, and sea stars,and can be potentially applied to other natural shapes. 'biogeom' can quantify the conspecific or interspecific similarity of natural outlines, and provides information with important ecological and evolutionary implications for the growth and form of living organisms. Please see Shi et al. (2022) <doi:10.1111/nyas.14862> for details.
Depends: R (>= 4.3.0)
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-04-16 06:45:35 UTC; PEIJIAN SHI
Repository: CRAN
Date/Publication: 2026-04-16 07:42:04 UTC
Built: R 4.6.0; ; 2026-04-26 02:53:01 UTC; unix

Package: biogeom
Type: Package
Title: Biological Geometries
Version: 1.5.2
Date: 2026-07-11
Authors@R: c(person(given="Peijian", family="Shi", email="pjshi@njfu.edu.cn", role=c("aut", "cre")),
        person(given=c("Johan"), family="Gielis", email="johan.gielis@uantwerpen.be", role=c("aut")),
        person(given=c("Brady K."), family="Quinn", email="brady.quinn@dfo-mpo.gc.ca", role=c("aut")))
Author: Peijian Shi [aut, cre],
  Johan Gielis [aut],
  Brady K. Quinn [aut]
Maintainer: Peijian Shi <pjshi@njfu.edu.cn>
Imports: bmp (>= 0.3), spatstat.geom (>= 2.4-0)
Description: Is used to simulate and fit biological geometries. 'biogeom' incorporates several novel universal parametric equations that can generate the profiles of bird eggs, flowers, linear and lanceolate leaves, seeds, starfish, and tree-rings (Gielis (2003) <doi:10.3732/ajb.90.3.333>; Shi et al. (2020) <doi:10.3390/sym12040645>), three growth-rate curves representing the ontogenetic growth trajectories of animals and plants against time, and the axially symmetrical and integral forms of all these functions (Shi et al. (2017) <doi:10.1016/j.ecolmodel.2017.01.012>; Shi et al. (2021) <doi:10.3390/sym13081524>). The optimization method proposed by Nelder and Mead (1965) <doi:10.1093/comjnl/7.4.308> was used to estimate model parameters. 'biogeom' includes several real data sets of the boundary coordinates of natural shapes, including avian eggs, fruit, lanceolate and ovate leaves, tree rings, seeds, and sea stars,and can be potentially applied to other natural shapes. 'biogeom' can quantify the conspecific or interspecific similarity of natural outlines, and provides information with important ecological and evolutionary implications for the growth and form of living organisms. Please see Shi et al. (2022) <doi:10.1111/nyas.14862> for details.
Depends: R (>= 4.3.0)
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-07-11 12:54:26 UTC; PEIJIAN SHI
Repository: CRAN
Date/Publication: 2026-07-11 13:20:02 UTC
Built: R 4.5.2; ; 2026-07-11 14:06:51 UTC; unix

exportPattern("^[[:alpha:]]+")
importFrom("bmp", "read.bmp")
importFrom("spatstat.geom", "area", "area.owin", "as.polygonal", "im", "inside.owin", "intersect.owin", "is.empty", "owin", "quadratcount", "setminus.owin", "pairdist", "perimeter", "plot.ppp", "ppp", "transmat", "union.owin")
importFrom("grDevices", "dev.new", "graphics.off")
importFrom("graphics", "abline", "axis", "layout", "lines", "locator", "mtext", "par", "plot", "points", "polygon", "text", "title")
importFrom("stats", "confint", "integrate", "lm", "median", "na.omit", "optim", "quantile", "sd", "wilcox.test")

fitsigmoid <- function(expr, x, y, ini.val, simpver = 1, 
                control = list(), par.list = FALSE, fig.opt = FALSE,
                xlim = NULL, ylim = NULL, xlab = NULL, ylab = NULL,         
                main = NULL, subdivisions = 100L,
                rel.tol=.Machine$double.eps^0.25, 
                abs.tol = rel.tol, stop.on.error = TRUE, 
                keep.xy = FALSE, aux = NULL){

    if(length(x)!=length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[,1]
    y   <- Tem[,2]  

    if(!is.null(simpver) & !identical(expr, MPerformanceE)){
       if( !(simpver %in% seq(1, 3, by=1)) )
       stop("'simpver' should be chosen in versions 1 to 3!")    
    }

    if(!is.null(simpver) & identical(expr, MPerformanceE)){
       if( !(simpver %in% seq(1, 5, by=1)) )
       stop("'simpver' should be chosen in versions 1 to 5!")    
    }

    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))
  
    if( !identical(expr, MBriereE) & !identical(expr, MPerformanceE) ){ 
      obj.fun <- function(P){  
        if(is.null(simpver)){
          Lower <- P[3]
          Upper <- P[4]
          if(Lower >= Upper | P[1] <= 0 | P[2] <= Lower | P[2] >= Upper | P[5] <= 0)
            temp <- Inf
          if(Upper > Lower & P[1] > 0 & P[2] > Lower & P[2] < Upper & P[5] > 0){
            y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
            temp <- sum((y.theo-y)^2) 
          }
        }
        if(!is.null(simpver)){
          if(simpver==1){
            Lower <- 0
            Upper <- P[3]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= Lower | P[2] >= Upper| P[4] <= 0)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > Lower & P[2] < Upper & P[4] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
          if(simpver==2){
            Lower <- P[3]
            Upper <- P[4]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= Lower | P[2] >= Upper)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > Lower & P[2] < Upper){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
          if(simpver==3){
            Lower <- 0
            Upper <- P[3]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= Lower | P[2] >= Upper)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > Lower & P[2] < Upper){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
        }
        return(temp) 
      }
    }

    if( identical(expr, MBriereE) ){
      obj.fun <- function(P){  
        if(is.null(simpver)){
          Lower <- P[3]
          Upper <- P[4]
          if(Lower >= Upper | Upper <= 0 | P[1] <= 0 | P[2] <= 0 | P[5] <= 0)
              temp <- Inf
          if(Upper > Lower & Upper > 0 & P[1] > 0 & P[2] > 0 & P[5] > 0){
            y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
            temp <- sum((y.theo-y)^2) 
          }
        }
        if(!is.null(simpver)){
          if(simpver==1){     
            Lower <- 0
            Upper <- P[3]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= 0 | P[4] <= 0)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > 0 & P[4] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux)             
              temp <- sum((y.theo-y)^2)
            }
          }
          if(simpver==2){
            Lower <- P[3]
            Upper <- P[4]
            if(Lower >= Upper | Upper <= 0 | P[1] <= 0 | P[2] <= 0)
                temp <- Inf
            if(Upper > Lower & Upper > 0 & P[1] > 0 & P[2] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
          if(simpver==3){
            Lower <- 0
            Upper <- P[3]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= 0)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
        }
        return(temp) 
      }
    }






    if( identical(expr, MPerformanceE) ){
      obj.fun <- function(P){  
        if(is.null(simpver)){
          Lower <- P[4]
          Upper <- P[5]
          if(Lower >= Upper | Upper <= 0 | P[1] <= 0 | P[2] <= 0 | P[3] <= 0 | P[6] <= 0 | P[7] <= 0)
              temp <- Inf
          if(Upper > Lower & Upper > 0 & P[1] > 0 & P[2] > 0 & P[3] > 0 & P[6] > 0 & P[7] > 0){
            y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
            temp <- sum((y.theo-y)^2) 
          }
        }
        if(!is.null(simpver)){
          if(simpver==1){     
            Lower <- 0
            Upper <- P[4]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= 0 | P[3] <= 0 | P[5] <= 0 | P[6] <= 0)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > 0 & P[3] > 0 & P[5] > 0 & P[6] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux)             
              temp <- sum((y.theo-y)^2)
            }
          }
          if(simpver==2){
            Lower <- P[4]
            Upper <- P[5]
            if(Lower >= Upper | Upper <= 0 | P[1] <= 0 | P[2] <= 0 | P[3] <= 0)
                temp <- Inf
            if(Upper > Lower & Upper > 0 & P[1] > 0 & P[2] > 0 & P[3] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }
          if(simpver==3){
            Lower <- 0
            Upper <- P[4]
            if(Lower >= Upper | P[1] <= 0 | P[2] <= 0 | P[3] <= 0)
                temp <- Inf
            if(Upper > Lower & P[1] > 0 & P[2] > 0 & P[3] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux) 
              temp <- sum((y.theo-y)^2) 
            }
          }

          if(simpver==4){     
            Lower <- 0
            Upper <- sqrt(2)
            if(P[1] <= 0 | P[2] <= 0 | P[3] <= 0 | P[4] <= 0 | P[5] <= 0)
                temp <- Inf
            if(P[1] > 0 & P[2] > 0 & P[3] > 0 & P[4] > 0 & P[5] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux)             
              temp <- sum((y.theo-y)^2)
            }
          }

          if(simpver==5){     
            Lower <- 0
            Upper <- sqrt(2)
            if(P[1] <= 0 | P[2] <= 0 | P[3] <= 0)
                temp <- Inf
            if(P[1] > 0 & P[2] > 0 & P[3] > 0){
              y.theo <- sigmoid(expr, P, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, 
                abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux)             
              temp <- sum((y.theo-y)^2)
            }
          }

        }
        return(temp) 
      }
    }












    for (i in 1:nrow(ini.val)) {
        res <- optim(ini.val[i, ], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")
    ind  <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    MAT  <- mat
    par  <- as.vector(mat[ind, 1:p])
    PAR  <- par






    y.theo <- sigmoid(expr, P=PAR, x, simpver=simpver,                
                subdivisions = subdivisions,
                rel.tol = rel.tol, abs.tol = abs.tol,
                stop.on.error = stop.on.error, 
                keep.xy = keep.xy, aux = aux)
    RSS     <- sum( (y - y.theo)^2 )
    r.sq    <- 1-sum((y-y.theo)^2)/sum((y-mean(y))^2)


    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){  
        xinterv <- (max(x)[1]-min(x)[1])/10 
        xval    <- seq(min(x)[1]-xinterv, max(x)[1]+xinterv, len=2000)
        yval    <- sigmoid(expr, P=PAR, xval, simpver=simpver,                
                     subdivisions = subdivisions,
                     rel.tol = rel.tol, abs.tol = abs.tol,
                     stop.on.error = stop.on.error, 
                     keep.xy = keep.xy, aux = aux)
        if(is.null(xlim)){
          xlim     <- c(min(x)[1]-xinterv, max(x)[1]+xinterv)
        }

        if(!is.null(xlim)){
          if(length(xlim)!=2) stop("'xlim' should have two elements!")         
          xval    <- seq(xlim[1], xlim[2], len=2000)
          yval    <- sigmoid(expr, P=PAR, xval, simpver=simpver,                
                     subdivisions = subdivisions,
                     rel.tol = rel.tol, abs.tol = abs.tol,
                     stop.on.error = stop.on.error, 
                     keep.xy = keep.xy, aux = aux)
          xlim <- xlim
        }
        if(!is.null(ylim)){
          if(length(ylim)!=2) stop("'ylim' should have two elements!")
          ylim <- ylim
        }

        x_ran  <- c(x, xval)
        y_ran  <- c(y, yval) 

        if(is.null(xlab))
          xlab <- expression(italic(x)) 
        if(is.null(ylab))
          ylab <- expression(italic(y))      
      
        dev.new()
        plot( x_ran, y_ran, xlab=xlab, ylab=ylab, type="n", 
              xlim=xlim, ylim=ylim, cex.lab=1.5, cex.axis=1.5 )
        lines(xval, yval, type="l", asp=1, col=2, lwd=2)
        points( x, y, cex=1.5, col="grey40" )
        title(main=main, cex.main=1.5, col.main=4, font.main=1)
    } 

    para.tab <- data.frame( Parameter = c(Names, 
                    "r.sq", "RSS", "sample.size"), 
                    Estimate = c(par, r.sq, RSS, length(x)) )

    if(par.list == "T" | par.list == "TRUE" | par.list == "True" ){
        print(para.tab)
        cat("\n")
    }
    return(list( par=PAR, r.sq=r.sq, RSS=RSS, sample.size=length(x),
                 x=x, y=y, y.pred=y.theo ) )
}

PE <- function(P, zeta, simpver = NULL){

  p <- length(P)
 
  if(is.null(simpver)){
    if(p != 5) 
      stop("The number of parameters is incorrect!")
    a        <- P[1]
    b        <- P[2]
    c1       <- P[3]
    c2       <- P[4]
    c3       <- P[5]
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 3, by=1)) )
      stop("'simpver' should be chosen in versions 1 to 3!")
  
    if(simpver==1){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- P[4]
        c3       <- 0
    }

    if(simpver==2){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- 0
        c3       <- 0
    }

    if(simpver==3){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- 0
        c2       <- P[3]
        c3       <- 0
    }
  }

  x <- b*cos(zeta)*(1+c1*sin(zeta)+c2*(sin(zeta))^2+c3*(sin(zeta))^3)
  y <- a*sin(zeta)
  r <- sqrt(x^2 + y^2)
  list( x=x, y=y, r=r )
}

MPerformanceE <- function(P, x, simpver = 1){

  p <- length(P)

  if(is.null(simpver)){
    if(p != 7) 
    stop("The length of 'P' shoud equal 7 for the modified version!")
    c    <- P[1]
    K1   <- P[2]
    K2   <- P[3]
    xmin <- P[4]
    xmax <- P[5]
    a    <- P[6]
    b    <- P[7] 
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 5, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 5!")  
  
    if(simpver==1){
      if(p != 6) 
      stop("The length of 'P' shoud equal 6 for the simplified version 1!")
      c    <- P[1]
      K1   <- P[2]
      K2   <- P[3]
      xmin <- 0
      xmax <- P[4]
      a    <- P[5]
      b    <- P[6] 
    }

   if(simpver==2){
      if(p != 5) 
      stop("The length of 'P' shoud equal 5 for the simplified version 2!")
      c    <- P[1]
      K1   <- P[2]
      K2   <- P[3]
      xmin <- P[4]
      xmax <- P[5]
      a    <- 1
      b    <- 1 
    }

    if(simpver==3){
      if(p != 4) 
      stop("The length of 'P' shoud equal 4 for the simplified version 3!")
      c    <- P[1]
      K1   <- P[2]
      K2   <- P[3]
      xmin <- 0
      xmax <- P[4]
      a    <- 1
      b    <- 1 
    }

    if(simpver==4){
      if(p != 5) 
      stop("The length of 'P' shoud equal 5 for the simplified version 4!")
      c    <- P[1]
      K1   <- P[2]
      K2   <- P[3]
      xmin <- 0
      xmax <- sqrt(2)
      a    <- P[4]
      b    <- P[5] 
    }

    if(simpver==5){
      if(p != 3) 
      stop("The length of 'P' shoud equal 3 for the simplified version 5!")
      c    <- P[1]
      K1   <- P[2]
      K2   <- P[3]
      xmin <- 0
      xmax <- sqrt(2)
      a    <- 1
      b    <- 1 
    }

  }

  fun0 <- function(y){
      y[y < xmin] <- xmin
      y[y > xmax] <- xmax
      return(y)
  }

  z <- fun0(x)

  temp1 <- c*( 1 - exp(-K1*(z-xmin)) )^a*( 1 - exp(K2*(z-xmax)) )^b 
  return(temp1)
}

adjdata <- function(x, y, ub.np = 2000, times = 1.2, 
               len.pro = 1/20, index.sp = 1){

  if(length(x)!=length(y)) 
    stop("The length of 'x' should equal that of 'y'!") 
  if(times < 1) 
    stop("The value of 'times' should be greater than 1!")
  if(len.pro > 1 | len.pro <= 0)
    stop("The value of 'len.pro' should range 0 to 1!")
  if( !(index.sp %in% 1:length(x)) )
    stop("'index.sp' should be an integer from 1 to length(x)!")

  start.mat  <- cbind(x,y)
  start.mat  <- na.omit(start.mat)
  x          <- start.mat[,1]
  y          <- start.mat[,2]

  ##### index.sp: the specified index of the starting point ####
  if(index.sp > 1){
    inde <- c(index.sp:length(x), 1:(index.sp-1))
    x    <- x[inde]
    y    <- y[inde]    
  }
  ##############################################################

  x.max  <- 2*max( abs(x) )[1]
  y.max  <- 2*max( abs(y) )[1]
  x      <- x + x.max
  y      <- y + y.max

  poly1  <- owin(xrange=c(min(x)[1], 
            max(x)[1]), yrange=c(min(y)[1],max(y)[1]))
  data0  <- ppp(x, y, window= poly1) 
  x      <- data0$x
  y      <- data0$y

  ini.np     <- ub.np*times
  if(length(x) > ini.np){
      ind   <- floor(as.numeric(quantile(1:length(x), 
                   probs=seq(0, 1, len=ini.np))))
      x     <- x[ind]
      y     <- y[ind]
      data0 <- ppp(x, y, window=poly1)   
  }

  dis.mat    <- pairdist(data0)
  len.max    <- max(dis.mat)[1]
  diag(dis.mat) <- NA 
  adj.mat    <- matrix(NA, nrow=data0$n, ncol=2)
  data1      <- cbind(x=data0$x, y=data0$y)
  dis.pool   <- c()
  for(i in 1:data0$n){
    if(i == 1){
      temp <- dis.mat[i, ]
      inde <- 1
    }
    old.inde     <- inde
    temp         <- dis.mat[inde, ]  
    if(length(temp[!is.na(temp)] ) > 0){ 
      inde <- which(temp == min(temp[!is.na(temp)]))[1]
      adj.mat[i, ] <- c( data1[old.inde, 1], data1[old.inde, 2] )
      dis.mat[old.inde, ] <- NA
      dis.mat[ ,old.inde] <- NA

      temp.dis <- min(temp[!is.na(temp)])[1]
      if(temp.dis > len.pro*len.max){
        adj.mat[i, ]    <- adj.mat[i-1, ]
        dis.mat[inde, ] <- NA
        dis.mat[, inde] <- NA
        inde            <- old.inde
      } 
    }
    if(length(temp[!is.na(temp)] ) == 0){ 
      adj.mat[i, ] <- c( data1[old.inde, 1], data1[old.inde, 2] )
      dis.mat[old.inde, ] <- NA
      dis.mat[ ,old.inde] <- NA
    }

  }
  adj.mat   <- unique(adj.mat)
  x         <- adj.mat[,1]
  y         <- adj.mat[,2] 
  poly.temp <- NULL
  try(poly.temp <- as.polygonal( owin(poly=list(x=x, 
                       y=y )) ), silent=TRUE)
  if( is.null(poly.temp) ){   
    x       <- x[length(x):1]
    y       <- y[length(y):1]
    poly0   <- as.polygonal( owin(poly=list(x=x, y=y )) )
  }
  if( !is.null(poly.temp) ){
    poly0   <- as.polygonal( owin(poly=list(x=x, y=y )) )
  }

  if(length(x) > ub.np){
      ind   <- floor(as.numeric(quantile(1:length(x), 
                   probs=seq(0, 1, len=ub.np))))
      x     <- x[ind]
      y     <- y[ind]
  }

  list(x=x-x.max, y=y-y.max)
}

sigmoid <- function(expr, P, x, simpver = 1, subdivisions = 100L,
                    rel.tol = .Machine$double.eps^0.25, 
                    abs.tol = rel.tol, stop.on.error = TRUE, 
                    keep.xy = FALSE, aux = NULL){

   rate.fun <- function(x){
     expr(P, x=x, simpver=simpver)
   }

   if(is.null(simpver) & !identical(expr, MPerformanceE)){
     Lower <- P[3]
     Upper <- P[4]
   }

   if(is.null(simpver) & identical(expr, MPerformanceE)){
     Lower <- P[4]
     Upper <- P[5]
   }

   if(!is.null(simpver) & !identical(expr, MPerformanceE)){

    if( !(simpver %in% seq(1, 3, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 3!")  
  
    if(simpver==1 | simpver==3){
      Lower <- 0
      Upper <- P[3]
    }
    if(simpver==2){
      Lower <- P[3]
      Upper <- P[4]
    }
   }

   if(!is.null(simpver) & identical(expr, MPerformanceE)){

    if( !(simpver %in% seq(1, 5, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 5!")  
  
    if(simpver==1 | simpver==3){
      Lower <- 0
      Upper <- P[4]
    }
    if(simpver==2){
      Lower <- P[4]
      Upper <- P[5]
    }
    if(simpver==4 | simpver==5){
      Lower <- 0
      Upper <- sqrt(2)
    }
   }

   yval <- c()
   for(i in 1:length(x)){
     if(x[i] < Lower) x[i] <- Lower
     if(x[i] > Upper) x[i] <- Upper
     temp <- integrate(rate.fun, lower=Lower, upper=x[i], 
               subdivisions = subdivisions,
               rel.tol = rel.tol, 
               abs.tol = abs.tol,
               stop.on.error = stop.on.error, 
               keep.xy = keep.xy, aux = aux)
     yval <- c(yval, temp$value)  
   }
  
   return( yval )

}

EPE <- function(P, x, simpver = NULL){

  if(P[1] < 0 | P[2] < 0)
    stop("a and b should be positive real numbers!")
  if(!is.numeric(x))
    stop("'x' should be a numerical value or a numerical vector!")
  x[x < -P[1]] <- -P[1]
  x[x >  P[1]] <- P[1]
  p <- length(P) 

  if(is.null(simpver)){
    if(p != 5) 
      stop("The number of parameters is incorrect!")
    a        <- P[1]
    b        <- P[2]
    c1       <- P[3]
    c2       <- P[4]
    c3       <- P[5]
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 3, by=1)) )
      stop("'simpver' should be chosen in versions 1 to 3!")
  
    if(simpver==1){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- P[4]
        c3       <- 0
    }

    if(simpver==2){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- 0
        c3       <- 0
    }

    if(simpver==3){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- 0
        c2       <- P[3]
        c3       <- 0
    }
  }

  d0 <- b/a
  d1 <- c1*(b/a)
  d2 <- c2*(b/a)
  d3 <- c3*(b/a)
  1/a^3*sqrt(a^2-x^2)*(a^3*d0 + a^2*d1*x + a*d2*x^2 + d3*x^3)

}

bilat <- function(x, y, strip.num = 200, peri.np = NULL, n.loop = 60,
           auto.search = TRUE, animation.fig = TRUE, time.interval = 0.001,  
           unit = "cm", main = NULL, diff.fig = TRUE,
           angle = NULL, ratiox = 0.02, ratioy = 0.08, 
           fd.opt = TRUE, frac.fig = TRUE,
           denomi.range = seq(8, 30, by = 1)){

  if( !is.null(angle) & !is.numeric(angle) ) 
      stop("'angle' should be a numerical value if it is not null.")

  if(length(x)!=length(y)) 
      stop("'x' should have the same data length as 'y'!")

  Tem <- cbind(x, y)
  Tem <- na.omit(Tem)
  x   <- Tem[,1]
  y   <- Tem[,2]  

  if(strip.num / floor(strip.num) != 1 | strip.num <= 0){
    stop("'strip.num' must be a positive integer")
  }

  if(is.null(peri.np)){
    poly0 <- as.polygonal( owin(poly=list(x=x, y=y)) )
    perimeter0 <- perimeter(poly0)
  }

  if(!is.null(peri.np)){
    if(!is.numeric(peri.np)){
      stop("'peri.np' must be a poitive integer!")
    }
    if(is.numeric(peri.np) & peri.np <= 0){
      stop("'peri.np' must be a poitive integer!")
    }
    my.num <- length(x)
    if( length(x) > peri.np ) my.num <- peri.np 
  
    my.peri <- c()  
    my.ind  <- sort( sample(1:length(x), n.loop, replace=FALSE) )
    for(i in 1:n.loop){
      if(my.ind[i] == 1){
         x1  <- x[1:length(x)]
         y1  <- y[1:length(x)]
         ind <- floor(as.numeric(quantile(1:length(x1), 
                      probs=seq(0, 1, len=my.num))))
         x2  <- x1[ind]
         y2  <- y1[ind]             
      }
      if(my.ind[i] > 1){
        inde <- c(my.ind[i]:length(x), 1:(my.ind[i]-1))
        x1   <- x[inde]
        y1   <- y[inde]  
        ind  <- floor(as.numeric(quantile(1:length(x1), 
                      probs=seq(0, 1, len=my.num))))
        x2   <- x1[ind]
        y2   <- y1[ind]    
      }
      my.poly <- as.polygonal( owin(poly=list(x=x2, y=y2)) )
      my.peri <- c(my.peri, perimeter(my.poly))  
    }
    perimeter0 <- mean(my.peri)   
  }

  poly1      <- owin(xrange=c(min(x)[1], max(x)[1]), 
                     yrange=c(min(y)[1],max(y)[1]))
  data0      <- ppp(x, y, window=poly1)
  x          <- data0$x
  y          <- data0$y
  n          <- length(x)
  mat        <- pairdist(data0) 
  xlabel <- bquote(paste(italic(x)," (", .(unit),")",sep="")) 
  ylabel <- bquote(paste(italic(y)," (", .(unit),")",sep=""))
  if(auto.search != "TRUE" & auto.search != "T"){
    dev.new()
    plot( x, y, asp=1, type="l", xlab=xlabel, ylab=ylabel, 
          cex.lab=1.5, cex.axis=1.5, lwd=3, col="grey50" )
    resu  <- locator(n = 2, type="o", col=2, cex=1.5)
    #### (x1, y1) represents the location of the leaf apex
    #### (x2, y2) represents the location of the leaf base
    x1    <- resu$x[1]
    x2    <- resu$x[2]
    y1    <- resu$y[1]
    y2    <- resu$y[2]
    if(x1 < x2 | y1 < y2){
stop("\n Leaf apex must be on the top right corner of leaf base! 
\n The angle from leaf apex to base should range 0 to pi/2!
\n The leaf apex should be chosen earlier than the leaf base!")
    }
  #### To find a point on the edge that has the shortest 
  ####   distance from a chosen point
  #### Two points on the edge will be found 
  ####   corresponding to the leaf apex and base
    dis.fun1 <- function(z){
      sqrt((z[1]-x1)^2 + (z[2]-y1)^2)    }
    pp       <- cbind(x,y)
    dis.val1 <- apply(pp, 1L, dis.fun1)
    ind1     <- which(dis.val1==min(dis.val1)[1])[1]
    x1       <- pp[ind1,1]
    y1       <- pp[ind1,2]
    dis.fun2 <- function(z){
      sqrt((z[1]-x2)^2 + (z[2]-y2)^2)
    }
    dis.val2 <- apply(pp, 1L, dis.fun2)
    ind2     <- which(dis.val2==min(dis.val2)[1])[1]
    x2       <- pp[ind2,1]
    y2       <- pp[ind2,2]

  ####################################################################
  }
  if(auto.search == "TRUE" | auto.search == "T"){
    # To find the points corresponding 
    #   to the leaf apex and leaf base
    qq <- cbind( which(mat == max(mat)[1], arr.ind=TRUE)[1,] )
    q  <- as.numeric( qq ) 
    x1 <- x[q[1]]
    y1 <- y[q[1]]
    x2 <- x[q[2]]
    y2 <- y[q[2]] 
  } 
  length0 <- sqrt((x1-x2)^2+(y1-y2)^2)
  length0 <- length0[[1]]
  x       <- x-x2
  y       <- y-y2
  x1      <- x1-x2
  y1      <- y1-y2
  x2      <- x2-x2
  y2      <- y2-y2
  z       <- sqrt( (y2-y1)^2 + (x2-x1)^2 )
  theta   <- acos( (x1-x2)/z ) %% (2*pi)
  x.new   <- x*cos(theta) + y*sin(theta)
  y.new   <- y*cos(theta) - x*sin(theta)
  x.max   <- max(x.new)[1]
  x.min   <- min(x.new)[1]
  y.max   <- max(y.new)[1]
  y.min   <- min(y.new)[1]
  upper.win  <- owin( c(x.min, x.max), c(0, y.max) )
  lower.win  <- owin( c(x.min, x.max), c(y.min, 0) )
  total.poly <- as.polygonal(owin(poly=list(x=x.new, y=y.new)))
  poly1      <- intersect.owin(upper.win, total.poly)
  poly2      <- intersect.owin(lower.win, total.poly) 
  n          <- nrow(data.frame(total.poly))
  n1         <- nrow(data.frame(poly1))
  n2         <- nrow(data.frame(poly2)) 
  upper.area <- area.owin(poly1)
  lower.area <- area.owin(poly2)
  area0      <- area.owin( union.owin(poly1, poly2) )
  y.max      <- max( c(abs(y.max), abs(y.min)) )[1] 
  x.pred     <- seq( x.min, x.max, len=(strip.num+1) )
  part.upper.area <- c()
  part.lower.area <- c()
  widt            <- c()
  xmean           <- c()
  for(j in 2:(strip.num+1)){
    x.temp <- c(x.pred[j-1], x.pred[j])
    um.win <- owin( x.temp, c(0, y.max) ) 
    lm.win <- owin( x.temp, c(-y.max, 0) )
    m.area <- area.owin(um.win)
    u.conv <- setminus.owin(um.win, poly1)
    u.area <- m.area - area.owin(u.conv)
    l.conv <- setminus.owin(lm.win, poly2)
    l.area <- m.area - area.owin(l.conv)
    part.upper.area <- c(part.upper.area, u.area)
    part.lower.area <- c(part.lower.area, l.area)
    h1 <- NULL
    h2 <- NULL
    h1 <- try(intersect.owin(um.win, poly1), silent=TRUE)
    h2 <- try(intersect.owin(lm.win, poly2), silent=TRUE)
    g1 <- class(h1)
    g2 <- class(h2)
    if( g1=="owin" & g2=="owin" ){
        temp.u <- max(h1$y)[1]
        temp.l <- min(h2$y)[1]
        if(is.empty(h1)) temp.u <- 0
        if(is.empty(h2)) temp.l <- 0 
        widt   <- c(widt, temp.u-temp.l)
        xmean  <- c( xmean, (x.pred[j-1] + x.pred[j])/2 )     
    }
  }
  D        <- part.upper.area - part.lower.area
  xmean    <- xmean[!is.na(widt)] # Former
  widt     <- widt[!is.na(widt)]  # Latter
  max.ind  <- which.max(widt)[1]
  width0   <- widt[max.ind]
  x.width  <- xmean[max.ind]
  x.1e     <- length0*1/8
  x.2e     <- length0*2/8
  x.4e     <- length0*4/8
  x.6e     <- length0*6/8
  x.7e     <- length0*7/8
  temp1    <- abs(x.1e-xmean)
  IND1     <- which.min(temp1)
  width.1e <- widt[IND1]
  temp2    <- abs(x.2e-xmean)
  IND2     <- which.min(temp2)
  width.2e <- widt[IND2]
  temp3    <- abs(x.4e-xmean)
  IND3     <- which.min(temp3)
  width.4e <- widt[IND3]
  temp4    <- abs(x.6e-xmean)
  IND4     <- which.min(temp4)
  width.6e <- widt[IND4]
  temp5    <- abs(x.7e-xmean)
  IND5     <- which.min(temp5)
  width.7e <- widt[IND5]
  bi.test  <- wilcox.test(part.upper.area, 
                part.lower.area, paired=TRUE)
  abs.D    <- abs(D)
  SI       <- sum(abs.D/(part.upper.area+
                part.lower.area))/strip.num
  AR       <- upper.area / lower.area
  Xlab     <- bquote(paste("Difference (",
                .(unit), ''^'2'*')', sep="")) 

  if(is.null(angle))  phi <- theta
  if(!is.null(angle)) phi <- angle

  if(animation.fig =="TRUE"|animation.fig==
          "T"|animation.fig == "True"){
    if(phi %% (2*pi) != 0){
      xx.new  <- x.new*cos(phi) - y.new*sin(phi)
      yy.new  <- y.new*cos(phi) + x.new*sin(phi)   
    }
    else{
      xx.new  <- x.new
      yy.new  <- y.new
    }
    dev.new()
    plot( xx.new, yy.new, type="n", 
          xlab=xlabel, ylab=ylabel, cex=0.1, pch=16,
          cex.lab=1.5, cex.axis=1.5, asp=1)
    title(main=main, cex.main=1.5, col.main=4, font.main=1)
    for(i in 1:length(xx.new)){
      Sys.sleep(time.interval)
      points(xx.new[i], yy.new[i], cex=0.1, col="grey70", pch=16)
    }
    polygon(xx.new, yy.new, col = "grey90", border = "grey70")
    abline(v=0, col=4, lwd=1, lty=2)
    abline(h=0, col=4, lwd=1, lty=2)
    if(phi %% (pi/2) != 0 ){
      abline(0, tan(phi), col=2, lwd=1, lty=2)
    }
    lines(xx.new, yy.new, lwd=1, col="grey70")
  }

  if(diff.fig =="TRUE" | diff.fig == "T" | diff.fig == "True"){
      dev.new()     
      colors <- ifelse(D >= 0, "blue", "red")
      plot( D, type="h", ylab=Xlab, xlab="Strip number", 
            cex.lab=1.5, cex.axis=1.5, lwd=1, col=colors )
      abline(h=0, col="black", lwd=1)
  }

  if(fd.opt=="TRUE"|fd.opt=="T"|fd.opt=="True"){
    poly0 <- as.polygonal( owin(poly=list(x=x, y=y)) )
    xj    <- x
    yj    <- y 
    # Calculating a fractal dimension of the polygon's perimeter
    x.dis <- range(x)[2]-range(x)[1]
    y.dis <- range(y)[2]-range(y)[1]
    L     <- max(x.dis, y.dis)[1]
    xt    <- xj - min(xj)[1] 
    yt    <- yj - min(yj)[1]
    #xt    <- xt + (z-max(xt)[1])/2
    #yt    <- yt + (z-max(yt)[1])/2
    Side     <- L/denomi.range
    k       <- 0
    delta   <- c()
    N       <- c()
    for(i in 1:length(Side)){
      k      <- k + 1
      ndiv   <- L/Side[i]
      W      <- owin(c(0, L), c(0, L))
      Index  <- inside.owin(xt, yt, W)
      xt2    <- xt[Index]
      yt2    <- yt[Index]     
      Z      <- ppp(xt2, yt2, window=W)
      Number <- array( quadratcount(Z, ndiv, ndiv) ) 
      N      <- c(N, length(Number[Number > 0]))
      delta  <- c(delta, Side[i])
    }
    log.x  <- -log(delta)
    log.y  <- log(N)
    resu   <- lm(log.y~log.x)    
    a      <- summary(resu)$coefficients[[1]]
    b      <- summary(resu)$coefficients[[2]]
    sd.a   <- summary(resu)$coefficients[[3]]
    sd.b   <- summary(resu)$coefficients[[4]]
    lci.a  <- confint( resu )[1,1]
    uci.a  <- confint( resu )[1,2]
    lci.b  <- confint( resu )[2,1]
    uci.b  <- confint( resu )[2,2]
    r.sq   <- summary(resu)$r.squared
    x0     <- log.x
    y0     <- log.y
    B  <- min(x0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=0.5)){
      if(B[1] < s + 0.5 & B[1] >= s) u <- s
    }
    B1 <- u
    B  <- max(x0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=0.5)){
      if(B[1] < s + 0.5 & B[1] >= s) u <- s + 0.5
    }
    B2 <- u
    C  <- min(y0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=1)){
      if(C[1] < s + 1 & C[1] >= s) u <- s
    }
    C1 <- u
    C  <- max(y0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=1)){
      if(C[1] < s + 1 & C[1] >= s) u <- s + 1
    }
    C2 <- u
    xlim0    <- c(B1, B2)
    ylim0    <- c(C1, C2) 
    if(B2-B1 < 2.0) xlim0 <- c(B2-2.0, B2)
    # if(C2-C1 < 4.0) ylim0 <- c(C2-4.0, C2)     
    if(C2-C1 < 2.5) ylim0 <- c(C2-2.5, C2)
    
    xloc   <- xlim0[1] + (xlim0[2]-xlim0[1])*ratiox
    yloc   <- ylim0[2] - (ylim0[2]-ylim0[1])*ratioy
    if( frac.fig =="TRUE" | frac.fig == "T" | frac.fig == "True"){
      dev.new()
      plot( log.x, log.y, cex.lab=1.5, cex.axis=1.5, 
            cex=1.5, xaxs="i", yaxs="i",
            xlim=xlim0, ylim=ylim0, las=1,
            xlab=expression(paste("ln ", 
            delta, {""}^{-"1"}, sep="")), 
            ylab=expression(paste("ln ", italic("N"), sep="")) )
      title(main=main, cex.main=1.5, col.main=4, font.main=1)
      abline( resu, col=2 )   
      text(xloc, yloc-0*(ylim0[2]-ylim0[1])/10, 
           bquote( paste(italic("y = "),  
           .(round(a, 3)), " + ", .(round(b, 3)), 
           italic("x"), seq="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-1*(ylim0[2]-ylim0[1])/10, 
           bquote(paste("CI: ", 
           .(round(confint( resu )[2,1], 3)), ", ", 
           .(round(confint( resu )[2,2], 3)),  
           sep="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-2*(ylim0[2]-ylim0[1])/10, 
        bquote( paste(italic(r), {""}^{"2"}, " = ", 
        .(round(summary(resu)$r.squared, 3)), sep="") ), 
        pos=4, cex=1.5, col=1)   
      text(xloc, yloc-3*(ylim0[2]-ylim0[1])/10, 
        bquote( paste(italic(n), , " = ", .(length(log.x)),
        sep="") ), pos=4, cex=1.5, col=1) 
    }
    te <- list( x=xx.new, y=yy.new, phi=phi, n1=n1, n2=n2, n=n, 
          total.poly=total.poly, upper.poly=poly1, 
          lower.poly=poly2, part.upper.area=part.upper.area,  
          part.lower.area=part.lower.area, D=D,   
          upper.area=upper.area, lower.area=lower.area, 
          SI=SI, AR=AR, scan.length=length0, 
          scan.width=width0, scan.area=area0, 
          scan.perimeter=perimeter0, x.width=x.width, width.1e=width.1e,
          width.2e=width.2e, width.4e=width.4e, width.6e=width.6e,
          width.7e=width.7e, bi.test=bi.test,
          a=a, sd.a=sd.a, lci.a=lci.a, uci.a=uci.a, b=b, sd.b=sd.b, 
          lci.b=lci.b, uci.b=uci.b, r.sq=r.sq, delta=delta, N=N  ) 
  }
  if(fd.opt != "TRUE" & fd.opt != "T" & fd.opt != "True"){
    te <- list( x=xx.new, y=yy.new, phi=phi, n1=n1, n2=n2, n=n, 
          total.poly=total.poly, upper.poly=poly1, 
          lower.poly=poly2, part.upper.area=part.upper.area,  
          part.lower.area=part.lower.area, D=D,   
          upper.area=upper.area, lower.area=lower.area, 
          SI=SI, AR=AR, scan.length=length0, 
          scan.width=width0, scan.area=area0, 
          scan.perimeter=perimeter0, x.width=x.width, width.1e=width.1e,
          width.2e=width.2e, width.4e=width.4e, width.6e=width.6e,
          width.7e=width.7e, bi.test=bi.test )
  }
  
  return( te )
}

fitLorenz <- function(expr, z, ini.val, simpver = 4, 
               method = "Nelder-Mead", control = list(),
               lower = -Inf, upper = Inf, 
               par.list = FALSE, fig.opt = FALSE, np = 2000, 
               xlab=NULL, ylab=NULL, main = NULL, subdivisions = 100L,
               rel.tol = .Machine$double.eps^0.25, 
               abs.tol = rel.tol, stop.on.error = TRUE, 
               keep.xy = FALSE, aux = NULL, par.limit = TRUE){


  if(!(par.limit %in% c("F", "False", "FALSE", "T", "True", "TRUE")))
    stop("'par.limit' only can be set to be FALSE or TRUE!")

  # The code for fitting the original Lorenz functions
  if(!identical(expr, MPerformanceE)){

    if(length(z) < 2) 
        stop("'z' should include 2 elements at least!")

    z   <- na.omit(z)
    z1  <- sort( z )
    x1  <- 1:length(z1)/length(z1)
    y1  <- cumsum(z1)/sum(z1)

    # Rotates the data and then shifts them to the right by a distance of sqrt(2) 
    theta <- -3/4*pi
    x     <- x1 * cos(theta) + y1 * sin(theta)
    y     <- y1 * cos(theta) - x1 * sin(theta)
    x     <- x+sqrt(2)

    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))

    if(par.limit == "T" | par.limit == "TRUE" | par.limit == "True"){
      if(identical(expr, SHE)){
        obj.fun <- function(P){
          if(P[1] < 0 | P[1] >= 1 | P[2] < 0 | P[2] > 1 | P[3] < 0 | P[3] > 1 | P[4] < 1)
              RSS <- Inf
          if(P[1] >= 0 & P[1] < 1 & P[2] >= 0 & P[2] <= 1 & P[3] >= 0 & P[3] <= 1 & P[4] >= 1){
            y1.theo <- expr(P, x1)
            theta   <- -3/4*pi
            x       <- x1 * cos(theta) + y1 * sin(theta)
            y.theo  <- y1.theo * cos(theta) - x1 * sin(theta)
            x       <- x+sqrt(2)
            y       <- y1 * cos(theta) - x1 * sin(theta)
            RSS     <- sum((y.theo-y)^2) 
          }
          return(RSS) 
        }
      }

      if(identical(expr, SCSE)){
        obj.fun <- function(P){
          if(P[1] < 0 | P[2] <= 0 | P[2] > 1 | P[3] < 1)
              RSS <- Inf
          if(P[1] >= 0 & P[2] > 0 & P[2] <= 1 & P[3] >= 1){
              y1.theo <- expr(P, x1)
              theta   <- -3/4*pi
              x       <- x1 * cos(theta) + y1 * sin(theta)
              y.theo  <- y1.theo * cos(theta) - x1 * sin(theta)
              x       <- x+sqrt(2)
              y       <- y1 * cos(theta) - x1 * sin(theta) 
              RSS     <- sum((y.theo-y)^2) 
          }
          return(RSS) 
        }
      }

      if(identical(expr, SarabiaE)){
        obj.fun <- function(P){
          if(P[1] < 0 | P[2]*P[4] + P[1] > 1 | P[2]*P[4] < 0 | P[3] < 0 | P[2] + 1 <= 0)
              RSS <- Inf
          if(P[1] >= 0 & P[2]*P[4] + P[1] <= 1 & P[2]*P[4] >= 0 & P[3] >= 0 & P[2] + 1 > 0){
            y1.theo <- expr(P, x1)
            theta   <- -3/4*pi
            x       <- x1 * cos(theta) + y1 * sin(theta)
            y.theo  <- y1.theo * cos(theta) - x1 * sin(theta)
            x       <- x+sqrt(2)
            y       <- y1 * cos(theta) - x1 * sin(theta) 
            RSS    <- sum((y.theo-y)^2) 
          }
          return(RSS) 
        }
      }
    }

    if(par.limit == "F" | par.limit == "FALSE" | par.limit == "False"){
      obj.fun <- function(P){
          y1.theo <- expr(P, x1)
          theta   <- -3/4*pi
          x       <- x1 * cos(theta) + y1 * sin(theta)
          y.theo  <- y1.theo * cos(theta) - x1 * sin(theta)
          x       <- x+sqrt(2)
          y       <- y1 * cos(theta) - x1 * sin(theta) 
          RSS     <- sum((y.theo-y)^2) 
      }
    }

    for (i in 1:nrow(ini.val)) {
      if(method=="Nelder-Mead"){
        res <- optim(ini.val[i, ], obj.fun, method=method, control = control)
      }
      if(method=="L-BFGS-B"){
        res <- optim(ini.val[i, ], obj.fun, method=method, 
                     lower=lower, upper=upper, control = control)
      }
      mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")

    ind    <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    par    <- as.vector(mat[ind, 1:p])

    x3      <- seq(0, 1, len=np)
    y3      <- expr(par, x3)
    yy2     <- expr(par, x1)
    theta   <- -3/4*pi
    x2      <- x3 * cos(theta) + y3 * sin(theta)   
    y2      <- y3 * cos(theta) - x3 * sin(theta)  
    x2      <- x2 + sqrt(2)                        
    y.theo  <- yy2 * cos(theta) - x1 * sin(theta)  

    RSS    <- sum((y.theo - y)^2)
    r.sq   <- 1-sum((y.theo - y)^2)/sum((y-mean(y))^2)

    goal.fun <- function(x){
      (x - expr(par, x))*2
    }  

    if(identical(expr, SHE)){
      GC <- 1-2*(1-par[1])/(par[4]+1)
    }

    if(identical(expr, SarabiaE)){
      GC <- par[1]*(1-2/(2+par[3])) + par[2]*(1-2/(2+par[4]))
    }

    if(!identical(expr, SHE) & !identical(expr, SarabiaE)){
      GC <- integrate(goal.fun, lower=0, upper=1, 
            subdivisions = subdivisions, 
            rel.tol = rel.tol, abs.tol = abs.tol, 
            stop.on.error = stop.on.error, keep.xy = keep.xy, 
            aux = aux)$value
    }

    if(is.null(xlab))
       xlab <- "Cumulative proportion of number"
    if(is.null(ylab))
       ylab <- "Cumulative proportion of size"

    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){
      ratiox <- 0.02
      ratioy <- 0.08
      xlim1  <- c(0, 1)
      ylim1  <- c(0, 1) 
      xloc   <- xlim1[1] + (xlim1[2]-xlim1[1])*ratiox
      yloc   <- ylim1[2] - (ylim1[2]-ylim1[1])*ratioy
      xlim2  <- c(0, 1.5)
      y2.candi <- as.numeric( na.omit(y2) )
      ymax <- max(c(y, y2.candi))[1]   
      A1   <- 10^seq(-6, 1, by=1)
      B1   <- A1*0.08
      B2   <- A1*0.12
      B3   <- A1*0.16
      B4   <- A1*0.20
      B5   <- A1*0.25
      B6   <- A1*0.40
      B7   <- A1*0.50
      B8   <- A1*0.70
      B9   <- A1*0.80   

      for(i in 1:length(A1)){
        if(ymax < B1[i])                { ylim2 <- c(0, B1[i]); break }
        if(ymax >= B1[i] & ymax < B2[i]){ ylim2 <- c(0, B2[i]); break }
        if(ymax >= B2[i] & ymax < B3[i]){ ylim2 <- c(0, B3[i]); break }
        if(ymax >= B3[i] & ymax < B4[i]){ ylim2 <- c(0, B4[i]); break }
        if(ymax >= B4[i] & ymax < B5[i]){ ylim2 <- c(0, B5[i]); break }
        if(ymax >= B5[i] & ymax < B6[i]){ ylim2 <- c(0, B6[i]); break }
        if(ymax >= B6[i] & ymax < B7[i]){ ylim2 <- c(0, B7[i]); break }
        if(ymax >= B7[i] & ymax < B8[i]){ ylim2 <- c(0, B8[i]); break }
        if(ymax >= B8[i] & ymax < B9[i]){ ylim2 <- c(0, B9[i]); break }
        if(ymax >= B9[i] & ymax < A1[i]){ ylim2 <- c(0, A1[i]*1.2); break }
      }  

      dev.new()
      layout( matrix(1:2, 1, 2, byrow=TRUE) )

      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )
      plot( x1, y1, main=main, cex.lab=1.5, cex.axis=1.5, 
            las=1, xaxs="i", yaxs="i", 
            xlab=xlab, ylab=ylab, 
            xlim=xlim1, ylim=ylim1, type="n" )
      polygon(x3, y3, col="grey70")
      points(x1, y1, cex=1.5, pch=16)
      lines(x3, y3, col=2) 
      lines(c(0, 1), c(0, 1), col=1)

      if(identical(expr, SHE)){
        if(par[1] >= 1e-9)
          text(xloc, yloc, bquote(paste(hat(delta), " = ", 
            .(sprintf("%.4f", round(par[1], 4))), sep="")), pos=4, cex=1.5, col=1)
        if(par[1] < 1e-9)
          text(xloc, yloc, bquote(paste(hat(delta), " = ", 
            .(sprintf("%.0f", round(par[1], 0))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-1.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(rho), " = ", 
           .(sprintf("%.4f", round(par[2], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-2.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(omega), " = ", 
          .(sprintf("%.4f", round(par[3], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(P)), " = ", 
             .(sprintf("%.4f", round(par[4], 4))), sep="")), pos=4, cex=1.5, col=1) 
        text(xloc, yloc-4.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
             .(sprintf("%.4f", round(r.sq, 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-5.0*(ylim1[2]-ylim1[1])/10, 
             bquote( paste(italic(n), " = ", 
             .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }

      if(identical(expr, SCSE)){
        if(par[1] >= 1e-9)
          text(xloc, yloc, bquote(paste(hat(gamma), " = ", 
            .(sprintf("%.4f", round(par[1], 4))), sep="")), pos=4, cex=1.5, col=1)
        if(par[1] < 1e-9)
          text(xloc, yloc, bquote(paste(hat(gamma), " = ", 
            .(sprintf("%.0f", round(par[1], 0))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-1.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(alpha), " = ", 
           .(sprintf("%.4f", round(par[2], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-2.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(beta), " = ", 
          .(sprintf("%.4f", round(par[3], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
             .(sprintf("%.4f", round(r.sq, 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-4.0*(ylim1[2]-ylim1[1])/10, 
             bquote( paste(italic(n), " = ", 
             .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }

      if(identical(expr, SarabiaE)){
        text(xloc, yloc-0.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(lambda), " = ", 
           .(sprintf("%.4f", round(par[1], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-1.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(eta), " = ", 
          .(sprintf("%.4f", round(par[2], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-2.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(a)), {""}[1], " = ", 
             .(sprintf("%.4f", round(par[3], 4))), sep="")), pos=4, cex=1.5, col=1) 
        if(abs(par[4]) >= 1e-9)
          text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(a)), {""}[2], " = ", 
            .(sprintf("%.4f", round(par[4], 4))), sep="")), pos=4, cex=1.5, col=1)
        if(abs(par[4]) < 1e-9)
          text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(a)), {""}[2], " = ",
            .(sprintf("%.0f", round(par[4], 0))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-4.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
             .(sprintf("%.4f", round(r.sq, 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-5.0*(ylim1[2]-ylim1[1])/10, 
             bquote( paste(italic(n), " = ", 
             .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }

      if(!identical(expr, SHE) & !identical(expr, SCSE) & !identical(expr, SarabiaE)){
        text(xloc, yloc-0.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
             .(sprintf("%.4f", round(r.sq, 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-1.0*(ylim1[2]-ylim1[1])/10, 
             bquote( paste(italic(n), " = ", 
             .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }
   
      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )

      plot(x, y, main=main, cex.lab=1.5, cex.axis=1.5,   
           las=1, xaxs="i", yaxs="i", xlab=expression(italic(x)), 
           ylab=expression(italic(y)), xlim=xlim2, ylim=ylim2, type="n")
      points(x, y, cex=1.5, pch=16)
      lines(x2, y2, col=2, lty=1, lwd=1) 

    }

    inde <- which.max(y2)
    xc   <- x2[inde]
    yc   <- y2[inde]
    LAC  <- xc/sqrt(2)

    para.tab <- data.frame( Parameter = c(Names, "r.sq", "RSS", 
                    "sample.size", "xc", "yc", "LAC", "GC"), 
                     Estimate = c(par, r.sq, RSS, length(x), xc, yc, LAC, GC) )
    if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
        print(para.tab)
        cat("\n")
    }
    return(list( x1=x1, y1=y1, x=x, y=y, par=par, r.sq=r.sq, RSS=RSS, 
      sample.size=length(x), xc=xc, yc=yc, LAC=LAC, GC=GC ) )

  }




  # The code for fitting the rotated and right-shifted Lorenz functions, i.e., MPerformanceE
  if(identical(expr, MPerformanceE)){

    if(!identical(expr, MPerformanceE)){
      stop("'expr' should be 'MPerformanceE'")
    }

    if( !(simpver %in% c(4, 5)) )
    stop("'simpver' should be 4 or 5 when using 'MPerformanceE' to fit the rotated and right-shifed Lorenz curve!")  

    if(length(z) < 2) 
        stop("'z' should include 2 elements at least!")

    z   <- na.omit(z)
    z1  <- sort( z )
    x1  <- 1:length(z1)/length(z1)
    y1  <- cumsum(z1)/sum(z1)  

    # Rotates the data and then shifts them to the right by a distance of sqrt(2) 
    theta <- -3/4*pi
    x     <- x1 * cos(theta) + y1 * sin(theta)
    y     <- y1 * cos(theta) - x1 * sin(theta)
    x     <- x+sqrt(2)

    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    if(simpver==4 & p!=5)
        stop("There should be five parameter for version 4!")
    if(simpver==5 & p!=3)
        stop("There should be three parameter for version 5!")
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))
    obj.fun <- function(P){
      if(P[1] <= 0 | P[2] < 0 | P[3] < 0)
          RSS <- Inf
      if(P[1] > 0 | P[2] >= 0 | P[3] >= 0){
          y.theo <- expr(P=P, x=x, simpver=simpver)
          RSS    <- sum((y.theo-y)^2) 
      }
      return(RSS) 
    }
    for (i in 1:nrow(ini.val)) {
      if(method=="Nelder-Mead"){
        res <- optim(ini.val[i, ], obj.fun, method=method, control = control)
      }
      if(method=="L-BFGS-B"){
        res <- optim(ini.val[i, ], obj.fun, method=method, 
                     lower=lower, upper=upper, control = control)
      }
      mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")

    ind    <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    par    <- as.vector(mat[ind, 1:p])
    x2     <- seq(0, sqrt(2), len=np)
    y2     <- expr(P=par, x=x2, simpver=simpver)
    y.theo <- expr(P=par, x=x, simpver=simpver)
    RSS    <- sum((y.theo - y)^2)
    r.sq   <- 1-sum((y.theo - y)^2)/sum((y-mean(y))^2)
    goal.fun <- function(x){
      expr(P=par, x=x, simpver=simpver)
    }  
    GC <- integrate(goal.fun, lower=0, upper=sqrt(2), 
            subdivisions = subdivisions, 
            rel.tol = rel.tol, abs.tol = abs.tol, 
            stop.on.error = stop.on.error, keep.xy = keep.xy, 
            aux = aux)$value/0.5

    theta <- 3/4*pi
    xt    <- x2 - sqrt(2)
    x3    <- xt * cos(theta) + y2 * sin(theta)
    y3    <- y2 * cos(theta) - xt * sin(theta)


    if(is.null(xlab))
       xlab <- "Cumulative proportion of number"
    if(is.null(ylab))
       ylab <- "Cumulative proportion of size"

    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){
      ratiox <- 0.02
      ratioy <- 0.08
      xlim1  <- c(0, 1)
      ylim1  <- c(0, 1) 
      xloc   <- xlim1[1] + (xlim1[2]-xlim1[1])*ratiox
      yloc   <- ylim1[2] - (ylim1[2]-ylim1[1])*ratioy
      xlim2  <- c(0, 1.5)

      ymax <- max(c(y, y2))[1]    
      A1   <- 10^seq(-6, 1, by=1)
      B1   <- A1*0.08
      B2   <- A1*0.12
      B3   <- A1*0.16
      B4   <- A1*0.20
      B5   <- A1*0.25
      B6   <- A1*0.40
      B7   <- A1*0.50
      B8   <- A1*0.70
      B9   <- A1*0.80   

      for(i in 1:length(A1)){
        if(ymax < B1[i])                { ylim2 <- c(0, B1[i]); break }
        if(ymax >= B1[i] & ymax < B2[i]){ ylim2 <- c(0, B2[i]); break }
        if(ymax >= B2[i] & ymax < B3[i]){ ylim2 <- c(0, B3[i]); break }
        if(ymax >= B3[i] & ymax < B4[i]){ ylim2 <- c(0, B4[i]); break }
        if(ymax >= B4[i] & ymax < B5[i]){ ylim2 <- c(0, B5[i]); break }
        if(ymax >= B5[i] & ymax < B6[i]){ ylim2 <- c(0, B6[i]); break }
        if(ymax >= B6[i] & ymax < B7[i]){ ylim2 <- c(0, B7[i]); break }
        if(ymax >= B7[i] & ymax < B8[i]){ ylim2 <- c(0, B8[i]); break }
        if(ymax >= B8[i] & ymax < B9[i]){ ylim2 <- c(0, B9[i]); break }
        if(ymax >= B9[i] & ymax < A1[i]){ ylim2 <- c(0, A1[i]*1.2); break }
      }  

      dev.new()
      layout( matrix(1:2, 1, 2, byrow=TRUE) )

      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )
      plot( x1, y1, main=main, cex.lab=1.5, cex.axis=1.5, 
            las=1, xaxs="i", yaxs="i", 
            xlab=xlab, ylab=ylab, 
            xlim=xlim1, ylim=ylim1, type="n" )
      polygon(x3, y3, col="grey70")
      points(x1, y1, cex=1.5, pch=16)
      lines(x3, y3, col=2) 
      lines(c(0, 1), c(0, 1), col=1)


      text(xloc, yloc, bquote(paste(hat(italic(c)), " = ", 
         .(sprintf("%.4f", round(par[1], 4))), sep="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-1.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(K)), {""}["1"], " = ", 
        .(sprintf("%.4f", round(par[2], 4))), sep="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-2.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(K)), {""}["2"], " = ", 
         .(sprintf("%.4f", round(par[3], 4))), sep="")), pos=4, cex=1.5, col=1)
      if(simpver==4){
        text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(a)), " = ", 
           .(sprintf("%.4f", round(par[4], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-4.0*(ylim1[2]-ylim1[1])/10, bquote(paste(hat(italic(b)), " = ", 
          .(sprintf("%.4f", round(par[5], 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-5.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
            .(sprintf("%.4f", round(r.sq, 4))), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-6.0*(ylim1[2]-ylim1[1])/10, 
           bquote( paste(italic(n), " = ", 
           .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }
      if(simpver==5){
        text(xloc, yloc-3.0*(ylim1[2]-ylim1[1])/10, bquote(paste(italic(r), {""}^{"2"}, " = ", 
           .(round(r.sq, 4)), sep="")), pos=4, cex=1.5, col=1)
        text(xloc, yloc-4.0*(ylim1[2]-ylim1[1])/10, 
           bquote( paste(italic(n), " = ", 
           .(length(x)), sep="") ), pos=4, cex=1.5, col=1)
      }

      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )

      plot(x, y, main=main, cex.lab=1.5, cex.axis=1.5,   
           las=1, xaxs="i", yaxs="i", xlab=expression(italic(x)), 
           ylab=expression(italic(y)), xlim=xlim2, ylim=ylim2, type="n")
      points(x, y, cex=1.5, pch=16)
      lines(x2, y2, col=2, lty=1, lwd=1) 

    }

    inde <- which.max(y2)
    xc   <- x2[inde]
    yc   <- y2[inde]
    LAC  <- xc/sqrt(2)

    para.tab <- data.frame( Parameter = c(Names, "r.sq", "RSS", 
                    "sample.size", "xc", "yc", "LAC", "GC"), 
                     Estimate = c(par, r.sq, RSS, length(x), xc, yc, LAC, GC) )

    if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
        print(para.tab)
        cat("\n")
    }
    return(list( x1=x1, y1=y1, x=x, y=y, par=par, r.sq=r.sq, 
      RSS=RSS, sample.size=length(x), xc=xc, yc=yc, LAC=LAC, GC=GC) )

  }
}

VolumeEPE <- function(P, simpver = NULL){

  if(P[1] < 0 | P[2] < 0)
    stop("a and b should be positive real numbers!")

  p <- length(P)
 
  if(is.null(simpver)){
    if(p != 5) 
      stop("The number of parameters is incorrect!")
    a        <- P[1]
    b        <- P[2]
    c1       <- P[3]
    c2       <- P[4]
    c3       <- P[5]
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 3, by=1)) )
      stop("'simpver' should be chosen in versions 1 to 3!")
  
    if(simpver==1){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- P[4]
        c3       <- 0
    }

    if(simpver==2){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- P[3]
        c2       <- 0
        c3       <- 0
    }

    if(simpver==3){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
        a        <- P[1]
        b        <- P[2]
        c1       <- 0
        c2       <- P[3]
        c3       <- 0
    }
  }

  4/315*a*b^2*(21*c1^2 + 42*c2 + 9*c2^2 + 18*c1*c3 + 5*(21 + c3^2))*pi

}

fitovate <- function(expr, x, y, ini.val, 
              par.list = FALSE, stand.fig = TRUE, control = list(), 
              angle = NULL, fig.opt = FALSE, index.xmax = 3, np = 2000, 
              xlim = NULL, ylim = NULL, unit = NULL, main = NULL){

    if(length(x)!=length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[,1]
    y   <- Tem[,2]    

    UpperFun <- function(P, x){
      z1    <- sort(x, decreasing=TRUE, index.return=TRUE)$x
      temp1 <- expr(P, z1, simpver=1) 
      Temp  <- cbind(z1, temp1)
      Temp  <- na.omit(Temp)
      x     <- Temp[,1]
      y     <- Temp[,2]
      list(x=x, y=y)
    }

    LowerFun <- function(P, x){
      z1    <- sort(x, decreasing=FALSE, index.return=TRUE)$x
      temp1 <- expr(P, z1, simpver=1) 
      temp2 <- -temp1
      Temp  <- cbind(z1, temp2)
      Temp  <- na.omit(Temp)
      x     <- Temp[,1]
      y     <- Temp[,2]
      list(x=x, y=y)
    }

    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))

    obj.fun <- function(z){
        x0      <- z[1]
        y0      <- z[2]
        theta   <- z[3]
        x.obs   <- x - x0
        y.obs   <- y - y0
        x.temp  <- x.obs*cos(theta) + y.obs*sin(theta)
        y.temp  <- y.obs*cos(theta) - x.obs*sin(theta)
        x.obs   <- x.temp
        y.obs   <- y.temp
        cond1   <- y.obs >= 0
        cond2   <- y.obs <  0
        xx1     <- x.obs[cond1]
        yy1     <- y.obs[cond1] 
        xx2     <- x.obs[cond2]
        yy2     <- y.obs[cond2]  
 
        ind1    <- sort(xx1, decreasing=TRUE, index.return=TRUE)$ix
        xx3     <- xx1[ind1]
        yy3     <- yy1[ind1] 
        ind2    <- sort(xx2, decreasing=FALSE, index.return=TRUE)$ix  
        xx4     <- xx2[ind2]
        yy4     <- yy2[ind2]  

        res1    <- UpperFun(z[4:p], x=xx3)
        res2    <- LowerFun(z[4:p], x=xx4) 
        x.theo  <- c(res1$x, res2$x)
        y.theo  <- c(res1$y, res2$y)
        x.obs   <- c(xx3, xx4)
        y.obs   <- c(yy3, yy4)
        Value   <- sum( (y.obs - y.theo)^2 )
        #### Diminishes the abnormal values ###################
        if(identical(expr, MbetaE) | identical(expr, 
            MLRFE) | identical(expr, MBriereE) ){
            A <- z[4]
            B <- z[5]
            C <- z[6]
            if(A <= 0 | B < 0 | C <= 0) 
            Value <- Inf 
          }

        if(TRUE){
          if( identical(expr, MPerformanceE) ){
            A <- z[4] # c
            B <- z[5] # K1
            C <- z[6] # K2
            D <- z[7] # xmax
            if(A <= 0 | B < 0 | C < 0 | D <= 0) 
            Value <- Inf 
          }
        }   
        ######################################################        
        return( Value )       
    }  

    for (i in 1:nrow(ini.val)) {
        res <- optim(ini.val[i, ], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")
    ind  <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    MAT  <- mat
    par  <- as.vector(mat[ind, 1:p])
    PAR  <- par[4:p]

    #### To solve the issue of abs(theta) > 2*pi ####
    if(par[3] > 2*pi){
        par[3] <- par[3]%%(2*pi)
    }
    if(par[3] < -2*pi){
        par[3] <- -((-par[3])%%(2*pi))
    }
    ##################################################

    goal.x0     <- par[1]
    goal.y0     <- par[2]
    goal.theta  <- par[3]  
    x.obs       <- x - goal.x0
    y.obs       <- y - goal.y0
    x.new       <- x.obs*cos(goal.theta) + y.obs*sin(goal.theta)
    y.new       <- y.obs*cos(goal.theta) - x.obs*sin(goal.theta)
    x.obs       <- x.new
    y.obs       <- y.new
    cond1       <- y.obs >= 0
    cond2       <- y.obs <  0
    xx1         <- x.obs[cond1]
    xx2         <- x.obs[cond2]
    yy1         <- y.obs[cond1] 
    yy2         <- y.obs[cond2]  
    ind1        <- sort(xx1, decreasing=TRUE, index.return=TRUE)$ix
    xx3         <- xx1[ind1]
    yy3         <- yy1[ind1] 
    ind2        <- sort(xx2, decreasing=FALSE, index.return=TRUE)$ix  
    xx4         <- xx2[ind2]
    yy4         <- yy2[ind2]  
    x1          <- c(xx3, xx4)
    y1          <- c(yy3, yy4)
    res1        <- UpperFun(PAR, x=xx3)
    res2        <- LowerFun(PAR, x=xx4)
    x.theo      <- c(res1$x, res2$x)
    y.theo      <- c(res1$y, res2$y)
    x.obs       <- c(xx3, xx4)
    y.obs       <- c(yy3, yy4)
    x2          <- x.theo
    y2          <- y.theo
    r.obs       <- sqrt( x1^2 + y1^2 )
    phi.obs     <- acos(x1/r.obs)
    phiA        <- phi.obs 
    x.arr       <- seq(0, PAR[index.xmax], len=np)
    if( is.null(angle) ){        
        x.new    <- x1*cos(goal.theta) - y1*sin(goal.theta) + par[1]
        y.new    <- y1*cos(goal.theta) + x1*sin(goal.theta) + par[2] 
        x.theory <- x2*cos(goal.theta) - y2*sin(goal.theta) + par[1]
        y.theory <- y2*cos(goal.theta) + x2*sin(goal.theta) + par[2] 
        results2 <- curveovate(expr, P=par, x=x.arr)
        phiB     <- phiA + goal.theta        
    }
    if( !is.null(angle) ){        
        par.new    <- par  
        #### The third element of 'par.new' is compulsorily defined as 'angle' ####
        par.new[3] <- angle 
        ###########################################################################
        x.new    <- x1*cos(angle) - y1*sin(angle) + par.new[1]
        y.new    <- y1*cos(angle) + x1*sin(angle) + par.new[2]         
        x.theory <- x2*cos(angle) - y2*sin(angle) + par[1]
        y.theory <- y2*cos(angle) + x2*sin(angle) + par[2] 
        results2 <- curveovate(expr, P=par.new, x=x.arr)
        phiB     <- phiA + angle 
    }
    if(is.null(xlim)) xlim <- NULL
    if(is.null(ylim)) ylim <- NULL
    if(!is.null(xlim)) xlim <- xlim
    if(!is.null(ylim)) ylim <- ylim      
    if(!is.null(unit)){
      xlabel <- bquote( paste(italic("x"), " (", .(unit), ")", sep="") ) 
      ylabel <- bquote( paste(italic("y"), " (", .(unit), ")", sep="") )
    }
    if(is.null(unit)){
      xlabel <- bquote( italic("x") ) 
      ylabel <- bquote( italic("y") )
    }

    if(stand.fig == "T" | stand.fig == "TRUE" | stand.fig == "True"){
          dev.new()
          plot(x1, y1, xlab=xlabel, ylab=ylabel, las=1,
               cex.lab=1.5, cex.axis=1.5, 
               type="l", lwd=3, col="grey50", asp=1)
          lines(x2, y2, col=2, lwd=2)
          title(main=main, cex.main=1.5, col.main=4, font.main=1)
          abline(h=0, lty=2, col=4)
          abline(v=0, lty=2, col=4)
    }

    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){  
      x_ran  <- c(x.new, x.theory)
      y_ran  <- c(y.new, y.theory)      
      if(is.null(angle)){ 
          dev.new()
          plot( x_ran, y_ran, xlab=xlabel, ylab=ylabel, type="n", 
                asp=1, xlim=xlim, ylim=ylim, cex.lab=1.5, cex.axis=1.5 )
          points( x.new, y.new, cex=0.5, col="grey40" )
          lines(results2$x, results2$y, type="l", asp=1, col=2, lwd=2)
          title(main=main, cex.main=1.5, col.main=4, font.main=1)
          if(abs(par[3])%%pi/2 != 0){
              slope <- tan(par[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
          }
          if(abs(par[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
          }
      }
      if(!is.null(angle)){ 
          dev.new()
          plot( x_ran, y_ran, xlab=xlabel, ylab=ylabel, type="n", 
                asp=1, xlim=xlim, ylim=ylim, cex.lab=1.5, cex.axis=1.5 )
          points( x.new, y.new, cex=0.5, col="grey40" )
          lines(results2$x, results2$y, type="l", asp=1, col=2, lwd=2)
          title(main=main, cex.main=1.5, col.main=4, font.main=1)
          if(abs(par.new[3])%%pi/2 != 0){
              slope <- tan(par.new[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
          }
          if(abs(par.new[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
          }
      }
    }

    L1      <- max(x1)[1] - min(x1)[1]
    W1      <- max(y1)[1] - min(y1)[1]  
    poly1   <- as.polygonal( owin(poly=list(x=x1, y=y1)) )
    P1      <- perimeter(poly1)
    A1      <- area(poly1)
    RES1    <- UpperFun(PAR, x=seq(0, PAR[3], len=np))
    RES2    <- LowerFun(PAR, x=seq(0, PAR[3], len=np))
    x3      <- c(RES1$x, RES2$x)
    y3      <- c(RES1$y, RES2$y)
    L2      <- max(x3)[1] - min(x3)[1]
    W2      <- max(y3)[1] - min(y3)[1] 
    poly2   <- as.polygonal( owin(poly=list(x=x3, y=y3)) )
    P2      <- perimeter(poly2)
    A2      <- area(poly2)
    RSS     <- sum((y.obs - y.theo)^2)
    r.sq    <- 1-sum((y.obs-y.theo)^2)/sum((y.obs-mean(y.obs))^2)

    para.tab <- data.frame( Parameter = c(Names, 
                    "r.sq", "RSS", "sample.size"), 
                    Estimate = c(par, r.sq, RSS, length(x)) )
    if(par.list == "T" | par.list == "TRUE"){
        print(para.tab)
        cat("\n")
    }
    return(list( par=par, r.sq=r.sq, RSS=RSS, sample.size=length(x),
                 scan.length=L1, scan.width=W1, scan.perimeter=P1, scan.area=A1,
                 pred.length=L2, pred.width=W2, pred.perimeter=P2, pred.area=A2,
                 x.stand.obs=x1, x.stand.pred=x2, 
                 y.stand.obs=y1, y.stand.pred=y2, 
                 x.obs=x.new, x.pred=x.theory, y.obs=y.new, y.pred=y.theory))
}

fitGS <- function(A, ini.val = NULL, control = list(), par.list = FALSE, fig.opt = TRUE){

  SA.temp <- A
  SA      <- sort( SA.temp )
  n       <- length(SA)
  x       <- 1:n
  y       <- SA
  z       <- cumsum(SA)  

  q1.est  <- mean(y[2:n]/y[1:(n-1)])  

  A1.est  <- 0 
  for(j in 1:n){
    A1.est <- A1.est + 1/n*y[j]/q1.est^(j-1)
  }

  obj.fun <- function(z){  
    A1 <- z[1]
    q  <- z[2]
    sum((A1*q^(x-1)-y)^2)
  }

  if(!is.null(ini.val)){
    ini.val <- as.list(ini.val)
    p <- length(ini.val)
    s <- 1
    for (i in 1:p) {
      s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))
  }
  if(is.null(ini.val)){
    ini.val <- t(cbind(c(A1.est, q1.est))) 
    p       <- 2
    mat     <- matrix(NA, nrow = 1, ncol = p+1)
  }

  for(i in 1:nrow(ini.val)){
    res      <- optim(ini.val[i, ], obj.fun, control = control)
    mat[i, ] <- c(res$par, res$val)
  }

  Names <- rep(NA, len = p)
  for (k in 1:p) {
      Names[k] <- paste("P[", k, "]", sep = "")
  }
  colnames(mat) <- c(Names, "RSS")
  ind <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
  MAT <- mat
  par <- as.vector(mat[ind, 1:p])
  PAR <- par[1:p]


  A.est   <- PAR[1]
  q.est   <- PAR[2]
  y.theo  <- A.est*q.est^(1:n-1) 
  z.theo  <- A.est*(1-q.est^(1:n))/(1-q.est)
  RSS     <- sum((y-y.theo)^2)
  r.sq    <- 1 - sum((y-y.theo)^2)/sum((y - mean(y))^2)
  RMSE1   <- sqrt( sum((y-y.theo)^2)/n )
  MAPE1   <- mean(abs(y-y.theo)/y * 100)
  RMSE2   <- sqrt( sum((z-z.theo)^2)/n )
  MAPE2   <- mean(abs(z-z.theo)/z * 100)

  para.tab <- data.frame(Parameter = c(Names, "r.sq", "RSS",  
      "sample.size", "RMSE1", "MAPE1", "RMSE2", "MAPE2"), 
      Estimate = c(par, r.sq, RSS, length(x), RMSE1, MAPE1, RMSE2, MAPE2))

  if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
    print(para.tab)
    cat("\n")
  }

  if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True") {
 
    dev.new()
    layout( matrix(1:2, 1, 2, byrow=TRUE) )

    par( mar=c(5, 5, 2, 2) )
    par( mgp=c(3.5, 1, 0) )
    plot(x, y, cex.lab=1.5, cex.axis=1.5, cex=1.5, xlab=expression(italic(x)), 
         ylab=expression(paste("Sorted ", italic(y), " values in ascending order", sep="")))
    lines(x, y.theo, col=2)

    par( mar=c(5, 5, 2, 2) )
    par( mgp=c(3.5, 1, 0) )
    plot(x, z, cex.lab=1.5, cex.axis=1.5, cex=1.5, xlab=expression(italic(x)), 
         ylab=expression(paste("Cumulative sorted ", italic(y), " values", sep="")))
    lines(x, z.theo, col=2)

  }

  return(list( x=x, y=y, y.theo=y.theo, z=z, z.theo=z.theo, par=PAR, r.sq=r.sq, RSS=RSS, 
               sample.size=length(x), RMSE1=RMSE1, MAPE1=MAPE1, RMSE2=RMSE2, MAPE2=MAPE2 ))
}

MbetaE <- function(P, x, simpver = 1){

  p <- length(P)

  if(is.null(simpver)){
    if(p != 5) 
    stop("The length of 'P' shoud equal 5 for the modified version!")
    yopt  <- P[1]
    xopt  <- P[2]
    xmin  <- P[3]
    xmax  <- P[4]
    delta <- P[5] 
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 3, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 3!")  
  
    if(simpver==1){
      if(p != 4) 
      stop("The length of 'P' shoud equal 4 for the simplified version 1!")
      yopt  <- P[1]
      xopt  <- P[2]
      xmax  <- P[3]
      delta <- P[4]
      xmin  <- 0 
    }

   if(simpver==2){
      if(p != 4) 
      stop("The length of 'P' shoud equal 4 for the simplified version 2!")
      yopt  <- P[1]
      xopt  <- P[2]
      xmin  <- P[3]
      xmax  <- P[4]
      delta <- 1
    }

    if(simpver==3){
      if(p != 3) 
      stop("The length of 'P' shoud equal 3 for the simplified version 3!")
      yopt  <- P[1]
      xopt  <- P[2]
      xmax  <- P[3]
      xmin  <- 0
      delta <- 1
    }

  }

  fun0 <- function(y){
      y[y < xmin] <- xmin
      y[y > xmax] <- xmax
      return(y)
  }
  z <- fun0(x)

  yopt*(((xmax-z)/(xmax-xopt)*((z-xmin)/(xopt-xmin))^((xopt-xmin)/(xmax-xopt))))^delta

}

fitETE <- function(x, y, ini.val,
           control = list(), par.list = FALSE, 
           stand.fig = TRUE, angle = NULL, fig.opt = FALSE, np = 2000,
           xlim = NULL, ylim = NULL, unit = NULL, main = NULL ){
    if(length(x)!=length(y)) 
        stop("'x' should have the same data length as 'y'!")
    if(np %% 2 == 1) np <- np + 1
    Tem   <- cbind(x, y)
    Tem   <- na.omit(Tem)
    x     <- Tem[,1]
    y     <- Tem[,2] 
    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))
    obj.fun <- function(z){
        x0      <- z[1]
        y0      <- z[2]
        theta   <- z[3]
        x.obs   <- x - x0
        y.obs   <- y - y0
        x.temp  <- x.obs*cos(theta) + y.obs*sin(theta)
        y.temp  <- y.obs*cos(theta) - x.obs*sin(theta)
        x.obs   <- x.temp
        y.obs   <- y.temp
        cond1   <- y.obs >= 0
        cond2   <- y.obs <  0
        xx1     <- x.obs[cond1]
        xx2     <- x.obs[cond2]     
        yy1     <- y.obs[cond1] 
        yy2     <- y.obs[cond2] 
  
        if(z[4] <= 0) RSS <- Inf 
        if(z[4] > 0){
          if(length(xx1)==0 | length(xx2)==0) 
            RSS <- Inf
          if(length(xx1) > 0 & length(xx2) > 0){ 
            yU  <- ETE(P=z[4:p], x=xx1) 
            yL  <- -ETE(P=z[4:p], x=xx2) 
            RSS <- sum( (yU - yy1)^2 ) + sum( (yL - yy2)^2 )
          }
        }
        return( RSS )       
    }  
    for (i in 1:nrow(ini.val)) {
        res <- optim(ini.val[i, ], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")

    ind  <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    par  <- as.vector(mat[ind, 1:p])
    #### To solve the issue of abs(theta) > 2*pi ####
    if(par[3] > 2*pi){
        par[3] <- par[3]%%(2*pi)
    }
    if(par[3] < -2*pi){
        par[3] <- -((-par[3])%%(2*pi))
    }
    ##################################################
    goal.x0    <- par[1]
    goal.y0    <- par[2]
    goal.theta <- par[3]
    x.obs <- x - goal.x0
    y.obs <- y - goal.y0
    x.new <- x.obs*cos(goal.theta) + y.obs*sin(goal.theta)
    y.new <- y.obs*cos(goal.theta) - x.obs*sin(goal.theta)
    x.obs <- x.new
    y.obs <- y.new
    r.obs   <- sqrt( x.obs^2 + y.obs^2 )
    phi.obs <- acos(x.obs/r.obs) 
    cond1 <- y.obs >= 0
    cond2 <- y.obs <  0
    xx1   <- x.obs[cond1]
    xx2   <- x.obs[cond2]
    yy1   <- y.obs[cond1] 
    yy2   <- y.obs[cond2]
    yU      <- ETE(P=par[4:p], x=xx1) 
    yL      <- -ETE(P=par[4:p], x=xx2)       
    phi1    <- phi.obs[cond1]  
    phi2    <- 2*pi - phi.obs[cond2]
    phi.obs <- c(phi1, phi2)
    x.obs   <- c(xx1, xx2)
    y.obs   <- c(yy1, yy2)
    y2      <- c(yU, yL) 
    resu    <- sort(phi.obs, decreasing = FALSE, index.return= T )
    phi.obs <- resu$x
    Index   <- resu$ix
    x1      <- x.obs[Index]
    y1      <- y.obs[Index]
    y2      <- y2[Index]
    CombTab <- cbind(x1, y1, y2)
    CombTab <- na.omit(CombTab)
    x1      <- CombTab[,1]
    y1      <- CombTab[,2]
    y2      <- CombTab[,3]     

    xv1    <- seq(par[4], -par[4], len=np/2)
    xv2    <- seq(-par[4], par[4], len=np/2)
    yU.val <- ETE(P=par[4:p], x=xv1)
    yL.val <- -ETE(P=par[4:p], x=xv2)
    xv3 <- c(xv1, xv2)
    yv3 <- c(yU.val, yL.val)
    if( is.null(angle) ){ 
        x.new  <- x1*cos(goal.theta) - y1*sin(goal.theta) + par[1]
        y.new  <- y1*cos(goal.theta) + x1*sin(goal.theta) + par[2] 
        xv4    <- xv3*cos(goal.theta) - yv3*sin(goal.theta) + par[1]
        yv4    <- yv3*cos(goal.theta) + xv3*sin(goal.theta) + par[2] 
        yv5    <- y2*cos(goal.theta) + x1*sin(goal.theta) + par[2] 
    }
    if( !is.null(angle) ){        
        par.new    <- par  
        #### The third element of 'par.new' is compulsorily defined as 'angle' ####
        par.new[3] <- angle 
        ###########################################################################
        x.new    <- x1*cos(angle) - y1*sin(angle) + par.new[1]
        y.new    <- y1*cos(angle) + x1*sin(angle) + par.new[2] 
        xv4      <- xv3*cos(angle) - yv3*sin(angle) + par.new[1]
        yv4      <- yv3*cos(angle) + xv3*sin(angle) + par.new[2] 
        yv5      <- y2*cos(angle) + x1*sin(angle) + par.new[2] 
    }
    if(is.null(xlim)) xlim <- NULL
    if(is.null(ylim)) ylim <- NULL
    if(!is.null(xlim)) xlim <- xlim
    if(!is.null(ylim)) ylim <- ylim        
    if(!is.null(unit)){
      xlabel <- bquote( paste(italic("x"), " (", .(unit), ")", sep="") ) 
      ylabel <- bquote( paste(italic("y"), " (", .(unit), ")", sep="") )
    }
    if(is.null(unit)){
      xlabel <- bquote( italic("x") ) 
      ylabel <- bquote( italic("y") )
    }
    if(stand.fig == "T" | stand.fig == "TRUE" | stand.fig == "True"){
          dev.new()
          plot(x1, y1, xlab=xlabel, ylab=ylabel, 
               cex.lab=1.5, cex.axis=1.5, 
               type="l", lwd=3, col="grey50", asp=1)
          lines(x1, y2, col=2, lwd=2)
          title(main=main, cex.main=1.5, col.main=4, font.main=1)
          abline(h=0, lty=2, col=4)
          abline(v=0, lty=2, col=4)
    }
    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){
      if(is.null(angle)){
            dev.new()
            plot( x.new, y.new, xlab=xlabel, ylab=ylabel, type="l",
                  cex.lab=1.5, cex.axis=1.5, col="grey50", lwd=3, asp=1, 
                  xlim=xlim, ylim=ylim )
            lines(xv4, yv4, type="l", asp=1, col=2, lwd=2)
            title(main=main, cex.main=1.5, col.main=4, font.main=1)
            if(abs(par[3])%%pi/2 != 0){
              slope <- tan(par[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)

            }
            if(abs(par[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
            }
      } 
      if(!is.null(angle)){
            dev.new()
            plot( x.new, y.new, xlab=xlabel, ylab=ylabel, type="l", 
                  cex.lab=1.5, cex.axis=1.5, col="grey50", lwd=3, asp=1,
                  xlim=xlim, ylim=ylim )
            lines(xv4, yv4, type="l", asp=1, col=2, lwd=2)
            title(main=main, cex.main=1.5, col.main=4, font.main=1)
            if(abs(par.new[3])%%pi/2 != 0){
              slope <- tan(par.new[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)

            }
            if(abs(par.new[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
            }
      }
    }
    x.range <- range(x1)
    y.range <- range(y1)
    length0 <- x.range[2] - x.range[1]
    width0  <- y.range[2] - y.range[1]    
    poly0   <- as.polygonal(owin(poly = list(x = x1, y = y1)))
    area0   <- area.owin(poly0)
    perimeter0 <- perimeter(poly0)
    RSS      <- sum((y1 - y2)^2)
    r.sq     <- 1-sum((y1-y2)^2)/sum((y1-mean(y1))^2)
    para.tab <- data.frame( Parameter = c(Names, 
                    "Length", "Width", "Area", "Perimeter", "r.sq", "RSS", 
                    "sample.size"), Estimate = c(par, length0, width0, 
                    area0, perimeter0, r.sq, RSS, length(x1)) )
    if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
        print(para.tab)
        cat("\n")
    }
    return(list( par=par, scan.length=length0, scan.width=width0, 
      scan.area=area0, scan.perimeter=perimeter0, r.sq=r.sq, 
      RSS=RSS, sample.size=length(x1),      
      x.stand.obs=x1, y.stand.obs=y1, y.stand.pred=y2, 
      x.obs=x.new, y.obs=y.new, y.pred=yv5) )
}

curveovate <- function(expr, P, x, fig.opt = FALSE, 
                deform.fun = NULL, Par = NULL,
                xlim = NULL, ylim = NULL, unit = NULL, main = NULL){
  if((is.null(deform.fun) & !is.null(Par
      )) | (!is.null(deform.fun) & is.null(Par)))
  stop("'Par' should be provided when 'deform.fun' is not null.")
  p        <- length(P)   
  x0       <- P[1]
  y0       <- P[2]
  theta    <- P[3]
  PAR      <- P[4:p] 
  UpperFun <- function(P, x){
    z1    <- sort(x, decreasing=TRUE, index.return=TRUE)$x
    temp1 <- expr(P, z1, simpver=1) 
    Temp  <- cbind(z1, temp1)
    Temp  <- na.omit(Temp)
    x     <- Temp[,1]
    y     <- Temp[,2]
    list(x=x, y=y)
  }
  LowerFun <- function(P, x){
    z1    <- sort(x, decreasing=FALSE, index.return=TRUE)$x
    temp1 <- expr(P, z1, simpver=1) 
    temp2 <- -temp1
    Temp  <- cbind(z1, temp2)
    Temp  <- na.omit(Temp)
    x     <- Temp[,1]
    y     <- Temp[,2]
    list(x=x, y=y)
  }
  res1     <- UpperFun(PAR, x)
  res2     <- LowerFun(PAR, x)
  x1       <- c(res1$x, res2$x)
  y1       <- c(res1$y, res2$y)
  if(!is.null(deform.fun)){  
    Resu <- deform.fun(Par=Par, z=cbind(x1,y1))
    x1   <- Resu$x
    y1   <- Resu$y
  }
  x.rot    <- x1*cos(theta) - y1*sin(theta)
  y.rot    <- y1*cos(theta) + x1*sin(theta)   
  x.coordi <- x.rot + x0
  y.coordi <- y.rot + y0    
  if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){
        if(is.null(xlim)) xlim <- NULL
        if(is.null(ylim)) ylim <- NULL
        if(!is.null(xlim)) xlim <- xlim
        if(!is.null(ylim)) ylim <- ylim
        if(!is.null(unit)){
  xlabel <- bquote(paste(italic("x")," (", .(unit),")", sep="")) 
  ylabel <- bquote(paste(italic("y")," (", .(unit),")", sep=""))
        }
        if(is.null(unit)){
          xlabel <- bquote( bolditalic("x") ) 
          ylabel <- bquote( bolditalic("y") )
        }
        dev.new()
        plot( x.coordi, y.coordi, asp=1, xlab=xlabel, ylab=ylabel, 
              pch=1, cex=2, cex.lab=1.5,
              cex.axis=1.5, type="l", lwd=2 )
        abline(h=y0, lty=2, col=4)
        abline(v=x0, lty=2, col=4)   
        abline(y0-tan(theta)*x0, tan(theta), col=2, lty=2)
        title(main=main, cex.main=1.5, col.main=4, font.main=1)
  }
  list(x = x.coordi, y = y.coordi)
}

SHE <- function(P, x){
    delta <- P[1]
    rho   <- P[2]
    omega <- P[3]
    P     <- P[4]
    myfun <- function(z){
      z[z < delta] <- delta
      return(z)
    }
    x <- myfun(x)
    (1-rho) * ( (2/(P+1)) * ((x-delta)/(1-delta)) ) + rho*(
    (1-omega)*((x-delta)/(1-delta))^P + omega * (1-(1-((x-delta)/(1-delta)))^(1/P)) )
}

fitAM <- function (expr, x, y, ini.val, method = "Nelder-Mead", control = list(), 
    lower = -Inf, upper = Inf, par.list = FALSE, stand.fig = TRUE, fig.opt = FALSE,  
    angle = NULL, xlim = NULL, ylim = NULL, unit = NULL, main = NULL){

    if( !( method %in% c("Nelder-Mead", "L-BFGS-B") ) ){
        stop("'method' is only selected as Nelder-Mead or L-BFGS-B!")
    } 

    if (length(x) != length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[, 1]
    y   <- Tem[, 2]
    ini.val <- as.list(ini.val)
    p <- length(ini.val)
    s <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat <- matrix(NA, nrow = s, ncol = (p + 1))
    obj.fun <- function(z) {
        x0     <- z[1]
        y0     <- z[2]
        theta  <- z[3]
        x.obs  <- x - x0
        y.obs  <- y - y0
        x.temp <- x.obs * cos(theta) + y.obs * sin(theta)
        y.temp <- y.obs * cos(theta) - x.obs * sin(theta)
        x.obs  <- x.temp
        y.obs  <- y.temp
        x.theo <- x.obs
        y.theo <- expr(z[4:p], x.obs)
        Value  <- sum((y.obs - y.theo)^2)
        return(Value)
    }
    for (i in 1:nrow(ini.val)) {
      if(method=="Nelder-Mead"){
        res <- optim(ini.val[i, ], obj.fun, method=method, control = control)
      }
      if(method=="L-BFGS-B"){
        res <- optim(ini.val[i, ], obj.fun, method=method, 
                     lower=lower, upper=upper, control = control)
      }
      mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")
    ind <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    MAT <- mat
    par <- as.vector(mat[ind, 1:p])
    PAR <- par[4:p]
    if (par[3] > 2 * pi) {
        par[3] <- par[3]%%(2 * pi)
    }
    if (par[3] < -2 * pi) {
        par[3] <- -((-par[3])%%(2 * pi))
    }
    goal.x0    <- par[1]
    goal.y0    <- par[2]
    goal.theta <- par[3]
    x.obs   <- x - goal.x0
    y.obs   <- y - goal.y0
    x.new   <- x.obs * cos(goal.theta) + y.obs * sin(goal.theta)
    y.new   <- y.obs * cos(goal.theta) - x.obs * sin(goal.theta)
    x.obs   <- x.new
    y.obs   <- y.new
    x1      <- x.obs
    y1      <- y.obs
    x.theo  <- x.obs
    y.theo  <- expr(PAR, x.obs)
    x2      <- x.theo
    y2      <- y.theo
    r.obs   <- sqrt(x1^2 + y1^2)
    phi.obs <- acos(x1/r.obs)
    phiA    <- phi.obs

    if (is.null(angle)) {
        x.new    <- x1 * cos(goal.theta) - y1 * sin(goal.theta) + par[1]
        y.new    <- y1 * cos(goal.theta) + x1 * sin(goal.theta) + par[2]
        x.theory <- x2 * cos(goal.theta) - y2 * sin(goal.theta) + par[1]
        y.theory <- y2 * cos(goal.theta) + x2 * sin(goal.theta) + par[2]
        phiB     <- phiA + goal.theta
    }
    if (!is.null(angle)) {
        par.new <- par
        par.new[3] <- angle
        x.new    <- x1 * cos(angle) - y1 * sin(angle) + par.new[1]
        y.new    <- y1 * cos(angle) + x1 * sin(angle) + par.new[2]
        x.theory <- x2 * cos(angle) - y2 * sin(angle) + par[1]
        y.theory <- y2 * cos(angle) + x2 * sin(angle) + par[2]
        phiB     <- phiA + angle
    }
    if (is.null(xlim)) 
        xlim <- NULL
    if (is.null(ylim)) 
        ylim <- NULL
    if (!is.null(xlim)) 
        xlim <- xlim
    if (!is.null(ylim)) 
        ylim <- ylim
    if (!is.null(unit)) {
        xlabel <- bquote(paste(italic("x"), " (", .(unit), ")", 
            sep = ""))
        ylabel <- bquote(paste(italic("y"), " (", .(unit), ")", 
            sep = ""))
    }
    if (is.null(unit)) {
        xlabel <- bquote(italic("x"))
        ylabel <- bquote(italic("y"))
    }
    if (stand.fig == "T" | stand.fig == "TRUE" | stand.fig == 
        "True") {
        dev.new()
        par( mar=c(5, 5 ,2, 2) )
        par( mgp=c(3, 1, 0) )  
        plot(c(x1, x2), c(y1, y2), xlab = xlabel, ylab = ylabel, las = 1, cex.lab = 1.5, 
            cex.axis = 1.5, type = "n", asp = 1)
        points(x1, y1, cex = 1, col = "grey40")
        lines(x2, y2, col = 2, lwd = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        abline(h = 0, lty = 2, col = 4)
        abline(v = 0, lty = 2, col = 4)
    }
    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True") {
        x_ran <- c(x.new, x.theory)
        y_ran <- c(y.new, y.theory)
        if (is.null(angle)) {
            dev.new()
            par( mar=c(5, 5 ,2, 2) )
            par( mgp=c(3, 1, 0) )  
            plot(x_ran, y_ran, xlab = xlabel, ylab = ylabel, 
                type = "n", asp = 1, xlim = xlim, ylim = ylim, 
                cex.lab = 1.5, cex.axis = 1.5)
            points(x.new, y.new, cex = 1, col = "grey40")
            lines(x.theory, y.theory, col = 2, lwd = 2)

            title(main = main, cex.main = 1.5, col.main = 4, 
                font.main = 1)
            if (abs(par[3])%%pi/2 != 0) {
                slope <- tan(par[3])
                abline(-slope * par[1] + par[2], slope, col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
            if (abs(par[3])%%pi/2 == 0) {
                abline(v = par[1], col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
        }
        if (!is.null(angle)) {
            dev.new()
            par( mar=c(5, 5 ,2, 2) )
            par( mgp=c(3, 1, 0) )  
            plot(x_ran, y_ran, xlab = xlabel, ylab = ylabel, 
                type = "n", asp = 1, xlim = xlim, ylim = ylim, 
                cex.lab = 1.5, cex.axis = 1.5)
            points(x.new, y.new, cex = 1, col = "grey40")
            lines(x.theory, y.theory, col = 2, lwd = 2)

            title(main = main, cex.main = 1.5, col.main = 4, 
                font.main = 1)
            if (abs(par.new[3])%%pi/2 != 0) {
                slope <- tan(par.new[3])
                abline(-slope * par[1] + par[2], slope, col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
            if (abs(par.new[3])%%pi/2 == 0) {
                abline(v = par[1], col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
        }
    }

    RSS  <- sum((y.obs - y.theo)^2)
    r.sq <- 1 - sum((y.obs - y.theo)^2)/sum((y.obs - mean(y.obs))^2)

    para.tab <- data.frame(Parameter = c(Names, "r.sq", "RSS", 
        "sample.size"), Estimate = c(par, r.sq, RSS, length(x)))
    if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
        print(para.tab)
        cat("\n")
    }
    return(list(par = par, r.sq = r.sq, RSS = RSS, sample.size = length(x), 
           x.stand.obs = x1, x.stand.pred = x2, y.stand.obs = y1, 
           y.stand.pred = y2, x.obs = x.new, x.pred = x.theory, 
           y.obs = y.new, y.pred = y.theory))
}

TSE <- function(P, x, simpver=NULL){
    temp       <- 1-x^2
    ind0       <- which(temp < 0)
    temp[ind0] <- 0
    z0         <- sqrt(temp)
    z1         <- x*z0
    z2         <- x^2*z0
    z3         <- x^3*z0
    if(is.null(simpver)){
      d0 <- P[1]
      d1 <- P[2]
      d2 <- P[3]
      d3 <- P[4]
      y  <- d0*z0 + d1*z1 + d2*z2 + d3*z3   
    }
    if(!is.null(simpver) && !is.numeric(simpver))
      stop("'simpver' must be chosen from 1, 2 and 3")  
    if(!is.null(simpver) && simpver==1){    
      d0 <- P[1]
      d1 <- P[2]
      d2 <- P[3]
      y <- d0*z0 + d1*z1 + d2*z2       
    }
    if(!is.null(simpver) && simpver==2){    
      d0 <- P[1]
      d1 <- P[2]
      y <- d0*z0 + d1*z1 
    }
    if(!is.null(simpver) && simpver==3){   
      d0 <- P[1]
      d2 <- P[2] 
      y <- d0*z0 + d2*z2
    }
    return(y)
}

SurfaceAreaSGE <- function(P, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL){
 
  p <- length(P)
  if(p != 3) 
    stop("The number of parameters should equal 3!")
 
  inner.fun <- function(phi){    
    SGE <- GE(P=P, phi=phi, simpver=1, m=1)
    2*pi*sin(phi)*SGE*sqrt(SGE^2+(DSGE(P=P, phi))^2)
  }

  temp <- integrate( inner.fun, 0, pi, subdivisions = subdivisions,
             rel.tol = rel.tol, abs.tol = abs.tol,
             stop.on.error = stop.on.error, keep.xy = keep.xy, aux = aux )$value
  as.numeric( temp )

}

curveGE <- function(expr, P, phi = seq(0, 2*pi, len=2000),
             m = 1, simpver = NULL, nval = 1,
             fig.opt = FALSE, deform.fun = NULL, Par = NULL,
             xlim = NULL, ylim = NULL, unit = NULL, main = ""){

    if((is.null(deform.fun) & !is.null(Par)) | 
        (!is.null(deform.fun) & is.null(Par)))
stop("'Par' should be provided when 'deform.fun' is not null.")

    phi      <- sort(phi, decreasing = FALSE)
    x0       <- P[1]
    y0       <- P[2]
    theta    <- P[3]
    npar     <- length(P)
  
    r        <- expr(P=P[4:npar], phi=phi, m=m, 
                simpver=simpver, nval=nval)
    x        <- r*cos(phi)
    y        <- r*sin(phi)

    if(!is.null(deform.fun)){  
      Resu <- deform.fun(Par=Par, z=cbind(x,y))
      x    <- Resu$x
      y    <- Resu$y
    }

    x.rot    <- x*cos(theta) - y*sin(theta)
    y.rot    <- y*cos(theta) + x*sin(theta)  
    r.rot    <- sqrt(x.rot^2 + y.rot^2)
    x.coordi <- x.rot + x0
    y.coordi <- y.rot + y0
    

    if(fig.opt == "T" | fig.opt == "TRUE"){

        if(is.null(xlim)) xlim <- NULL
        if(is.null(ylim)) ylim <- NULL

        if(!is.null(xlim)) xlim <- xlim
        if(!is.null(ylim)) ylim <- ylim

        if(!is.null(unit)){
  xlabel <- bquote(paste(italic("x")," (", .(unit),")", sep="")) 
  ylabel <- bquote(paste(italic("y")," (", .(unit),")", sep=""))
        }
        if(is.null(unit)){
          xlabel <- bquote( italic("x") ) 
          ylabel <- bquote( italic("y") )
        }

        dev.new()
        plot( x.coordi, y.coordi, asp=1, xlab=xlabel, ylab=ylabel, 
              pch=1, cex=2, cex.lab=1.5, cex.axis=1.5, type="l", 
              lwd=2, xlim=xlim, ylim=ylim )
        abline(h=y0, lty=2, col=4)
        abline(v=x0, lty=2, col=4)   
        title(main=main, cex.main=1.5, col.main=4, font.main=1)

        ru <- expr(P=P[4:npar], phi=0, m=m, 
                   simpver=simpver, nval=nval)
        xu <- ru*cos(0)
        yu <- ru*sin(0)


        if(!is.null(deform.fun)){  
          Right <- deform.fun(Par=Par, z=cbind(xu,yu))
          xu    <- Right$x
          yu    <- Right$y
        }
        
        xv <- xu*cos(theta) - yu*sin(theta)
        yv <- yu*cos(theta) + xu*sin(theta) 
        xv <- xv + x0
        yv <- yv + y0 

        temp <- xv - x0        

        if(temp != 0){
            slope <- (yv-y0)/(xv-x0)
            abline(-slope*x0+y0, slope, col=1, lty=2)
        }
        if(temp == 0){
            abline(v = x0, col = 1, lty=2)
        }

        points(x0, y0, cex=2, pch=16, col=2)
        points(xv, yv, cex=2, pch=1, col=4)

    }
    list(x = x.coordi, y = y.coordi, r = r.rot)
}

TE <- function(P, x){
  if(!is.numeric(x))
    stop("'x' should be a numerical value or a numerical vector!")
  x[x < -1] <- -1
  x[x >  1] <- 1
  alpha0 <- P[1]
  alpha1 <- P[2]
  alpha2 <- P[3] 
  exp( alpha0 + alpha1*x + alpha2*x^2 ) * sqrt(1 - x^2)
}

fitNRGE <- function (x, y, dev.angle = NULL, ini.C = c(-1, 0.1, 0.5, 1), 
    strip.num = 2000, control = list(), fig.opt = TRUE, np = 2000,
    xlim = NULL, ylim = NULL, unit = NULL, main = NULL) 
{
    options(warn=-1)
    if (length(x) != length(y)) 
        stop("'x' should have the same data length as 'y'!")
    if(!is.null(dev.angle) & !is.numeric(dev.angle)){
        stop("'dev.angle' should be NULL or a numerical value or a numerical vector!")
    }
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[, 1]
    y   <- Tem[, 2]
    poly1 <- owin(xrange = c(min(x)[1], max(x)[1]), 
               yrange = c(min(y)[1], max(y)[1]))
    poly0 <- as.polygonal(owin(poly = list(x = x, y = y)))
    data0 <- ppp(x, y, window = poly1)
    area0 <- area.owin(poly0)
    perimeter0 <- perimeter(poly0)
    mat <- pairdist(data0)
    qq  <- cbind(which(mat == max(mat)[1], arr.ind = TRUE)[1,])
    q   <- as.numeric(qq)
    x1  <- x[q[1]]
    y1  <- y[q[1]]
    x2  <- x[q[2]]
    y2  <- y[q[2]]

    if (is.null(dev.angle)) {
      xx <- x - x2
      yy <- y - y2
      x1 <- x1 - x2
      y1 <- y1 - y2
      x2 <- x2 - x2
      y2 <- y2 - y2
      z  <- sqrt((y2 - y1)^2 + (x2 - x1)^2)
      theta <- acos((x1 - x2)/z)%%(2 * pi)
      x.new <- xx * cos(theta) + yy * sin(theta)
      y.new <- yy * cos(theta) - xx * sin(theta)
      xmin  <- min(x.new)
      ymean <- mean(y.new)
      x.new <- x.new - xmin
      y.new <- y.new - ymean
      length0 <- max(x.new) - min(x.new)
      Index1 <- which.max(y.new)
      Index2 <- which.min(y.new)
      x.mb   <- (x.new[Index1]+x.new[Index2])/2
      if(x.mb > length0/2){         
        xT    <- x.new * cos(pi) + y.new * sin(pi)
        yT    <- y.new * cos(pi) - x.new * sin(pi)
        x.new <- xT
        y.new <- yT
        theta <- (theta + pi) %% (2 * pi)
        x.new <- x.new - min(x.new)
      }
      x.max <- max(x.new)
      x.min <- min(x.new)
      y.max <- max(y.new)
      y.min <- min(y.new)
      upper.win <- owin(c(x.min, x.max), c(0, y.max))
      lower.win <- owin(c(x.min, x.max), c(y.min, 0))
      total.poly <- as.polygonal(owin(poly = list(x = x.new, y = y.new)))
      poly1 <- intersect.owin(upper.win, total.poly)
      poly2 <- intersect.owin(lower.win, total.poly)
      n <- nrow(data.frame(total.poly))
      n1 <- nrow(data.frame(poly1))
      n2 <- nrow(data.frame(poly2))
      upper.area <- area.owin(poly1)
      lower.area <- area.owin(poly2)
      area0 <- area.owin(union.owin(poly1, poly2))
      y.max <- max(c(abs(y.max), abs(y.min)))[1]
      x.pred <- seq(x.min, x.max, len = (strip.num + 1))
      part.upper.area <- c()
      part.lower.area <- c()
      widt  <- c()
      xmean <- c()
      for (j in 2:(strip.num + 1)) {
        x.temp <- c(x.pred[j - 1], x.pred[j])
        um.win <- owin(x.temp, c(0, y.max))
        lm.win <- owin(x.temp, c(-y.max, 0))
        m.area <- area.owin(um.win)
        u.conv <- setminus.owin(um.win, poly1)
        u.area <- m.area - area.owin(u.conv)
        l.conv <- setminus.owin(lm.win, poly2)
        l.area <- m.area - area.owin(l.conv)
        part.upper.area <- c(part.upper.area, u.area)
        part.lower.area <- c(part.lower.area, l.area)
        h1 <- NULL
        h2 <- NULL
        h1 <- try(intersect.owin(um.win, poly1), silent = TRUE)
        h2 <- try(intersect.owin(lm.win, poly2), silent = TRUE)
        g1 <- class(h1)
        g2 <- class(h2)
        if (g1 == "owin" & g2 == "owin") {
            temp.u <- max(h1$y)[1]
            temp.l <- min(h2$y)[1]
            if (is.empty(h1)) 
                temp.u <- 0
            if (is.empty(h2)) 
                temp.l <- 0
            widt <- c(widt, temp.u - temp.l)
            xmean <- c(xmean, (x.pred[j - 1] + x.pred[j])/2)
        }
      }
      D       <- part.upper.area - part.lower.area
      xmean   <- xmean[!is.na(widt)]
      widt    <- widt[!is.na(widt)]
      width0  <- max(widt)[1]
      A0      <- length0
      B0      <- width0
      A1      <- A0/2
      A2      <- A0 * 3/4
      ind1    <- which.max(widt)
      C0      <- abs(xmean[ind1] - A0/2)
      temp2   <- abs(A2 - xmean)
      ind2    <- which.min(temp2)
      D0      <- widt[ind2]
      ini.val <- ini.C
      mat     <- matrix(NA, nrow = length(ini.val), ncol = 2)
      obj.fun <- function(v) {
        Par0   <- c(A0, B0, v, D0)
        z0     <- x.new - A0/2
        Ind1   <- which(y.new >= 0)
        Ind2   <- which(y.new < 0)
        xv1    <- z0[Ind1]
        yv1    <- y.new[Ind1]
        ypred1 <- NRGE(Par0, xv1)
        xv2    <- z0[Ind2]
        yv2    <- y.new[Ind2]
        ypred2 <- -NRGE(Par0, xv2)
        RSS0   <- sum((yv1 - ypred1)^2) + sum((yv2 - ypred2)^2)
        return(RSS0)
      }
      for (i in 1:length(ini.val)) {
        res <- optim(ini.val[i], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
      }
      colnames(mat) <- c("w", "RSS")
      ind    <- which(mat[, 2] == min(mat[, 2])[1])[1]
      par    <- as.vector(mat[ind, 1])
      C0     <- par[1]
      Par0   <- c(A0, B0, C0, D0)
      z0     <- x.new - A0/2
      Ind1   <- which(y.new >= 0)
      Ind2   <- which(y.new < 0)
      xv1    <- z0[Ind1]
      yv1    <- y.new[Ind1]
      ypred1 <- NRGE(P = Par0, x = xv1)
      xv2    <- z0[Ind2]
      yv2    <- y.new[Ind2]
      ypred2 <- -NRGE(P = Par0, x = xv2)
      Ind3   <- sort(xv1, decreasing = TRUE, index.return = TRUE)$ix
      Ind4   <- sort(xv2, decreasing = FALSE, index.return = TRUE)$ix
      x.obs  <- c(xv1[Ind3], xv2[Ind4])
      y.obs  <- c(yv1[Ind3], yv2[Ind4])
      y.pred <- c(ypred1[Ind3], ypred2[Ind4])
      RSS0   <- sum((y.obs - y.pred)^2)
      RMSE0  <- sqrt(RSS0/length(y.obs))
    }

    if (!is.null(dev.angle)) {
      xx <- x - x2
      yy <- y - y2
      x1 <- x1 - x2
      y1 <- y1 - y2
      x2 <- x2 - x2
      y2 <- y2 - y2
      z  <- sqrt((y2 - y1)^2 + (x2 - x1)^2)
      theta <- acos((x1 - x2)/z)%%(2 * pi)     
      RSSV <- c()
      AngleTotal <- length(dev.angle) + 1
      for(i in 1:length(dev.angle)){
        print(paste("Progress: ", i, "/", AngleTotal, sep=""))
        epsilon <- dev.angle[i]
        x.new <- xx * cos(theta+epsilon) + yy * sin(theta+epsilon)
        y.new <- yy * cos(theta+epsilon) - xx * sin(theta+epsilon)
        xmin  <- min(x.new)
        ymean <- mean(y.new)
        x.new <- x.new - xmin
        y.new <- y.new - ymean
        length0 <- max(x.new) - min(x.new)
        Index1 <- which.max(y.new)
        Index2 <- which.min(y.new)
        x.mb   <- (x.new[Index1]+x.new[Index2])/2
        if(x.mb > length0/2){         
          xT    <- x.new * cos(pi) + y.new * sin(pi)
          yT    <- y.new * cos(pi) - x.new * sin(pi)
          x.new <- xT
          y.new <- yT
          theta <- (theta + pi) %% (2 * pi)
          x.new <- x.new - min(x.new)
        }
        x.max <- max(x.new)
        x.min <- min(x.new)
        y.max <- max(y.new)
        y.min <- min(y.new)
        upper.win <- owin(c(x.min, x.max), c(0, y.max))
        lower.win <- owin(c(x.min, x.max), c(y.min, 0))
        total.poly <- as.polygonal(owin(poly = list(x = x.new, y = y.new)))
        poly1 <- intersect.owin(upper.win, total.poly)
        poly2 <- intersect.owin(lower.win, total.poly)
        n <- nrow(data.frame(total.poly))
        n1 <- nrow(data.frame(poly1))
        n2 <- nrow(data.frame(poly2))
        upper.area <- area.owin(poly1)
        lower.area <- area.owin(poly2)
        area0 <- area.owin(union.owin(poly1, poly2))
        y.max <- max(c(abs(y.max), abs(y.min)))[1]
        x.pred <- seq(x.min, x.max, len = (strip.num + 1))
        part.upper.area <- c()
        part.lower.area <- c()
        widt  <- c()
        xmean <- c()
        for (j in 2:(strip.num + 1)) {
          x.temp <- c(x.pred[j - 1], x.pred[j])
          um.win <- owin(x.temp, c(0, y.max))
          lm.win <- owin(x.temp, c(-y.max, 0))
          m.area <- area.owin(um.win)
          u.conv <- setminus.owin(um.win, poly1)
          u.area <- m.area - area.owin(u.conv)
          l.conv <- setminus.owin(lm.win, poly2)
          l.area <- m.area - area.owin(l.conv)
          part.upper.area <- c(part.upper.area, u.area)
          part.lower.area <- c(part.lower.area, l.area)
          h1 <- NULL
          h2 <- NULL
          h1 <- try(intersect.owin(um.win, poly1), silent = TRUE)
          h2 <- try(intersect.owin(lm.win, poly2), silent = TRUE)
          g1 <- class(h1)
          g2 <- class(h2)
          if (g1 == "owin" & g2 == "owin") {
            temp.u <- max(h1$y)[1]
            temp.l <- min(h2$y)[1]
            if (is.empty(h1)) 
                temp.u <- 0
            if (is.empty(h2)) 
                temp.l <- 0
            widt <- c(widt, temp.u - temp.l)
            xmean <- c(xmean, (x.pred[j - 1] + x.pred[j])/2)
          }
        }
        D       <- part.upper.area - part.lower.area
        xmean   <- xmean[!is.na(widt)]
        widt    <- widt[!is.na(widt)]
        width0  <- max(widt)[1]
        A0      <- length0
        B0      <- width0
        A1      <- A0/2
        A2      <- A0 * 3/4
        ind1    <- which.max(widt)
        C0      <- abs(xmean[ind1] - A0/2)
        temp2   <- abs(A2 - xmean)
        ind2    <- which.min(temp2)
        D0      <- widt[ind2]
        ini.val <- ini.C
        mat     <- matrix(NA, nrow = length(ini.val), ncol = 2)
        obj.fun <- function(v) {
          Par0   <- c(A0, B0, v, D0)
          z0     <- x.new - A0/2
          Ind1   <- which(y.new >= 0)
          Ind2   <- which(y.new < 0)
          xv1    <- z0[Ind1]
          yv1    <- y.new[Ind1]
          ypred1 <- NRGE(Par0, xv1)
          xv2    <- z0[Ind2]
          yv2    <- y.new[Ind2]
          ypred2 <- -NRGE(Par0, xv2)
          RSS0   <- sum((yv1 - ypred1)^2) + sum((yv2 - ypred2)^2)
          return(RSS0)
        }
        for (i in 1:length(ini.val)) {
          res <- optim(ini.val[i], obj.fun, control = control)            
          mat[i, ] <- c(res$par, res$val)
        }
        colnames(mat) <- c("w", "RSS")
        ind    <- which(mat[, 2] == min(mat[, 2])[1])[1]
        par    <- as.vector(mat[ind, 1])
        C0     <- par[1]
        Par0   <- c(A0, B0, C0, D0)
        z0     <- x.new - A0/2
        Ind1   <- which(y.new >= 0)
        Ind2   <- which(y.new < 0)
        xv1    <- z0[Ind1]
        yv1    <- y.new[Ind1]
        ypred1 <- NRGE(P = Par0, x = xv1)
        xv2    <- z0[Ind2]
        yv2    <- y.new[Ind2]
        ypred2 <- -NRGE(P = Par0, x = xv2)
        Ind3   <- sort(xv1, decreasing = TRUE, index.return = TRUE)$ix
        Ind4   <- sort(xv2, decreasing = FALSE, index.return = TRUE)$ix
        x.obs  <- c(xv1[Ind3], xv2[Ind4])
        y.obs  <- c(yv1[Ind3], yv2[Ind4])
        y.pred <- c(ypred1[Ind3], ypred2[Ind4])
        RSS0   <- sum((y.obs - y.pred)^2)
        RMSE0  <- sqrt(RSS0/length(y.obs))
        RSSV   <- c(RSSV, RSS0)  
      }
      print(paste("Progress: ", AngleTotal, "/", AngleTotal, sep=""))
      Ind0     <- which.min(RSSV)[1]
      epsilon0 <- dev.angle[Ind0]
      x.new    <- xx * cos(theta+epsilon0) + yy * sin(theta+epsilon0)
      y.new    <- yy * cos(theta+epsilon0) - xx * sin(theta+epsilon0)
      xmin  <- min(x.new)
      ymean <- mean(y.new)
      x.new <- x.new - xmin
      y.new <- y.new - ymean
      length0 <- max(x.new) - min(x.new)
      Index1 <- which.max(y.new)
      Index2 <- which.min(y.new)
      x.mb   <- (x.new[Index1]+x.new[Index2])/2
      if(x.mb > length0/2){         
        xT    <- x.new * cos(pi) + y.new * sin(pi)
        yT    <- y.new * cos(pi) - x.new * sin(pi)
        x.new <- xT
        y.new <- yT
        theta <- (theta + pi) %% (2 * pi)
        x.new <- x.new - min(x.new)
      }
      x.max <- max(x.new)
      x.min <- min(x.new)
      y.max <- max(y.new)
      y.min <- min(y.new)
      upper.win <- owin(c(x.min, x.max), c(0, y.max))
      lower.win <- owin(c(x.min, x.max), c(y.min, 0))
      total.poly <- as.polygonal(owin(poly = list(x = x.new, y = y.new)))
      poly1 <- intersect.owin(upper.win, total.poly)
      poly2 <- intersect.owin(lower.win, total.poly)
      n  <- nrow(data.frame(total.poly))
      n1 <- nrow(data.frame(poly1))
      n2 <- nrow(data.frame(poly2))
      upper.area <- area.owin(poly1)
      lower.area <- area.owin(poly2)
      area0 <- area.owin(union.owin(poly1, poly2))
      y.max <- max(c(abs(y.max), abs(y.min)))[1]
      x.pred <- seq(x.min, x.max, len = (strip.num + 1))
      part.upper.area <- c()
      part.lower.area <- c()
      widt  <- c()
      xmean <- c()
      for (j in 2:(strip.num + 1)) {
        x.temp <- c(x.pred[j - 1], x.pred[j])
        um.win <- owin(x.temp, c(0, y.max))
        lm.win <- owin(x.temp, c(-y.max, 0))
        m.area <- area.owin(um.win)
        u.conv <- setminus.owin(um.win, poly1)
        u.area <- m.area - area.owin(u.conv)
        l.conv <- setminus.owin(lm.win, poly2)
        l.area <- m.area - area.owin(l.conv)
        part.upper.area <- c(part.upper.area, u.area)
        part.lower.area <- c(part.lower.area, l.area)
        h1 <- NULL
        h2 <- NULL
        h1 <- try(intersect.owin(um.win, poly1), silent = TRUE)
        h2 <- try(intersect.owin(lm.win, poly2), silent = TRUE)
        g1 <- class(h1)
        g2 <- class(h2)
        if (g1 == "owin" & g2 == "owin") {
            temp.u <- max(h1$y)[1]
            temp.l <- min(h2$y)[1]
            if (is.empty(h1)) 
                temp.u <- 0
            if (is.empty(h2)) 
                temp.l <- 0
            widt <- c(widt, temp.u - temp.l)
            xmean <- c(xmean, (x.pred[j - 1] + x.pred[j])/2)
        }
      }
      D       <- part.upper.area - part.lower.area
      xmean   <- xmean[!is.na(widt)]
      widt    <- widt[!is.na(widt)]
      width0  <- max(widt)[1]
      A0      <- length0
      B0      <- width0
      A1      <- A0/2
      A2      <- A0 * 3/4
      ind1    <- which.max(widt)
      C0      <- abs(xmean[ind1] - A0/2)
      temp2   <- abs(A2 - xmean)
      ind2    <- which.min(temp2)
      D0      <- widt[ind2]
      ini.val <- ini.C
      mat     <- matrix(NA, nrow = length(ini.val), ncol = 2)
      obj.fun <- function(v) {
        Par0   <- c(A0, B0, v, D0)
        z0     <- x.new - A0/2
        Ind1   <- which(y.new >= 0)
        Ind2   <- which(y.new < 0)
        xv1    <- z0[Ind1]
        yv1    <- y.new[Ind1]
        ypred1 <- NRGE(Par0, xv1)
        xv2    <- z0[Ind2]
        yv2    <- y.new[Ind2]
        ypred2 <- -NRGE(Par0, xv2)
        RSS0   <- sum((yv1 - ypred1)^2) + sum((yv2 - ypred2)^2)
        return(RSS0)
      }
      for (i in 1:length(ini.val)) {
        res <- optim(ini.val[i], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
      }
      colnames(mat) <- c("w", "RSS")
      ind    <- which(mat[, 2] == min(mat[, 2])[1])[1]
      par    <- as.vector(mat[ind, 1])
      C0     <- par[1]
      Par0   <- c(A0, B0, C0, D0)
      z0     <- x.new - A0/2
      Ind1   <- which(y.new >= 0)
      Ind2   <- which(y.new < 0)
      xv1    <- z0[Ind1]
      yv1    <- y.new[Ind1]
      ypred1 <- NRGE(P = Par0, x = xv1)
      xv2    <- z0[Ind2]
      yv2    <- y.new[Ind2]
      ypred2 <- -NRGE(P = Par0, x = xv2)
      Ind3   <- sort(xv1, decreasing = TRUE, index.return = TRUE)$ix
      Ind4   <- sort(xv2, decreasing = FALSE, index.return = TRUE)$ix
      x.obs  <- c(xv1[Ind3], xv2[Ind4])
      y.obs  <- c(yv1[Ind3], yv2[Ind4])
      y.pred <- c(ypred1[Ind3], ypred2[Ind4])
      RSS0   <- sum((y.obs - y.pred)^2)
      RMSE0  <- sqrt(RSS0/length(y.obs))
    }

    Resu <- curveNRGE(P = c(0, 0, 0, Par0), np = np, fig.opt = F)
    x.theor <- Resu$x
    y.theor <- Resu$y
    if (!is.null(unit)) {
        xlabel <- bquote(paste(italic("x"), " (", .(unit), ")", 
            sep = ""))
        ylabel <- bquote(paste(italic("y"), " (", .(unit), ")", 
            sep = ""))
    }
    if (is.null(unit)) {
        xlabel <- bquote(italic("x"))
        ylabel <- bquote(italic("y"))
    }
    if (is.null(xlim)) 
        xlim <- NULL
    if (is.null(ylim)) 
        ylim <- NULL
    if (!is.null(xlim)) 
        xlim <- xlim
    if (!is.null(ylim)) 
        ylim <- ylim
    if (fig.opt == "TRUE" | fig.opt == "T" | fig.opt == "True") {
        dev.new()
        plot(z0, y.new, asp = 1, col = "grey50", lwd = 2, xlab = xlabel, 
            ylab = ylabel, xlim = xlim, ylim = ylim, cex.lab = 1.5, 
            cex.axis = 1.5, type = "l")
        lines(x.theor, y.theor, col = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        text(0, 0, bquote(paste("RMSE = ", .(round(RMSE0, 4)), 
            sep = "")), pos = NULL, cex = 1.5, col = 1)
    }
   if (is.null(dev.angle)){
      Res <- list(theta = theta, x.obs = x.obs, y.obs = y.obs, y.pred = y.pred, 
        par = c(A0, B0, C0, D0), scan.length = length0, scan.width = width0, 
        scan.area = area0, scan.perimeter = perimeter0, RSS = RSS0, 
        sample.size = length(y.new), RMSE = sqrt(RSS0/length(y.new)))
   }
   if (!is.null(dev.angle)){
      Res <- list(theta = theta, epsilon = epsilon0, RSS.vector = RSSV, 
        x.obs = x.obs, y.obs = y.obs, y.pred = y.pred, 
        par = c(A0, B0, C0, D0), scan.length = length0, scan.width = width0, 
        scan.area = area0, scan.perimeter = perimeter0, RSS = RSS0, 
        sample.size = length(y.new), RMSE = sqrt(RSS0/length(y.new)))
   }
   options(warn=0)
   return( Res )
}

curveNRGE <- function(P, np = 5000, fig.opt = FALSE, deform.fun = NULL, 
    Par = NULL, xlim = NULL, ylim = NULL, unit = NULL, main = ""){

  if( length(P)!=7) stop("There are seven elements in P!" )  
    if ((is.null(deform.fun) & !is.null(Par)) | (!is.null(deform.fun) & 
        is.null(Par))) 
        stop("'Par' should be provided when 'deform.fun' is not null.")

    x0    <- P[1]
    y0    <- P[2]
    theta <- P[3]
    npar  <- length(P)
    if(np %% 2 == 1) np <- np + 1
    xU    <- seq(P[4]/2, -P[4]/2, len = np/2)
    yU    <- NRGE(P = P[4:npar], x = xU)
    xL    <- seq(-P[4]/2, P[4]/2, len = np/2)
    yL    <- -NRGE(P = P[4:npar], x = xL)
    x     <- c(xU, xL)
    y     <- c(yU, yL)

    if (!is.null(deform.fun)) {
        Resu <- deform.fun(Par = Par, z = cbind(x, y))
        x <- Resu$x
        y <- Resu$y
    }
    x.rot    <- x * cos(theta) - y * sin(theta)
    y.rot    <- y * cos(theta) + x * sin(theta)
    r.rot    <- sqrt(x.rot^2 + y.rot^2)
    x.coordi <- x.rot + x0
    y.coordi <- y.rot + y0
    if (fig.opt == "T" | fig.opt == "TRUE") {
        if (is.null(xlim)) 
            xlim <- NULL
        if (is.null(ylim)) 
            ylim <- NULL
        if (!is.null(xlim)) 
            xlim <- xlim
        if (!is.null(ylim)) 
            ylim <- ylim
        if (!is.null(unit)) {
            xlabel <- bquote(paste(italic("x"), " (", .(unit), 
                ")", sep = ""))
            ylabel <- bquote(paste(italic("y"), " (", .(unit), 
                ")", sep = ""))
        }
        if (is.null(unit)) {
            xlabel <- bquote(italic("x"))
            ylabel <- bquote(italic("y"))
        }
        dev.new()
        plot(x.coordi, y.coordi, asp = 1, xlab = xlabel, ylab = ylabel, 
            pch = 1, cex = 2, cex.lab = 1.5, cex.axis = 1.5, 
            type = "l", lwd = 2, xlim = xlim, ylim = ylim)
        abline(h = y0, lty = 2, col = 4)
        abline(v = x0, lty = 2, col = 4)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        xu <- P[4]/2
        yu <- NRGE(P = P[4:npar], x = xu)
        if (!is.null(deform.fun)) {
            Right <- deform.fun(Par = Par, z = cbind(xu, yu))
            xu <- Right$x
            yu <- Right$y
        }
        xv <- xu * cos(theta) - yu * sin(theta)
        yv <- yu * cos(theta) + xu * sin(theta)
        xv <- xv + x0
        yv <- yv + y0
        temp <- xv - x0
        if (temp != 0) {
            slope <- (yv - y0)/(xv - x0)
            abline(-slope * x0 + y0, slope, col = 1, lty = 2)
        }
        if (temp == 0) {
            abline(v = x0, col = 1, lty = 2)
        }
        points(x0, y0, cex = 2, pch = 16, col = 2)
        points(xv, yv, cex = 2, pch = 1, col = 4)
    }
    list(x = x.coordi, y = y.coordi)
}

PlanCoor <- function( folder.name, lower.val = 0, upper.val = 250, ratio = 1,  
                fig.opt = TRUE, np = NULL, unit = "unitless", verbose = TRUE ){

  if(!is.null(np) & !is.numeric(np)) 
    stop("'np' should be a integer or NULL!")
  if(!is.null(np) & is.numeric(np)){ 
    if(np <= 0)
      stop("'np' should be a positive integer!")
  }

  if(!is.character(folder.name))
    stop("'folder.name' should be an object of type 'character'!")

  files    <- list.files(folder.name) 
  U        <- length(files)
  FileName <- c()
  x_vec    <- c()
  y_vec    <- c()

  for(counter in 1:U){
    if(verbose){
      print(paste("The current progress is ", counter, "/", U, sep=""))
    }
    x.fig  <- files[counter]
    y.fig  <- substr(x.fig, 1, nchar(x.fig)-4)
    Format <- substr(x.fig, nchar(x.fig)-2, nchar(x.fig))
    Format <- tolower(Format)
    if( Format != "bmp" )
      stop("All files in this folder should be grayscale .bmp files!")
    if( Format == "bmp" ){
      suppressWarnings({
        mat <- read.bmp( paste(folder.name, "/", files[counter], sep="") )
      })
    }

    #### To convert arrays of pixel data between different display conventions ####
    smat <- transmat(mat, from="European", to="spatstat")
    ###############################################################################

    temp.w   <- ncol(mat)
    temp.h   <- nrow(mat)

    Width    <- temp.w/(attr(mat, "header")$hres/100) * ratio
    Height   <- temp.h/(attr(mat, "header")$vres/100) * ratio

    vim <- im( smat, xrange=c(0, Width), yrange=c(0, Height),
               unitname=unit )
    xlabel <- bquote( paste(italic(x), " (", .(unit), ")", sep="") ) 
    ylabel <- bquote( paste(italic(y), " (", .(unit), ")", sep="") )

    X   <- data.frame(vim)
    x1  <- X$x
    y1  <- X$y
    z1  <- X$value  
    ind <- z1 >= lower.val & z1 <= upper.val

    x   <- x1[ind]
    y   <- y1[ind]
    z   <- z1[ind]

    if(!is.null(np)){
      if(length(x) > np){
          ind2 <- sample(1:length(x), np, replace=FALSE)
          x <- x[ind2]
          y <- y[ind2]
      }
    }

    if( fig.opt == "TRUE" ){
      dev.new()
      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )
      par(family="serif")
      plot( vim, cex.lab=1.5, cex.axis=1.5, main="", axes=TRUE )
      mtext(xlabel, side = 1, line = 2, cex=1.5)
      mtext(ylabel, side = 2, line = 2, cex=1.5)
      title(main=y.fig, cex.main=1.5, col.main=4)

      dev.new()
      par( mar=c(5, 5, 2, 2) )
      par( mgp=c(3.5, 1, 0) )
      par(family="serif")
      plot( x, y, asp=1, cex.lab=1.5, cex.axis=1.5, main="", 
            xlab=xlabel, ylab=ylabel, xlim=c(0, Width), ylim=c(0, Height) )
      title(main=y.fig, cex.main=1.5, col.main=4)
    }
  
    x_vec    <- c(x_vec, x)
    y_vec    <- c(y_vec, y)
    FileName <- c(FileName, rep(y.fig, len=length(x))) 

  }

  return( list(FileName=FileName, x=x_vec, y=y_vec) )
}

VolumeAM <- function(model = "Hybrid", P, upper = Inf, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL){


  if(!(model %in% c("Hybrid", "Superparabola"))){
    stop("'model' only can be 'Hybrid' or 'Superparabola' here!")
  }

  if(model == "Hybrid"){
    p <- length(P)
 
    if(p != 3) 
      stop("There are three model parameters for the hybrid catenary-parabolic equation!")

    alpha <- P[1]
    beta  <- P[2]
    gamma <- P[3]
 
    Hybrid <- function(x){
      alpha * cosh(beta*x) + gamma*x^2 - alpha
    } 

    inner.fun <- function(x){
      2 * pi * abs(x * Hybrid(x))     
    }

    temp <- integrate( inner.fun, lower=0, upper=upper, subdivisions = subdivisions,
               rel.tol = rel.tol, abs.tol = abs.tol,
               stop.on.error = stop.on.error, keep.xy = keep.xy, aux = aux )$value

    if( Hybrid(upper) > Hybrid(0) )
        return( pi * upper^2 * Hybrid(upper) - as.numeric( temp ) )
    if( Hybrid(upper) < Hybrid(0) )
        return( as.numeric( temp ) )
    if( Hybrid(upper) == Hybrid(0) )
        return(0)
  }

  if(model == "Superparabola"){
    p <- length(P)
 
    if(p != 2) 
      stop("There are two model parameters for the superparabolic equation!")

    beta1 <- P[1]
    beta2 <- P[2]

    Superparabola <- function(x){
      beta1 * abs(x)^beta2
    }
 
    inner.fun <- function(x){
      2 * pi * abs(x * Superparabola(x))      
    }

    temp <- integrate( inner.fun, lower=0, upper=upper, subdivisions = subdivisions,
               rel.tol = rel.tol, abs.tol = abs.tol,
               stop.on.error = stop.on.error, keep.xy = keep.xy, aux = aux )$value

    

    if( Superparabola(upper) > Superparabola(0) )
        return( pi * upper^2 * Superparabola(upper) - as.numeric( temp ) )
    if( Superparabola(upper) < Superparabola(0) )
        return( as.numeric( temp ) )
    if( Superparabola(upper) == Superparabola(0) )
        return(0)
  }

}

fitSuper <- function (x, y, ini.val,  
    control = list(), par.list = FALSE, stand.fig = TRUE, angle = NULL, 
    fig.opt = FALSE, np = 2000, xlim = NULL, ylim = NULL, unit = NULL, 
    main = NULL){
    if (length(x) != length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x <- Tem[, 1]
    y <- Tem[, 2]
    ini.val <- as.list(ini.val)
    p <- length(ini.val)
    s <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat <- matrix(NA, nrow = s, ncol = (p + 1))
    x.obs <- x
    y.obs <- y
    obj.fun <- function(z) {
        x0 <- z[1]
        y0 <- z[2]
        theta <- z[3]
        x.obs <- x.obs - x0
        y.obs <- y.obs - y0
        x.temp <- x.obs * cos(theta) + y.obs * sin(theta)
        y.temp <- y.obs * cos(theta) - x.obs * sin(theta)
        x.obs <- x.temp
        y.obs <- y.temp
        r.obs <- sqrt(x.obs^2 + y.obs^2)
        phi.obs <- acos(x.obs/r.obs)
        cond1 <- y.obs >= 0
        cond2 <- y.obs < 0
        xx1 <- x.obs[cond1]
        xx2 <- x.obs[cond2]
        yy1 <- y.obs[cond1]
        yy2 <- y.obs[cond2]
        phi1 <- phi.obs[cond1]
        phi2 <- 2 * pi - phi.obs[cond2]
        phi.obs <- c(phi1, phi2)
        x.obs <- c(xx1, xx2)
        y.obs <- c(yy1, yy2)
        resu <- sort(phi.obs, decreasing = FALSE, index.return = T)
        phi.obs <- resu$x
        Index <- resu$ix
        x.obs <- x.obs[Index]
        y.obs <- y.obs[Index]
        r.obs <- sqrt(x.obs^2 + y.obs^2)
        r.theo <- GE(P = z[4:p], phi = phi.obs, m = 4, simpver = 9)
        x.theo <- r.theo * cos(phi.obs)
        y.theo <- r.theo * sin(phi.obs)
        temp   <- sum((r.obs - r.theo)^2)
        if(z[5] > 1 | z[5] < 0) temp <- Inf    
        return(temp)
    }
    for (i in 1:nrow(ini.val)) {
        res <- optim(ini.val[i, ], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
    }
    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")
    ind <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    par <- as.vector(mat[ind, 1:p])
    if (par[3] > 2 * pi) {
        par[3] <- par[3]%%(2 * pi)
    }
    if (par[3] < -2 * pi) {
        par[3] <- -((-par[3])%%(2 * pi))
    }
    goal.x0 <- par[1]
    goal.y0 <- par[2]
    goal.theta <- par[3]
    x.obs <- x - goal.x0
    y.obs <- y - goal.y0
    x.new <- x.obs * cos(goal.theta) + y.obs * sin(goal.theta)
    y.new <- y.obs * cos(goal.theta) - x.obs * sin(goal.theta)
    x.obs <- x.new
    y.obs <- y.new
    r.obs <- sqrt(x.obs^2 + y.obs^2)
    phi.obs <- acos(x.obs/r.obs)
    cond1 <- y.obs >= 0
    cond2 <- y.obs < 0
    xx1  <- x.obs[cond1]
    xx2  <- x.obs[cond2]
    yy1  <- y.obs[cond1]
    yy2  <- y.obs[cond2]
    phi1 <- phi.obs[cond1]
    phi2 <- 2 * pi - phi.obs[cond2]
    phi.obs <- c(phi1, phi2)
    x.obs <- c(xx1, xx2)
    y.obs <- c(yy1, yy2)
    resu  <- sort(phi.obs, decreasing = FALSE, index.return = T)
    phi.obs <- resu$x
    Index <- resu$ix
    x.obs <- x.obs[Index]
    y.obs <- y.obs[Index]
    r.obs <- sqrt(x.obs^2 + y.obs^2)
    x1 <- x.obs
    y1 <- y.obs
    poly0 <- as.polygonal(owin(poly = list(x = x1, y = y1)))
    Area  <- area(poly0)
    Perimeter <- perimeter(poly0)
    r.theo <- GE(par[4:p], phi = phi.obs, m = 4, simpver = 9)
    x.theo <- r.theo * cos(phi.obs)
    y.theo <- r.theo * sin(phi.obs)
    x2 <- x.theo
    y2 <- y.theo
    phiA <- phi.obs
    phi.arr <- seq(0, 2 * pi, len = np)
    if (is.null(angle)) {
        results <- curveGE(GE, P = par, phi = phi.obs, m = 4, 
                           simpver = 9)
        results2 <- curveGE(GE, P = par, phi = phi.arr, m = 4, 
                            simpver = 9)
        x.new <- x1 * cos(goal.theta) - y1 * sin(goal.theta) + 
            par[1]
        y.new <- y1 * cos(goal.theta) + x1 * sin(goal.theta) + 
            par[2]
        r.new <- sqrt((x.new - par[1])^2 + (y.new - par[2])^2)
        phiB <- phiA + goal.theta
    }
    if (!is.null(angle)) {
        par.new <- par
        par.new[3] <- angle
        results <- curveGE(GE, P = par.new, phi = phi.obs, 
                           m = 4, simpver = 9)
        results2 <- curveGE(GE, P = par.new, phi = phi.arr, 
                            m = 4, simpver = 9)
        x.new <- x1 * cos(angle) - y1 * sin(angle) + par.new[1]
        y.new <- y1 * cos(angle) + x1 * sin(angle) + par.new[2]
        r.new <- sqrt((x.new - par.new[1])^2 + (y.new - par.new[2])^2)
        phiB <- phiA + angle
    }
    if (is.null(xlim)) 
        xlim <- NULL
    if (is.null(ylim)) 
        ylim <- NULL
    if (!is.null(xlim)) 
        xlim <- xlim
    if (!is.null(ylim)) 
        ylim <- ylim
    if (!is.null(unit)) {
        xlabel <- bquote(paste(italic("x"), " (", .(unit), ")", 
            sep = ""))
        ylabel <- bquote(paste(italic("y"), " (", .(unit), ")", 
            sep = ""))
    }
    if (is.null(unit)) {
        xlabel <- bquote(italic("x"))
        ylabel <- bquote(italic("y"))
    }
    if (stand.fig == "T" | stand.fig == "TRUE" | stand.fig == 
        "True") {
        dev.new()
        plot(x1, y1, xlab = xlabel, ylab = ylabel, cex.lab = 1.5, 
            cex.axis = 1.5, type = "l", lwd = 3, col = "grey50", 
            asp = 1)
        lines(x2, y2, col = 2, lwd = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        abline(h = 0, lty = 2, col = 4)
        abline(v = 0, lty = 2, col = 4)
    }
    if (fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True") {
        if (is.null(angle)) {
            dev.new()
            plot(x.new, y.new, xlab = xlabel, ylab = ylabel, 
                type = "l", cex.lab = 1.5, cex.axis = 1.5, col = "grey50", 
                lwd = 3, asp = 1, xlim = xlim, ylim = ylim)
            lines(results2$x, results2$y, type = "l", asp = 1, 
                col = 2, lwd = 2)
            title(main = main, cex.main = 1.5, col.main = 4, 
                font.main = 1)
            if (abs(par[3])%%pi/2 != 0) {
                slope <- tan(par[3])
                abline(-slope * par[1] + par[2], slope, col = 1, 
                  lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
            if (abs(par[3])%%pi/2 == 0) {
                abline(v = par[1], col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
        }
        if (!is.null(angle)) {
            dev.new()
            plot(x.new, y.new, xlab = xlabel, ylab = ylabel, 
                type = "l", cex.lab = 1.5, cex.axis = 1.5, col = "grey50", 
                lwd = 3, asp = 1, xlim = xlim, ylim = ylim)
            lines(results2$x, results2$y, type = "l", asp = 1, 
                col = 2, lwd = 2)
            title(main = main, cex.main = 1.5, col.main = 4, 
                font.main = 1)
            if (abs(par.new[3])%%pi/2 != 0) {
                slope <- tan(par.new[3])
                abline(-slope * par[1] + par[2], slope, col = 1, 
                  lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
            if (abs(par.new[3])%%pi/2 == 0) {
                abline(v = par[1], col = 1, lty = 2)
                abline(v = par[1], col = 4, lty = 2, lwd = 1)
                abline(h = par[2], col = 4, lty = 2, lwd = 1)
            }
        }
    }
    x.range <- range(x1)
    y.range <- range(y1)
    Length  <- x.range[2] - x.range[1]
    Width   <- y.range[2] - y.range[1]
    r1      <- sqrt(x1^2 + y1^2)
    r2      <- sqrt(x2^2 + y2^2)
    RSS     <- sum((r1 - r2)^2)
    r.sq <- 1 - sum((r1 - r2)^2)/sum((r1 - mean(r1))^2)
    para.tab <- data.frame(Parameter = c(Names, "Length", "Width", 
        "r.sq", "RSS", "sample.size"), Estimate = c(par, Length, 
        Width, r.sq, RSS, length(x)))
    if (par.list == "T" | par.list == "TRUE" | par.list == "True") {
        print(para.tab)
        cat("\n")
    }
    return(list(par = par, scan.length = Length, scan.width = Width, 
        scan.area = Area, scan.perimeter = Perimeter, r.sq = r.sq, 
        RSS = RSS, sample.size = length(x), 
        phi.stand.obs = phiA, phi.trans = phiB, r.stand.obs = r1, 
        r.stand.pred = r2, x.stand.obs = x1, x.stand.pred = x2, 
        y.stand.obs = y1, y.stand.pred = y2, r.obs = r.new, r.pred = results$r, 
        x.obs = x.new, x.pred = results$x, y.obs = y.new, y.pred = results$y))
}

TGE <- function(P, phi, m = 1, simpver = NULL, nval = 1){
# Twin Gielis equation
  p <- length(P)
 
  if(is.null(simpver)){
    if(p != 6) 
    stop("The length of 'P' shoud equal 6 for the original TGE version!")
    a        <- P[1]
    b        <- P[2]
    c        <- P[3]
    k        <- P[4] 
    n2       <- P[5]
    n3       <- P[6] 
   }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 5, by=1)) )
  stop("'simpver' should be chosen in versions 1 to 5!")
  
    if(simpver==1){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      b        <- P[2]
      c        <- P[3]
      k        <- 1
      n2       <- P[4]
      n3       <- n2  
    }

    if(simpver==2){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
      if(!is.numeric(nval))
        stop("'nval' should be a number!") 

      a        <- P[1]
      b        <- P[2]
      c        <- P[3]
      k        <- 1
      n2       <- nval
      n3       <- nval  
    }

    if(simpver==3){
      if(p != 5) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      b        <- P[2]
      c        <- P[3]      
      k        <- 1
      n2       <- P[4]
      n3       <- P[5]   
    }


    if(simpver==4){
      if(p != 5) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      b        <- P[2]
      c        <- P[3]   
      k        <- P[4] 
      n2       <- P[5]
      n3       <- n2  
    }

    if(simpver==5){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
      if(!is.numeric(nval))
        stop("'nval' should be a number!") 
      a        <- P[1]
      b        <- P[2]
      c        <- P[3]   
      k        <- P[4] 
      n2       <- nval
      n3       <- nval 
    }

  }

  re  <- (abs(cos(m/4*phi))^n2 + abs(1/k*sin(m/4*phi))^n3)^(-1) 
  r   <- exp( 1/(a+b*log(re)) + c )
  return( r )
}

DETE <- function(P, x){

  if(P[1] <= 0)
    stop("a should be positive real numbers!")
  p <- length(P)
  if(p != 4) 
    stop("The number of parameters should equal 4!")

  x[x < -P[1]] <- -P[1]
  x[x >  P[1]] <- P[1]
  a      <- P[1]
  alpha0 <- P[2]
  alpha1 <- P[3]
  alpha2 <- P[4]
  (alpha1+2*alpha2/a*x-x/a*(1-(x/a)^2)^(-1)) * ETE(P=P, x=x)/a

}

areaGE <- function(expr, P, m = 1, simpver = NULL,  
            nval = 1, subdivisions = 100L,
            rel.tol = .Machine$double.eps^0.25, 
            abs.tol = rel.tol,
            stop.on.error = TRUE, keep.xy = FALSE, 
            aux = NULL){
  
   area.fun <- function(x){
     0.5*(expr(P, x, m=m, simpver=simpver, 
     nval=nval))^2
   } 

   temp <- integrate(area.fun, 0, 2*pi, 
           subdivisions = subdivisions,
           rel.tol = rel.tol, 
           abs.tol = abs.tol,
           stop.on.error = stop.on.error, 
           keep.xy = keep.xy, aux = aux)
   temp$value
}

SurfaceAreaEPE <- function(P, simpver = NULL, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL){

  if(P[1] < 0 | P[2] < 0)
    stop("a and b should be positive real numbers!")

  p <- length(P)
 
  if(is.null(simpver)){
    if(p != 5) 
      stop("The number of parameters is incorrect!")
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 3, by=1)) )
      stop("'simpver' should be chosen in versions 1 to 3!")
  
    if(simpver==1){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
    }

    if(simpver==2){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
    }

    if(simpver==3){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
    }
  }

  inner.fun <- function(x){
    2 * pi * EPE(P=P, x, simpver=simpver) * sqrt( 
      1 + DEPE(P=P, x, simpver=simpver)^2 )
  }

  temp <- integrate( inner.fun, -P[1], P[1], subdivisions = subdivisions,
             rel.tol = rel.tol, abs.tol = abs.tol,
             stop.on.error = stop.on.error, keep.xy = keep.xy, aux = aux )$value
  as.numeric( temp )

}

DSGE <- function(P, phi){

  p <- length(P)
  if(p != 3) 
    stop("The number of parameters should equal 3!")

  a  <- P[1]
  n1 <- P[2]
  n2 <- P[3]
  a/4*n2/n1*(cos(phi/4)^n2 + sin(phi/4)^n2)^(-1/n1-1)*
  ( (cos(phi/4))^(n2-1)*sin(phi/4) - (sin(phi/4))^(n2-1)*cos(phi/4) )
}

fracdim <- function(x, y,  frac.fig = TRUE,
             denomi.range = seq(8, 30, by = 1), 
             ratiox = 0.02, ratioy = 0.08, main = NULL){

    if(length(x)!=length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[,1]
    y   <- Tem[,2]  

    poly1 <- owin(xrange=c(min(x)[1], max(x)[1]), 
                  yrange=c(min(y)[1],max(y)[1]))
    data0 <- ppp(x, y, window=poly1)
    xj    <- x
    yj    <- y 
    # Calculating a fractal dimension
    x.dis <- range(x)[2]-range(x)[1]
    y.dis <- range(y)[2]-range(y)[1]
    L     <- max(x.dis, y.dis)[1]
    xt    <- xj - min(xj)[1] 
    yt    <- yj - min(yj)[1]
    Side     <- L/denomi.range
    k       <- 0
    delta   <- c()
    N       <- c()
    for(i in 1:length(Side)){
      k      <- k + 1
      ndiv   <- L/Side[i]
      W      <- owin(c(0, L), c(0, L))
      Index  <- inside.owin(xt, yt, W)
      xt2    <- xt[Index]
      yt2    <- yt[Index]     
      Z      <- ppp(xt2, yt2, window=W)
      Number <- array( quadratcount(Z, ndiv, ndiv) ) 
      N      <- c(N, length(Number[Number > 0]))
      delta  <- c(delta, Side[i])
    }
    log.x  <- -log(delta)
    log.y  <- log(N)
    resu   <- lm(log.y~log.x)    
    a      <- summary(resu)$coefficients[[1]]
    b      <- summary(resu)$coefficients[[2]]
    sd.a   <- summary(resu)$coefficients[[3]]
    sd.b   <- summary(resu)$coefficients[[4]]
    lci.a  <- confint( resu )[1,1]
    uci.a  <- confint( resu )[1,2]
    lci.b  <- confint( resu )[2,1]
    uci.b  <- confint( resu )[2,2]
    r.sq   <- summary(resu)$r.squared
    x0     <- log.x
    y0     <- log.y
    B  <- min(x0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=0.5)){
      if(B[1] < s + 0.5 & B[1] >= s) u <- s
    }
    B1 <- u
    B  <- max(x0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=0.5)){
      if(B[1] < s + 0.5 & B[1] >= s) u <- s + 0.5
    }
    B2 <- u
    C  <- min(y0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=1)){
      if(C[1] < s + 1 & C[1] >= s) u <- s
    }
    C1 <- u
    C  <- max(y0)[1]
    u  <- NA
    for(s in seq(-100, 100, by=1)){
      if(C[1] < s + 1 & C[1] >= s) u <- s + 1
    }
    C2 <- u
    xlim0    <- c(B1, B2)
    ylim0    <- c(C1, C2) 
    if(B2-B1 < 2.0) xlim0 <- c(B2-2.0, B2)
    if(C2-C1 < 4.0) ylim0 <- c(C2-4.0, C2)


    xloc   <- xlim0[1] + (xlim0[2]-xlim0[1])*ratiox
    yloc   <- ylim0[2] - (ylim0[2]-ylim0[1])*ratioy
    if( frac.fig =="TRUE" | frac.fig == "T" | frac.fig == "True"){
      dev.new()
      plot( log.x, log.y, cex.lab=1.5, cex.axis=1.5, cex=1.5, xaxs="i", yaxs="i",
            xlim=xlim0, ylim=ylim0, las=1,
            xlab=expression(paste("ln ", delta, {""}^{-"1"}, sep="")), 
            ylab=expression(paste("ln ", italic("N"), sep="")) )
      title(main=main, cex.main=1.5, col.main=4, font.main=1)
      abline( resu, col=2 )   
      text(xloc, yloc-0*(ylim0[2]-ylim0[1])/10, bquote( paste(italic("y = "),  
        .(round(a, 3)), " + ", .(round(b, 3)), italic("x"), seq="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-1*(ylim0[2]-ylim0[1])/10, bquote(paste("CI: ", 
        .(round(confint( resu )[2,1], 3)), ", ", .(round(confint( resu )[2,2], 3)),  
        sep="")), pos=4, cex=1.5, col=1)
      text(xloc, yloc-2*(ylim0[2]-ylim0[1])/10, 
        bquote( paste(italic(r), {""}^{"2"}, " = ", 
        .(round(summary(resu)$r.squared, 3)), sep="") ), pos=4, cex=1.5, col=1)   
      text(xloc, yloc-3*(ylim0[2]-ylim0[1])/10, 
        bquote( paste(italic(n), , " = ", .(length(log.x)),
        sep="") ), pos=4, cex=1.5, col=1) 
    }
    list( a=a, sd.a=sd.a, lci.a=lci.a, uci.a=uci.a, b=b, sd.b=sd.b, 
          lci.b=lci.b, uci.b=uci.b, r.sq=r.sq, delta=delta, N=N  ) 
  }

SurfaceAreaETE <- function(P, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL){

  if(P[1] <= 0)
    stop("a should be positive real numbers!")

  p <- length(P)
  if(p != 4) 
    stop("The number of parameters should equal 4!")
 
  inner.fun <- function(x){
    2 * pi * ETE(P=P, x) * sqrt( 
      1 + DETE(P=P, x)^2 )
  }

  temp <- integrate( inner.fun, -P[1], P[1], subdivisions = subdivisions,
             rel.tol = rel.tol, abs.tol = abs.tol,
             stop.on.error = stop.on.error, keep.xy = keep.xy, aux = aux )$value
  as.numeric( temp )
}

fitGE <- function( expr, x, y, ini.val, m = 1, simpver = NULL, 
           nval = nval, control = list(), par.list = FALSE, 
           stand.fig = TRUE, angle = NULL, fig.opt = FALSE, np = 2000,
           xlim = NULL, ylim = NULL, unit = NULL, main = NULL ){

    if(length(x)!=length(y)) 
        stop("'x' should have the same data length as 'y'!")
    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[,1]
    y   <- Tem[,2]  

    ini.val <- as.list(ini.val)
    p       <- length(ini.val)
    s       <- 1
    for (i in 1:p) {
        s <- s * length(ini.val[[i]])
    }
    ini.val <- expand.grid(ini.val)
    mat     <- matrix(NA, nrow = s, ncol = (p + 1))
    x.obs   <- x
    y.obs   <- y

    obj.fun <- function(z){
        x0      <- z[1]
        y0      <- z[2]
        theta   <- z[3]
        x.obs   <- x.obs - x0
        y.obs   <- y.obs - y0
        x.temp  <- x.obs*cos(theta) + y.obs*sin(theta)
        y.temp  <- y.obs*cos(theta) - x.obs*sin(theta)
        x.obs   <- x.temp
        y.obs   <- y.temp
        r.obs   <- sqrt( x.obs^2 + y.obs^2 )
        phi.obs <- acos(x.obs/r.obs)
        cond1   <- y.obs >= 0
        cond2   <- y.obs <  0
        xx1     <- x.obs[cond1]
        xx2     <- x.obs[cond2]     
        yy1     <- y.obs[cond1] 
        yy2     <- y.obs[cond2]  
        phi1    <- phi.obs[cond1]  
        phi2    <- 2*pi - phi.obs[cond2]
        phi.obs <- c(phi1, phi2) 
        x.obs   <- c(xx1, xx2)
        y.obs   <- c(yy1, yy2)
        resu    <- sort(phi.obs, decreasing = FALSE, index.return= T )
        phi.obs <- resu$x
        Index   <- resu$ix
        x.obs   <- x.obs[Index]
        y.obs   <- y.obs[Index]
        r.obs   <- sqrt( x.obs^2 + y.obs^2 )
        r.theo  <- expr(P=z[4:p], phi=phi.obs, m=m, simpver=simpver, nval=nval) 
        x.theo  <- r.theo*cos(phi.obs)
        y.theo  <- r.theo*sin(phi.obs) 
        return( sum( (r.obs - r.theo)^2 ) )       
    }  

    for (i in 1:nrow(ini.val)) {
        res <- optim(ini.val[i, ], obj.fun, control = control)
        mat[i, ] <- c(res$par, res$val)
    }

    Names <- rep(NA, len = p)
    for (k in 1:p) {
        Names[k] <- paste("P[", k, "]", sep = "")
    }
    colnames(mat) <- c(Names, "RSS")

    ind  <- which(mat[, p + 1] == min(mat[, p + 1])[1])[1]
    par  <- as.vector(mat[ind, 1:p])
    #### To solve the issue of abs(theta) > 2*pi ####
    if(par[3] > 2*pi){
        par[3] <- par[3]%%(2*pi)
    }
    if(par[3] < -2*pi){
        par[3] <- -((-par[3])%%(2*pi))
    }
    ##################################################

    goal.x0     <- par[1]
    goal.y0     <- par[2]
    goal.theta  <- par[3]  

    x.obs       <- x - goal.x0
    y.obs       <- y - goal.y0
    x.new       <- x.obs*cos(goal.theta) + y.obs*sin(goal.theta)
    y.new       <- y.obs*cos(goal.theta) - x.obs*sin(goal.theta)
    x.obs       <- x.new
    y.obs       <- y.new 
    r.obs       <- sqrt( x.obs^2 + y.obs^2 )
    phi.obs     <- acos(x.obs/r.obs)
    cond1       <- y.obs >= 0
    cond2       <- y.obs <  0
    xx1         <- x.obs[cond1]
    xx2         <- x.obs[cond2]
    yy1         <- y.obs[cond1] 
    yy2         <- y.obs[cond2]     
    phi1        <- phi.obs[cond1]  
    phi2        <- 2*pi - phi.obs[cond2]
    phi.obs     <- c(phi1, phi2) 
    x.obs       <- c(xx1, xx2)
    y.obs       <- c(yy1, yy2)
    resu        <- sort(phi.obs, decreasing = FALSE, index.return= T )
    phi.obs     <- resu$x
    Index       <- resu$ix
    x.obs       <- x.obs[Index]
    y.obs       <- y.obs[Index]
    r.obs       <- sqrt( x.obs^2 + y.obs^2 )
    x1          <- x.obs
    y1          <- y.obs
    poly0       <- as.polygonal(owin(poly=list(x=x1, y=y1)))
    Area        <- area(poly0)

    r.theo      <- expr(par[4:p], phi=phi.obs, m=m, 
                        simpver=simpver, nval=nval)

    x.theo      <- r.theo*cos(phi.obs)
    y.theo      <- r.theo*sin(phi.obs) 

    x2          <- x.theo
    y2          <- y.theo   
    phiA        <- phi.obs
 
    phi.arr     <- seq(0, 2*pi, len=np)
    if( is.null(angle) ){        
        results  <- curveGE(expr, P=par, phi=phi.obs, m=m, simpver=simpver, nval=nval)
        results2 <- curveGE(expr, P=par, phi=phi.arr, m=m, simpver=simpver, nval=nval)
        x.new   <- x1*cos(goal.theta) - y1*sin(goal.theta) + par[1]
        y.new   <- y1*cos(goal.theta) + x1*sin(goal.theta) + par[2] 
        r.new   <- sqrt((x.new-par[1])^2 + (y.new-par[2])^2)
        phiB    <- phiA + goal.theta        
    }
    if( !is.null(angle) ){        
        par.new    <- par  
        #### The third element of 'par.new' is compulsorily defined as 'angle' ####
        par.new[3] <- angle 
        ###########################################################################
        results  <- curveGE(expr, P=par.new, phi=phi.obs, m=m, simpver=simpver, nval=nval)
        results2 <- curveGE(expr, P=par.new, phi=phi.arr, m=m, simpver=simpver, nval=nval)
        x.new   <- x1*cos(angle) - y1*sin(angle) + par.new[1]
        y.new   <- y1*cos(angle) + x1*sin(angle) + par.new[2] 
        r.new   <- sqrt((x.new-par.new[1])^2 + (y.new-par.new[2])^2)
        phiB    <- phiA + angle 
    }

    if(is.null(xlim)) xlim <- NULL
    if(is.null(ylim)) ylim <- NULL

    if(!is.null(xlim)) xlim <- xlim
    if(!is.null(ylim)) ylim <- ylim
        
    if(!is.null(unit)){
      xlabel <- bquote( paste(italic("x"), " (", .(unit), ")", sep="") ) 
      ylabel <- bquote( paste(italic("y"), " (", .(unit), ")", sep="") )
    }
    if(is.null(unit)){
      xlabel <- bquote( italic("x") ) 
      ylabel <- bquote( italic("y") )
    }

    if(stand.fig == "T" | stand.fig == "TRUE" | stand.fig == "True"){
          dev.new()
          plot(x1, y1, xlab=xlabel, ylab=ylabel, 
               cex.lab=1.5, cex.axis=1.5, 
               type="l", lwd=3, col="grey50", asp=1)
          lines(x2, y2, col=2, lwd=2)
          title(main=main, cex.main=1.5, col.main=4, font.main=1)
          abline(h=0, lty=2, col=4)
          abline(v=0, lty=2, col=4)
    }

    if(fig.opt == "T" | fig.opt == "TRUE" | fig.opt == "True"){
      if(is.null(angle)){
            dev.new()
            plot( x.new, y.new, xlab=xlabel, ylab=ylabel, type="l",
                  cex.lab=1.5, cex.axis=1.5, col="grey50", lwd=3, asp=1, 
                  xlim=xlim, ylim=ylim )
            lines(results2$x, results2$y, type="l", asp=1, col=2, lwd=2)
            title(main=main, cex.main=1.5, col.main=4, font.main=1)
            if(abs(par[3])%%pi/2 != 0){
              slope <- tan(par[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)

            }
            if(abs(par[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
            }
      } 
      if(!is.null(angle)){
            dev.new()
            plot( x.new, y.new, xlab=xlabel, ylab=ylabel, type="l", 
                  cex.lab=1.5, cex.axis=1.5, col="grey50", lwd=3, asp=1,
                  xlim=xlim, ylim=ylim )
            lines(results2$x, results2$y, type="l", asp=1, col=2, lwd=2)
            title(main=main, cex.main=1.5, col.main=4, font.main=1)
            if(abs(par.new[3])%%pi/2 != 0){
              slope <- tan(par.new[3])
              abline(-slope*par[1]+par[2], slope, col=1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)

            }
            if(abs(par.new[3])%%pi/2 == 0){
              abline(v = par[1], col = 1, lty=2)
              abline(v = par[1], col = 4, lty=2, lwd=1)
              abline(h = par[2], col = 4, lty=2, lwd=1)
            }
      }
    }

    x.range  <- range(x1)
    y.range  <- range(y1)
    Length   <- x.range[2] - x.range[1]
    Width    <- y.range[2] - y.range[1]    
    r1       <- sqrt(x1^2 + y1^2)
    r2       <- sqrt(x2^2 + y2^2)
    RSS      <- sum((r1 - r2)^2)
    r.sq     <- 1-sum((r1-r2)^2)/sum((r1-mean(r1))^2)

    para.tab <- data.frame( Parameter = c(Names, 
                    "Length", "Width", "r.sq", "RSS", "sample.size"), 
                    Estimate = c(par, Length, Width, r.sq, RSS, length(x)) )
    if(par.list == "T" | par.list == "TRUE" | par.list == "True"){
        print(para.tab)
        cat("\n")
    }

    return(list( par=par, scan.length=Length, scan.width=Width, 
      scan.area=Area,  
      r.sq=r.sq, RSS=RSS, sample.size=length(x),
      phi.stand.obs=phiA, phi.trans = phiB, 
      r.stand.obs=r1, r.stand.pred=r2,   
      x.stand.obs=x1, x.stand.pred=x2, 
      y.stand.obs=y1, y.stand.pred=y2, 
      r.obs=r.new, r.pred=results$r, x.obs=x.new,  
      x.pred=results$x, y.obs=y.new, y.pred=results$y) )
   
}

ETE <- function(P, x){
  if(!is.numeric(x))
    stop("'x' should be a numerical value or a numerical vector!")
  a      <- P[1]
  alpha0 <- P[2]
  alpha1 <- P[3]
  alpha2 <- P[4] 
  x[x < -a] <- -a
  x[x >  a] <- a
  a * exp( alpha0 + alpha1*(x/a) + alpha2*(x/a)^2 ) * sqrt(1 - (x/a)^2)
}

lmPE <- function (x, y, simpver = NULL, dev.angle = NULL,  
    weights = NULL, fig.opt = TRUE, prog.opt = TRUE, xlim = NULL, 
    ylim = NULL, unit = NULL, main = NULL, extr.method = "Shi") 
{
    w <- weights
    if (!is.null(w) && !is.numeric(w)) 
        stop("'weights' must be a numeric vector")
    if (is.null(simpver)) {
        if (!is.null(w) && length(w) != 4) 
            stop("'weights' should have four numeric elements")
    }
    if (!is.null(simpver) && !is.numeric(simpver)) 
        stop("'simpver' must be chosen from 1, 2 and 3")
    if (!is.null(simpver) && simpver == 1) {
        if (!is.null(w) && length(w) != 3) 
            stop("'weights' should have three numeric elements")
    }
    if (!is.null(simpver) && simpver == 2) {
        if (!is.null(w) && length(w) != 2) 
            stop("'weights' should have two numeric elements")
    }
    if (!is.null(simpver) && simpver == 3) {
        if (!is.null(w) && length(w) != 2) 
            stop("'weights' should have two numeric elements")
    }
    if (length(x) != length(y)) 
        stop("'x' should have the same data length as 'y'!")
    if(!is.null(dev.angle) & !is.numeric(dev.angle)){
        stop("'dev.angle' should be NULL or a numerical value or a numerical vector!")
    }
    if( !(extr.method %in% c("Shi", "Biggins")) ){
        stop("'extr.method' should be selected from one of the available two options!")
    }
    if( (extr.method %in% c("Shi", "Biggins")) ){
      temp <- setdiff(c("Shi", "Biggins"), extr.method)
      if(length(temp) == 0){
        stop("'extr.method' should be selected from one of the available two options rather than both!")
      }
    }

    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[, 1]
    y   <- Tem[, 2]
    poly1 <- owin(xrange = c(min(x)[1], max(x)[1]), 
                 yrange = c(min(y)[1], max(y)[1]))
    poly0 <- as.polygonal(owin(poly = list(x = x, y = y)))
    data0 <- ppp(x, y, window = poly1)
    area0 <- area.owin(poly0)
    perimeter0 <- perimeter(poly0)
    mat <- pairdist(data0)
    qq  <- cbind(which(mat == max(mat)[1], 
               arr.ind = TRUE)[1,])
    q <- as.numeric(qq)
    x1 <- x[q[1]]
    y1 <- y[q[1]]
    x2 <- x[q[2]]
    y2 <- y[q[2]]
    xx <- x - x2
    yy <- y - y2
    x1 <- x1 - x2
    y1 <- y1 - y2
    x2 <- x2 - x2
    y2 <- y2 - y2
    z  <- sqrt((y2 - y1)^2 + (x2 - x1)^2)
    theta <- acos((x1 - x2)/z)%%(2 * pi)
    if(theta > 2*pi) theta <- theta %% (2 * pi)

    xx2     <- xx * cos(theta) + yy * sin(theta)
    yy2     <- yy * cos(theta) - xx * sin(theta)
    length1 <- max(xx2) - min(xx2)
    xx3     <- xx2 - min(xx2)
    yy3     <- yy2 - min(yy2)
    Index1  <- which.max(yy3)
    Index2  <- which.min(yy3)
    x.mb    <- (xx3[Index1]+xx3[Index2])/2
    if(x.mb > length1/2){ 
      theta <- (theta + pi) %% (2 * pi)
    }

    if (is.null(dev.angle)) {    
      x.new <- xx * cos(theta) + yy * sin(theta)
      y.new <- yy * cos(theta) - xx * sin(theta)
      length0 <- max(x.new) - min(x.new)
      width0  <- max(y.new) - min(y.new)

      if(extr.method == "Shi"){
        x.new   <- x.new - (max(x.new)+min(x.new))/2
        y.new   <- y.new - (max(y.new)+min(y.new))/2
      }

      if(extr.method == "Biggins"){
        x.new   <- x.new - mean(x.new)
        y.new   <- y.new - mean(y.new)
      }

      xv      <- x.new/(length0/2)
      yv      <- y.new/(length0/2)
      Index2  <- which(yv < 0)
      temp <- 1 - xv^2
      ind0 <- which(temp < 0)
      temp[ind0] <- 0
      z0 <- sqrt(temp)
      z1 <- xv * z0
      z2 <- xv^2 * z0
      z3 <- xv^3 * z0
      z0[Index2] <- -z0[Index2]
      z1[Index2] <- xv[Index2] * z0[Index2]
      z2[Index2] <- xv[Index2]^2 * z0[Index2]
      z3[Index2] <- xv[Index2]^3 * z0[Index2]
      if (is.null(simpver)) {
        res <- lm(yv ~ -1 + z0 + z1 + z2 + z3, weights = w)
      }
      if (!is.null(simpver)) {
        if (simpver == 1) 
            res <- lm(yv ~ -1 + z0 + z1 + z2, weights = w)
        if (simpver == 2) 
            res <- lm(yv ~ -1 + z0 + z1, weights = w)
        if (simpver == 3) 
            res <- lm(yv ~ -1 + z0 + z2, weights = w)
      }
      yv.pred <- TSE(P = as.numeric(res$coefficients), x = xv, 
                     simpver = simpver)
      yv.pred[Index2] <- -yv.pred[Index2]
      y.pred <- yv.pred * length0/2
      RSS1   <- sum((yv - yv.pred)^2)
      RSS2   <- sum((y.new - y.pred)^2)
      RMSE1  <- sqrt(sum((yv - yv.pred)^2)/length(yv))
      RMSE2  <- sqrt(sum((y.new - y.pred)^2)/length(y.new))
    }

    if (!is.null(dev.angle)) {   
      RSSV <- c()
      AngleTotal <- length(dev.angle) + 1
      for(i in 1:length(dev.angle)){
        if(prog.opt == "TRUE" | prog.opt == "T" | prog.opt == "True")
            print(paste("Progress: ", i, "/", AngleTotal, sep=""))
        epsilon <- dev.angle[i]
        x.new   <- xx * cos(theta+epsilon) + yy * sin(theta+epsilon)
        y.new   <- yy * cos(theta+epsilon) - xx * sin(theta+epsilon)
        length0 <- max(x.new) - min(x.new)
        width0  <- max(y.new) - min(y.new)

        if(extr.method == "Shi"){
          x.new   <- x.new - (max(x.new)+min(x.new))/2
          y.new   <- y.new - (max(y.new)+min(y.new))/2
        }

        if(extr.method == "Biggins"){
          x.new   <- x.new - mean(x.new)
          y.new   <- y.new - mean(y.new)
        }

        xv      <- x.new/(length0/2)
        yv      <- y.new/(length0/2)
        Index2  <- which(yv < 0)
        temp <- 1 - xv^2
        ind0 <- which(temp < 0)
        temp[ind0] <- 0
        z0 <- sqrt(temp)
        z1 <- xv * z0
        z2 <- xv^2 * z0
        z3 <- xv^3 * z0
        z0[Index2] <- -z0[Index2]
        z1[Index2] <- xv[Index2] * z0[Index2]
        z2[Index2] <- xv[Index2]^2 * z0[Index2]
        z3[Index2] <- xv[Index2]^3 * z0[Index2]
        if (is.null(simpver)) {
          res <- lm(yv ~ -1 + z0 + z1 + z2 + z3, weights = w)
        }
        if (!is.null(simpver)) {
          if (simpver == 1) 
              res <- lm(yv ~ -1 + z0 + z1 + z2, weights = w)
          if (simpver == 2) 
              res <- lm(yv ~ -1 + z0 + z1, weights = w)
          if (simpver == 3) 
              res <- lm(yv ~ -1 + z0 + z2, weights = w)
        }
        yv.pred <- TSE(P = as.numeric(res$coefficients), x = xv, 
                       simpver = simpver)
        yv.pred[Index2] <- -yv.pred[Index2]
        y.pred <- yv.pred * length0/2
        RSS1   <- sum((yv - yv.pred)^2)
        RSSV   <- c(RSSV, RSS1)  
      }
      if(prog.opt == "TRUE" | prog.opt == "T" | prog.opt == "True")
          print(paste("Progress: ", AngleTotal, "/", AngleTotal, sep=""))
      Ind0     <- which.min(RSSV)[1]
      epsilon0 <- dev.angle[Ind0]
      x.new <- xx * cos(theta+epsilon0) + yy * sin(theta+epsilon0)
      y.new <- yy * cos(theta+epsilon0) - xx * sin(theta+epsilon0)
      length0 <- max(x.new) - min(x.new)
      width0  <- max(y.new) - min(y.new)

      if(extr.method == "Shi"){
        x.new   <- x.new - (max(x.new)+min(x.new))/2
        y.new   <- y.new - (max(y.new)+min(y.new))/2
      }

      if(extr.method == "Biggins"){
        x.new   <- x.new - mean(x.new)
        y.new   <- y.new - mean(y.new)
      }

      xv <- x.new/(length0/2)
      yv <- y.new/(length0/2)
      Index2 <- which(yv < 0)
      temp <- 1 - xv^2
      ind0 <- which(temp < 0)
      temp[ind0] <- 0
      z0 <- sqrt(temp)
      z1 <- xv * z0
      z2 <- xv^2 * z0
      z3 <- xv^3 * z0
      z0[Index2] <- -z0[Index2]
      z1[Index2] <- xv[Index2] * z0[Index2]
      z2[Index2] <- xv[Index2]^2 * z0[Index2]
      z3[Index2] <- xv[Index2]^3 * z0[Index2]
      if (is.null(simpver)) {
        res <- lm(yv ~ -1 + z0 + z1 + z2 + z3, weights = w)
      }
      if (!is.null(simpver)) {
        if (simpver == 1) 
            res <- lm(yv ~ -1 + z0 + z1 + z2, weights = w)
        if (simpver == 2) 
            res <- lm(yv ~ -1 + z0 + z1, weights = w)
        if (simpver == 3) 
            res <- lm(yv ~ -1 + z0 + z2, weights = w)
      }
      yv.pred <- TSE(P = as.numeric(res$coefficients), x = xv, 
                     simpver = simpver)
      yv.pred[Index2] <- -yv.pred[Index2]
      y.pred <- yv.pred * length0/2
      RSS1 <- sum((yv - yv.pred)^2)
      RSS2 <- sum((y.new - y.pred)^2)
      RMSE1 <- sqrt(sum((yv - yv.pred)^2)/length(yv))
      RMSE2 <- sqrt(sum((y.new - y.pred)^2)/length(y.new))
    }

    if (!is.null(unit)) {
        xlabel <- bquote(paste(italic(x), " (", .(unit), ")", 
            sep = ""))
        ylabel <- bquote(paste(italic(y), " (", .(unit), ")", 
            sep = ""))
    }
    if (is.null(unit)) {
        xlabel <- bquote(italic(x))
        ylabel <- bquote(italic(y))
    }
    if (is.null(xlim)) 
        xlim <- NULL
    if (is.null(ylim)) 
        ylim <- NULL
    if (!is.null(xlim)) 
        xlim <- xlim
    if (!is.null(ylim)) 
        ylim <- ylim
    if (fig.opt == "TRUE" | fig.opt == "T" | fig.opt == "True") {
        dev.new()
        par(family = "serif")
        par(mar = c(5, 5, 2, 2))
        plot(xv, yv, asp = 1, col = "grey50", lwd = 2, xlab = bquote(italic(x)), 
            ylab = bquote(italic(y)), xlim = xlim, ylim = ylim, 
            cex.lab = 1.5, cex.axis = 1.5, type = "l")
        lines(xv, yv.pred, col = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        text(0, 0, bquote(paste("RMSE = ", .(round(RMSE1, 4)), 
            sep = "")), pos = NULL, cex = 1.5, col = 1)
        dev.new()
        par(family = "serif")
        par(mar = c(5, 5, 2, 2))
        plot(x.new, y.new, asp = 1, col = "grey50", lwd = 2, 
            xlab = xlabel, ylab = ylabel, xlim = xlim, ylim = ylim, 
            cex.lab = 1.5, cex.axis = 1.5, type = "l")
        lines(x.new, y.pred, col = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        text(0, 0, bquote(paste("RMSE = ", .(round(RMSE2, 4)), 
            sep = "")), pos = NULL, cex = 1.5, col = 1)
    }

    if (is.null(dev.angle)){
      Res <- list(lm.tse = res, par = res$coefficients, theta = theta,          
          x.obs = x.new, y.obs = y.new, y.pred = y.pred, x.stand.obs = xv, 
          y.stand.obs = yv, y.stand.pred = yv.pred, scan.length = length0, 
          scan.width = width0, scan.area = area0, scan.perimeter = perimeter0, 
          RSS.scaled = RSS1, RSS = RSS2, sample.size = length(y.new), 
          RMSE.scaled = RMSE1, RMSE = RMSE2)
    }

    if (!is.null(dev.angle)){
      Res <- list(lm.tse = res, par = as.numeric(res$coefficients), theta = theta, 
          epsilon = epsilon0, RSS.vector = RSSV, 
          x.obs = x.new, y.obs = y.new, y.pred = y.pred, x.stand.obs = xv, 
          y.stand.obs = yv, y.stand.pred = yv.pred, scan.length = length0, 
          scan.width = width0, scan.area = area0, scan.perimeter = perimeter0, 
          RSS.scaled = RSS1, RSS = RSS2, sample.size = length(y.new), 
          RMSE.scaled = RMSE1, RMSE = RMSE2)
    }
    return(Res)
}

lmTE <- function (x, y, dev.angle = NULL,  
    weights = NULL, fig.opt = TRUE, prog.opt = TRUE, xlim = NULL, 
    ylim = NULL, unit = NULL, main = NULL) 
{
    w <- weights
    if (!is.null(w) && !is.numeric(w)) 
        stop("'weights' must be a numeric vector")
    if (length(x) != length(y)) 
        stop("'x' should have the same data length as 'y'!")
    if(!is.null(dev.angle) & !is.numeric(dev.angle)){
        stop("'dev.angle' should be NULL or a numerical value or a numerical vector!")
    }

    Tem <- cbind(x, y)
    Tem <- na.omit(Tem)
    x   <- Tem[, 1]
    y   <- Tem[, 2]
    poly1 <- owin(xrange = c(min(x)[1], max(x)[1]), 
                  yrange = c(min(y)[1], max(y)[1]))
    poly0 <- as.polygonal(owin(poly = list(x = x, y = y)))
    data0 <- ppp(x, y, window = poly1)
    area0 <- area.owin(poly0)
    perimeter0 <- perimeter(poly0)
    mat <- pairdist(data0)
    qq  <- cbind(which(mat == max(mat)[1], 
               arr.ind = TRUE)[1,])
    q <- as.numeric(qq)
    x1 <- x[q[1]]
    y1 <- y[q[1]]
    x2 <- x[q[2]]
    y2 <- y[q[2]]
    xx <- x - x2
    yy <- y - y2
    x1 <- x1 - x2
    y1 <- y1 - y2
    x2 <- x2 - x2
    y2 <- y2 - y2
    z  <- sqrt((y2 - y1)^2 + (x2 - x1)^2)
    theta <- acos((x1 - x2)/z)%%(2 * pi)
    if(theta > 2*pi) theta <- theta %% (2 * pi)
    xx2     <- xx * cos(theta) + yy * sin(theta)
    yy2     <- yy * cos(theta) - xx * sin(theta)
    length1 <- max(xx2) - min(xx2)
    xx3     <- xx2 - min(xx2)
    yy3     <- yy2 - min(yy2)
    Index1  <- which.max(yy3)
    Index2  <- which.min(yy3)
    x.mb    <- (xx3[Index1]+xx3[Index2])/2
    if(x.mb > length1/2){ 
      theta <- (theta + pi) %% (2 * pi)
    }
    if (is.null(dev.angle)) {    
      x.new <- xx * cos(theta) + yy * sin(theta)
      y.new <- yy * cos(theta) - xx * sin(theta)
      length0 <- max(x.new) - min(x.new)
      width0  <- max(y.new) - min(y.new)
      Index1 <- which.max(y.new)
      Index2 <- which.min(y.new)
      x.mb   <- (x.new[Index1]+x.new[Index2])/2
      if(x.mb > length0/2){         
        xT    <- x.new * cos(pi) + y.new * sin(pi)
        yT    <- y.new * cos(pi) - x.new * sin(pi)
        x.new <- xT
        y.new <- yT
        theta <- (theta + pi) %% (2 * pi)
        x.new <- x.new - min(x.new)
      }
      x.new  <- x.new - (max(x.new)+min(x.new))/2      
      y.new  <- y.new - (max(y.new)+min(y.new))/2
      xv     <- x.new/(length0/2)
      yv     <- y.new/(length0/2)
      xv     <<- xv
      yv     <<- yv
      inde1  <- which(yv > 0)
      inde2  <- which(yv <= 0)
      log.yv <- yv
      log.yv[inde1] <- log(yv[inde1])
      log.yv[inde2] <- log(-yv[inde2])
      temp <- 1 - xv^2
      ind0 <- which(temp <= 0)
      temp[ind0] <- NA
      z1   <- xv
      z2   <- xv^2
      z3   <- log(temp)
      res  <- lm(log.yv ~ z1 + z2 + offset(0.5*z3), weights = w) 
      res  <<- res
      alpha0 <- as.numeric( res$coefficients[[1]] )
      alpha1 <- as.numeric( res$coefficients[[2]] )
      alpha2 <- as.numeric( res$coefficients[[3]] )
      yv.pred <- TE(P = c(alpha0, alpha1, alpha2 ), x = xv)
      yv.pred[inde2] <- -yv.pred[inde2]
      y.pred <- yv.pred * length0/2 
      RSS1   <- sum((yv - yv.pred)^2)
      RSS2   <- sum((y.new - y.pred)^2)
      RMSE1  <- sqrt(sum((yv - yv.pred)^2)/length(yv))
      RMSE2  <- sqrt(sum((y.new - y.pred)^2)/length(y.new))
    }

    if (!is.null(dev.angle)) {   
      RSSV <- c()
      AngleTotal <- length(dev.angle) + 1
      for(i in 1:length(dev.angle)){
        if(prog.opt == "TRUE" | prog.opt == "T" | prog.opt == "True")
            print(paste("Progress: ", i, "/", AngleTotal, sep=""))
        epsilon <- dev.angle[i]
        x.new   <- xx * cos(theta+epsilon) + yy * sin(theta+epsilon)
        y.new   <- yy * cos(theta+epsilon) - xx * sin(theta+epsilon)
        length0 <- max(x.new) - min(x.new)
        width0  <- max(y.new) - min(y.new)  
        Index1 <- which.max(y.new)
        Index2 <- which.min(y.new)
        x.mb   <- (x.new[Index1]+x.new[Index2])/2
        if(x.mb > length0/2){         
          xT    <- x.new * cos(pi) + y.new * sin(pi)
          yT    <- y.new * cos(pi) - x.new * sin(pi)
          x.new <- xT
          y.new <- yT
          theta <- (theta + pi) %% (2 * pi)
          x.new <- x.new - min(x.new)
        }
        x.new  <- x.new - (max(x.new)+min(x.new))/2      
        y.new  <- y.new - (max(y.new)+min(y.new))/2
        xv     <- x.new/(length0/2)
        yv     <- y.new/(length0/2)
        inde1  <- which(yv > 0)
        inde2  <- which(yv <= 0)
        log.yv <- yv
        log.yv[inde1] <- log(yv[inde1])
        log.yv[inde2] <- log(-yv[inde2])
        temp <- 1 - xv^2
        ind0 <- which(temp <= 0)
        temp[ind0] <- NA
        z1   <- xv
        z2   <- xv^2
        z3   <- log(temp)
        z1[inde2] <- xv[inde2]
        z2[inde2] <- xv[inde2]^2
        z3[inde2] <- log(temp[inde2])  
        res  <- lm(log.yv ~ z1 + z2 + offset(0.5*z3), weights = w) 
        res  <<- res
        alpha0 <- as.numeric( res$coefficients[[1]] )
        alpha1 <- as.numeric( res$coefficients[[2]] )
        alpha2 <- as.numeric( res$coefficients[[3]] )
        yv.pred <- TE(P = c(alpha0, alpha1, alpha2), x = xv)
        yv.pred[inde2] <- -yv.pred[inde2]
        y.pred <- yv.pred * length0/2 
        RSS1   <- sum((yv - yv.pred)^2)
        RSSV   <- c(RSSV, RSS1)  
      }
      if(prog.opt == "TRUE" | prog.opt == "T" | prog.opt == "True")
          print(paste("Progress: ", AngleTotal, "/", AngleTotal, sep=""))
      Ind0     <- which.min(RSSV)[1]
      epsilon0 <- dev.angle[Ind0]
      x.new <- xx * cos(theta+epsilon0) + yy * sin(theta+epsilon0)
      y.new <- yy * cos(theta+epsilon0) - xx * sin(theta+epsilon0)
      length0 <- max(x.new) - min(x.new)
      width0  <- max(y.new) - min(y.new)
      Index1 <- which.max(y.new)
      Index2 <- which.min(y.new)
      x.mb   <- (x.new[Index1]+x.new[Index2])/2
      if(x.mb > length0/2){         
        xT    <- x.new * cos(pi) + y.new * sin(pi)
        yT    <- y.new * cos(pi) - x.new * sin(pi)
        x.new <- xT
        y.new <- yT
        theta <- (theta + pi) %% (2 * pi)
        x.new <- x.new - min(x.new)
      }
      x.new  <- x.new - (max(x.new)+min(x.new))/2      
      y.new  <- y.new - (max(y.new)+min(y.new))/2
      xv     <- x.new/(length0/2)
      yv     <- y.new/(length0/2)
      inde1  <- which(yv > 0)
      inde2  <- which(yv <= 0)
      log.yv <- yv
      log.yv[inde1] <- log(yv[inde1])
      log.yv[inde2] <- log(-yv[inde2])
      temp <- 1 - xv^2
      ind0 <- which(temp <= 0)
      temp[ind0] <- NA
      z1   <- xv
      z2   <- xv^2
      z3   <- log(temp)
      z1[inde2] <- xv[inde2]
      z2[inde2] <- xv[inde2]^2
      z3[inde2] <- log(temp[inde2])  
      res  <- lm(log.yv ~ z1 + z2 + offset(0.5*z3), weights = w) 
      res  <<- res
      alpha0 <- as.numeric( res$coefficients[[1]] )
      alpha1 <- as.numeric( res$coefficients[[2]] )
      alpha2 <- as.numeric( res$coefficients[[3]] )
      yv.pred <- TE(P = c(alpha0, alpha1, alpha2), x = xv)
      yv.pred[inde2] <- -yv.pred[inde2]
      y.pred <- yv.pred * length0/2 
      RSS1   <- sum((yv - yv.pred)^2)
      RSS2   <- sum((y.new - y.pred)^2)
      RMSE1  <- sqrt(sum((yv - yv.pred)^2)/length(yv))
      RMSE2  <- sqrt(sum((y.new - y.pred)^2)/length(y.new))
    }

    if (!is.null(unit)) {
        xlabel <- bquote(paste(italic(x), " (", .(unit), ")", 
            sep = ""))
        ylabel <- bquote(paste(italic(y), " (", .(unit), ")", 
            sep = ""))
    }
    if (is.null(unit)) {
        xlabel <- bquote(italic(x))
        ylabel <- bquote(italic(y))
    }
    if (is.null(xlim)) 
        xlim <- NULL
    if (is.null(ylim)) 
        ylim <- NULL
    if (!is.null(xlim)) 
        xlim <- xlim
    if (!is.null(ylim)) 
        ylim <- ylim
    if (fig.opt == "TRUE" | fig.opt == "T" | fig.opt == "True") {
        dev.new()
        par(family = "serif")
        par(mar = c(5, 5, 2, 2))
        plot(xv, yv, asp = 1, col = "grey50", lwd = 2, xlab = bquote(italic(x)), 
            ylab = bquote(italic(y)), xlim = xlim, ylim = ylim, 
            cex.lab = 1.5, cex.axis = 1.5, type = "l")
        lines(xv, yv.pred, col = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        text(0, 0, bquote(paste("RMSE = ", .(round(RMSE1, 4)), 
            sep = "")), pos = NULL, cex = 1.5, col = 1)
        dev.new()
        par(family = "serif")
        par(mar = c(5, 5, 2, 2))
        plot(x.new, y.new, asp = 1, col = "grey50", lwd = 2, 
            xlab = xlabel, ylab = ylabel, xlim = xlim, ylim = ylim, 
            cex.lab = 1.5, cex.axis = 1.5, type = "l")
        lines(x.new, y.pred, col = 2)
        title(main = main, cex.main = 1.5, col.main = 4, font.main = 1)
        text(0, 0, bquote(paste("RMSE = ", .(round(RMSE2, 4)), 
            sep = "")), pos = NULL, cex = 1.5, col = 1)
    }

    if (is.null(dev.angle)){
      Res <- list(lm.te = res, par = c(alpha0, alpha1, alpha2), theta = theta,          
          x.obs = x.new, y.obs = y.new, y.pred = y.pred, x.stand.obs = xv, 
          y.stand.obs = yv, y.stand.pred = yv.pred, scan.length = length0, 
          scan.width = width0, scan.area = area0, scan.perimeter = perimeter0, 
          RSS.scaled = RSS1, RSS = RSS2, sample.size = length(y.new), 
          RMSE.scaled = RMSE1, RMSE = RMSE2)
    }

    if (!is.null(dev.angle)){
      Res <- list(lm.te = res, par = c(alpha0, alpha1, alpha2), theta = theta, 
          epsilon = epsilon0, RSS.vector = RSSV, 
          x.obs = x.new, y.obs = y.new, y.pred = y.pred, x.stand.obs = xv, 
          y.stand.obs = yv, y.stand.pred = yv.pred, scan.length = length0, 
          scan.width = width0, scan.area = area0, scan.perimeter = perimeter0, 
          RSS.scaled = RSS1, RSS = RSS2, sample.size = length(y.new), 
          RMSE.scaled = RMSE1, RMSE = RMSE2)
    }
    return(Res)
}

GE <- function(P, phi, m = 1, simpver = NULL, nval = 1){

  p <- length(P)
 
  if(is.null(simpver)){
    if(p != 5) 
      stop("The number of parameters is incorrect!")
    a        <- P[1]
    k        <- P[2]
    n1       <- P[3]
    n2       <- P[4]
    n3       <- P[5]   
  }

  if(!is.null(simpver)){

    if( !(simpver %in% seq(1, 9, by=1)) )
  stop("'simpver' should be chosen in versions 1 to 9!")
  
    if(simpver==1){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      k        <- 1
      n1       <- P[2]
      n2       <- P[3]
      n3       <- n2  
    }

    if(simpver==2){
      if(p != 2) 
        stop("The number of parameters is incorrect!")
    if(!is.numeric(nval))
      stop("'nval' should be a number!") 
      a        <- P[1]
      k        <- 1
      n1       <- P[2]
      n2       <- nval
      n3       <- nval  
    }


    if(simpver==3){
      if(p != 1) 
        stop("The number of parameters is incorrect!")
      if(!is.numeric(nval))
        stop("'nval' should be a number!") 
      a        <- P[1]
      k        <- 1
      n1       <- nval
      n2       <- nval
      n3       <- nval  
    }

    if(simpver==4){
      if(p != 2) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      k        <- 1
      n1       <- P[2]
      n2       <- n1
      n3       <- n2   
    }

    if(simpver==5){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      k        <- 1 
      n1       <- P[2]
      n2       <- P[3]
      n3       <- P[4]  
    }

    if(simpver==6){
      if(p != 4) 
        stop("The number of parameters is incorrect!")
      a        <- P[1]
      k        <- P[2] 
      n1       <- P[3]
      n2       <- P[4]
      n3       <- n2  
    }

    if(simpver==7){
      if(p != 3) 
        stop("The number of parameters is incorrect!")
      if(!is.numeric(nval))
        stop("'nval' should be a number!") 
      a        <- P[1]
      k        <- P[2] 
      n1       <- P[3]
      n2       <- nval
      n3       <- nval 
    }

    if(simpver==8){
      if(p != 2) 
        stop("The number of parameters is incorrect!")
      if(!is.numeric(nval))
        stop("'nval' should be a number!") 
      a        <- P[1]
      k        <- P[2] 
      n1       <- nval
      n2       <- nval
      n3       <- nval
    }


    if(simpver==9){
      if(p != 3) 
  stop("The length of 'P' shoud equal 3 for the simplified version 9!")
      a        <- P[1]
      k        <- P[2] 
      n1       <- P[3]
      n2       <- n1
      n3       <- n2
    }

  }

  r  <- a*(abs(cos(m/4*phi))^n2 + abs(1/k*sin(m/4*phi))^n3)^(-1/n1) 
  return( r )
}

areaovate <- function(expr, P, simpver = NULL,  
               subdivisions = 100L,
               rel.tol = .Machine$double.eps^0.25, 
               abs.tol = rel.tol,
               stop.on.error = TRUE, keep.xy = FALSE, 
               aux = NULL){

   area.fun <- function(x){
     2*expr(P, x=x, simpver=simpver)
   }

   if(is.null(simpver) & !identical(expr, MPerformanceE)){
     Lower <- P[3]
     Upper <- P[4]
   }

   if(is.null(simpver) & identical(expr, MPerformanceE)){
     Lower <- P[4]
     Upper <- P[5]
   }

   if(!is.null(simpver) & !identical(expr, MPerformanceE)){

    if( !(simpver %in% seq(1, 3, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 3!")  
  
    if(simpver==1 | simpver==3){
      Lower <- 0
      Upper <- P[3]
    }
    if(simpver==2){
      Lower <- P[3]
      Upper <- P[4]
    }
   }

   if(!is.null(simpver) & identical(expr, MPerformanceE)){

    if( !(simpver %in% seq(1, 5, by=1)) )
    stop("'simpver' should be chosen in versions 1 to 5!")  
  
    if(simpver==1 | simpver==3){
      Lower <- 0
      Upper <- P[4]
    }
    if(simpver==2){
      Lower <- P[4]
      Upper <- P[5]
    }
    if(simpver==4 | simpver==5){
      Lower <- 0
      Upper <- sqrt(2)
    }
   }

   temp <- integrate(area.fun, lower=Lower, upper=Upper, 
           subdivisions = subdivisions,
           rel.tol = rel.tol, 
           abs.tol = abs.tol,
           stop.on.error = stop.on.error, 
           keep.xy = keep.xy, aux = aux)
   temp$value
}

\name{fitAM}
\encoding{UTF-8}
\alias{fitAM}
\title{
Fitting the 2-D Profiles of Apical Meristems
}
\description{
\code{fitAM} is used to estimate the parameters of any non-linear equation 
the user defines for describing the 2-D profiles of shoot or root apical meristems.
}
\usage{
fitAM(expr, x, y, ini.val, method = "Nelder-Mead", control = list(),  
      lower = -Inf, upper = Inf, par.list = FALSE, stand.fig = TRUE, fig.opt = FALSE, 
      angle = NULL, xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{expr}{the non-linear equation for describing the 2-D profiles of shoot or root apical meristems.}
  \item{x}{the \eqn{x} coordinates of an apical meristem (AM)'s profile.}
  \item{y}{the \eqn{y} coordinates of an AM's profile.}
  \item{ini.val}{the list of initial values for the model parameters.}
  \item{method}{an optional argument to select an optimization method.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{lower}{the lower bounds on the variables for the \code{L-BFGS-B} algorithm.}
  \item{upper}{the upper bounds on the variables for the \code{L-BFGS-B} algorithm.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{stand.fig}{an optional argument to draw the observed and predicted profiles of an AM at the standard state 
(i.e., the origin for indicating the curve predicted by \code{expr} is located at (0, 0), 
and the \eqn{x}-axis of the predicted curve at this state is aligned with the \eqn{x}-axis).}
  \item{fig.opt}{an optional argument to draw the observed and predicted profiles of an AM 
at arbitrary angle between the rotated \eqn{x}-axis and the actual \eqn{x}-axis.}
  \item{angle}{the angle between the rotated \eqn{x}-axis and the actual \eqn{x}-axis, which can be defined by the user.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the predicted AM's profile curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the predicted AM's profile curve.}
  \item{unit}{the unit of the \eqn{x}-axis and the \eqn{y}-axis when showing the predicted AM's profile curve.}
  \item{main}{the main title of the figure.}
}
\details{
Here, the rotated \eqn{x}-axis means that for a scanned (photographed) AM the \eqn{x}-axis of the AM's profile  
curve at the standard state predicted by \code{expr} might deviate from the actual horizontal axis 
(see Shi et al. [2026] for details). 
The \code{Nelder-Mead} algorithm (Nelder and Mead, 1965) and the optimization method 
(referred to as \code{L-BFGS-B}) proposed by Byrd et al. (1995) in which each variable can be given 
a lower and/or upper bound can be selected to carry out the optimization of minimizing 
the residual sum of squares (RSS) between the observed and predicted \eqn{y} values. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out 
the \code{Nelder-Mead} algorithm and the \code{L-BFGS-B} algorithm. 
When \code{angle = NULL}, the observed AM's profile curve will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, 
it indicates that the \eqn{x}-axis at the standard state 
is rotated by the amount (\eqn{\pi/4}) counterclockwise from the actutal \eqn{x}-axis.
}
\value{
  \item{par}{the estimates of the model parameters.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values 
on the AM's profile curve.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values 
on the AM's profile curve.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates of the points 
on the AM's profile curve at the standard state.}
  \item{x.stand.pred}{the predicted \eqn{x} coordinates of the points 
on the AM's profile curve at the standard state.} 
  \item{y.stand.obs}{the observed \eqn{y} coordinates of the points 
on the AM's profile curve at the standard state.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates of the points 
on the AM's profile curve at the standard state.} 
  \item{x.obs}{the observed \eqn{x} coordinates of the points on the AM's profile curve 
at the transferred polar angles as defined by the user.}
  \item{x.pred}{the predicted \eqn{x} coordinates of the points on the AM's profile curve 
at the transferred polar angles as defined by the user.}   
  \item{y.obs}{the observed \eqn{y} coordinates of the points on the AM's profile curve 
at the transferred polar angles as defined by the user.}
  \item{y.pred}{the predicted \eqn{y} coordinates of the points on the AM's profile curve 
at the transferred polar angles as defined by the user.}       
}
\note{
In the arguments, \code{expr} can be flexibly defined by the user, but it requires taking the form as 
\code{myfun <- function(P, x){...}}, where \code{P} represents the parameter vector, and \code{x} 
is the independent variable. In the outputs, the data length of the predicted values is the same as that of 
the observations. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Byrd, R.H., Lu, P., Nocedal, J., Zhu, C. (1995) A limited memory algorithm for bound constrained 
optimization. \emph{SIAM Journal on Scientific Computing} 16, 1190\eqn{-}1208. \doi{10.1137/0916069}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Liu, X., Gielis, J., Beirinckx, B., Niklas, K.J. (2026) 
Comparison of six nonlinear equations describing the 2-D profiles of apical meristems. 
\emph{American Journal of Botany} 113, e70177. \doi{10.1002/ajb2.70177}
}
\seealso{
\code{\link{PlanCoor}}, \code{\link{SAMs}}, \code{\link{SurfaceAreaAM}}, \code{\link{VolumeAM}}
}
\examples{

# See Shi et al. (2026) for details.

data(SAMs)

uni.sam <- sort( unique(SAMs$Genus) )
ind     <- 2
Data    <- SAMs[SAMs$Genus==uni.sam[ind], ]
x0      <- Data$x
y0      <- Data$y

Res1    <- adjdata(x0, y0, ub.np=200, times=1.2, len.pro=1/20)
X       <- Res1$x
Y       <- Res1$y

dev.new()
plot( X, Y, pch=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(paste(italic(x), " (unitless)", sep="")), 
      ylab=expression(paste(italic(y), " (unitless)", sep="")) )

x1 <- X
y1 <- Y

if(TRUE){

  # The code results in an upward-opening profile curve with 
  #   all y-values less than zero, facilitating data fitting by 
  #   providing suitable initial values for model parameters.

  y1 <- min(Y)-Y
  x1 <- X-mean(X)  
   
  # To normalize the profile coordinates, 
  #   and make x-coordinates range between -1 and 1  
  x2 <- x1/max(abs(x1))
  y2 <- y1/max(abs(x1))

  rm(x1)
  rm(y1)

  x1 <- x2
  y1 <- y2
}


#### Fitting the catenary equation ###############################################
myfun1 <- function(P, x){
  a <- P[1]
  return( a * cosh(x/a) )
}

x0.ini    <- 0
y0.ini    <- -min(y1)
theta.ini <- 0 
a.ini     <- c( 0.75*abs(min(y1)), abs(min(y1)), 1.25*abs(min(y1)) )
ini.val1  <- list(x0.ini, y0.ini, theta.ini, a.ini )

Res1 <- fitAM( myfun1, x=x1, y=y1, ini.val=ini.val1, 
               control=list(reltol=1e-20, maxit=20000), 
               par.list=FALSE, stand.fig=FALSE, fig.opt=TRUE, angle=NULL, 
               unit="unitless", main="Catenary equation" )
###################################################################################


#### Fitting the parabolic equation ###############################################
myfun2 <- function(P, x){
  alpha1 <- P[1]
  alpha2 <- P[2]
  alpha1*x + alpha2*x^2 
}

x0.ini    <- 0
y0.ini    <- -abs(min(y1))
theta.ini <- 0 
beta1.ini <- 1e-3
beta2.ini <- c(1, 5, 10, 15)
ini.val2  <- list(x0.ini, y0.ini, theta.ini, beta1.ini, beta2.ini)

Res2 <- fitAM( myfun2, x=x1, y=y1, ini.val=ini.val2, 
               control=list(factr=1e-12, maxit=20000), 
               method="L-BFGS-B", lower=c(-Inf, -Inf, -pi/2/4, -Inf, 0), 
               upper=c(Inf, Inf, pi/2/4, Inf, Inf), 
               par.list=FALSE, stand.fig=FALSE, fig.opt=TRUE, angle=NULL, 
               unit="unitless", main="Parabolic equation" )
###################################################################################


#### Fitting the hybrid catenary-parabolic equation ###############################
myfun3 <- function(P, x){
  alpha <- P[1]
  beta  <- P[2]
  gamma <- P[3]
  alpha * cosh(beta * x) + gamma * x^2 - alpha
}

x0.ini    <- 0
y0.ini    <- -abs(min(y1))
theta.ini <- 0 
alpha.ini <- c(0.1, 0.5, 1, 2.5, 5)
beta.ini  <- 1/abs(min(y1))
gamma.ini <- 1
ini.val3  <- list(x0.ini, y0.ini, theta.ini, alpha.ini, beta.ini, gamma.ini)

Res3 <- fitAM( myfun3, x=x1, y=y1, ini.val=ini.val3,  
               control=list(reltol=1e-30, maxit=50000),           
               par.list=FALSE, stand.fig=FALSE, fig.opt=TRUE, angle=NULL,               
               unit="unitless", main="Hybrid catenary-parabolic equation" )
###################################################################################


#### Fitting the performance equation #############################################
myfun4 <- function(P, x){
  c    <- P[1]
  K1   <- P[2]
  K2   <- P[3]
  xmin <- 0
  xmax <- P[4]
  # x[x > xmax] <- xmax
  # x[x < xmin] <- xmin
  -c * ( 1-exp(-K1*(x-xmin)) )*( 1-exp(K2*(x-xmax)) )
}

x0.ini    <- min(x1)
y0.ini    <- 0
theta.ini <- -pi/12 
c.ini     <- abs(min(y1))
K1.ini    <- 1
K2.ini    <- 1
xmax.ini  <- max(x1)*2
ini.val4  <- list(x0.ini, y0.ini, theta.ini, c.ini, K1.ini, K2.ini, xmax.ini)

Res4 <- fitAM( myfun4, x=x1, y=y1, ini.val=ini.val4, method="L-BFGS-B",
               lower=c(-Inf, -Inf, -pi/2/4, 0, 0, 0, 0), 
               upper=c(Inf, Inf, pi/2/4, Inf, Inf, Inf, Inf),   
               control=list(factr=1e-12, maxit=20000),           
               par.list=FALSE, stand.fig=FALSE, fig.opt=TRUE, angle=NULL,
               unit="unitless", main="Performance equation" )
###################################################################################


#### Fitting the superparabolic equation equation #################################
myfun5 <- function(P, x){
  beta1 <- P[1]
  beta2 <- P[2]
  beta1 * abs(x)^beta2
}

x0.ini    <- 0
y0.ini    <- -max( y1 )  
theta.ini <- 0
beta1.ini <- max(x1)/2
beta2.ini <- c(1.5, 2, 2.5)
ini.val5  <- list(x0.ini, y0.ini, theta.ini, beta1.ini, beta2.ini)

Res5 <- fitAM( myfun5, x=x1, y=y1, ini.val=ini.val5, 
               control=list(reltol=1e-20, maxit=20000), 
               par.list=FALSE, stand.fig=FALSE, fig.opt=TRUE, angle=NULL,
               unit="unitless", main="Superparabolic equation" )
###################################################################################


#### Fitting the superellipse equation equation ###################################
myfun6 <- function(P, x){
  A <- P[1]
  B <- P[2]
  n <- P[3]
  -B*(1-abs(x/A)^n)*(1/n)
}

x0.ini    <- 0
y0.ini    <- 0
theta.ini <- c(0, pi/2) 
A.ini     <- max(x1)
B.ini     <- -min(y1)
n.ini     <- c(1, 2, 3)
ini.val6  <- list(x0.ini, y0.ini, theta.ini, A.ini, B.ini, n.ini)
Res6 <- fitAM( myfun6, x=x1, y=y1, ini.val=ini.val6, 
               control=list(reltol=1e-20, maxit=20000), 
               par.list=FALSE, stand.fig = FALSE, fig.opt=TRUE, angle=NULL,
               unit="unitless", main="Superellipse equation" )
###################################################################################

graphics.off()
}

\name{MPerformanceE}
\encoding{UTF-8}
\alias{MPerformanceE}
\title{
Modified Performance Equation
}
\description{
\code{MPerformanceE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the modified performance equation or one of its simplified versions. 
}
\usage{
MPerformanceE(P, x, simpver = 1)
}
\arguments{
  \item{P}{the parameters of the modified performance equation or one of its simplified versions.}
  \item{x}{the given \eqn{x} values.}
  \item{simpver}{an optional argument to use the simplified version of the modified performance equation.}
}
\details{

When \code{simpver = NULL}, the modified performance equation is selected: 
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = c\left(1-e^{-K_{1}\left(x-x_{\mathrm{min}}\right)}\right)^{a}\left(1-e^{K_{2}\left(x-x_{\mathrm{max}}\right)}\right)^{b};}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
and \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, \eqn{a}, 
and \eqn{b} are constants to be estimated, 
where \eqn{x_{\mathrm{min}}} and \eqn{x_{\mathrm{max}}} represents the 
lower and upper intersections between the curve and the \eqn{x}-axis. \eqn{y} is defined as 0 
when \eqn{x < x_{\mathrm{min}}} or \eqn{x > x_{\mathrm{max}}}. There are seven elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, \eqn{a}, and \eqn{b}, respectively.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)^{a}\left(1-e^{K_{2}\left(x-x_{\mathrm{max}}\right)}\right)^{b};}
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are six elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{x_{\mathrm{max}}}, \eqn{a}, and \eqn{b} respectively.


\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = c\left(1-e^{-K_{1}\left(x-x_{\mathrm{min}}\right)}\right)\left(1-e^{K_{2}\left(x-x_{\mathrm{max}}\right)}\right);}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are five elements in \code{P} representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{x_{\mathrm{min}}}, and \eqn{x_{\mathrm{max}}}, respectively.


\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected: 
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)\left(1-e^{K_{2}\left(x-x_{\mathrm{max}}\right)}\right);}
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are four elements in \code{P} representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, and \eqn{x_{\mathrm{max}}}, respectively.

\eqn{\quad} When \code{simpver = 4}, the simplified version 4 is selected: 
\deqn{\mbox{if } x \in{\left(0, \ \sqrt{2}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)^{a}\left(1-e^{K_{2}\left(x-\sqrt{2}\right)}\right)^{b};}
\deqn{\mbox{if } x \notin{\left(0, \ \sqrt{2}\right)},}
\deqn{y = 0.}
There are five elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{a}, and \eqn{b}, respectively.

\eqn{\quad} When \code{simpver = 5}, the simplified version 5 is selected:
\deqn{\mbox{if } x \in{\left(0, \ \sqrt{2}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)\left(1-e^{K_{2}\left(x-\sqrt{2}\right)}\right);}
\deqn{\mbox{if } x \notin{\left(0, \ \sqrt{2}\right)},}
\deqn{y = 0.}
There are three elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, and \eqn{K_{2}}, respectively.

}
\value{
The \eqn{y} values predicted by the modified performance equation or one of its simplified versions.
}
\note{
We have added two parameters \eqn{a} and \eqn{b} in the original performance 
equation (i.e., \code{simpver = 2}) to increase the flexibility for data fitting. 
The cases of \code{simpver = 4} and \code{simpver = 5} are used to describe the rotated and right-shifted 
Lorenz curve (see Lian et al. [2023] for details).
}
\references{
Huey, R.B., Stevenson, R.D. (1979) Integrating thermal physiology and ecology of ectotherms: 
a discussion of approaches. \emph{American Zoologist} 19, 357\eqn{-}366. \doi{10.1093/icb/19.1.357}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Shi, P., Ge, F., Sun, Y., Chen, C. (2011) A simple model for describing 
the effect of temperature on insect developmental rate. \emph{Journal of Asia-Pacific Entomology} 
14, 15\eqn{-}20. \doi{10.1016/j.aspen.2010.11.008} 

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{areaovate}}, \code{\link{curveovate}}, \code{\link{fitLorenz}}, 
\code{\link{fitovate}}, \code{\link{fitsigmoid}}, \code{\link{MbetaE}}, 
\code{\link{MBriereE}}, \code{\link{MLRFE}}, \code{\link{sigmoid}}
}
\examples{
x4   <- seq(0, 40, len=2000)
Par4 <- c(0.117, 0.090, 0.255, 5, 35, 1, 1)
y4   <- MPerformanceE(P=Par4, x=x4, simpver=NULL)

dev.new()
plot( x4, y4, cex.lab=1.5, cex.axis=1.5, type="l",
      xlab=expression(italic(x)), ylab=expression(italic(y)) )

graphics.off()
}

\name{veins}
\docType{data}
\encoding{UTF-8}
\alias{veins}
\title{
Leaf Vein Data of \emph{Michelia compressa}
}
\description{
The data consist of the leaf vein data of a leaf of \emph{M. compressa} 
sampled at Nanjing Forestry University campus in late July 2019.
}
\usage{
data(veins)
}
\details{
In the data set, there are two columns of variables: \code{x} and \code{y}. 
\code{x} saves the \eqn{x} coordinates of the leaf veins in the Cartesian coordinate system (cm); 
\code{y} saves the \eqn{y} coordinates of the leaf veins in the Cartesian coordinate system (cm).
}
\note{
The data cannot be adjusted by the \code{\link{adjdata}} function.
}
\seealso{
\code{\link{fracdim}}
}
\references{
Shi, P., Yu, K., Niinemets, Ü., Gielis, J. (2021) Can leaf shape be represented by the ratio of 
leaf width to length? Evidence from nine species of \emph{Magnolia} and \emph{Michelia} (Magnoliaceae). 
\emph{Forests} 12, 41. \doi{10.3390/f12010041}
}
\examples{
data(veins)

dev.new()
plot(veins$x, veins$y, cex=0.01, asp=1, cex.lab=1.5, cex.axis=1.5, 
     xlab=expression(italic("x")), ylab=expression(italic("y")))

graphics.off()
}

\name{SAMs}
\encoding{UTF-8}
\docType{data}
\alias{SAMs}
\title{
Boundary Data of Shoot Apical Meristems
}
\description{
The data consist of the boundary data of the shoot apical meristems (SAMs) from six genera.
}
\usage{
data(SAMs)
}
\details{
In the data set, there are three columns of variables: \code{Genus}, \code{x}, and \code{y}. 
\code{Genus} saves the genus information for each SAM; 
\code{x} saves the \eqn{x} coordinates of the six SAMs in the Cartesian coordinate system (unitless); 
and \code{y} saves the \eqn{y} coordinates of the six SAMs in the Cartesian coordinate system (unitless). 
In \code{Genus}, there are six genera including \emph{Glycine}, \emph{Coleus}, \emph{Juniperus}, \emph{Pinus}, 
\emph{Equisetum}, and \emph{Isoetes}, spanning the three lineages: angiosperms, gymnosperms, and pteridophytes 
(see Shi et al. [2026] for details).
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Liu, X., Gielis, J., Beirinckx, B., Niklas, K.J. (2026) 
Comparison of six nonlinear equations describing the 2-D profiles of apical meristems. 
\emph{American Journal of Botany} 113, e70177. \doi{10.1002/ajb2.70177}
}
\seealso{
\code{\link{fitAM}}, \code{\link{PlanCoor}}, \code{\link{SurfaceAreaAM}}, \code{\link{VolumeAM}}
}
\examples{
# See Shi et al. (2026) for details.

data(SAMs)

uni.sam <- sort( unique(SAMs$Genus) )
ind     <- 2
Data    <- SAMs[SAMs$Genus==uni.sam[ind], ]
x0      <- Data$x
y0      <- Data$y

Res1    <- adjdata(x0, y0, ub.np=200, times=1.2, len.pro=1/20)
X       <- Res1$x
Y       <- Res1$y

dev.new()
plot( X, Y, pch=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(paste(italic(x), " (unitless)", sep="")), 
      ylab=expression(paste(italic(y), " (unitless)", sep="")) )

graphics.off()
}

\name{fracdim}
\encoding{UTF-8}
\alias{fracdim}
\title{
Calculation of Fractal Dimension of Lef Veins Based on the Box-Counting Method
}
\description{
\code{fracdim} is used to calculate the fractal dimension of leaf veins 
based on the box-counting method.
}
\usage{
fracdim(x, y, frac.fig = TRUE, denomi.range = seq(8, 30, by=1), 
        ratiox = 0.02, ratioy = 0.08, main = NULL)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of leaf-vein pixels.}
  \item{y}{the \eqn{y} coordinates of leaf-vein pixels.}
  \item{frac.fig}{the option of drawing the results of the linear fitting.}
  \item{denomi.range}{the number of equidistant segments of the maximum range 
between the range of the \eqn{x} coordinates and that of the \eqn{y} coordinates.}
  \item{ratiox}{the the \eqn{x} coordinate of the location parameter for positioning the legend.}
  \item{ratioy}{the the \eqn{y} coordinate of the location parameter for positioning the legend.}
  \item{main}{the main title of the figure.}
}
\details{
The box-counting approach uses a group of boxes (squares for simplicity) with different
sizes (\eqn{\delta}) to divide the leaf vein image into different parts. Let \eqn{N} represent the number
of boxes that include at least one pixel of leaf vein. 
The maximum of the range of the \eqn{x} coordinates and the range of the \eqn{y} coordinates 
for leaf-vein pixels is defined as \eqn{z}. Let \eqn{\delta} represent the vector of 
\eqn{z}/\code{denomi.range}. Then, we used the following equation to calculate the fractal 
dimension of leaf veins:
\deqn{\mathrm{ln } N = a + b\,\mathrm{ ln} \left({\delta}^{-1}\right),}
where \eqn{b} is the theoretical value of the fractal dimension. We can use its estimate as the 
numerical value of the fractal dimension for a leaf venation network.      
}
\value{
  \item{a}{the estimate of the intercept.}
  \item{sd.a}{the standard deviation of the estimated intercept.}
  \item{lci.a}{the lower bound of the 95\% confidence interval of the estimated intercept.}
  \item{uci.a}{the upper bound of the 95\% confidence interval of the estimated intercept.}
  \item{b}{the estimate of the slope.}
  \item{sd.b}{the standard deviation of the estimated slope.}
  \item{lci.a}{the lower bound of the 95\% confidence interval of the estimated slope.}
  \item{uci.a}{the upper bound of the 95\% confidence interval of the estimated slope.}
  \item{r.sq}{the coefficient of determination.}
  \item{delta}{the vector of box sizes.}
  \item{N}{the number of boxes that include at least one pixel of leaf vein.}
}
\note{
Here, \code{x} and \code{y} cannot be adjusted by the \code{\link{adjdata}} function 
because the leaf veins are not the leaf's boundary data.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Yu, K., Niinemets, Ü., Gielis, J. (2021) Can leaf shape be represented by the ratio of 
leaf width to length? Evidence from nine species of \emph{Magnolia} and \emph{Michelia} (Magnoliaceae). 
\emph{Forests} 12, 41. \doi{10.3390/f12010041}

Vico, P.G., Kyriacos, S., Heymans, O., Louryan, S., Cartilier, L. (1998) 
Dynamic study of the extraembryonic vascular network of the 
chick embryo by fractal analysis. \emph{Journal of Theoretical Biology} 195, 525\eqn{-}532. 
\doi{10.1006/jtbi.1998.0810}
}
\seealso{
\code{\link{veins}}
}
\examples{
data(veins)

dev.new()
plot(veins$x, veins$y, cex=0.01, asp=1, cex.lab=1.5, cex.axis=1.5, 
     xlab=expression(italic("x")), ylab=expression(italic("y")))

fracdim(veins$x, veins$y)

graphics.off()
}

\name{fitNRGE}
\encoding{UTF-8}
\alias{fitNRGE}
\title{
Parameter Estimation for the Narushin-Romanov-Griffin Equation
}
\description{
\code{fitNRGE} is used to estimate the parameters of the Narushin-Romanov-Griffin equation.
}
\usage{
fitNRGE(x, y, dev.angle = NULL, ini.C = c(-1, 0.1, 0.5, 1), 
        strip.num = 2000, control = list(), fig.opt = TRUE, np = 2000,
        xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of the edge of an egg's boundary.}
  \item{y}{the \eqn{y} coordinates of the edge of an egg's boundary.}
  \item{dev.angle}{the angle of deviation for the axis associated with the maximum distance between two points 
on an egg's profile from the mid-line of the egg's profile.}
  \item{ini.C}{the initial value(s) of parameter \eqn{C} in the Narushin-Romanov-Griffin equation.}  
  \item{strip.num}{the number of equidistant strips intersecting with 
the egg's boundary that are horizontally placed. See Shi et al. (2018, 2020) for details.}  
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{fig.opt}{an optional argument to draw the observed and predicted egg's boundaries.}
  \item{np}{the number of data points on the predicted Narushin-Romanov-Griffin curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Narushin-Romanov-Griffin curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Narushin-Romanov-Griffin curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Narushin-Romanov-Griffin curve.}
  \item{main}{the main title of the figure.}
}
\details{
The NRGE (see \code{\link{NRGE}}) has a complex model structure with four parameters (i.e., \eqn{A}, \eqn{B}, \eqn{C}, and \eqn{D}). 
Because three out of four parameters of NRGE have clear biological and geometric meanings (i.e., \eqn{A}, \eqn{B}, and \eqn{D}), 
their values could be estimated by means of numerical calculation. After obtaining the numerical values of the three parameters, 
the Nelder-Mead algorithm (Nelder and Mead, 1965) was used to estimate \eqn{C}. 
Because of the failure of the optimization method to estimate the major axis (i.e., the mid-line) and model parameters of NRGE, 
it was difficult to define the egg length axis, although it is essential for calculating \eqn{A}, \eqn{B}, and \eqn{D}. 
For this reason, two methods were used to obtain the major axis: the maximum distance method, and 
the longest axis adjustment method. In the first method, the straight line through two points forming the maximum distance 
on the egg's profile is defined as the major axis (i.e., the mid-line). In the second method, we assume that there is an angle 
of deviation for the longest axis (i.e., the axis associated with the maximum distance between two points on an egg's profile) 
from the mid-line of the egg's profile. That is to say, 
the mid-line of an egg's profile is not the axis associated with the maximum distance between two points on the egg's profile. 
When \code{angle = NULL}, the maximum distance method is used; when \code{angle} is a numerical value or a numerical vector, 
the longest axis adjustment method is used. Here, the numerical value of \code{dev.angle} is not 
the angle of deviation for the major axis of an egg's profile from the \eqn{x}-axis, and instead it is the angle of deviation  
for the longest axis (associated with the maximum distance between two points on the egg's profile) from the mid-line of the egg's profile. 
Once the major axis is established, the distance of the major axis can be calculated as the estimate of \eqn{A}. 
Using the maximum distance method, \eqn{A} equals the maximum distance. Using the longest axis adjustment method, 
\eqn{A} may be slightly smaller than the maximum distance. After rotating the major axis to make it overlap with the \eqn{x}-axis, 
a large number of equidistant strips can be used (e.g., 2000) from the egg base to egg tip to intersect the egg's boundary. 
This methodology makes it easy to obtain the maximum egg's breadth (i.e., \eqn{B}) and \eqn{D}. The residual sum of squares (RSS) 
between the observed and predicted \eqn{y} values can be minimized using an optimization method (Nelder and Mead, 1965) to estimate \eqn{C}. 
Despite the complex structure of NRGE (see \code{\link{NRGE}}), the optimization method for estimating the remaining parameter \eqn{C} 
becomes feasible after the other three parameters have been numerically estimated. Please see Shi et al. (2022) for details.
}
\value{
  \item{theta}{the angle between the longest axis of an egg's profile (i.e., 
the axis associated with the maximum distance between two points on the egg's profile) and the \eqn{x}-axis.}
  \item{epsilon}{the optimal angle of deviation for the longest axis (associated with the maximum distance between two points on an egg's profile) 
from the mid-line of the egg's profile, when \code{dev.angle} is not \code{NULL}.}
  \item{RSS.vector}{the vector of residual sum of squares corresponding to \code{dev.angle}, when \code{dev.angle} is not \code{NULL}.}
  \item{x.obs}{the observed \eqn{x} coordinates.}
  \item{y.obs}{the observed \eqn{y} coordinates.}
  \item{y.pred}{the predicted \eqn{y} coordinates corresponding to the the observed \eqn{x} coordinates.}
  \item{par}{the estimates of the four model parameters in the Narushin-Romanov-Griffin equation.}
  \item{scan.length}{the length of the egg's boundary. The default is the maximum distance between two points on 
the egg's boundary.}
  \item{scan.width}{the maximum width of the egg's boundary.}
  \item{scan.area}{the area of the egg's boundary.}
  \item{scan.perimeter}{the perimeter of the egg's boundary based on all data points on the egg's boundary.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points used in the numerical calculation.}
  \item{RMSE}{the root-mean-square errors between the observed and predicted \eqn{y} values.}       
}
\note{
\code{theta} is the calculated angle between the longest axis (i.e., the axis associated with the maximum distance 
between two points on an egg's profile) and the \eqn{x}-axis, and \code{epsilon} is the calculated angle of deviation for the longest 
axis from the mid-line of the egg's profile. This means that the angle between the mid-line and the \eqn{x}-axis is equal to 
\code{theta} + \code{epsilon}. In the outputs, there is no \code{x.pred}, because \code{y.obs} and 
\code{y.pred} share the same \eqn{x} values (i.e., \code{x.obs}).
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Nelder, J.A., Mead, R. (1965). A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Gielis, J., Niklas, K.J. (2022) Comparison of a universal (but complex) model for avian egg 
shape with a simpler model. \emph{Annals of the New York Academy of Sciences} 1514, 34\eqn{-}42. \doi{10.1111/nyas.14799}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Niinemets, Ü., Hui, C., Niklas, K.J., Yu, X., Hölscher, D. (2020) 
Leaf bilateral symmetry and the scaling of the perimeter vs. the surface area in 15 vine species. 
\emph{Forests} 11, 246. \doi{10.3390/f11020246}

Shi, P., Zheng, X., Ratkowsky, D.A., Li, Y., Wang, P., Cheng, L. (2018) 
A simple method for measuring the bilateral symmetry of leaves. 
\emph{Symmetry} 10, 118. \doi{10.3390/sym10040118}

Tian, F., Wang, Y., Sandhu, H.S., Gielis, J., Shi, P. (2020) Comparison of seed morphology of two ginkgo cultivars. 
\emph{Journal of Forestry Research} 31, 751\eqn{-}758. \doi{10.1007/s11676-018-0770-y}
}
\seealso{
\code{\link{curveNRGE}}, \code{\link{NRGE}}
}
\examples{
data(eggs)

uni.C <- sort( unique(eggs$Code) )
ind   <- 8
Data  <- eggs[eggs$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1  <- adjdata(x0, y0, ub.np=3000, len.pro=1/20)
x1    <- Res1$x
y1    <- Res1$y

dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) ) 

\donttest{
  Res2 <- fitNRGE(x1, y1, dev.angle=NULL, ini.C=c(-1, -0.1, seq(0.1, 1, by=0.05)), 
                  strip.num=2000, fig.opt=TRUE) 
         
  dev.new()
  plot(Res2$x.obs, Res2$y.obs, asp=1, cex.lab=1.5, cex.axis=1.5, 
       xlab=expression(italic("x")), ylab=expression(italic("y")),
       type="l", col=4) 
  lines( Res2$x.obs, Res2$y.pred, col=2)

  Res3 <- fitNRGE(x1, y1, dev.angle=seq(-0.05, 0.05, by=0.01), 
                  ini.C=c(-1, -0.1, seq(0.1, 1, by=0.05)), 
                  strip.num=2000, fig.opt=TRUE)   

  zeta <- Res3$theta + Res3$epsilon
  x2   <- x1*cos(zeta) + y1*sin(zeta)
  y2   <- y1*cos(zeta) - x1*sin(zeta)
  plot( x2-min(x2), y2-min(y2), asp=1, col="grey70", cex=1,
        xlab=expression(italic("x")), ylab=expression(italic("y")) )  
  lines(Res3$x.obs-min(Res3$x.obs), Res3$y.obs-min(Res3$y.obs), col=4)
  lines(Res3$x.obs-min(Res3$x.obs), Res3$y.pred-min(Res3$y.obs), col=2)

  RMSE <- sqrt( Res3$RSS / Res3$sample.size )
  RMSE

  # To calculate the volume of the egg 
  VolumeNRGE(P=Res3$par)

  # To calculate the surface area of the egg
  SurfaceAreaNRGE(P=Res3$par)
}

graphics.off()
}

\name{whitespruce}
\encoding{UTF-8}
\docType{data}
\alias{whitespruce}
\title{
Planar Coordinates of \emph{Picea glauca} Tree Rings
}
\description{
The data consist of the planar coordinates of \emph{Picea glauca} tree rings.
}
\usage{
data(whitespruce)
}
\details{
In the data set, there are three columns of variables: \code{Code}, \code{x}, and \code{y}. 
\code{Code} saves the age codes of tree rings from the 2nd year to the 44th year; 
\code{x} saves the \eqn{x} coordinates of the tree rings in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the tree rings in the Cartesian coordinate system (cm).
}
\references{
Shi, P., Huang, J., Hui, C., Grissino-Mayer, H.D., Tardif, J., Zhai, L., Wang, F., Li, B. (2015) 
Capturing spiral radial growth of conifers using the superellipse to model tree-ring geometric shape. 
\emph{Frontiers in Plant Science} 6, 856. \doi{10.3389/fpls.2015.00856}
}
\examples{
data(whitespruce)

uni.C <- sort( unique(whitespruce$Code) )  
Data  <- whitespruce[whitespruce$Code==uni.C[10], ]
x0    <- Data$x
y0    <- Data$y
Res1  <- adjdata(x0, y0, ub.np=2000, len.pro=1/20)

plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      xlim=c(3, 13), ylim=c(3, 13), col="grey73", lwd=2,
      xlab=expression(italic(x)), ylab=expression(italic(y)) )

\donttest{

  uni.C <- sort( unique(whitespruce$Code) )  
  for(i in 1:length(uni.C)){
    Data  <- whitespruce[whitespruce$Code==uni.C[i], ]
    x0    <- Data$x
    y0    <- Data$y

    Res1  <- adjdata(x0, y0, ub.np=200, len.pro=1/10)
  
    if(i == 1){
      plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
            xlim=c(3, 13), ylim=c(3, 13), col=1, lwd=1,
            xlab=expression(italic(x)), ylab=expression(italic(y)) )
    }
    if(i > 1) lines(Res1$x, Res1$y, col=1, lwd=1)
   
  }

  uni.C   <- sort( unique(whitespruce$Code) ) 
  uni.C   <- uni.C[1:12]
  Length  <- c()
  results <- data.frame(Code=c(), x0=c(), y0=c(), theta=c(),
                   a=c(), k=c(), n1=c(), r.sq=c(), RSS=c(), N=c())
  for(i in 1:length(uni.C)){
    Data      <- whitespruce[whitespruce$Code==uni.C[i], ]
    x0        <- Data$x
    y0        <- Data$y
    Res1      <- adjdata(x0, y0, ub.np=200, len.pro=1/10)
    x1        <- Res1$x
    y1        <- Res1$y
    x0.ini    <- mean( x1 )
    y0.ini    <- mean( y1 )
    theta.ini <- c(0, pi/4, pi/2)
    a.ini     <- 0.9
    k.ini     <- 1
    n1.ini    <- c(1.5, 2, 2.5)
    ini.val   <- list(x0.ini, y0.ini, theta.ini, 
                      a.ini, k.ini, n1.ini)

    print(paste("Progress: ", i, "/", length(uni.C), sep=""))
    H <- NULL
    try( H <- fitGE(GE, x=x1, y=y1, ini.val=ini.val, 
                    m=4, simpver=9, unit="cm", par.list=FALSE,
                    stand.fig=FALSE, angle=NULL, fig.opt=FALSE,  
                    control=list(reltol=1e-20, maxit=20000), 
                    np=2000), silent=TRUE )
    if(is.null(H)){
      RE <- data.frame(Code=uni.C[i], x0=NA, y0=NA, theta=NA,
               a=NA, k=NA, n1=NA, r.sq=NA, RSS=NA, N=NA)
    }
    if(!is.null(H)){
      RE     <- data.frame(Code=uni.C[i], x0=H$par[1], y0=H$par[2], 
                  theta=H$par[3], a=H$par[4], k=H$par[5], n1=H$par[6],
                  r.sq=H$r.sq, RSS=H$RSS, N=H$sample.size)
      Length <- c(Length, max(max(H$y.stand.pred)[1]-min(H$y.stand.pred)[1], 
                  max(H$x.stand.pred)[1]-min(H$x.stand.pred)[1])[1])
      if(i == 1){
        plot(H$x.obs, H$y.obs, asp=1, xlim=c(7.4, 8.6), ylim=c(7.4, 8.6),
             cex.lab=1.5, cex.axis=1.5, type="l", lwd=2, col="grey70",
             xlab=expression(italic(x)), ylab=expression(italic(y)))
        lines(H$x.pred, H$y.pred, col=2)         
      } 
      if(i > 1){
        lines(H$x.obs, H$y.obs, lwd=2, col="grey70")
        lines(H$x.pred, H$y.pred, col=2)   
      }
      
    }
    results <- rbind(results, RE)
  }

  # To adjust the estimates of partial parameters to ensure k <= 1
  results2            <- results
  Ind                 <- results$k > 1
  results2$theta[Ind] <- results$theta[Ind] + pi/2
  results2$a[Ind]     <- results$a[Ind] * results$k[Ind]^(1/results$n1[Ind])
  results2$k[Ind]     <- 1/results$k[Ind] 
  results2
  Length/2

}  

}

\name{shoots}
\docType{data}
\alias{shoots}
\title{
Height Growth Data of Bamboo Shoots
}
\description{
The height data of four species of bamboo at Nanjing Forestry University campus in 2016.
}
\usage{
data(shoots)
}
\details{
In the data set, there are four columns of variables: \code{Code}, \code{LatinName}, \code{x}, and \code{y}. 
\code{Code} saves the number codes of different bamboo species; 
\code{LatinName} saves the Latin names of different bamboo species; 
\code{x} saves the investigation times (days from a specific starting time of growth, 
and where every bamboo has a different starting time of growth);  
and \code{y} saves the measured aboveground height values (cm).
 
\code{Code = 1} represents \emph{Phyllostachys iridescens}, and the starting time (namely \code{time = 0}) was defined as 12:00, 3rd April, 2016; 
 
\code{Code = 2} represents \emph{Phyllostachys mannii}, and the starting time (namely \code{time = 0}) was defined as 12:00, 4th April, 2016; 

\code{Code = 3} represents \emph{Pleioblastus maculatus}, and the starting time (namely \code{time = 0}) was defined as 12:00, 29th April, 2016;

\code{Code = 4} represents \emph{Sinobambusa tootsik}, and the starting time (namely \code{time = 0}) was defined as 12:00, 18th April, 2016. 

}
\references{
Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}
}
\examples{
data(shoots)
attach(shoots)
# Choose a species
# 1: Phyllostachys iridescens; 2: Phyllostachys mannii; 
# 3: Pleioblastus maculatus; 4: Sinobambusa tootsik
ind <- 4
x1  <- x[Code == ind]
y1  <- y[Code == ind] 

dev.new()
plot(x1, y1, cex=1.5, cex.lab=1.5, cex.axis=1.5, xlab="Time (days)", ylab="Height (cm)")

\donttest{
  delta0  <- c(0.5, 1, 2, 5, 10, 20)
  ini.val <- list(600, 25, 0, 40, delta0)
  resu1   <- fitsigmoid(MLRFE, x=x1, y=y1, ini.val=ini.val, simpver=NULL, 
               fig.opt=TRUE, control=list(reltol=1e-20, maxit=20000), 
               subdivisions = 100L, rel.tol=.Machine$double.eps^0.25,                
               abs.tol=.Machine$double.eps^0.25, stop.on.error=TRUE, 
               keep.xy=FALSE, aux=NULL)
}

graphics.off()
}

\name{adjdata}
\encoding{UTF-8}
\alias{adjdata}
\title{
Boundary Data Adjustment of A Polygon
}
\description{
\code{adjdata} adjusts the data points in counterclockwise order based on the shortest distance method.
}
\usage{
adjdata(x, y, ub.np = 2000, times = 1.2, len.pro = 1/20, index.sp = 1)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of points on a polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of points on a polygon's boundary.}
  \item{ub.np}{the upper bound of the number of points eventually retained on the polygon's boundary.}
  \item{times}{the number of times \code{ub.np} is initially retained as the number of points.}
  \item{len.pro}{the proportion of the distance between any two points to 
the maximum distance between the points on the polygon's boundary, which is used to 
determine whether the second point needs to be deleted.}
  \item{index.sp}{the index of the starting point of a group of indices that regularly 
divide the number of points on the polygon's boundary into \code{ub.np} parts.}
}
\details{
When \code{ub.np} > \code{length(x)}, \code{length(x)} points 
on the polygon's boundary are retained. 
The \code{\link[stats]{quantile}} function in package \pkg{stats} 
is used to carry out the regular division of data points. From the starting point, the second point is the 
one that has the shortest distance from the former. When the distance between the two points 
is larger than \code{len.pro} multiplied by the maximum distance between points on the polygon's boundary,   
the second point is deleted from the coordinates. 
Then, the third point that has the shortest distance from the first point is defined as the second point. 
If the distance between the first point and the second point is no more than \code{len.pro} multiplied 
by the maximum distance, the first and second points are recorded in a new matrix for the coordinates of the polygon, 
and the second point is defined as the first point in the old matrix for the coordinates of the polygon. 
The shortest distance method is then used to look for a third point that meets the requirement. 
}
\value{
  \item{x}{the \eqn{x} coordinates of points eventually retained on the polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of points eventually retained on the polygon's boundary.}
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Li, Y., Zhang, L., Lin, S., Gielis, J. (2018) General leaf-area geometric 
formula exists for plants - Evidence from the simplified Gielis equation. 
\emph{Forests} 9, 714. \doi{10.3390/f9110714}

Su, J., Niklas, K.J., Huang, W., Yu, X., Yang, Y., Shi, P. (2019) 
Lamina shape does not correlate with lamina surface area: An analysis based on the simplified Gielis equation. 
\emph{Global Ecology and Conservation} 19, e00666. \doi{10.1016/j.gecco.2019.e00666}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\note{
The initial boundary data of a polygon can be obtained by running the M-file based on Matlab (version >= 2009a) 
developed by Shi et al. (2018) and Su et al. (2019) for a .bmp black and white image of the polygon. See references below.
}
\examples{
data(eggs)
uni.C1 <- sort( unique(eggs$Code) )
ind1   <- 2
Data1  <- eggs[eggs$Code==uni.C1[ind1], ]
x0     <- Data1$x
y0     <- Data1$y

Res1   <- adjdata(x0, y0, ub.np=2000, times=1.2, len.pro=1/20)
x1     <- Res1$x
y1     <- Res1$y

dev.new()
plot( x1, y1, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")),
      pch=1, col=1 ) 

Res2   <- adjdata(x0, y0, ub.np=40, times=1, len.pro=1/2, index.sp=20)
x2     <- Res2$x
y2     <- Res2$y

Res3   <- adjdata(x0, y0, ub.np=100, times=1, len.pro=1/2, index.sp=100)
x3     <- Res3$x
y3     <- Res3$y

dev.new()
plot( x2, y2, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")),
      pch=1, col=4 ) 
points( x3, y3, col=2)


data(starfish)

uni.C2 <- sort( unique(starfish$Code) )
ind2   <- 2
Data2  <- starfish[starfish$Code==uni.C2[ind2], ]
x4     <- Data2$x
y4     <- Data2$y

dev.new()
plot( x4, y4, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

Res4 <- adjdata(x4, y4, ub.np=500, times=1.2, len.pro=1/20)
x5   <- Res4$x
y5   <- Res4$y

dev.new()
plot( x5, y5, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

graphics.off()

}

\name{eggs}
\docType{data}
\alias{eggs}
\title{
Egg Boundary Data of Nine Species of Birds
}
\description{
The data consist of the egg boundary data of nine species of birds.
}
\usage{
data(eggs)
}
\details{
In the data set, there are four columns of variables: \code{Code}, \code{LatinName}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual eggs; 
\code{LatinName} saves the Latin names of the nine species of birds; 
\code{x} saves the \eqn{x} coordinates of the egg boundary in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the egg boundary in the Cartesian coordinate system (cm). 
In \code{Code}, codes 1-9 represent \emph{Strix uralensis}, \emph{Dromaius novaehollandiae}, 
\emph{Turdus philomelos}, \emph{Gallus gallus}, \emph{Pandion haliaetus}, \emph{Uria aalge}, 
\emph{Uria lomvia}, \emph{Gallinago media}, and \emph{Aptenodytes patagonicus}, respectively. 
}
\references{
Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Shi, P., Gielis, J., Niklas, K.J. (2022) Comparison of a universal (but complex) model for avian egg 
shape with a simpler model. \emph{Annals of the New York Academy of Sciences} 1514, 34\eqn{-}42. \doi{10.1111/nyas.14799}

Tian, F., Wang, Y., Sandhu, H.S., Gielis, J., Shi, P. (2020) Comparison of seed morphology of two ginkgo cultivars. 
\emph{Journal of Forestry Research} 31, 751\eqn{-}758. \doi{10.1007/s11676-018-0770-y}
}
\examples{
data(eggs)

uni.C <- sort( unique(eggs$Code) )
ind   <- 8
Data  <- eggs[eggs$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=1000, times=1.2, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y

dev.new()
plot( x1, y1, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      xlab=expression(italic("x")), ylab=expression(italic("y")),
      pch=1, col=1 ) 

Res2 <- adjdata(x0, y0, ub.np=60, times=1, len.pro=1/2, index.sp=20)
x2   <- Res2$x
y2   <- Res2$y

Res3 <- adjdata(x0, y0, ub.np=60, times=1, len.pro=1/2, index.sp=100)
x3   <- Res3$x
y3   <- Res3$y

dev.new()
plot( x2, y2, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")),
      pch=1, col=4 ) 
points( x3, y3, col=2)

graphics.off()
}

\name{EPE}
\encoding{UTF-8}
\alias{EPE}
\title{
Calculation of the Ordinate For an Arbitrary Point on the Preston Curve in the Plane  
}
\description{
\code{EPE} is used to calculate the \emph{y}-value for an arbitrary point on the Preston curve 
that was generated by the explicit Preston equation or one of its simplified versions for a given \emph{x}-value.
}
\usage{
EPE(P, x, simpver = NULL)
}
\arguments{
  \item{P}{the parameters of the explicit Preston equation or one of its simplified versions.}
  \item{x}{the \emph{x}-value used in the explicit Preston equation.}
  \item{simpver}{an optional argument to use the simplified version of the explicit Preston equation.}
}
\details{
When \code{simpver = NULL}, the explicit Preston equation is selected: 
\deqn{ y = b\ \sqrt{1-\left(\frac{x}{a}\right)^2}\left(1+c_{1}\ \frac{x}{a}+c_{2}\left(\frac{x}{a}\right)^2+c_{3}\left(\frac{x}{a}\right)^3\right), }
where \code{P} has five parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, \eqn{c_{2}}, and \eqn{c_{3}}.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{ y = b\ \sqrt{1-\left(\frac{x}{a}\right)^2}\left(1+c_{1}\ \frac{x}{a}+c_{2}\left(\frac{x}{a}\right)^2\right), }
where \code{P} has four parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, and \eqn{c_{2}}.

\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{ y = b\ \sqrt{1-\left(\frac{x}{a}\right)^2}\left(1+c_{1}\ \frac{x}{a}\right), }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{1}}.

\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{ y = b\ \sqrt{1-\left(\frac{x}{a}\right)^2}\left(1+c_{2}\left(\frac{x}{a}\right)^2\right), }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{2}}.
}
\value{
The \eqn{y} values predicted by the explicit Preston equation.
}
\note{
We only considered the upper part of the egg-shape curve in the above expressions because 
the lower part is symmetrical to the upper part around the \emph{x}-axis.  
The mid-line of an egg's profile in \code{\link{EPE}} is aligned to 
the \emph{x}-axis, while the mid-line of an egg's profile in \code{\link{PE}} 
is aligned to the \emph{y}-axis. The \code{\link{EPE}} function has the same parameters, 
\code{P}, as those in the \code{\link{PE}} function. 
The explicit Preston equation is used for calculating an egg's volume and surface area, 
when the parameters, which are saved in the  \code{P} vector, 
are obtained using the \code{\link{fitEPE}} function 
or the \code{\link{lmPE}} function based on the \code{\link{TSE}} function. 
In addition, the values in \code{x} > \eqn{a} (i.e., the first element in \code{P}) 
are forced to be \eqn{a}, and the values in 
\code{x} < \eqn{-a} will be forced to be \eqn{-a}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}
}
\seealso{
\code{\link{curveEPE}}, \code{\link{fitEPE}}, \code{\link{PE}}, \code{\link{SurfaceAreaEPE}}, \code{\link{VolumeEPE}}
}
\examples{
  Par3 <- c(4.27, 2.90, 0.0868, 0.0224, -0.0287)
  xx1  <- seq(-4.27, 4.27, by=0.001)
  yy1  <- EPE(P=Par3, x=xx1, simpver=NULL)
  yy2  <- -EPE(P=Par3, x=xx1, simpver=NULL)

  dev.new()
  plot(xx1, yy1, asp=1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlim=c(-5, 5), ylim=c(-5, 5), 
       xlab=expression(italic(x)), ylab=expression(italic(y)))
  lines(xx1, yy2, col=2) 

  graphics.off() 
}

\name{MBriereE}
\encoding{UTF-8}
\alias{MBriereE}
\title{
Modified Briere Equation
}
\description{
\code{MBriereE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the modified Brière equation or one of its simplified versions. 
}
\usage{
MBriereE(P, x, simpver = 1)
}
\arguments{
  \item{P}{the parameters of the modified Brière equation or one of its simplified versions.}
  \item{x}{the given \eqn{x} values.}
  \item{simpver}{an optional argument to use the simplified version of the modified Brière equation.}
}
\details{

When \code{simpver = NULL}, the modified Brière equation is selected: 
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = a\left|x(x-x_{\mathrm{min}})(x_{\mathrm{max}}-x)^{1/m}\right|^{\delta};}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
and \eqn{a}, \eqn{m}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta} are constants to be estimated, 
where \eqn{x_{\mathrm{min}}} and \eqn{x_{\mathrm{max}}} represents the 
lower and upper intersections between the curve and the \eqn{x}-axis. \eqn{y} is defined as 0 
when \eqn{x < x_{\mathrm{min}}} or \eqn{x > x_{\mathrm{max}}}. There are five elements in \code{P}, representing 
the values of \eqn{a}, \eqn{m}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta}, respectively.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = a\left|x^{2}(x_{\mathrm{max}}-x)^{1/m}\right|^{\delta};}
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are four elements in \code{P}, representing 
the values of \eqn{a}, \eqn{m}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta}, respectively.


\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = ax(x-x_{\mathrm{min}})(x_{\mathrm{max}}-x)^{1/m};}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are four elements in \code{P} representing 
the values of \eqn{a}, \eqn{m}, \eqn{x_{\mathrm{min}}}, and \eqn{x_{\mathrm{max}}}, respectively.


\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected: 
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = ax^{2}(x_{\mathrm{max}}-x)^{1/m};}
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are three elements in \code{P} representing 
the values of \eqn{a}, \eqn{m}, and \eqn{x_{\mathrm{max}}}, respectively.
}
\value{
The \eqn{y} values predicted by the modified Brière equation or one of its simplified versions.
}
\note{
We have added a parameter \eqn{\delta} in the original Brière equation (i.e., \code{simpver = 2}) to increase the flexibility for data fitting.
}
\references{
Brière, J.-F., Pracros, P, Le Roux, A.-Y., Pierre, J.-S. (1999) A novel rate
model of temperature-dependent development for arthropods. \emph{Environmental 
Entomology} 28, 22\eqn{-}29. \doi{10.1093/ee/28.1.22}

Cao, L., Shi, P., Li, L., Chen, G. (2019) A new flexible sigmoidal growth model. \emph{Symmetry} 11, 204.
\doi{10.3390/sym11020204}

Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{areaovate}}, \code{\link{curveovate}}, \code{\link{fitovate}}, \code{\link{fitsigmoid}}, 
\code{\link{MbetaE}}, \code{\link{MLRFE}}, \code{\link{MPerformanceE}}, \code{\link{sigmoid}}
}
\examples{
x2   <- seq(-5, 15, len=2000)
Par2 <- c(0.01, 3, 0, 10, 1)
y2   <- MBriereE(P=Par2, x=x2, simpver=NULL)

dev.new()
plot( x2, y2, cex.lab=1.5, cex.axis=1.5, type="l",
      xlab=expression(italic(x)), ylab=expression(italic(y)) )

graphics.off()
}

\name{MbetaE}
\encoding{UTF-8}
\alias{MbetaE}
\title{
Modified Beta Equation
}
\description{
\code{MbetaE} is used to calculate \eqn{y} values at given \eqn{x} values 
using the modified beta equation or one of its simplified versions.
}
\usage{
MbetaE(P, x, simpver = 1)
}
\arguments{
  \item{P}{the parameters of the modified beta equation or one of its simplified versions.}
  \item{x}{the given \eqn{x} values.}
  \item{simpver}{an optional argument to use the simplified version of the modified beta equation.}
}
\details{

When \code{simpver = NULL}, the modified beta equation is selected: 
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = y_{\mathrm{opt}}{ \left[\left(\frac{x_{\mathrm{max}}-x}{x_{\mathrm{max}}-x_{\mathrm{opt}}}\right)\left(\frac{x-x_{\mathrm{min}}}{x_{\mathrm{opt}}-x_{\mathrm{min}}}\right)^{\frac{x_{\mathrm{opt}}-x_{\mathrm{min}}}{x_{\mathrm{max}}-x_{\mathrm{opt}}}} \right] }^{\delta};}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
\eqn{y_{\mathrm{opt}}}, \eqn{x_{\mathrm{opt}}}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta} are constants to be estimated;  
\eqn{y_{\mathrm{opt}}} represents the maximum \eqn{y}, and \eqn{x_{\mathrm{opt}}} is the \eqn{x} value associated with 
the maximum \eqn{y} (i.e., \eqn{y_{\mathrm{opt}}}); 
and \eqn{x_{\mathrm{min}}} and \eqn{x_{\mathrm{max}}} represent the 
lower and upper intersections between the curve and the \eqn{x}-axis. \eqn{y} is defined as 0 
when \eqn{x < x_{\mathrm{min}}} or \eqn{x > x_{\mathrm{max}}}. There are five elements in \code{P}, representing 
the values of \eqn{y_{\mathrm{opt}}}, \eqn{x_{\mathrm{opt}}}, \eqn{x_{\mathrm{min}}}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta}, respectively.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = y_{\mathrm{opt}}{ \left[\left(\frac{x_{\mathrm{max}}-x}{x_{\mathrm{max}}-x_{\mathrm{opt}}}\right)\left(\frac{x}{x_{\mathrm{opt}}}\right)^{\frac{x_{\mathrm{opt}}}{x_{\mathrm{max}}-x_{\mathrm{opt}}}} \right] }^{\delta};}
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are four elements in \code{P}, representing 
the values of \eqn{y_{\mathrm{opt}}}, \eqn{x_{\mathrm{opt}}}, \eqn{x_{\mathrm{max}}}, and \eqn{\delta}, respectively.


\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{\mbox{if } x \in{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = y_{\mathrm{opt}}{ \left(\frac{x_{\mathrm{max}}-x}{x_{\mathrm{max}}-x_{\mathrm{opt}}}\right)\left(\frac{x-x_{\mathrm{min}}}{x_{\mathrm{opt}}-x_{\mathrm{min}}}\right)^{\frac{x_{\mathrm{opt}}-x_{\mathrm{min}}}{x_{\mathrm{max}}-x_{\mathrm{opt}}}} };}
\deqn{\mbox{if } x \notin{\left(x_{\mathrm{min}}, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are four elements in \code{P}, representing 
the values of \eqn{y_{\mathrm{opt}}}, \eqn{x_{\mathrm{opt}}}, \eqn{x_{\mathrm{min}}}, and \eqn{x_{\mathrm{max}}}, respectively.


\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{\mbox{if } x \in{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = y_{\mathrm{opt}}{ \left(\frac{x_{\mathrm{max}}-x}{x_{\mathrm{max}}-x_{\mathrm{opt}}}\right)\left(\frac{x}{x_{\mathrm{opt}}}\right)^{\frac{x_{\mathrm{opt}}}{x_{\mathrm{max}}-x_{\mathrm{opt}}}} }; } 
\deqn{\mbox{if } x \notin{\left(0, \ x_{\mathrm{max}}\right)},}
\deqn{y = 0.}
There are three elements in \code{P}, representing 
the values of \eqn{y_{\mathrm{opt}}}, \eqn{x_{\mathrm{opt}}}, and \eqn{x_{\mathrm{max}}}, respectively.
}
\value{
The \eqn{y} values predicted by the modified beta equation or one of its simplified versions.
}
\references{
Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\note{
We have added a parameter \eqn{\delta} in the original beta equation (i.e., \code{simpver = 2}) to increase the flexibility for data fitting.
}
\seealso{
\code{\link{areaovate}}, \code{\link{curveovate}}, \code{\link{fitovate}}, \code{\link{fitsigmoid}}, 
\code{\link{MBriereE}}, \code{\link{MLRFE}}, \code{\link{MPerformanceE}}, \code{\link{sigmoid}}
}
\examples{
x1   <- seq(-5, 15, len=2000)
Par1 <- c(3, 3, 10, 2)
y1   <- MbetaE(P=Par1, x=x1, simpver=1)

dev.new()
plot( x1, y1,cex.lab=1.5, cex.axis=1.5, type="l",
      xlab=expression(italic(x)), ylab=expression(italic(y)) )
 
graphics.off()
}

\name{SCSE}
\encoding{UTF-8}
\alias{SCSE}
\title{
Sarabia-Castillo-Slottje Equation (SCSE)
}
\description{
\code{SCSE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the Sarabia-Castillo-Slottje equation. The equation describes the \eqn{y} coordinates of the Lorenz curve.
}
\usage{
SCSE(P, x)
}
\arguments{
  \item{P}{the parameters of the Sarabia-Castillo-Slottje equation.}
  \item{x}{the given \eqn{x} values ranging between 0 and 1.}
}
\details{

\deqn{y = x^{\gamma}\left[1-\left(1-x\right)^{\alpha}\right]^{\beta}.}

Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
and \eqn{\gamma}, \eqn{\alpha} and \eqn{\beta} are constants to be estimated, where \eqn{\gamma \ge 0}, 
\eqn{0 < \alpha \le 1}, and \eqn{\beta \ge 1}.   
There are three elements in \code{P}, representing 
the values of \eqn{\gamma}, \eqn{\alpha} and \eqn{\beta}, respectively.
}
\value{
The \eqn{y} values predicted by the Sarabia-Castillo-Slottje equation.
}
\note{
The numerical range of \eqn{x} should range between 0 and 1.
}
\references{
Sarabia, J.-M., Castillo, E., Slottje, D.J. (1999) An ordered family of Lorenz curves. 
\emph{Journal of Econometrics}. 91, 43\eqn{-}60. \doi{10.1016/S0304-4076(98)00048-7}

Sitthiyot, T., Holasut, K. (2023) A universal model for the Lorenz curve with novel applications 
for datasets containing zeros and/or exhibiting extreme inequality. \emph{Scientific Reports} 
13, 4729. \doi{10.1038/s41598-023-31827-x}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{fitLorenz}}, \code{\link{MPerformanceE}}, \code{\link{SarabiaE}}, \code{\link{SHE}}
}
\examples{
X1  <- seq(0, 1, len=2000)
Pa2 <- c(0, 0.790, 1.343)
Y2  <- SCSE(P=Pa2, x=X1)

dev.new()
plot( X1, Y2, cex.lab=1.5, cex.axis=1.5, type="l", asp=1, xaxs="i", 
      yaxs="i", xlim=c(0, 1), ylim=c(0, 1), 
      xlab="Cumulative proportion of the number of infructescences", 
      ylab="Cumulative proportion of the infructescence length" )

graphics.off()
}

\name{TSE}
\encoding{UTF-8}
\alias{TSE}
\title{
The Todd-Smart Equation (TSE) 
}
\description{
\code{TSE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the Todd and Smart's re-expression of Preston's universal egg shape.
}
\usage{
TSE(P, x, simpver = NULL)
}
\arguments{
  \item{P}{the parameters of the original Todd-Smart equation or one of its simplified versions.}
  \item{x}{the given \eqn{x} values ranging from -1 to 1.}
  \item{simpver}{an optional argument to use the simplified version of the original Todd-Smart equation.}
}
\details{
When \code{simpver = NULL}, the original Preston equation is selected: 
\deqn{y = d_{0}z_{0} + d_{1}z_{1} + d_{2}z_{2} + d_{3}z_{3},}
where 
\deqn{z_{0}=\sqrt{1-x^2},}
\deqn{z_{1}=x\sqrt{1-x^2},}
\deqn{z_{2}=x^{2}\sqrt{1-x^2},}
\deqn{z_{3}=x^{3}\sqrt{1-x^2}.}
Here, \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Todd-Smart curve; 
\eqn{d_{0}}, \eqn{d_{1}}, \eqn{d_{2}}, and \eqn{d_{3}} are parameters to be estimated.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{y = d_{0}z_{0} + d_{1}z_{1} + d_{2}z_{2},}
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Todd-Smart curve; 
\eqn{d_{0}}, \eqn{d_{1}}, and \eqn{d_{2}} are parameters to be estimated.

\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{y = d_{0}z_{0} + d_{1}z_{1},} 
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Todd-Smart curve; 
\eqn{d_{0}}, and \eqn{d_{1}} are parameters to be estimated.

\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{y = d_{0}z_{0} + d_{2}z_{2},}
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Todd-Smart curve; 
\eqn{d_{0}}, and \eqn{d_{2}} are parameters to be estimated.

}
\value{
The \eqn{y} values predicted by the Todd-Smart equation.
}
\note{
Here, \eqn{x} and \eqn{y} in the Todd-Smart equation are actually equal to \eqn{y/a} 
and \eqn{x/a}, respectively, in the Preston equation (See \code{\link{PE}} for details). 
Since \eqn{a} represents half the egg length, this means that the egg length is fixed to be 2, 
and the maximum egg width is correspondingly adjusted to keep the same scale.   
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston's universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Nelder, J.A., Mead, R. (1965). A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Preston, F.W. (1953) The shapes of birds' eggs. \emph{The Auk} 70, 160\eqn{-}182.

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Todd, P.H., Smart, I.H.M. (1984) The shape of birds' eggs. \emph{Journal of Theoretical Biology} 
106, 239\eqn{-}243. \doi{10.1016/0022-5193(84)90021-3}
}
\seealso{
\code{\link{lmPE}}, \code{\link{PE}}
}
\examples{
  Par <- c(0.695320398, -0.210538656, -0.070373518, 0.116839895)
  xb1 <- seq(-1, 1, len=20000)
  yb1 <- TSE(P=Par, x=xb1)
  xb2 <- seq(1, -1, len=20000)
  yb2 <- -TSE(P=Par, x=xb2)

  dev.new()
  plot(xb1, yb1, asp=1, type="l", col=2, ylim=c(-1, 1), cex.lab=1.5, cex.axis=1.5, 
    xlab=expression(italic(x)), ylab=expression(italic(y)))
  lines(xb2, yb2, col=4)

  graphics.off()
}

\name{Neocinnamomum}
\docType{data}
\alias{Neocinnamomum}
\title{
Leaf Boundary Data of Seven Species of \emph{Neocinnamomum}
}
\description{
The data consist of the leaf boundary data of seven species of \emph{Neocinnamomum}.
}
\usage{
data(Neocinnamomum)
}
\details{
In the data set, there are four columns of variables: \code{Code}, \code{LatinName}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual leaves; 
\code{LatinName} saves the Latin names of the seven species of \emph{Neocinnamomum}; 
\code{x} saves the \eqn{x} coordinates of the leaf boundary in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the leaf boundary in the Cartesian coordinate system (cm).
}
\references{
Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Yu, K., Niklas, K.J., Schrader, J., Song, Y., Zhu, R., Li, Y., Wei, H., Ratkowsky, D.A. (2021)  
A general model for describing the ovate leaf shape. \emph{Symmetry}, 13, 1524. \doi{10.3390/sym13081524}
}
\examples{
data(Neocinnamomum)

uni.C <- sort( unique(Neocinnamomum$Code) )
ind   <- 2
Data  <- Neocinnamomum[Neocinnamomum$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y
length(x0)

Res1  <- adjdata(x0, y0, ub.np=200, len.pro=1/20)
x1    <- Res1$x
y1    <- Res1$y
length(x1)

dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) ) 

graphics.off()
}

\name{fitovate}
\encoding{UTF-8}
\alias{fitovate}
\title{
Data-Fitting Function for the Ovate Leaf-Shape Equation
}
\description{
\code{fitovate} is used to estimate the parameters of a simplified performance equation.
}
\usage{
fitovate(expr, x, y, ini.val, 
         par.list = FALSE, stand.fig = TRUE, control = list(), 
         angle = NULL, fig.opt = FALSE, index.xmax = 3, np = 2000, 
         xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{expr}{the simplified version 1 of the performance equations.}
  \item{x}{the \eqn{x} coordinates of a polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of a polygon's boundary.}
  \item{ini.val}{the initial values of the simplified version 1 of a performance equation.}  
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{stand.fig}{an optional argument to draw the observed and predicted polygons' boundaries at the standard state 
(i.e., the origin is located at (0, 0), and the major axis overlaps with the \eqn{x}-axis).}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{angle}{the angle between the major axis of the polygon and the \eqn{x}-axis, which can be defined by the user.}
  \item{fig.opt}{an optional argument to draw the observed and predicted polygons at an arbitrary angle 
between the major axis and the \eqn{x}-axis.}
  \item{index.xmax}{the specified index in parameters representing \eqn{x_{\mathrm{max}}}.}
  \item{np}{the number of data points on the predicted ovate leaf-shape curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the ovate leaf-shape curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the ovate leaf-shape curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the ovate leaf-shape curve.}
  \item{main}{the main title of the figure.}
}
\details{
\code{ini.val} is a list for two types of parameters: three location parameters, 
and model parameters. This means that \code{expr} is limited to 
being the simplified version 1 (where \eqn{x_{\mathrm{min}} = 0})  
in \code{\link{MbetaE}}, \code{\link{MBriereE}}, \code{\link{MLRFE}}, and \code{\link{MPerformanceE}}. 
The initial values for the first three parameters in \code{ini.val} are location parameters, 
among which the first two are the planar coordinates of the transferred origin, 
and the third is the angle between the major axis of the polygon and the \eqn{x}-axis. 
The Nelder-Mead algorithm (Nelder and Mead, 1965) is used to carry out the optimization of minimizing 
the residual sum of squares (RSS) between the observed and predicted \eqn{y}-axis. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
When \code{angle = NULL}, the observed polygon will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, it indicates that the major axis 
is rotated by the amount (\eqn{\pi/4}) counterclockwise from the \eqn{x}-axis.
}
\value{
  \item{par}{the estimates of the model parameters.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points on the polygon's boundary in the data fitting.}
  \item{scan.length}{the observed length of the polygon's boundary.}
  \item{scan.width}{the observed width of the polygon's boundary.}
  \item{scan.perimeter}{the observed perimeter of the polygon's boundary.}
  \item{scan.area}{the observed area of the polygon's boundary.}
  \item{pred.length}{the predicted length of the polygon's boundary.}
  \item{pred.width}{the predicted width of the polygon's boundary.}
  \item{pred.perimeter}{the predicted perimeter of the polygon's boundary.}
  \item{pred.area}{the predicted area of the polygon's boundary.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates at the standard state.}
  \item{x.stand.pred}{the predicted \eqn{x} coordinates at the standard state.}
  \item{y.stand.obs}{the observed \eqn{y} coordinates at the standard state.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates at the standard state.} 
  \item{x.obs}{the observed \eqn{x} coordinates at the transferred angles defined by the user.}
  \item{x.pred}{the predicted \eqn{x} coordinates at the transferred angles defined by the user.}
  \item{y.obs}{the observed \eqn{y} coordinates at the transferred angles defined by the user.}
  \item{y.pred}{the predicted \eqn{y} coordinates at the transferred angles defined by the user.}       
}
\note{
There are two types of parameters (i.e., three location parameters and model parameters) 
for the value of \code{par}. The transferred 
angle denotes the angle between the major axis and the \eqn{x}-axis. For the argument \code{index.xmax}, 
the default is 3, which corresponds to the order of the model parameter of \eqn{x_{\mathrm{max}}} in 
\code{\link{MbetaE}}, \code{\link{MBriereE}}, and \code{\link{MLRFE}}. However, in \code{\link{MPerformanceE}}, 
\code{index.xmax} should be 4 rather than 3.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Huey, R.B., Stevenson, R.D. (1979) Integrating thermal physiology and ecology of ectotherms: 
a discussion of approaches. \emph{American Zoologist} 19, 357\eqn{-}366. \doi{10.1093/icb/19.1.357}

Li, Y., Zheng, Y., Ratkowsky, D.A., Wei, H., Shi, P. (2022) Application of an ovate leaf shape model 
to evaluate leaf bilateral asymmetry and calculate lamina centroid location. 
\emph{Frontiers in Plant Science} 12, 822907. \doi{10.3389/fpls.2021.822907}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Ge, F., Sun, Y., Chen, C. (2011) A simple model for describing 
the effect of temperature on insect developmental rate. \emph{Journal of Asia-Pacific Entomology} 
14, 15\eqn{-}20. \doi{10.1016/j.aspen.2010.11.008} 

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Yu, K., Niklas, K.J., Schrader, J., Song, Y., Zhu, R., Li, Y., Wei, H., Ratkowsky, D.A. (2021)  
A general model for describing the ovate leaf shape. \emph{Symmetry} 13, 1524. \doi{10.3390/sym13081524}
}
\seealso{
\code{\link{areaovate}}, \code{\link{curveovate}}, \code{\link{MbetaE}}, 
\code{\link{MBriereE}}, \code{\link{MLRFE}}, \code{\link{MPerformanceE}}
}
\examples{
data(Neocinnamomum)

uni.C <- sort( unique(Neocinnamomum$Code) )
ind   <- 2
Data  <- Neocinnamomum[Neocinnamomum$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=200, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y

dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) ) 

\donttest{
  x0.ini    <- min( x1 )
  y0.ini    <- min( y1 )
  theta.ini <- pi/4
  len.max   <- max( max(y1)-min(y1), max(x1)-min(x1) ) *2/sqrt(2)
  a.ini     <- c(0.1, 0.01, 0.001, 0.0001)
  m.ini     <- c(0.1, 0.5, 1, 2)
  x2.ini    <- len.max
  delta.ini <- c(0.5, 1)
  ini.val   <- list(x0.ini, y0.ini, theta.ini, a.ini, m.ini, x2.ini, delta.ini)

  Res1 <- fitovate(MBriereE, x=x1, y=y1, ini.val=ini.val,            
            par.list=FALSE, fig.opt=TRUE, angle=pi/6, 
            control=list(reltol=1e-20, maxit=20000), 
            np=2000, unit=NULL)
  Res1$RSS

  x0.ini    <- min( x1 )
  y0.ini    <- min( y1 )
  theta.ini <- pi/4
  len.max   <- max( max(y1)-min(y1), max(x1)-min(x1) ) *2/sqrt(2)
  yc.ini    <- len.max/3 
  xc.ini    <- 1/4*len.max
  x2.ini    <- len.max
  delta.ini <- c(0.5, seq(1, 5, by=5))
  ini.val   <- list(x0.ini, y0.ini, theta.ini, yc.ini, xc.ini, x2.ini, delta.ini)

  Res2 <- fitovate( MbetaE, x=x1, y=y1, ini.val=ini.val,            
                    par.list=TRUE, fig.opt=TRUE, angle=pi/3, 
                    control=list(reltol=1e-20, maxit=20000), 
                    np=2000, unit=NULL )
  Res2$RSS

  Res3 <- fitovate( MLRFE, x=x1, y=y1, ini.val=ini.val, 
                    unit=NULL, par.list=FALSE, fig.opt=TRUE, 
                    angle=NULL, control=list(reltol=1e-20, 
                    maxit=20000), np=2000)
  Res3$RSS


  x0.ini    <- min( x1 )
  y0.ini    <- min( y1 )
  theta.ini <- pi/4
  len.max   <- max( max(y1)-min(y1), max(x1)-min(x1) ) *2/sqrt(2)
  c.ini     <- 1/5*len.max
  K1.ini    <- c(0.1, 1, 5, 10)
  K2.ini    <- 1
  x2.ini    <- len.max
  a.ini     <- 1
  b.ini     <- 1
  ini.val   <- list(x0.ini, y0.ini, theta.ini, c.ini, K1.ini, K2.ini, x2.ini, a.ini, b.ini)

  Res4 <- fitovate( MPerformanceE, x=x1, y=y1, ini.val=ini.val,            
                    par.list=TRUE, fig.opt=TRUE, index.xmax=4, angle=pi/3, 
                    control=list(reltol=1e-20, maxit=20000), 
                    np=2000, unit=NULL )
  Res4$RSS
}

graphics.off()
}

\name{kp}
\docType{data}
\alias{kp}
\title{
Boundary Data of the Vertical Projections of \emph{Koelreuteria paniculata} Fruit
}
\description{
The data consist of the boundary data of four vertical projections of \emph{K. paniculata} fruit  
sampled at Nanjing Forestry University campus in early October 2021.
}
\usage{
data(kp)
}
\details{
In the data set, there are three columns of variables: \code{Code}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual fruit; 
\code{x} saves the \eqn{x} coordinates of the vertical projections of fruit in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the vertical projections of fruit in the Cartesian coordinate system (cm).
}
\references{
Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}
}
\examples{
data(kp)

uni.C <- sort( unique(kp$Code) )
ind   <- 1
Data  <- kp[kp$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=200, len.pro=1/20)
dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

\donttest{
  x1        <- Res1$x
  y1        <- Res1$y
  x0.ini    <- mean( x1 )
  y0.ini    <- mean( y1 )
  theta.ini <- pi
  a.ini     <- 0.9
  n1.ini    <- c(1, 4)
  n2.ini    <- 5
  n3.ini    <- c(5, 10, 15)
  ini.val   <- list(x0.ini, y0.ini, theta.ini, 
                    a.ini, n1.ini, n2.ini, n3.ini)

  Res2 <- fitGE( GE, x=x1, y=y1, ini.val=ini.val, 
                 m=3, simpver=5, nval=1, unit="cm",  
                 par.list=FALSE, fig.opt=TRUE, angle=NULL, 
                 control=list(reltol=1e-20, maxit=20000), 
                 np=2000 )
}

graphics.off()
}

\name{GE}
\encoding{UTF-8}
\alias{GE}
\title{
Calculation of the Polar Radius of the Gielis Curve
}
\description{
\code{GE} is used to calculate polar radii of the original Gielis equation  
or one of its simplified versions at given polar angles.
}
\usage{
GE(P, phi, m = 1, simpver = NULL, nval = 1)
}
\arguments{
  \item{P}{the parameters of the original Gielis equation or one of its simplified versions.}
  \item{phi}{the polar angle(s).}
  \item{m}{the given \eqn{m} value that determines the number of angles of 
the Gielis curve within \eqn{[0, 2\pi)}.}
  \item{simpver}{an optional argument to use the simplified version of the original Gielis equation.}
  \item{nval}{the specified value for \eqn{n_{1}} or \eqn{n_{2}} or \eqn{n_{3}} in the simplified versions.}
}
\details{
When \code{simpver = NULL}, the original Gielis equation is selected: 
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{3}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{r} represents the polar radius at the polar angle \eqn{\varphi}; 
\eqn{m} determines the number of angles within \eqn{[0, 2\pi)}; and \eqn{a}, \eqn{k}, \eqn{n_{1}}, 
\eqn{n_{2}}, and \eqn{n_{3}} need to be provided in \code{P}.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}} need to be provided in \code{P}.

\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}\right)^{-\frac{1}{n_{1}}}, }
where \eqn{a} and \eqn{n_{1}} need to be provided in \code{P}, and \eqn{n_{2}} should be specified in \code{nval}.

\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}\right)^{-\frac{1}{n_{1}}}, }
where \eqn{a} needs to be provided in \code{P}, and \eqn{n_{1}} 
should be specified in \code{nval}.

\eqn{\quad} When \code{simpver = 4}, the simplified version 4 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}\right)^{-\frac{1}{n_{1}}}, }
where \eqn{a} and \eqn{n_{1}} need to be provided in \code{P}.

\eqn{\quad} When \code{simpver = 5}, the simplified version 5 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{3}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a}, \eqn{n_{1}}, \eqn{n_{2}}, and \eqn{n_{3}} need to be provided in \code{P}.
 
\eqn{\quad} When \code{simpver = 6}, the simplified version 6 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a}, \eqn{k}, \eqn{n_{1}}, and \eqn{n_{2}} need to be provided in \code{P}.

\eqn{\quad} When \code{simpver = 7}, the simplified version 7 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a}, \eqn{k}, and \eqn{n_{1}} need to be provided in \code{P}, and \eqn{n_{2}} 
should be specified in \code{nval}.

\eqn{\quad} When \code{simpver = 8}, the simplified version 8 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a} and \eqn{k} are parameters that need to be provided in \code{P}, and \eqn{n_{1}} 
should be specified in \code{nval}.

\eqn{\quad} When \code{simpver = 9}, the simplified version 9 is selected:
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{1}}\right)^{-\frac{1}{n_{1}}},}
where \eqn{a}, \eqn{k}, and \eqn{n_{1}} need to be provided in \code{P}.
}
\value{
The polar radii predicted by the original Gielis equation or one of its simplified versions.
}
\note{
\code{simpver} here is different from that in the \code{\link{TGE}} function.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Gielis, J. (2003) A generic geometric transformation that unifies a wide range of natural 
and abstract shapes. \emph{American Journal of Botany} 90, 333\eqn{-}338. \doi{10.3732/ajb.90.3.333}

Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric 
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}

Shi, P., Xu, Q., Sandhu, H.S., Gielis, J., Ding, Y., Li, H., Dong, X. (2015) Comparison
of dwarf bamboos (\emph{Indocalamus} sp.) leaf parameters to determine relationship
between spatial density of plants and total leaf area per plant. \emph{Ecology and Evolution} 5,
4578\eqn{-}4589. \doi{10.1002/ece3.1728}
}
\seealso{
\code{\link{areaGE}}, \code{\link{curveGE}}, \code{\link{DSGE}}, \code{\link{fitGE}}, 
\code{\link{SurfaceAreaSGE}}, \code{\link{TGE}}, \code{\link{VolumeSGE}}
}
\examples{
GE.par  <- c(2, 1, 4, 6, 3)
varphi.vec <- seq(0, 2*pi, len=2000)
r.theor <- GE(P=GE.par, phi=varphi.vec, m=5)

dev.new()
plot( varphi.vec, r.theor, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(varphi)), ylab=expression(italic("r")),
      type="l", col=4 ) 

graphics.off()
}

\name{PlanCoor}
\encoding{UTF-8}
\alias{PlanCoor}
\title{
Extracts the Planar Coordinates the 2-D Profiles of Apical Meristems
}
\description{
\code{PlanCoor} is used to extract the planar coordinates the 2-D profiles 
of shoot or root apical meristems in grayscale bitmap (.bmp) images saved in a folder.
}
\usage{
PlanCoor( folder.name, lower.val = 0, upper.val = 250, ratio = 1,  
          fig.opt = TRUE, np = NULL, unit = "unitless", verbose = TRUE )
}
\arguments{
  \item{folder.name}{the name of a folder that saves the 2-D profiles 
of shoot or root apical meristems in grayscale .bmp images}
  \item{lower.val}{the lower bound of pixel values for selecting an AM's profile curve from a grayscale image.}
  \item{upper.val}{the upper bound of pixel values for selecting an AM's profile curve from a grayscale image.}
  \item{ratio}{the scaling factor between the actual image dimensions and the desired coordinate system scale.}
  \item{fig.opt}{an optional argument to draw the extracted the AM's profile curve.}
  \item{np}{the number of data points forming an AM's profile curve.}
  \item{unit}{the unit of the \eqn{x}-axis and the \eqn{y}-axis when showing an AM's profile curve.}
  \item{verbose}{an optional argument allowing the user to suppress the printing of computation progress.}
}
\details{
The apical meristem profiles are recommended to be extracted using the Pen Tool in Adobe Photoshop 
(version >= 22.4.2; Adobe, San Jose, CA, USA) and saved as grayscale bitmap (.bmp) images. 
In each image, the profile should be depicted in black or a gray value close to black, 
whereas the remaining areas should be set to white (with pixel values of 255). 
All profiles are recommended to be adjusted to form downward-opening curves using Adobe Photoshop. 
The resulting profiles are to be saved in a folder within the current R working directory. 
The name of this folder is used as an argument \code{folder.name} in the \code{\link{PlanCoor}} function. 
Users can adjust the values of \code{lower.val} and \code{upper.val} to enhance 
the clarity of the shoot or root apical meristem profiles. The argument \code{ratio} 
represents the scaling factor between the actual image dimensions and the desired coordinate system scale. 
For example, if an image has a width of 7 cm and a height of 10 cm, setting \code{ratio = 2} will result in 
\eqn{x}- and \eqn{y}-coordinates being mapped to a window of 14 cm by 20 cm. The default of \code{np} is 
\code{NULL}, and the number of data points forming an AM's profile curve depends on the resolution of the 
image and the size of the extracted AM's profile. If the use defines an integer such as 500, the final 
number of data points is equal to the minimum value of 500 and the number of data point when \code{np = NULL}.
}
\value{
  \item{FileName}{the names of the files in the folder but removing the file extension 
(e.g., "myimage" from a file named "myimage.bmp" by dropping its extension ".bmp").}
  \item{x}{the \eqn{x}-coordinates of the profile curve(s).}
  \item{y}{the \eqn{y}-coordinates of the profile curve(s).}   
}
\note{
In the folder, one image is also allowed. Assume that all grayscale .bmp images are saved in 
a folder named "Image" in the current working directory. Using \code{PlanCoor(folder.name = "Image", 
fig.opt = FALSE)} can obtain the \eqn{x}- and \eqn{y}-coordinates of the profiles. 

\eqn{\quad} The \code{\link{PlanCoor}} function can also be used to extract two-dimensional profiles 
of other objects, such as leaves. The leaf profile can first be obtained using image processing 
software (e.g., Adobe Photoshop). It is recommended to fill the exterior of the leaf profile 
in black and the interior in white. In such cases, the values of \code{lower.val} and \code{upper.val} 
should be adjusted accordingly to ensure a clear leaf profile is extracted.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Liu, X., Gielis, J., Beirinckx, B., Niklas, K.J. (2026) 
Comparison of six nonlinear equations describing the 2-D profiles of apical meristems. 
\emph{American Journal of Botany} 113, e70177. \doi{10.1002/ajb2.70177}
}
\seealso{
\code{\link{fitAM}}, \code{\link{SAMs}}, \code{\link{SurfaceAreaAM}}, \code{\link{VolumeAM}}
}
\examples{
  folder_path1 <- system.file("extdata", "SAM", package="biogeom")
  bmp.res1     <- PlanCoor( folder_path1, lower.val = 0, upper.val = 250, 
                            fig.opt = TRUE, np = NULL )

  folder_path2 <- system.file("extdata", "Leaf", package="biogeom")
  bmp.res2     <- PlanCoor( folder_path2, lower.val = 1, upper.val = 254, 
                            fig.opt = TRUE, np = NULL, unit = "cm", verbose = FALSE )

  graphics.off()
}

\name{sigmoid}
\encoding{UTF-8}
\alias{sigmoid}
\title{
Sigmoid Growth Equation
}
\description{
\code{sigmoid} is used to calculate the \eqn{y} values (e.g., biomass, height, body length, and so on) at given investigation times.
}
\usage{
sigmoid(expr, P, x, simpver = 1, subdivisions = 100L,
        rel.tol = .Machine$double.eps^0.25, 
        abs.tol = rel.tol, stop.on.error = TRUE, 
        keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{expr}{a performance equation or one of its simplified versions.}
  \item{P}{the parameters of the performance equation or one of its simplified versions.}
  \item{x}{the given investigation times.}
  \item{simpver}{an optional argument to use the simplfied version of the performance equation.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The performance equations denote \code{MbetaE}, \code{MBriereE}, 
\code{MLRFE}, and their simplified versions. 
The arguments of \code{P} and \code{simpver} should correspond 
to \code{expr} (i.e., \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, and \code{\link{MPerformanceE}}). 
The sigmoid curve is the integral of the performance equation or one of its simplified versions.
}
\value{
The \eqn{y} values (i.e., biomass, height, body length, and so on) at given investigation times.  
The growth euqation is actually an integral of the performance equation or one of its simplified versions.
}
\note{
Here, the user can define other performance equations, but new equations or 
their simplified versions should include the lower and upper thresholds in 
the \eqn{x}-axis corresponding to \eqn{y = 0}, whose indices of the parameters in \code{P} should 
be the same as those in \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, and \code{\link{MPerformanceE}}).
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}
}
\seealso{
\code{\link{fitsigmoid}}, \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, and \code{\link{MPerformanceE}}
}
\examples{

Pa1 <- c(3, 3, 10, 1)
xv1 <- seq(-5, 15, len=2000)
yv1 <- sigmoid(MBriereE, P=Pa1, x=xv1, simpver=1)
Pa2 <- c(3, 3, 2, 12, 1)
yv2 <- sigmoid(MBriereE, P=Pa2, x=xv1, simpver=NULL)
Pa3 <- c(200, 1.32, 0.85, 12, 3.7, 17)
yv3 <- sigmoid(MPerformanceE, P=Pa3, x=xv1, simpver=1)

dev.new()
plot( xv1, yv2, cex.lab=1.5, cex.axis=1.5, type="l", col=4,
      xlab=expression(italic(x)), ylab=expression(italic(y)) )
lines( xv1, yv1, col=2 )
lines( xv1, yv3, col=3 )

graphics.off()
}

\name{fitGE}
\encoding{UTF-8}
\alias{fitGE}
\title{
Data-Fitting Function for the Gielis Equation
}
\description{
\code{fitGE} is used to estimate the parameters of the original (or twin) Gielis equation 
or one of its simplified versions.
}
\usage{
fitGE(expr, x, y, ini.val, m = 1, simpver = NULL, 
      nval = nval, control = list(), par.list = FALSE, 
      stand.fig = TRUE, angle = NULL, fig.opt = FALSE, np = 2000,
      xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{expr}{the original (or twin) Gielis equation or one of its simplified versions.}
  \item{x}{the \eqn{x} coordinates of a polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of a polygon's boundary.}
  \item{ini.val}{the list of initial values for the model parameters.}
  \item{m}{the given \eqn{m} value that determines the number of angles of the Gielis curve within \eqn{[0, 2\pi)}.}
  \item{simpver}{an optional argument to use the simplified version of the original (or twin) Gielis equation.}
  \item{nval}{the specified value for \eqn{n_{1}} or \eqn{n_{2}} or \eqn{n_{3}} in the simplified versions.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{stand.fig}{an optional argument to draw the observed and predicted polygons at the standard state 
(i.e., the polar point is located at (0, 0), and the major axis overlaps with the \eqn{x}-axis).}
  \item{angle}{the angle between the major axis and the \eqn{x}-axis, which can be defined by the user.}
  \item{fig.opt}{an optional argument to draw the observed and predicted polygons at arbitrary angle 
between the major axis and the \eqn{x}-axis.}
  \item{np}{the number of data points on the predicted Gielis curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Gielis curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Gielis curve.}
  \item{unit}{the unit of the \eqn{x}-axis and the \eqn{y}-axis when showing the Gielis curve.}
  \item{main}{the main title of the figure.}
}
\details{
The arguments of \code{m}, \code{simpver}, and \code{nval} should correspond 
to \code{expr} (i.e., \code{GE} or \code{TGE}). Please note the differences in the simplified version number and the 
number of parameters between \code{GE} and \code{TGE}. 
The Nelder-Mead algorithm (Nelder and Mead, 1965) is used to carry out the optimization of minimizing 
the residual sum of squares (RSS) between the observed and predicted radii. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
When \code{angle = NULL}, the observed polygon will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, it indicates that the major axis 
is rotated by the amount (\eqn{\pi/4}) counterclockwise from the \eqn{x}-axis.
}
\value{
  \item{par}{the estimates of the model parameters.}
  \item{scan.length}{the observed length of the polygon.}
  \item{scan.width}{the observed width of the polygon.}
  \item{scan.area}{the observed area of the polygon.}
  \item{r.sq}{the coefficient of determination between the observed and predicted polar radii.}
  \item{RSS}{the residual sum of squares between the observed and predicted polar radii.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{phi.stand.obs}{the polar angles at the standard state.}
  \item{phi.trans}{the transferred polar angles rotated as defined by the user.}
  \item{r.stand.obs}{the observed polar radii at the standard state.}
  \item{r.stand.pred}{the predicted polar radii at the standard state.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates at the standard state.}
  \item{x.stand.pred}{the predicted \eqn{x} coordinates at the standard state.}
  \item{y.stand.obs}{the observed \eqn{y} coordinates at the standard state.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates at the standard state.} 
  \item{r.obs}{the observed polar radii at the transferred polar angles as defined by the user.}
  \item{r.pred}{the predicted polar radii at the transferred polar angles as defined by the user.}
  \item{x.obs}{the observed \eqn{x} coordinates at the transferred polar angles as defined by the user.}
  \item{x.pred}{the predicted \eqn{x} coordinates at the transferred polar angles as defined by the user.}
  \item{y.obs}{the observed \eqn{y} coordinates at the transferred polar angles as defined by the user.}
  \item{y.pred}{the predicted \eqn{y} coordinates at the transferred polar angles as defined by the user.}       
}
\note{
\code{simpver} in \code{GE} is different from that in \code{TGE}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Gielis, J. (2003) A generic geometric transformation that unifies a wide range of natural 
and abstract shapes. \emph{American Journal of Botany} 90, 333\eqn{-}338. \doi{10.3732/ajb.90.3.333}

Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}

Shi, P., Xu, Q., Sandhu, H.S., Gielis, J., Ding, Y., Li, H., Dong, X. (2015) Comparison
of dwarf bamboos (\emph{Indocalamus} sp.) leaf parameters to determine relationship
between spatial density of plants and total leaf area per plant. \emph{Ecology and Evolution} 5,
4578-4589. \doi{10.1002/ece3.1728}
}
\seealso{
\code{\link{areaGE}}, \code{\link{curveGE}}, \code{\link{DSGE}}, \code{\link{GE}}, 
\code{\link{SurfaceAreaSGE}}, \code{\link{TGE}}, \code{\link{VolumeSGE}}
}
\examples{
data(eggs)

uni.C <- sort( unique(eggs$Code) )
ind   <- 1
Data  <- eggs[eggs$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=200, times=1.2, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y
Res2 <- adjdata(x0, y0, ub.np=40, times=1, len.pro=1/2, index.sp=20)
x2   <- Res2$x
y2   <- Res2$y
Res3 <- adjdata(x0, y0, ub.np=100, times=1, len.pro=1/2, index.sp=100)
x3   <- Res3$x
y3   <- Res3$y

dev.new()
plot( x2, y2, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")),
      pch=1, col=4 ) 
points( x3, y3, col=2)

\donttest{
  x0.ini    <- mean( x1 )
  y0.ini    <- mean( y1 )
  theta.ini <- pi
  a.ini     <- sqrt(2) * max( y0.ini-min(y1), x0.ini-min(x1) ) 
  n1.ini <- c(5, 25)
  n2.ini <- c(15, 25)
  if(ind == 2){
    n1.ini <- c(0.5, 1)
    n2.ini <- c(6, 12)
  }
  ini.val <- list(x0.ini, y0.ini, theta.ini, a.ini, n1.ini, n2.ini)

  Res4 <- fitGE( GE, x=x1, y=y1, ini.val=ini.val, 
                 m=1, simpver=1, nval=1, unit="cm",  
                 par.list=FALSE, fig.opt=TRUE, angle=NULL, 
                 control=list(reltol=1e-20, maxit=20000), 
                 np=2000 )
  Res4$par
  sqrt(sum((Res4$y.stand.obs-Res4$y.stand.pred)^2)/Res4$sample.size)

  xx    <- Res4$x.stand.obs
  yy    <- Res4$y.stand.obs

  library(spatstat.geom)
  poly0 <- as.polygonal(owin(poly=list(x=xx, y=yy)))
  area(poly0)

  areaGE(GE, P = Res4$par[4:6], 
         m=1, simpver=1)


  # The following code is used to 
  #   calculate the root-mean-square error (RMSE) in the y-coordinates
  ind1  <- which(yy >= 0)
  ind2  <- which(yy < 0)
  xx1   <- xx[ind1] # The upper part of the egg
  yy1   <- yy[ind1]
  xx2   <- xx[ind2] # The lower part of the egg
  yy2   <- yy[ind2]
  Para  <- c(0, 0, 0, Res4$par[4:length(Res4$par)])
  PartU <- curveGE(GE, P=Para, phi=seq(0, pi, len=100000), m=1, simpver=1, fig.opt=FALSE)
  xv1   <- PartU$x
  yv1   <- PartU$y
  PartL <- curveGE(GE, P=Para, phi=seq(pi, 2*pi, len=100000), m=1, simpver=1, fig.opt=FALSE)
  xv2   <- PartL$x
  yv2   <- PartL$y  
  ind3  <- c()
  for(q in 1:length(xx1)){
    ind.temp <- which.min(abs(xx1[q]-xv1))
    ind3     <- c(ind3, ind.temp)
  }  
  ind4  <- c()
  for(q in 1:length(xx2)){
    ind.temp <- which.min(abs(xx2[q]-xv2))
    ind4     <- c(ind4, ind.temp)
  }
  RSS   <- sum((yy1-yv1[ind3])^2) + sum((yy2-yv2[ind4])^2)
  RMSE  <- sqrt( RSS/length(yy) )


  # To calculate the volume of the Gielis egg when simpver=1 & m=1
  VolumeSGE(P=Res4$par[4:6])

  # To calculate the surface area of the Gielis egg when simpver=1 & m=1
  SurfaceAreaSGE(P=Res4$par[4:6])
}

graphics.off()
}

\name{PE}
\encoding{UTF-8}
\alias{PE}
\title{
Calculation of the Abscissa, Ordinate and Distance From the Origin For an Arbitrary Point on the Preston Curve 
}
\description{
\code{PE} is used to calculate the abscissa, ordinate and distance from the origin for an arbitrary point on 
the Preston curve that was generated by the original Preston equation or one of its simplified versions at a given angle.
}
\usage{
PE(P, zeta, simpver = NULL)
}
\arguments{
  \item{P}{the parameters of the original Preston equation or one of its simplified versions.}
  \item{zeta}{the angle(s) used in the Preston equation.}
  \item{simpver}{an optional argument to use the simplified version of the original Preston equation.}
}
\details{
When \code{simpver = NULL}, the original Preston equation is selected: 
\deqn{y = a\ \mathrm{sin}\,\zeta, }
\deqn{x = b\ \mathrm{cos}\,\zeta\left(1+c_{1}\,\mathrm{sin}\,\zeta+c_{2}\,\mathrm{sin}^{2}\,\zeta+c_{3}\,\mathrm{sin}^{3}\,\zeta\right), }
\deqn{r = \sqrt{x^{2}+y^{2}}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Preston curve  
corresponding to an angle \eqn{\zeta}; \eqn{r} represents the distance of the point from the origin; \eqn{a}, \eqn{b}, \eqn{c_{1}}, 
\eqn{c_{2}}, and \eqn{c_{3}} are parameters to be estimated.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{y = a\ \mathrm{sin}\,\zeta, }
\deqn{x = b\ \mathrm{cos}\,\zeta\left(1+c_{1}\,\mathrm{sin}\,\zeta+c_{2}\,\mathrm{sin}^{2}\,\zeta\right), }
\deqn{r = \sqrt{x^{2}+y^{2}}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Preston curve  
corresponding to an angle \eqn{\zeta}; \eqn{r} represents the distance of the point from the origin; \eqn{a}, \eqn{b}, \eqn{c_{1}}, 
and \eqn{c_{2}} are parameters to be estimated.

\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{y = a\ \mathrm{sin}\,\zeta, }
\deqn{x = b\ \mathrm{cos}\,\zeta\left(1+c_{1}\,\mathrm{sin}\,\zeta\right), }
\deqn{r = \sqrt{x^{2}+y^{2}}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Preston curve  
corresponding to an angle \eqn{\zeta}; \eqn{r} represents the distance of the point from the origin; \eqn{a}, \eqn{b}, and \eqn{c_{1}}  
are parameters to be estimated.

\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{y = a\ \mathrm{sin}\,\zeta, }
\deqn{x = b\ \mathrm{cos}\,\zeta\left(1+c_{2}\,\mathrm{sin}^{2}\,\zeta\right), }
\deqn{r = \sqrt{x^{2}+y^{2}}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Preston curve  
corresponding to an angle \eqn{\zeta}; \eqn{r} represents the distance of the point from the origin; \eqn{a}, \eqn{b}, and 
\eqn{c_{2}} are parameters to be estimated.

}
\value{
  \item{x}{the abscissa(s) of the Preston curve corresponding to the given angle(s).}
  \item{y}{the ordinate(s) of the Preston curve corresponding to the given angle(s).}
  \item{r}{the distance(s) of the Preston curve corresponding to the given angle(s) from the origin.}
}
\note{
\eqn{\zeta} is NOT the polar angle corresponding to \eqn{r}, i.e., 
\deqn{y \neq r\,\mathrm{sin}\,\zeta, } 
\deqn{x \neq r\,\mathrm{cos}\,\zeta. } 
Let \eqn{\varphi} be the polar angle corresponding to \eqn{r}. We have: 
\deqn{ \zeta = \mathrm{arc\,sin}\frac{ r\ \mathrm{sin}\,\varphi }{a}. }
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston's universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Preston, F.W. (1953) The shapes of birds' eggs. \emph{The Auk} 70, 160\eqn{-}182.

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Todd, P.H., Smart, I.H.M. (1984) The shape of birds' eggs. \emph{Journal of Theoretical Biology} 
106, 239\eqn{-}243. \doi{10.1016/0022-5193(84)90021-3}
}
\seealso{
\code{\link{EPE}}, \code{\link{lmPE}}, \code{\link{TSE}}
}
\examples{
  zeta <- seq(0, 2*pi, len=2000)
  Par1 <- c(10, 6, 0.325, -0.0415)
  Res1 <- PE(P=Par1, zeta=zeta, simpver=1)
  Par2 <- c(10, 6, -0.325, -0.0415)
  Res2 <- PE(P=Par2, zeta=zeta, simpver=1)

  dev.new()
  plot(Res1$x, Res1$y, asp=1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlab=expression(italic(x)), ylab=expression(italic(y)))
  lines(Res2$x, Res2$y, col=2)

  dev.new()
  plot(Res1$r, Res2$r, asp=1, cex.lab=1.5, cex.axis=1.5,
       xlab=expression(paste(italic(r), ""[1], sep="")), 
       ylab=expression(paste(italic(r), ""[2], sep="")))
  abline(0, 1, col=4)

  graphics.off()
}

\name{SarabiaE}
\encoding{UTF-8}
\alias{SarabiaE}
\title{
Sarabia Equation
}
\description{
\code{SarabiaE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the Sarabia equation. The equation describes the \eqn{y} coordinates of the Lorenz curve.
}
\usage{
SarabiaE(P, x)
}
\arguments{
  \item{P}{the parameters of the Sarabia equation.}
  \item{x}{the given \eqn{x} values ranging between 0 and 1.}
}
\details{

\deqn{y = \left(1-\lambda+\eta\right)x+\lambda x^{a_1 + 1}-\eta \left[1-\left(1-x\right)^{a_2 + 1}\right].}

Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
and \eqn{\lambda}, \eqn{\eta}, \eqn{a_1} and \eqn{a_2} are constants to be estimated, where 
\eqn{a_1 \ge 0}, \eqn{a_2 + 1 \ge 0}, \eqn{\eta\,a_2 + \lambda \le 1}, \eqn{\lambda \ge 0}, and \eqn{\eta\,a_2 \ge 0}.   
There are four elements in \code{P}, representing 
the values of \eqn{\lambda}, \eqn{\eta}, \eqn{a_1} and \eqn{a_2}, respectively.

}
\value{
The \eqn{y} values predicted by the Sarabia equation.
}
\note{
The numerical range of \eqn{x} should range between 0 and 1. 
}
\references{
Sarabia, J.-M. (1997) A hierarchy of Lorenz curves based on the generalized Tukey's lambda distribution. 
\emph{Econometric Reviews} 16, 305\eqn{-}320. \doi{10.1080/07474939708800389} 

Sitthiyot, T., Holasut, K. (2023) A universal model for the Lorenz curve with novel applications 
for datasets containing zeros and/or exhibiting extreme inequality. \emph{Scientific Reports} 
13, 4729. \doi{10.1038/s41598-023-31827-x}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{fitLorenz}}, \code{\link{MPerformanceE}}, \code{\link{SCSE}}, \code{\link{SHE}}
}
\examples{
X1  <- seq(0, 1, len=2000)
Pa1 <- c(0.295, 101.485, 0.705, 0.003762)
Y1  <- SarabiaE(P=Pa1, x=X1)

dev.new()
plot( X1, Y1, cex.lab=1.5, cex.axis=1.5, type="l", asp=1, xaxs="i", 
      yaxs="i", xlim=c(0, 1), ylim=c(0, 1), 
      xlab="Cumulative proportion of the number of infructescences", 
      ylab="Cumulative proportion of the infructescence length" )

graphics.off()
}

\name{biogeom}
\encoding{UTF-8}
\alias{biogeom}
\docType{package}
\title{
Biological Geometries
}
\description{
Is used to simulate and fit biological geometries. 'biogeom' incorporates several novel universal parametric equations 
that can generate the profiles of bird eggs, flowers, linear and lanceolate leaves, seeds, starfish, 
and tree-rings (Gielis, 2003; Shi et al., 2020), three growth-rate curves representing 
the ontogenetic growth trajectories of animals and plants against time, 
and the axially symmetrical and integral forms of all these functions (Shi et al., 2017, 2021). 
The optimization method proposed by Nelder and Mead (1965) was used to estimate model parameters. 
'biogeom' includes several real data sets of the boundary coordinates of natural shapes, 
including avian eggs, fruit, lanceolate and ovate leaves, 
tree rings, seeds, and sea stars,and can be potentially applied to other natural shapes. 
'biogeom' can quantify the conspecific or interspecific similarity of natural outlines, and provides information 
with important ecological and evolutionary implications for the growth and form of living organisms. Please see 
Shi et al. (2022) for details.  
}
\details{
The DESCRIPTION file:
\packageDESCRIPTION{biogeom}
\packageIndices{biogeom}
}
\note{
We are deeply thankful to Cang Hui, Yang Li, Uwe Ligges, Valeriy G. Narushin, 
Ülo Niinemets, Karl J. Nikas, Honghua Ruan, 
David A. Ratkowsky, Julian Schrader, Rolf Turner, Lin Wang, and Victoria Wimmer for 
their valuable help during creating this package. This work was supported by 
the National Key Research and Development Program of China (Grant No. 2021YFD02200403) and 
Simon Stevin Institute for Geometry (Antwerpen, Belguim).
}
\author{
Peijian Shi [aut, cre], Johan Gielis [aut], Brady K. Quinn [aut]

Maintainer: Peijian Shi <pjshi@njfu.edu.cn>
}
\references{
Gielis, J. (2003) A generic geometric transformation that unifies a wide range of natural 
and abstract shapes. \emph{American Journal of Botany} 90, 333\eqn{-}338. \doi{10.3732/ajb.90.3.333}

Nelder, J.A., Mead, R. (1965). A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric 
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}

Shi, P., Yu, K., Niklas, K.J., Schrader, J., Song, Y., Zhu, R., Li, Y., Wei, H., Ratkowsky, D.A. (2021)  
A general model for describing the ovate leaf shape. \emph{Symmetry}, 13, 1524. \doi{10.3390/sym13081524}
}

\keyword{ package }

\name{fitLorenz}
\encoding{UTF-8}
\alias{fitLorenz}
\title{
Data-Fitting Function for the Rotated and Right-Shifted Lorenz Curve
}
\description{
\code{fitLorenz} is used to estimate the parameters of the rotated and right-shifted Lorenz curve 
using version 4 or 5 of \code{\link{MPerformanceE}}, or the Lorenz equations including 
\code{\link{SarabiaE}}, \code{\link{SCSE}}, and \code{\link{SHE}}.
}
\usage{
fitLorenz(expr, z, ini.val, simpver = 4, 
          method = "Nelder-Mead", control = list(),
          lower = -Inf, upper = Inf, 
          par.list = FALSE, fig.opt = FALSE, np = 2000, 
          xlab=NULL, ylab=NULL, main = NULL, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, 
          abs.tol = rel.tol, stop.on.error = TRUE, 
          keep.xy = FALSE, aux = NULL, par.limit = TRUE)
}
\arguments{
  \item{expr}{version 4 or 5 of \code{\link{MPerformanceE}}, or the Lorenz equations including 
\code{\link{SarabiaE}}, \code{\link{SCSE}}, and \code{\link{SHE}}.}
  \item{z}{the observations of size distribution (i.e., the household income distribution, the leaf size distribution).}
  \item{ini.val}{the initial values of the model parameters.}
  \item{simpver}{an optional argument to use version 4 or 5 of \code{\link{MPerformanceE}}.}
  \item{method}{an optional argument to select an optimization method.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{lower}{the lower bounds on the variables for the \code{L-BFGS-B} algorithm.}
  \item{upper}{the upper bounds on the variables for the \code{L-BFGS-B} algorithm.}
  \item{par.list}{the option to show the list of parameters on the screen.}
  \item{fig.opt}{an optional argument to draw the original and rotated Lorenz curves.}
  \item{np}{the number of data points to draw the predicted original and rotated Lorenz curves.}
  \item{xlab}{the label of the \eqn{x}-axis when showing the original Lorenz curve.}
  \item{ylab}{the label of the \eqn{y}-axis when showing the original Lorenz curve.}
  \item{main}{the main title of the figure.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{par.limit}{an optional argument to limit the numerical ranges of model parameters of the three Lorenz 
equations including \code{\link{SarabiaE}}, \code{\link{SCSE}}, and \code{\link{SHE}}.}
}
\details{
Here, \code{ini.val} only includes the initial values of the model parameters as a list. 
The \code{Nelder-Mead} algorithm (Nelder and Mead, 1965) and the optimization method 
(referred to as \code{L-BFGS-B}) proposed by Byrd et al. (1995) in which each variable can be given 
a lower and/or upper bound can be selected to carry out the optimization of minimizing 
the residual sum of squares (RSS) between the observed and predicted \eqn{y} values. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out 
the \code{Nelder-Mead} algorithm and the \code{L-BFGS-B} algorithm. When the user chooses 
the \code{L-BFGS-B} algorithm, \code{par.limit} should be set to be \code{FALSE}. 
Here, versions 4 and 5 of \code{\link{MPerformanceE}} and the Lorenz equations including 
\code{\link{SarabiaE}}, \code{\link{SCSE}}, and \code{\link{SHE}} can be used to fit the rotated 
and right-shifted Lorenz curve.

\eqn{\quad} When \code{simpver = 4}, the simplified version 4 of \code{\link{MPerformanceE}} is selected: 
\deqn{\mbox{if } x \in{\left(0, \ \sqrt{2}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)^{a}\left(1-e^{K_{2}\left(x-\sqrt{2}\right)}\right)^{b};}
\deqn{\mbox{if } x \notin{\left(0, \ \sqrt{2}\right)},}
\deqn{y = 0.}
There are five elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, \eqn{K_{2}}, \eqn{a}, and \eqn{b}, respectively.

\eqn{\quad} When \code{simpver = 5}, the simplified version 5 of \code{\link{MPerformanceE}} is selected:
\deqn{\mbox{if } x \in{\left(0, \ \sqrt{2}\right)},}
\deqn{y = c\left(1-e^{-K_{1}x}\right)\left(1-e^{K_{2}\left(x-\sqrt{2}\right)}\right);}
\deqn{\mbox{if } x \notin{\left(0, \ \sqrt{2}\right)},}
\deqn{y = 0.}
There are three elements in \code{P}, representing 
the values of \eqn{c}, \eqn{K_{1}}, and \eqn{K_{2}}, respectively.

\eqn{\quad} For the Lorenz functions, the user can define any formulae that follow the below form: 
\code{Lorenz.fun <- function(P, x)\{...\}}, where \code{P} is the parameter vector, \code{x} is the preditor that 
ranges between 0 and 1 representing the cumulative proportion of the number of individuals in a statistical 
unit, and \code{Lorenz.fun} is the name of a Lorenz function defined by the user, which also ranges between 0 and 1 
representing the cumulative 
proportion of the income or size in a statistical unit. This package provides three representative Lorenz 
functions: \code{\link{SarabiaE}}, \code{\link{SCSE}}, and \code{\link{SHE}}.  


\eqn{\quad} Here, the Gini coefficient (GC) is calculated as follows when \code{\link{MPerformanceE}} 
is selected:
\deqn{\mbox{GC} = 2\int_{0}^{\sqrt{2}}y\,dx,}
where \eqn{x} and \eqn{y} are the independent and dependent variables 
in version 4 or 5 of \code{\link{MPerformanceE}}, respectively.

\eqn{\quad} However, the Gini coefficient (GC) is calculated as follows when a Lorenz function, e.g., 
\code{\link{SCSE}}, is selected: 
\deqn{\mbox{GC} = 2\int_{0}^{1}y\,dx,}
where \eqn{x} and \eqn{y} are the independent and dependent variables 
in the Lorenz function, respectively. 

\eqn{\quad} For \code{\link{SarabiaE}} and \code{\link{SHE}}, there are explicit formulae for GC 
(Sarabia, 1997; Sitthiyot and Holasut, 2023). 

\eqn{\quad} In addition, the function provides the Lorenz asymmetry coefficient (LAC) based on 
the rotated and right-shifted Lorenz curve (RRLC), which is used to examine whether the RRLC is 
skewed or symmetrical (Chen et al., 2025). The LAC takes the form:
\deqn{\mbox{LAC} = \frac{x_c}{2},} 
where \eqn{x_c} represents the \eqn{x}-coordinate of the maximum value point on the RRLC. 
When \code{LAC > 0.5}, the RRLC is left-skewed; when \code{LAC < 0.5}, the RRLC is right-skewed; 
when \code{LAC = 0.5}, the RRLC is bilaterally symmetrical about the vertical line \eqn{x = x_c}. 
The three cases of the LAC numerical values correspond to three size distribution patterns: 
(i) inequality driven by abundant large individuals, (ii) inequality dominated by a few large individuals, 
and (iii) parity in contributions between small and large individuals (Chen et al., 2025).
}
\value{
  \item{x1}{the cumulative proportion of the number of an entity of interest, 
i.e., the number of households of a city, the number of leaves of a plant.}
  \item{y1}{the cumulative proportion of the size of an entity of interest.}
  \item{x}{the \eqn{x} coordinates of the rotated and right-shifted \code{y1} versus \code{x1}.}
  \item{y}{the \eqn{y} coordinates of the rotated and right-shifted \code{y1} versus \code{x1}.}
  \item{par}{the estimates of the model parameters.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{xc}{the \eqn{x}-coordinate of the maximum value point on the rotated and right-shifted Lorenz curve.}
  \item{yc}{the \eqn{y}-coordinate of the maximum value point on the rotated and right-shifted Lorenz curve.}
  \item{LAC}{the Lorenz asymmetry coefficient associated with the rotated and right-shifted Lorenz curve, 
which equals \eqn{x_c/\sqrt{2}}.}
  \item{GC}{the calculated Gini coefficient.}       
}
\note{
When \code{\link{MPerformanceE}} is selected, the estimates of the model parameters 
denote those in \code{\link{MPerformanceE}} rather than 
being obtained by directly fitting the \code{y1} versus \code{x1} data; 
when a Lorenz function is selected, the estimates of the model parameters 
denote those in the Lorenz function. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Byrd, R.H., Lu, P., Nocedal, J., Zhu, C. (1995) A limited memory algorithm for bound constrained 
optimization. \emph{SIAM Journal on Scientific Computing} 16, 1190\eqn{-}1208. \doi{10.1137/0916069}


Chen, Y., Jiang, F., Damgaard, C.F., Shi, P., Weiner, J. (2025) Re-expression of the Lorenz asymmetry 
coefficient on the rotated and right-shifted Lorenz curve of leaf area distributions. 
\emph{Plants} 14, 1345. \doi{10.3390/plants14091345}

Huey, R.B., Stevenson, R.D. (1979) Integrating thermal physiology and ecology of ectotherms: 
a discussion of approaches. \emph{American Zoologist} 19, 357\eqn{-}366. \doi{10.1093/icb/19.1.357}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Lorenz, M.O. (1905) Methods of measuring the concentration of wealth. 
\emph{Journal of the American Statistical Association} 9(70), 209\eqn{-}219. \doi{10.2307/2276207}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Sarabia, J.-M. (1997) A hierarchy of Lorenz curves based on the generalized Tukey's lambda distribution. 
\emph{Econometric Reviews} 16, 305\eqn{-}320. \doi{10.1080/07474939708800389} 

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Sitthiyot, T., Holasut, K. (2023) A universal model for the Lorenz curve with novel applications 
for datasets containing zeros and/or exhibiting extreme inequality. \emph{Scientific Reports} 
13, 4729. \doi{10.1038/s41598-023-31827-x}
}
\seealso{
\code{\link{LeafSizeDist}}, \code{\link{MPerformanceE}}, \code{\link{SarabiaE}}, 
\code{\link{SCSE}}, \code{\link{SHE}}
}
\examples{
  data(LeafSizeDist)

  CulmNumber <- c()
  for(i in 1:length(LeafSizeDist$Code)){
    temp <- as.numeric( strsplit(LeafSizeDist$Code[i], "-", fixed=TRUE)[[1]][1] )
    CulmNumber <- c(CulmNumber, temp)
  }
  uni.CN <- sort( unique(CulmNumber) )  
  ind    <- CulmNumber==uni.CN[1]
  A0     <- LeafSizeDist$A[ind]

  ini.val1 <- list(0.5, 0.1, c(0.01, 0.1, 1, 5, 10), 1, 1)
  ini.val2 <- list(0.5, 0.1, c(0.01, 0.1, 1, 5, 10))
  resu1 <- fitLorenz(MPerformanceE, z=A0, ini.val=ini.val1, simpver=4, fig.opt=TRUE)
  resu2 <- fitLorenz(MPerformanceE, z=A0, ini.val=ini.val2, simpver=5, fig.opt=TRUE)
  resu1$par
  resu2$par

  ini.val3 <- list(0.9, c(10, 50, 100, 500), 1, 0)   
  resu3 <- fitLorenz( SarabiaE, z=A0, ini.val=ini.val3, par.limit=TRUE, 
                      fig.opt=TRUE, control=list(reltol=1e-20, maxit=10000) )
  resu3$par
  resu3$GC

  graphics.off()
}

\name{curveEPE}
\encoding{UTF-8}
\alias{curveEPE}
\title{
Drawing the Preston Curve Produced by the the Explicit Preston Equation
}
\description{
\code{curveEPE} is used to draw the Preston curve that is produced by the explicit Preston equation.
}
\usage{
curveEPE(P, np = 5000, simpver = NULL,
        fig.opt = FALSE, deform.fun = NULL, Par = NULL,
        xlim = NULL, ylim = NULL, unit = NULL, main="")
}
\arguments{
  \item{P}{the three location parameters and the parameters of the explicit 
Preston equation or one of its simplified versions.}
  \item{np}{the number of data points on the Preston curve.}
  \item{simpver}{an optional argument to use the simplfied version of the explicit Preston equation.}
  \item{fig.opt}{an optional argument to draw the Preston curve.}
  \item{deform.fun}{the deformation function used to describe the deviation from a theoretical Preston curve.}
  \item{Par}{the parameter(s) of the deformation function.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Preston curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Preston curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Preston curve.}
  \item{main}{the main title of the figure.}
}
\details{
The first three elements of \code{P} are location parameters. The first two are the planar coordinates of the transferred origin, 
and the third is the angle between the major axis of the curve and the \eqn{x}-axis. Here, the major axis is a straight line through 
the two ends of an egg's profile (i.e., the mid-line of the egg's profile). The other arguments in \code{P} 
(except these first three location parameters), and \code{simpver} should correspond to those of \code{P} in \code{EPE}. 
\code{deform.fun} should take the form as: \code{deform.fun <- function(Par, z){\dots}}, where \code{z} is 
a two-dimensional matrix related to the \eqn{x} and \eqn{y} values. 
And the return value of \code{deform.fun} should be a \code{list} with two variables \code{x} and \code{y}.
}
\value{
  \item{x}{the \eqn{x} coordinates of the Preston curve.}
  \item{y}{the \eqn{y} coordinates of the Preston curve.}
}
\note{
When the rotation angle is zero (i.e., the third element in \code{P} is zero), \code{np} data points 
are distributed counterclockwise on the Preston curve from the rightmost end of the egg's profile to itself. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Preston, F.W. (1953) The shapes of birds' eggs. \emph{The Auk} 70, 160\eqn{-}182.

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Todd, P.H., Smart, I.H.M. (1984) The shape of birds' eggs. \emph{Journal of Theoretical Biology} 
106, 239\eqn{-}243. \doi{10.1016/0022-5193(84)90021-3}
}
\seealso{
\code{\link{EPE}}, \code{\link{fitEPE}}, \code{\link{lmPE}}, \code{\link{PE}}, \code{\link{TSE}}
}
\examples{
  Para1 <- c(0, 0, 0, 10, 6, 0.325, -0.0415)
  curveEPE(P=Para1, simpver=1, fig.opt=TRUE)
  Para2 <- c(0, 0, pi, 10, 6, -0.325, -0.0415)
  curveEPE(P=Para2, simpver=1, fig.opt=TRUE)

  Para3 <- c(0, 0, 0, 10, 6, 0.325, -0.0415, 0.2)
  curveEPE(P=Para3, simpver=NULL, fig.opt=TRUE)
  Para4 <- c(0, 0, pi, 10, 6, -0.325, -0.0415, 0.2)
  curveEPE(P=Para4, simpver=NULL, fig.opt=TRUE)

  Para5 <- c(0, 0, pi/4, 10, 6, 0.325, -0.0415)
  curveEPE(P=Para5, simpver=1, 
          fig.opt=TRUE, main="A rotated egg shape")

  # There is an example that introduces a deformation function in the egg-shape equation
  myfun <- function(Par, z){
    x  <- z[,1]
    y  <- z[,2]
    k1 <- Par[1]
    k2 <- Par[2]
    y  <- y - k1*(y+k2)^2
    list(x=x, y=y)
  }
  deform.op <- curveEPE(P=Para1, np=5000, simpver=1, 
                       fig.opt=TRUE, deform.fun=myfun, Par=c(0.05, 8))


  graphics.off()
}

\name{curveNRGE}
\encoding{UTF-8}
\alias{curveNRGE}
\title{
Drawing the Egg Shape Predicted by the Narushin-Romanov-Griffin Equation
}
\description{
\code{curveNRGE} is used to draw the egg shape predicted by the Narushin-Romanov-Griffin equation.
}
\usage{
curveNRGE(P, np = 5000, fig.opt = FALSE, deform.fun = NULL, Par = NULL, 
    xlim = NULL, ylim = NULL, unit = NULL, main = "")
}
\arguments{ 
  \item{P}{the three location parameters and the four parameters of the Narushin-Romanov-Griffin equation (Narushin et al., 2021).}
  \item{np}{the number of data points on the Narushin-Romanov-Griffin curve.}
  \item{fig.opt}{an optional argument to draw the Narushin-Romanov-Griffin curve.}
  \item{deform.fun}{the deformation function used to describe the deviation from a theoretical Narushin-Romanov-Griffin curve.}
  \item{Par}{the parameter(s) of the deformation function.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Narushin-Romanov-Griffin curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Narushin-Romanov-Griffin curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Narushin-Romanov-Griffin curve.}
  \item{main}{the main title of the figure.}
}
\details{
The first three elements of \code{P} are location parameters. The first two are the planar coordinates of the transferred origin, 
and the third is the angle between the major axis of the curve and the \eqn{x}-axis. The other arguments in \code{P} 
should be the same as those in \code{\link{NRGE}}.  
\code{deform.fun} should take the form as: \code{deform.fun <- function(Par, z){\dots}}, where \code{z} is 
a two-dimensional matrix related to the \eqn{x} and \eqn{y} values. 
And the return value of \code{deform.fun} should be a \code{list} with two variables \code{x} and \code{y}.
}
\value{
  \item{x}{the \eqn{x} coordinates of the Narushin-Romanov-Griffin curve.}
  \item{y}{the \eqn{y} coordinates of the Narushin-Romanov-Griffin curve.}
}
\note{
When the rotation angle is zero (i.e., the third element in \code{P} is zero), \code{np} data points 
are distributed counterclockwise on the Narushin-Romanov-Griffin curve from the rightmost end of the egg's profile to itself.       
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Shi, P., Gielis, J., Niklas, K.J. (2022) Comparison of a universal (but complex) model for avian egg 
shape with a simpler model. \emph{Annals of the New York Academy of Sciences} 1514, 34\eqn{-}42. \doi{10.1111/nyas.14799}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Tian, F., Wang, Y., Sandhu, H.S., Gielis, J., Shi, P. (2020) Comparison of seed morphology of two ginkgo cultivars. 
\emph{Journal of Forestry Research} 31, 751\eqn{-}758. \doi{10.1007/s11676-018-0770-y}
}
\seealso{
\code{\link{fitNRGE}}, \code{\link{NRGE}}
}
\examples{
PA   <- c(1, 1, pi/4, 11.5, 7.8, 1.1, 5.6)
resA <- curveNRGE(PA, np=5000, fig.opt=TRUE)
resB <- curveNRGE(PA, np=5000, fig.opt=TRUE, xlim=c(-6, 6), 
                  ylim=c(-6, 6), main="A pear-shaped egg") 
cbind(resB$x, resB$y)

graphics.off()
}

\name{ginkgoseed}
\docType{data}
\alias{ginkgoseed}
\title{
Boundary Data of the Side Projections of \emph{Ginkgo biloba} Seeds
}
\description{
The data consist of the boundary data of four side projections of \emph{G. biloba} (Cultivar 'Fozhi') seeds 
sampled at Nanjing Forestry University campus on September 23, 2021.
}
\usage{
data(ginkgoseed)
}
\details{
In the data set, there are three columns of variables: \code{Code}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual fruit; 
\code{x} saves the \eqn{x} coordinates of the side projections of seeds in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the side projections of seeds in the Cartesian coordinate system (cm).
}
\references{
Tian, F., Wang, Y., Sandhu, H.S., Gielis, J., Shi, P. (2020) Comparison of seed morphology of two ginkgo cultivars. 
\emph{Journal of Forestry Research} 31, 751\eqn{-}758. \doi{10.1007/s11676-018-0770-y}
}
\examples{
data(ginkgoseed)

uni.C <- sort( unique(ginkgoseed$Code) )
ind   <- 1
Data  <- ginkgoseed[ginkgoseed$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=2000, len.pro=1/20)
dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

\donttest{
  x1        <- Res1$x
  y1        <- Res1$y
  x0.ini    <- mean( x1 )
  y0.ini    <- mean( y1 )
  theta.ini <- pi/4
  a.ini     <- 1
  n1.ini    <- seq(0.6, 1, by=0.1)
  n2.ini    <- 1
  n3.ini    <- 1
  ini.val   <- list(x0.ini, y0.ini, theta.ini, 
                    a.ini, n1.ini, n2.ini, n3.ini)

  Res2 <- fitGE( GE, x=x1, y=y1, ini.val=ini.val, 
                 m=2, simpver=5, nval=1, unit="cm",  
                 par.list=FALSE, fig.opt=TRUE, angle=NULL, 
                 control=list(reltol=1e-20, maxit=20000), 
                 np=2000 )
}

graphics.off()
}

\name{SurfaceAreaAM}
\encoding{UTF-8}
\alias{SurfaceAreaAM}
\title{
Calculation of the Lateral Surface Area of an Apical meristem. 
}
\description{
\code{SurfaceAreaAM} is used to calculate the lateral surface area of an apical meristem 
that follows the the hybrid catenary-parabolic equation or the superparabolic equation.
}
\usage{
SurfaceAreaAM(model = "Hybrid", P, upper = Inf, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{model}{an optional argument to select a model to calculate the surface area.}
  \item{P}{the parameters of the hybrid catenary-parabolic equation or the superparabolic equation.}
  \item{upper}{the upper limit of integration in \eqn{x}.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The formula of the lateral surface area (\eqn{S}) of an apical meristem 
based on the hybrid catenary-parabolic equation or the superparabolic equation: 
\deqn{S(x)=2 \, \pi \int_{0}^{a} x \,\sqrt{1+\left(\frac{dy}{dx}\right)^2}\,dx,} 
where \eqn{a} is the upper limit of integration in \eqn{x}. The lower limit of integration in \eqn{x} is 0. 
 
\eqn{\quad} If \code{model = "Hybrid"}, \eqn{y} denotes the hybrid catenary-parabolic equation, 
which equals \eqn{y\left(x\right) = \alpha\,\mbox{cosh}(\beta x) + \gamma x^{2}-\alpha}, 
and \eqn{\frac{dy}{dx} = \alpha\,\beta\,\mbox{sinh}(\beta x) + 2\gamma x}. 
Here, \eqn{\alpha}, \eqn{\beta} and \eqn{\gamma} are 
model parameters provided by the argument \code{P}.

\eqn{\quad} If \code{model = "Superparabola"}, \eqn{y} denotes the superparabolic equation, 
which equals \eqn{y\left(x\right) = \beta_{1}\, {\left|x\right|}^{\beta_{2}}}, 
and \eqn{\frac{dy}{dx} = \beta_{1}\,\beta_{2}\,x \left|x\right|^{\beta_{2}-2}}. Here, \eqn{\beta_{1}} and \eqn{\beta_{2}} are 
model parameters provided by the argument \code{P}.  
}
\note{
The \code{\link{SurfaceAreaAM}} function actually calculates 
the lateral surface area regardless of the area of the 'base' circle. 
The argument \code{P} in the \code{\link{SurfaceAreaAM}} function has three parameters for \code{model = "Hybrid"}, 
and two parameters for \code{model = "Superparabola"}. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Liu, X., Gielis, J., Beirinckx, B., Niklas, K.J. (2026) 
Comparison of six nonlinear equations describing the 2-D profiles of apical meristems. 
\emph{American Journal of Botany} 113, e70177. \doi{10.1002/ajb2.70177}
}
\seealso{
\code{\link{fitAM}}, \code{\link{PlanCoor}}, \code{\link{SAMs}}, \code{\link{VolumeAM}}
}
\examples{
  par3 <- c(-20, 0.9695, 11.40)
  SurfaceAreaAM(model = "Hybrid", P = par3, upper=1)
  
  par5 <- c(1.3807, 1.3173)
  SurfaceAreaAM(model = "Superparabola", P = par5, upper=1)
}

\name{SurfaceAreaEPE}
\encoding{UTF-8}
\alias{SurfaceAreaEPE}
\title{
Calculation of the Surface Area of An Egg Based on the Explicit Preston Equation 
}
\description{
\code{SurfaceAreaEPE} is used to calculate the surface area of an egg that follows the explicit Preston equation.
}
\usage{
SurfaceAreaEPE(P, simpver = NULL, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{P}{the parameters of the explicit Preston equation or one of its simplified versions.}
  \item{simpver}{an optional argument to use the simplified version of the explicit Preston equation.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The formula of the surface area (\eqn{S}) of an egg based on the explicit Preston equation or one of its simplified versions is:
\deqn{S(x)=2\,\pi\int_{-a}^{a}y\,\sqrt{1+\left(\frac{dy}{dx}\right)^2}\,dx,}
where \eqn{y} denotes the explicit Preston equation (i.e., \code{\link{EPE}}), and 
\eqn{a} denotes half the egg's length. 
When \code{simpver = NULL}, \code{P} has five parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, \eqn{c_{2}}, and \eqn{c_{3}}; 
when \code{simpver = 1}, \code{P} has four parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, and \eqn{c_{2}}; 
when \code{simpver = 2}, \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{1}}; 
when \code{simpver = 3}, \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{2}}.  
}
\note{
The argument \code{P} in the \code{\link{SurfaceAreaEPE}} function has the same parameters, as those in the 
\code{\link{EPE}} function. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Narushin, V.G., Romanov, M.N., Mishra, B., Griffin, D.K. (2022) Mathematical progression of 
avian egg shape with associated area and volume determinations. 
\emph{Annals of the New York Academy of Sciences} 1513, 65\eqn{-}78. \doi{10.1111/nyas.14771}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{DEPE}}, \code{\link{EPE}}, \code{\link{fitEPE}}, \code{\link{VolumeEPE}}
}
\examples{
  Par4 <- c(4.27, 2.90, 0.0868, 0.0224, -0.0287)
  SurfaceAreaEPE(P = Par4, simpver = NULL)
}

\name{areaGE}
\encoding{UTF-8}
\alias{areaGE}
\title{
Area Calculation for the Gielis Curve Within \eqn{[0, 2\pi)}
}
\description{
\code{areaGE} is used to calculate the area of the polygon 
generated by the Gielis curve within \eqn{[0, 2\pi)}.
}
\usage{
areaGE(expr, P, m = 1, simpver = NULL,  
       nval = 1, subdivisions = 100L,
       rel.tol = .Machine$double.eps^0.25, 
       abs.tol = rel.tol, stop.on.error = TRUE, 
       keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{expr}{the original (or twin) Gielis equation or one of its simplified versions.}
  \item{P}{the parameters of the original (or twin) Gielis equation or one of its simplified versions.}
  \item{m}{the given \eqn{m} value that determines the number of angles of the Gielis curve within \eqn{[0, 2\pi)}.}
  \item{simpver}{an optional argument to use the simplified version of the original (or twin) Gielis equation.}
  \item{nval}{the specified value for \eqn{n_{1}} or \eqn{n_{2}} or \eqn{n_{3}} in the simplified versions.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The arguments of \code{P}, \code{m}, \code{simpver}, and \code{nval} should correspond 
to \code{expr} (i.e., \code{GE} or \code{TGE}). Please note the differences in the simplified 
version number and the number of parameters between \code{GE} and \code{TGE}.
}
\value{
The area of the polygon within \eqn{[0, 2\pi)} generated by the original (or twin) Gielis equation 
or one of its simplified versions.
}
\note{
\code{simpver} in \code{GE} is different from that in \code{TGE}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Gielis, J. (2003) A generic geometric transformation that unifies a wide range of natural 
and abstract shapes. \emph{American Journal of Botany} 90, 333\eqn{-}338. \doi{10.3732/ajb.90.3.333}

Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric 
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}

Shi, P., Xu, Q., Sandhu, H.S., Gielis, J., Ding, Y., Li, H., Dong, X. (2015) Comparison
of dwarf bamboos (\emph{Indocalamus} sp.) leaf parameters to determine relationship
between spatial density of plants and total leaf area per plant. \emph{Ecology and Evolution} 5,
4578\eqn{-}4589. \doi{10.1002/ece3.1728}
}
\seealso{
\code{\link{curveGE}}, \code{\link{fitGE}}, \code{\link{GE}}, \code{\link{TGE}}
}
\examples{
Para1 <- c(1.7170, 5.2258, 7.9802)
areaGE(GE, P = Para1, m=5, simpver=1)

Para2 <- c(2.1066, 3.5449, 0.4619, 10.5697)
areaGE(TGE, P = Para2, m=5, simpver=1)
}

\name{DEPE}
\encoding{UTF-8}
\alias{DEPE}
\title{
Calculation of the First-Order Derivative of the Explicit Preston Equation  
}
\description{
\code{DEPE} is used to calculate the first-order derivative of the explicit Preston equation at a given \emph{x}-value.
}
\usage{
DEPE(P, x, simpver = NULL)
}
\arguments{
  \item{P}{the parameters of the explicit Preston equation or one of its simplified versions.}
  \item{x}{the \emph{x}-value used in the explicit Preston equation.}
  \item{simpver}{an optional argument to use the simplified version of the explicit Preston equation.}
}
\details{
When \code{simpver = NULL}, the first-order derivative of 
the explicit Preston equation at a given \emph{x}-value is selected: 
\deqn{ f(x)=\frac{b\left[a^{4}\,c_{1}+a^{3}\left(2\,c_{2}-1\right)x+
a^2\left(3\,c_{3}-2\,c_{1}\right)x^{2}-3\,a\,c_{2}x^3-4\,c_{3}\,x^{4}\right]}{a^4\sqrt{a^2-x^2}}, }
where \code{P} has five parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, \eqn{c_{2}}, and \eqn{c_{3}}.

\eqn{\quad} When \code{simpver = 1}, the first-order derivative of the simplified version 1 is selected: 
\deqn{ f(x)=\frac{b\left[a^{4}\,c_{1}+a^{3}\left(2\,c_{2}-1\right)x-
2\,a^2\,c_{1}\,x^{2}-3\,a\,c_{2}x^3\right]}{a^4\sqrt{a^2-x^2}}, }
where \code{P} has four parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, and \eqn{c_{2}}.

\eqn{\quad} When \code{simpver = 2}, the first-order derivative of the simplified version 2 is selected: 
\deqn{ f(x)=\frac{b\left[a^{4}\,c_{1}-a^{3}\,x-
2\,a^2\,c_{1}\,x^{2}\right]}{a^4\sqrt{a^2-x^2}}, }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{1}}.

\eqn{\quad} When \code{simpver = 3}, the first-order derivative of the simplified version 3 is selected: 
\deqn{ f(x)=\frac{b\left[a^{3}\left(2\,c_{2}-1\right)x-3\,a\,c_{2}x^3\right]}{a^4\sqrt{a^2-x^2}}, }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{2}}.
}
\note{
The argument \code{P} in the \code{\link{DEPE}} function has the same parameters, as those in the 
\code{\link{EPE}} function. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{EPE}}, \code{\link{fitEPE}}, \code{\link{SurfaceAreaEPE}}
}
\examples{
  Par3 <- c(4.27, 2.90, 0.0868, 0.0224, -0.0287)
  xx1  <- seq(-4.27, 4.27, by=0.001)
  f1   <- DEPE(P=Par3, x=xx1, simpver=NULL)
  f2   <- -DEPE(P=Par3, x=xx1, simpver=NULL)

  dev.new()
  plot(xx1, f1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlim=c(-5, 5), ylim=c(-35, 35), xlab=expression(italic(x)), 
       ylab=expression(paste(italic(f), "(", italic(x), ")", sep="")))
  lines(xx1, f2, col=2)  

  graphics.off()
}

\name{DNRGE}
\encoding{UTF-8}
\alias{DNRGE}
\title{
Calculation of the First-Order Derivative of the Narushin-Romanov-Griffin Equation  
}
\description{
\code{DNRGE} is used to calculate the first-order derivative of the Narushin-Romanov-Griffin equation at a given \emph{x}-value.
}
\usage{
DNRGE(P, x)
}
\arguments{
  \item{P}{the parameters of the Narushin-Romanov-Griffin equation.}
  \item{x}{the \emph{x}-value used in the Narushin-Romanov-Griffin equation.}
}
\details{
Let us define:

\deqn{f_{1}(x) = \frac{B}{2}\sqrt{\frac{A^2-4x^2}{A^2+8Cx+4C^2}},}
\deqn{f_{2}(x) = \sqrt{\frac{A\left(A^{2}+8Cx+4C^{2}\right)}{2(A-2C)x^{2}+\left(A^{2}+8AC-4C^{2}\right)x+2AC^{2}+A^{2}C+A^{3}}},}
\deqn{f_{3}(x) = A^2 - 4x,}
\deqn{f_{4}(x) = A^2+8Cx+4C^2,}
\deqn{E = \frac{\sqrt{5.5A^{2}+11AC+4C^{2}} \cdot \left(\sqrt{3}AB-2D\sqrt{A^{2}+2AC+4C^{2
}}\right)}{\sqrt{3}AB\left(\sqrt{5.5A^{2}+11AC+4C^{2}}-2\sqrt{A^{2}+2AC+4C^{2}}\right)},}
\deqn{F = 2\left(A-2C\right),}
\deqn{G = A^{2}+8AC-4C^{2},}
\deqn{H = 2AC^{2}+A^{2}C+A^{3},}

and then the first-order derivative of the Narushin-Romanov-Griffin equation at a given \emph{x}-value is:
\deqn{J(x) = -\frac{4\,f_{1}(x)\left[C\,f_{3}(x)+x\,f_{4}(x)\right]}{f_{3}(x) \cdot f_{4}(x)}\left\{1-E \cdot \left[1-f_{2}(x)\right]\right\}-\frac{AE}{2}\frac{f_{1}(x)}{f_{2}(x)}\frac{f_{4}(x) \cdot \left(2Fx+G\right)}{\left(Fx^2+Gx+H\right)^2},}
where \code{P} has four parameters: \eqn{A}, \eqn{B}, \eqn{C}, and \eqn{D}.
}
\note{
The argument \code{P} in the \code{\link{DNRGE}} function has the same parameters, as those in the 
\code{\link{NRGE}} function.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Narushin, V.G., Romanov, M.N., Mishra, B., Griffin, D.K. (2022) Mathematical progression of 
avian egg shape with associated area and volume determinations. 
\emph{Annals of the New York Academy of Sciences} 1513, 65\eqn{-}78. \doi{10.1111/nyas.14771}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{fitNRGE}}, \code{\link{NRGE}}, \code{\link{SurfaceAreaNRGE}}
}
\examples{
  Par6 <- c(4.51, 3.18, 0.1227, 2.2284)
  xx3  <- seq(-4.51/2, 4.51/2, len=2000)
  J1   <- DNRGE(P=Par6, x=xx3)
  J2   <- -DNRGE(P=Par6, x=xx3)
  ind  <- which(is.na(J1) | is.na(J2))
  xx3  <- xx3[-ind]
  J1   <- J1[-ind]
  J2   <- J2[-ind]

  dev.new()
  plot(xx3, J1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlim=c(-4.51/2, 4.51/2), ylim=c(-20, 20), xlab=expression(italic(x)), 
       ylab=expression(paste(italic(J), "(", italic(x), ")", sep="")))
  lines(xx3, J2, col=2)  

  graphics.off()
}

\name{TE}
\encoding{UTF-8}
\alias{TE}
\title{
The Troscianko Equation (TE) 
}
\description{
\code{TE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the re-expression of Troscianko's egg-shape equation, which was proposed by Biggins et al. (2018, 2022).
}
\usage{
TE(P, x)
}
\arguments{
  \item{P}{the parameters of the Troscianko equation, including \eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}}.}
  \item{x}{the given \eqn{x} values ranging from \eqn{-}1 to 1.}
}
\details{
The Troscianko equation is recommended as (Biggins et al., 2022): 
\deqn{y = \exp\left(\alpha_{0}+\alpha_{1}\,x+\alpha_{2}\,x^2\right)\sqrt{1-x^2}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the Troscianko curve; 
\eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}} are parameters to be estimated.
}
\value{
The \eqn{y} values predicted by the Troscianko equation.
}
\note{
Here, \eqn{x} and \eqn{y} in the Troscianko equation are actually equal to \eqn{y/a} 
and \eqn{x/a}, respectively, in the explicit Troscianko equation, where \eqn{a} 
represents half the egg length (See \code{\link{ETE}} for details). 
This means that the egg length is scaled to be 2, 
and the maximum egg width is correspondingly adjusted to keep the same scale.   
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston's universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Nelder, J.A., Mead, R. (1965). A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Troscianko, J. (2014). A simple tool for calculating egg shape, volume and surface area from digital images. 
\emph{Ibis}, 156, 874\eqn{-}878. \doi{10.1111/ibi.12177} 
}
\seealso{
\code{\link{fitETE}}, \code{\link{lmTE}}
}
\examples{
  Par <- c(-0.377, -0.29, -0.16)
  xb1 <- seq(-1, 1, len=20000)
  yb1 <- TE(P=Par, x=xb1)
  xb2 <- seq(1, -1, len=20000)
  yb2 <- -TE(P=Par, x=xb2)

  dev.new()
  plot(xb1, yb1, asp=1, type="l", col=2, ylim=c(-1, 1), cex.lab=1.5, cex.axis=1.5, 
    xlab=expression(italic(x)), ylab=expression(italic(y)))
  lines(xb2, yb2, col=4)

  graphics.off()
}

\name{areaovate}
\encoding{UTF-8}
\alias{areaovate}
\title{
Area Calculation for an Ovate Polygon
}
\description{
\code{areaovate} is used to calculate the area of an ovate polygon made 
from combing two symmetrical curves generated by a performance equation (e.g., \code{\link{MLRFE}}).
}
\usage{
areaovate(expr, P, simpver = NULL,  
          subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, 
          abs.tol = rel.tol, stop.on.error = TRUE, 
          keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{expr}{a performance equation or one of its simplified versions.}
  \item{P}{the parameters of the performance equation or one of its simplified versions.}
  \item{simpver}{an optional argument to use the simplfied version of the performance equation.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The performance equations denote \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, and their simplified versions. 
The arguments of \code{P} and \code{simpver} should correspond 
to \code{expr} (i.e., \code{\link{MbetaE}} or \code{\link{MBriereE}} or \code{\link{MLRFE}}). 
}
\value{
The area of two symmetrical curves along the \eqn{x}-axis 
generated by a performance equation or one of its simplified versions.
}
\note{
Here, the user can define other performance equations, but new equations or 
their simplified versions should include the lower and upper thresholds in 
the \eqn{x}-axis corresponding to \eqn{y = 0}, whose indices should 
be the same as those in \code{\link{MbetaE}} or \code{\link{MBriereE}} or \code{\link{MLRFE}}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Yu, K., Niklas, K.J., Schrader, J., Song, Y., Zhu, R., Li, Y., Wei, H., Ratkowsky, D.A. (2021)  
A general model for describing the ovate leaf shape. \emph{Symmetry} 13, 1524. \doi{10.3390/sym13081524}
}
\seealso{
\code{\link{curveovate}}, \code{\link{fitovate}}, \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, \code{\link{MPerformanceE}}, \code{\link{sigmoid}}
}
\examples{
Par1 <- c(1.8175, 2.7795, 7.1557, 1.6030)
areaovate(MbetaE, P = Par1, simpver = 1)

Par2 <- c(0.0550, 0.3192, 7.1965, 0.5226)
areaovate(MBriereE, P = Par2, simpver = 1)

Par3 <- c(1.8168, 2.7967, 7.2623, 0.9662)
areaovate(MLRFE, P = Par3, simpver = 1)

Par4 <- c(2.4, 0.96, 0.64, 7.75, 1.76, 3.68)
areaovate(MPerformanceE, P = Par4, simpver = 1)
}

\name{starfish}
\docType{data}
\alias{starfish}
\title{
Boundary Data of Eight Sea Stars
}
\description{
The data consist of the boundary data of eight sea stars from five species.
}
\usage{
data(starfish)
}
\details{
In the data set, there are four columns of variables: \code{Code}, \code{LatinName}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual sea stars; 
\code{LatinName} saves the Latin names of the eight sea stars; 
\code{x} saves the \eqn{x} coordinates of the eight sea stars in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the eight sea stars in the Cartesian coordinate system (cm). 
In \code{Code}, codes 1-9 represent \emph{Anthenoides tenuis}, \emph{Culcita schmideliana} sample 1, 
\emph{Culcita schmideliana} sample 2, \emph{Culcita schmideliana} sample 3, \emph{Stellaster equestris}, \emph{Tosia australis}, 
\emph{Tosia magnifica} sample 1, and \emph{Tosia magnifica} sample 2, respectively. See Table A1 published in Shi et al. (2020).
}
\references{
Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric 
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}
}
\examples{
data(starfish)

uni.C <- sort( unique(starfish$Code) )
ind   <- 2
Data  <- starfish[starfish$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

dev.new()
plot( x0, y0, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )
length(x0)

Res1 <- adjdata(x0, y0, ub.np=400, times=1.2, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y

dev.new()
plot( x1, y1, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )
length(x1)

graphics.off()
}

\name{curveETE}
\encoding{UTF-8}
\alias{curveETE}
\title{
Drawing the Troscianko Curve Produced by the Explicit Troscianko Equation
}
\description{
\code{curveETE} is used to draw the Troscianko curve that is produced by the explicit Troscianko equation.
}
\usage{
curveETE(P, np = 5000, fig.opt = FALSE, deform.fun = NULL, Par = NULL,
        xlim = NULL, ylim = NULL, unit = NULL, main="")
}
\arguments{
  \item{P}{the three location parameters and the parameters of the explicit 
Troscianko equation.}
  \item{np}{the number of data points on the Troscianko curve.}
  \item{fig.opt}{an optional argument to draw the Troscianko curve.}
  \item{deform.fun}{the deformation function used to describe the deviation from a theoretical Troscianko curve.}
  \item{Par}{the parameter(s) of the deformation function.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Troscianko curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Troscianko curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Troscianko curve.}
  \item{main}{the main title of the figure.}
}
\details{
The first three elements of \code{P} are location parameters. The first two are the planar coordinates of the transferred origin, 
and the third is the angle between the major axis of the curve and the \eqn{x}-axis. Here, the major axis is a straight line through 
the two ends of an egg's profile (i.e., the mid-line of the egg's profile). The other arguments in \code{P} 
(except these first three location parameters) should correspond to those of \code{P} in \code{ETE}. 
\code{deform.fun} should take the form as: \code{deform.fun <- function(Par, z){\dots}}, where \code{z} is 
a two-dimensional matrix related to the \eqn{x} and \eqn{y} values. 
And the return value of \code{deform.fun} should be a \code{list} with two variables \code{x} and \code{y}.
}
\value{
  \item{x}{the \eqn{x} coordinates of the Troscianko curve.}
  \item{y}{the \eqn{y} coordinates of the Troscianko curve.}
}
\note{
When the rotation angle is zero (i.e., the third element in \code{P} is zero), \code{np} data points 
are distributed counterclockwise on the Troscianko curve from the rightmost end of the egg's profile to itself. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston’s universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}
}
\seealso{
\code{\link{ETE}}, \code{\link{fitETE}}
}
\examples{
  Para1 <- c(0, 0, 0, 2.25, -0.377, -0.29, -0.16)
  curveETE(P=Para1, fig.opt=TRUE)

  # There is an example that introduces a deformation function in the egg-shape equation
  myfun <- function(Par, z){
    x  <- z[,1]
    y  <- z[,2]
    k1 <- Par[1]
    k2 <- Par[2]
    y  <- y - k1*(y+k2)^2
    list(x=x, y=y)
  }
  deform.op <- curveETE(P=Para1, np=5000, fig.opt=TRUE, deform.fun=myfun, Par=c(0.05, 8))

  graphics.off()
}

\name{bambooleaves}
\docType{data}
\alias{bambooleaves}
\title{
Leaf Boundary Data of \emph{Phyllostachys incarnata} T. H. Wen (Poaceae: Bambusoideae)
}
\description{
The data consist of the boundary data of six leaves of \emph{P. incarnata} 
sampled at Nanjing Forestry University campus in early December 2016.
}
\usage{
data(bambooleaves)
}
\details{
In the data set, there are three columns of variables: \code{Code}, \code{x}, and \code{y}. 
\code{Code} saves the codes of individual leaves; 
\code{x} saves the \eqn{x} coordinates of the leaf boundary in the Cartesian coordinate system (cm); 
and \code{y} saves the \eqn{y} coordinates of the leaf boundary in the Cartesian coordinate system (cm).
}
\references{
Lin, S., Shao, L., Hui, C., Song, Y., Reddy, G.V.P., Gielis, J., Li, F., Ding, Y., Wei, Q., 
Shi, P. (2018) Why does not the leaf weight-area allometry of bamboos follow the 3/2-power law? 
\emph{Frontiers in Plant Science} 9, 583. \doi{10.3389/fpls.2018.00583}

Shi, P., Ratkowsky, D.A., Li, Y., Zhang, L., Lin, S., Gielis, J. (2018) 
General leaf-area geometric formula exists for plants - Evidence from the simplified Gielis equation. 
\emph{Forests} 9, 714. \doi{10.3390/f9110714}
}
\examples{
data(bambooleaves)

uni.C <- sort( unique(bambooleaves$Code) )
ind   <- 1
Data  <- bambooleaves[bambooleaves$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

dev.new()
plot( x0, y0, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )
length(x0)

Res1 <- adjdata(x0, y0, ub.np=600, len.pro=1/20)
dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

graphics.off()
}

\name{DSGE}
\encoding{UTF-8}
\alias{DSGE}
\title{
Calculation of the First-Order Derivative of the Simplified Gielis Equation  
}
\description{
\code{DSGE} is used to calculate the first-order derivative of the simplified Gielis equation at a given \eqn{\varphi}-value.
}
\usage{
DSGE(P, phi)
}
\arguments{
  \item{P}{the parameters of the simplified Gielis equation, including \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}}.}
  \item{phi}{the \eqn{\varphi}-value used in the simplified Gielis equation.}
}
\details{
The first-order derivative of the simplified Gielis equation with arguments \code{simpver = 1} and \code{m = 1} at a given \eqn{\varphi}-value is: 
\deqn{g(x) = \frac{a}{4}\,\frac{n_{2}}{n_{1}}\,\left[\left(\cos{\frac{\varphi}{4}}\right)^{n_{2}-1}\left(\sin{\frac{\varphi}{4}}\right)-\left(\sin{\frac{\varphi}{4}}\right)^{n_{2}-1}\left(\cos{\frac{\varphi}{4}}\right)\right]\ \left[\left(\cos{\frac{\varphi}{4}}\right)^{n_{2}}+\left(\sin{\frac{\varphi}{4}}\right)^{n_{2}}\right]^{-\frac{1}{n_{1}}-1}, }

where \code{P} has three parameters: \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}}.
}
\note{
The argument \code{P} in the \code{\link{DSGE}} function only has 
the three parameters: \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}}. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Chen, Z. (2012) Volume and area of revolution under polar coordinate system. 
\emph{Studies in College Mathematics} 15(6), 9\eqn{-}11.

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{GE}}, \code{\link{fitGE}}, \code{\link{SurfaceAreaSGE}}
}
\examples{
  Par7 <- c(1.124, 14.86, 49.43)
  phi1 <- seq(0, pi, len=2000)
  g1   <- DSGE(P=Par7, phi=phi1)

  dev.new()
  plot(phi1, g1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlab=expression(italic(varphi)), 
       ylab=expression(paste(italic(g), "(", italic(varphi), ")", sep="")))

  graphics.off()
}

\name{fitsigmoid}
\encoding{UTF-8}
\alias{fitsigmoid}
\title{
Data-Fitting Function for the Sigmoid Growth Equation
}
\description{
\code{fitsigmoid} is used to estimate the parameters of a sigmoid growth equation based on the integral of 
a performance equation or one of its simplified versions.
}
\usage{
fitsigmoid(expr, x, y, ini.val, simpver = 1, 
           control = list(), par.list = FALSE, fig.opt = FALSE,
           xlim = NULL, ylim = NULL, xlab = NULL, ylab = NULL,         
           main = NULL, subdivisions = 100L,
           rel.tol = .Machine$double.eps^0.25, 
           abs.tol = rel.tol, stop.on.error = TRUE, 
           keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{expr}{a performance equation or one of its simplified versions that is used to build a sigmoid growth equation.}
  \item{x}{the observed investigation times.}
  \item{y}{the observed \eqn{y} values (i.e., biomass, height, body length, etc.).}
  \item{ini.val}{the initial values of the model parameters.}
  \item{simpver}{an optional argument to use the simplified version of the performance equation.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{fig.opt}{an optional argument to draw the observations and the predicted sigmoid curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot a sigmoid growth curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot a sigmoid growth curve.}
  \item{xlab}{the label of the \eqn{x}-axis when showing a sigmoid growth curve.}
  \item{ylab}{the label of the \eqn{y}-axis when showing a sigmoid growth curve.}
  \item{main}{the main title of the figure.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
Here, \code{ini.val} only includes the initial values of the model parameters as a list. 
The Nelder-Mead algorithm (Nelder and Mead, 1965) is used to carry out the optimization of minimizing the residual 
sum of squares (RSS) between the observed and predicted \eqn{y} values. The \code{\link[stats]{optim}} 
function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
The performance equations denote \code{\link{MbetaE}}, \code{\link{MBriereE}}, 
\code{\link{MLRFE}}, \code{\link{MPerformanceE}} and their simplified versions. 
The arguments of \code{P} and \code{simpver} should correspond 
to \code{expr} (i.e., \code{\link{MbetaE}} or \code{\link{MBriereE}} 
or \code{\link{MLRFE}} or \code{\link{MPerformanceE}}). 
The sigmoid equation is the integral of a performance equation or one of its simplified versions.
}
\value{
  \item{par}{the estimates of the model parameters.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{x}{the observed \eqn{x} values.}
  \item{y}{the observed \eqn{y} values.}
  \item{y.pred}{the predicted \eqn{y} values.}       
}
\note{
Here, the user can define other performance equations, but new equations or 
their simplified versions should include the lower and upper thresholds on 
the \eqn{x}-axis corresponding to \eqn{y = 0}, whose indices should 
be the same as those in \code{\link{MbetaE}} or \code{\link{MBriereE}} 
or \code{\link{MLRFE}} or \code{\link{MPerformanceE}}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}
}
\seealso{
\code{\link{areaovate}}, \code{\link{MbetaE}}, \code{\link{MBriereE}}, \code{\link{MLRFE}}, 
\code{\link{MPerformanceE}}, \code{\link{sigmoid}}
}
\examples{

# The shrimp growth data(See the supplementary table in West et al., 2001)
# West, G.B., Brown, J.H., Enquist, B.J. (2001) A general model for ontogenetic growth. 
#     Nature 413, 628-631.
t0 <- c(3, 60, 90, 120, 150, 180, 384)
m0 <- c(0.001, 0.005, 0.018, 0.037, 0.06, 0.067, 0.07)

dev.new()
plot( t0, m0, cex.lab=1.5, cex.axis=1.5, col=4,
      xlab=expression(italic(x)), ylab=expression(italic(y)) )

xopt0   <- seq(100, 150, by=5)
ini.val <- list(0.035, xopt0, 200, 1)
resu1   <- fitsigmoid(MLRFE, x=t0, y=m0, ini.val=ini.val, simpver=1, fig.opt=TRUE, par.list=TRUE)

\donttest{
  xopt0   <- seq(100, 150, by=5)
  ini.val <- list(0.035, xopt0, 200, 1)
  resu1   <- fitsigmoid(MbetaE, x=t0, y=m0, ini.val=ini.val, simpver=1, fig.opt=TRUE)

  m.ini   <- c(0.5, 1, 2, 3, 4, 5, 10, 20)
  ini.val <- list(1e-8, m.ini, 200, 1)
  resu2   <- fitsigmoid(MBriereE, x=t0, y=m0, ini.val=ini.val, simpver=1, 
             fig.opt=TRUE, control=list(reltol=1e-20, maxit=20000, trace=FALSE), 
             subdivisions=100L, rel.tol=.Machine$double.eps^0.25, 
             abs.tol=.Machine$double.eps^0.25, stop.on.error=TRUE, 
             keep.xy=FALSE, aux=NULL)

  delta0  <- c(0.5, 1, 2, 5, 10, 20)
  ini.val <- list(0.035, 150, -100, 200, delta0)
  resu3   <- fitsigmoid(MLRFE, x=t0, y=m0, ini.val=ini.val, simpver=NULL, 
               fig.opt=TRUE, control=list(reltol=1e-20, maxit=20000), 
               subdivisions = 100L, rel.tol=.Machine$double.eps^0.25, 
               abs.tol=.Machine$double.eps^0.25, stop.on.error=TRUE, 
               keep.xy=FALSE, aux=NULL)

  a.ini   <- c(0.1, 1, 10, 100, 200)
  b.ini   <- 200
  ini.val <- list(0.001, 0.02, 0.15, 0, 200, a.ini, b.ini)
  resu4   <- fitsigmoid(MPerformanceE, x=t0, y=m0, ini.val=ini.val, simpver=NULL, 
             fig.opt=TRUE, control=list(reltol=1e-20, maxit=20000, trace=FALSE), 
             subdivisions=100L, rel.tol=.Machine$double.eps^0.25, 
             abs.tol=.Machine$double.eps^0.25, stop.on.error=TRUE, 
             keep.xy=FALSE, aux=NULL)
  resu5   <- fitsigmoid(MPerformanceE, x=t0, y=m0, ini.val=resu4$par, simpver=NULL, 
               fig.opt=TRUE, control=list(reltol=1e-30, maxit=200000, trace=FALSE))

  ini.val <- list(0.001, 0.01, c(0.1, 1, 10), 0, 200)
  resu6   <- fitsigmoid(MPerformanceE, x=t0, y=m0, ini.val=ini.val, simpver=2, 
             fig.opt=TRUE, control=list(reltol=1e-20, maxit=20000, trace=FALSE), 
             subdivisions=100L, rel.tol=.Machine$double.eps^0.25, 
             abs.tol=.Machine$double.eps^0.25, stop.on.error=TRUE, 
             keep.xy=FALSE, aux=NULL)
}

graphics.off()
}

\name{VolumeEPE}
\encoding{UTF-8}
\alias{VolumeEPE}
\title{
Calculation of the Volume of An Egg Based on the Explicit Preston Equation
}
\description{
\code{VolumeEPE} is used to calculate the volume of an egg that follows the explicit Preston equation.
}
\usage{
VolumeEPE(P, simpver = NULL)
}
\arguments{
  \item{P}{the parameters of the explicit Preston equation or one of its simplified versions.}
  \item{simpver}{an optional argument to use the simplified version of the explicit Preston equation.}
}
\details{
When \code{simpver = NULL}, the volume formula (\eqn{V}) of the explicit Preston equation is selected: 
\deqn{ V(x) = \frac{4\,\pi}{315}a\,b^{2}\left(105+21\,c_{1}^{2}+42\,c_{2}+9\,c_{2}^2+18\,c_{1}\,c_{3}+5\,c_{3}^2\right), }
where \code{P} has five parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, \eqn{c_{2}}, and \eqn{c_{3}}.

\eqn{\quad} When \code{simpver = 1}, the volume formula of the simplified version 1 is selected:
\deqn{ V(x) = \frac{4\,\pi}{315}a\,b^{2}\left(105+21\,c_{1}^{2}+42\,c_{2}+9\,c_{2}^2\right), }
where \code{P} has four parameters: \eqn{a}, \eqn{b}, \eqn{c_{1}}, and \eqn{c_{2}}.

\eqn{\quad} When \code{simpver = 2}, the volume formula of the simplified version 2 is selected:
\deqn{ V(x) = \frac{4\,\pi}{315}a\,b^{2}\left(105+21\,c_{1}^{2}\right), }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{1}}.

\eqn{\quad} When \code{simpver = 3}, the volume formula of the simplified version 3 is selected:
\deqn{ V(x) = \frac{4\,\pi}{315}a\,b^{2}\left(105+42\,c_{2}+9\,c_{2}^2\right), }
where \code{P} has three parameters: \eqn{a}, \eqn{b}, and \eqn{c_{2}}.
}
\note{
The argument \code{P} in the \code{\link{VolumeEPE}} function has the same parameters, as those in the 
\code{\link{EPE}} function. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Narushin, V.G., Romanov, M.N., Mishra, B., Griffin, D.K. (2022) Mathematical progression of 
avian egg shape with associated area and volume determinations. 
\emph{Annals of the New York Academy of Sciences} 1513, 65\eqn{-}78. \doi{10.1111/nyas.14771}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{EPE}}, \code{\link{fitEPE}}, \code{\link{SurfaceAreaEPE}}
}
\examples{
  Par3 <- c(4.27, 2.90, 0.0868, 0.0224, -0.0287)
  VolumeEPE(P=Par3, simpver=NULL)

  # Test the case when simpver = NULL
  a    <- Par3[1]
  b    <- Par3[2]
  c1   <- Par3[3]
  c2   <- Par3[4]
  c3   <- Par3[5]
  pi*4/315*a*b^2*(105+21*c1^2+42*c2+9*c2^2+18*c1*c3+5*c3^2)

  myfun <- function(x){
    pi*EPE(P=Par3, x=x, simpver=NULL)^2
  }
  integrate(myfun, -4.27, 4.27)$value
}

\name{SHE}
\encoding{UTF-8}
\alias{SHE}
\title{
Sitthiyot-Holasut Equation
}
\description{
\code{SHE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the Sitthiyot-Holasut equation. The equation describes the \eqn{y} coordinates of the Lorenz curve.
}
\usage{
SHE(P, x)
}
\arguments{
  \item{P}{the parameters of the Sitthiyot-Holasut equation.}
  \item{x}{the given \eqn{x} values ranging between 0 and 1.}
}
\details{

\deqn{\mbox{if } x > \delta,}
\deqn{y = \left(1-\rho\right)\,\left[\left(\frac{2}{P+1}\right)\left(\frac{x-\delta}{1-\delta}\right)\right] + 
\rho\,\left[\left(1-\omega\right)\left(\frac{x-\delta}{1-\delta}\right)^{P}+\omega\,\left\{1-\left[1-\left(\frac{x-\delta}{1-\delta}\right)\right]^{\frac{1}{P}}\right\}\right];}
\deqn{\mbox{if } x \le \delta,}
\deqn{y = 0.}
Here, \eqn{x} and \eqn{y} represent the independent and dependent variables, respectively; 
and \eqn{\delta}, \eqn{\rho}, \eqn{\omega} and \eqn{P} are constants to be estimated, where \eqn{0 \le \delta < 1}, 
\eqn{0 \le \rho \le 1}, \eqn{0 \le \omega \le 1}, and \eqn{P \ge 1}.   
There are four elements in \code{P}, representing 
the values of \eqn{\delta}, \eqn{\rho}, \eqn{\omega} and \eqn{P}, respectively.

}
\value{
The \eqn{y} values predicted by the Sitthiyot-Holasut equation.
}
\note{
The numerical range of \eqn{x} should range between 0 and 1. 
When \eqn{x < \delta}, the \eqn{x} value is assigned to be \eqn{\delta}. 
}
\references{
Sitthiyot, T., Holasut, K. (2023) A universal model for the Lorenz curve with novel applications 
for datasets containing zeros and/or exhibiting extreme inequality. \emph{Scientific Reports} 
13, 4729. \doi{10.1038/s41598-023-31827-x}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{fitLorenz}}, \code{\link{MPerformanceE}}, \code{\link{SarabiaE}}, \code{\link{SCSE}}
}
\examples{
X1  <- seq(0, 1, len=2000)
Pa3 <- c(0, 1, 0.446, 1.739)
Y3  <- SHE(P=Pa3, x=X1)

dev.new()
plot( X1, Y3, cex.lab=1.5, cex.axis=1.5, type="l", asp=1, xaxs="i", 
      yaxs="i", xlim=c(0, 1), ylim=c(0, 1), 
      xlab="Cumulative proportion of the number of infructescences", 
      ylab="Cumulative proportion of the infructescence length" )

graphics.off()
}

\name{LeafSizeDist}
\encoding{UTF-8}
\docType{data}
\alias{LeafSizeDist}
\title{
Leaf size distribution of \emph{Shibataea chinensis}
}
\description{
The data consist of the leaf size measures of 12 individuad culms of \emph{Shibataea chinensis}.
}
\usage{
data(LeafSizeDist)
}
\details{
In the data set, there are five columns of variables: \code{Code}, \code{L}, 
\code{W}, \code{A}, and \code{M}. \code{Code} saves the bamboo number (the number before the hyphen) 
and the leaf number (the number after the hyphen) on each bamboo. \code{L} saves the length of each 
leaf lamina (cm); \code{W} saves the width of each leaf lamina (cm); 
\code{A} saves the area of each leaf lamina (\eqn{\mbox{cm}^{2}}); and \code{M} saves 
the dry mass of each leaf lamina (g).
}
\references{
Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees \eqn{-} Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}
}
\examples{
data(LeafSizeDist)

CulmNumber <- c()
for(i in 1:length(LeafSizeDist$Code)){
  temp <- as.numeric( strsplit(LeafSizeDist$Code[i],"-", fixed=TRUE)[[1]][1] )
  CulmNumber <- c(CulmNumber, temp)
}

uni.CN <- sort( unique(CulmNumber) )  
ind    <- CulmNumber==uni.CN[1]

A0 <- LeafSizeDist$A[ind]
A1 <- sort( A0 )
x1 <- 1:length(A1)/length(A1)
y1 <- cumsum(A1)/sum(A1)
x1 <- c(0, x1)
y1 <- c(0, y1)

M0 <- LeafSizeDist$M[ind]
M1 <- sort( M0 )
x2 <- 1:length(M1)/length(M1)
y2 <- cumsum(M1)/sum(M1)
x2 <- c(0, x2)
y2 <- c(0, y2)

dev.new()
plot(x1, y1, cex.lab=1.5, cex.axis=1.5, type="l",
    xlab="Cumulative proportion of the number of leaves", 
    ylab="Cumulative proportion of leaf area") 
lines(c(0,1), c(0,1), col=4) 

dev.new()
plot(x2, y2, cex.lab=1.5, cex.axis=1.5, type="l",
    xlab="Cumulative proportion of the number of leaves", 
    ylab="Cumulative proportion of leaf dry mass")
lines(c(0,1), c(0,1), col=4)   

graphics.off()
}

\name{DETE}
\encoding{UTF-8}
\alias{DETE}
\title{
Calculation of the First-Order Derivative of the Explicit Troscianko Equation  
}
\description{
\code{DETE} is used to calculate the first-order derivative of the explicit Troscianko equation at a given \emph{x}-value.
}
\usage{
DETE(P, x)
}
\arguments{
  \item{P}{the parameters of the explicit Troscianko equation.}
  \item{x}{the \emph{x}-value used in the explicit Troscianko equation.}
}
\details{
The first-order derivative of the explicit Troscianko equation at a given \emph{x}-value is: 

\deqn{h(x) = \left\{\alpha_{1}+\frac{2\,\alpha_{2}}{a}\,x-\frac{x}{a}\,\left[1-\left(\frac{x}{a}\right)^2\right]^{-1}\right\}\,\exp\left\{\alpha_{0}+\alpha_{1}\left(\frac{x}{a}\right)+\alpha_{2}\left(\frac{x}{a}\right)^2\right\}\,\sqrt{ 1-\left(\frac{x}{a}\right)^2 }, }

where \code{P} has four parameters: \eqn{a}, \eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}}.
}
\note{
The argument \code{P} in the \code{\link{DETE}} function has the same parameters, as those in the 
\code{\link{ETE}} function.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{ETE}}, \code{\link{fitETE}}, \code{\link{SurfaceAreaETE}}
}
\examples{
  Par5 <- c(2.25, -0.38, -0.29, -0.16)
  xx2  <- seq(-2.25, 2.25, by=0.001)
  h1   <- DETE(P=Par5, x=xx2)
  h2   <- -DETE(P=Par5, x=xx2)
  ind  <- which(is.na(h1) | is.na(h2))
  xx2  <- xx2[-ind]
  h1   <- h1[-ind]
  h2  <- h2[-ind]

  dev.new()
  plot(xx2, h1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlim=c(-2.25, 2.25), ylim=c(-30, 30), xlab=expression(italic(x)), 
       ylab=expression(paste(italic(h), "(", italic(x), ")", sep="")))
  lines(xx2, h2, col=2)  

  graphics.off()
}

\name{VolumeSGE}
\encoding{UTF-8}
\alias{VolumeSGE}
\title{
Calculation of the Volume of An Egg Based on the Simplified Gielis Equation 
}
\description{
\code{VolumeSGE} is used to calculate the volume of an egg that follows the simplified Gielis equation.
}
\usage{
VolumeSGE(P, subdivisions = 100L,
          rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
          stop.on.error = TRUE, keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{P}{the parameters of the simplified Gielis equation, including \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}}.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The formula of the volume (\eqn{V}) of an egg based on the simplified Gielis equation is:
\deqn{V\left(\varphi\right)=\frac{2}{3}\,\pi\int_{0}^{\pi}\sin{\left(\varphi\right)}\ r^3\left(\varphi\right)\,d\varphi,}

where the polar raidus (\eqn{r}) is the function of the polar angle (\eqn{\varphi}):

\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}\right)^{-\frac{1}{n_{1}}},} 

namely the simplified Gielis equation (i.e., \code{\link{GE}}) with arguments 
\code{simpver = 1} and \code{m = 1}.  
}
\note{
The argument \code{P} in the \code{\link{VolumeSGE}} function only has 
the three parameters: \eqn{a}, \eqn{n_{1}}, and \eqn{n_{2}}. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Chen, Z. (2012) Volume and area of revolution under polar coordinate system. 
\emph{Studies in College Mathematics} 15(6), 9\eqn{-}11.

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{fitGE}}, \code{\link{GE}}, \code{\link{SurfaceAreaSGE}}
}
\examples{
  Par7 <- c(1.124, 14.86, 49.43)
  VolumeSGE(P = Par7)
}

\name{TGE}
\encoding{UTF-8}
\alias{TGE}
\title{
Calculation of the Polar Radius of the Twin Gielis Curve
}
\description{
\code{TGE} is used to calculate the polar radii of the twin Gielis equation or 
one of its simplified versions at given polar angles.
}
\usage{
TGE(P, phi, m = 1, simpver = NULL, nval = 1)
}
\arguments{
  \item{P}{the parameters of the twin Gielis equation or one of its simplified versions.}
  \item{phi}{the polar angle(s).}
  \item{m}{the given \eqn{m} value that determines the number of angles of the twin Gielis curve within \eqn{[0, 2\pi)}.}
  \item{simpver}{an optional argument to use the simplified version of the twin Gielis equation.}
  \item{nval}{the specified value for \eqn{n_{2}} or \eqn{n_{3}} in the simplified versions.}
}
\details{
The general form of the twin Gielis equation can be represented as follows:

\deqn{r\left(\varphi\right) = \mathrm{exp}\left\{\frac{1}{\alpha+\beta\,\mathrm{ln}\left[r_{e}\left(\varphi\right)\right]}+\gamma\right\},}
where \eqn{r} represents the polar radius of the twin Gielis curve at the polar angle \eqn{\varphi}, and 
\eqn{r_{e}} represents the elementary polar radius at the polar angle \eqn{\varphi}. There is a hyperbolic 
link function to link their log-transformations, i.e., 
\deqn{\mathrm{ln}\left[r\left(\varphi\right)\right] = \frac{1}{\alpha+\beta\,\mathrm{ln}\left[r_{e}\left(\varphi\right)\right]}+\gamma.}  
The first three elements of \code{P} are \eqn{\alpha}, \eqn{\beta}, and \eqn{\gamma}, and the remaining element(s) of 
\code{P} are the parameters of the elementary polar function, i.e., \eqn{r_{e}\left(\varphi\right)}. 
See Shi et al. (2020) for details. 

\eqn{\quad} When \code{simpver = NULL}, the original twin Gielis equation is selected: 
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{3}},}
where \eqn{r_{e}} represents the elementary polar radius at the polar angle \eqn{\varphi}; 
\eqn{m} determines the number of angles of the twin Gielis curve within \eqn{[0, 2\pi)}; 
and \eqn{k}, \eqn{n_{2}}, and \eqn{n_{3}} are the fourth to the sixth elements in \code{P}. In total, there are 
six elements in \code{P}.

\eqn{\quad} When \code{simpver = 1}, the simplified version 1 is selected:
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}},}
where \eqn{n_{2}} is the fourth element in \code{P}. There are 
four elements in total in \code{P}.

\eqn{\quad} When \code{simpver = 2}, the simplified version 2 is selected:
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}, }
where \eqn{n_{2}} should be specified in \code{nval}, and \code{P} only includes three elements, i.e., 
\eqn{\alpha}, \eqn{\beta}, and \eqn{\gamma}.

\eqn{\quad} When \code{simpver = 3}, the simplified version 3 is selected:
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{3}},}
where \eqn{n_{2}} and \eqn{n_{3}} are the fourth and fifth elements in \code{P}. There are 
five elements in total in \code{P}.
 
\eqn{\quad} When \code{simpver = 4}, the simplified version 4 is selected:
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}},}
where \eqn{k} and \eqn{n_{2}} are the fourth and fifth elelments in \code{P}. There are 
five elements in total in \code{P}.
 
\eqn{\quad} When \code{simpver = 5}, the simplified version 5 is selected:
\deqn{r_{e}\left(\varphi\right) = \left|\mathrm{cos}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\frac{m}{4}\varphi\right)\right|^{n_{2}},}
where \eqn{k} is the fourth elelment in \code{P}. There are 
four elements in total in \code{P}. \eqn{n_{2}} should be specified in \code{nval}.

}
\value{
The polar radii predicted by the twin Gielis equation or one of its simplified versions.
}
\note{
\code{simpver} here is different from that in the \code{\link{GE}} function.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric 
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}
}
\seealso{
\code{\link{areaGE}}, \code{\link{curveGE}}, \code{\link{fitGE}}, \code{\link{GE}}
}
\examples{
TGE.par    <- c(2.88, 0.65, 1.16, 139)
varphi.vec <- seq(0, 2*pi, len=2000)
r2.theor   <- TGE(P=TGE.par, phi=varphi.vec, simpver=1, m=5)

dev.new()
plot( varphi.vec, r2.theor, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(varphi)), ylab=expression(italic("r")),
      type="l", col=4 ) 

starfish4 <- curveGE(TGE, P=c(0, 0, 0, TGE.par), simpver=1, m=5, fig.opt=TRUE)

graphics.off()
}

\name{curveovate}
\encoding{UTF-8}
\alias{curveovate}
\title{
Drawing the Ovate Leaf-Shape Curve
}
\description{
\code{curveovate} is used to draw the ovate leaf-shape curve.
}
\usage{
curveovate(expr, P, x, fig.opt = FALSE, 
           deform.fun = NULL, Par = NULL,
           xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{expr}{the simplified version 1 of a performance equation.}
  \item{P}{the three location parameters and the parameters of the simplified version 1 of a performance equation.}
  \item{x}{the given \eqn{x} values to draw the ovate leaf-shape curve.}
  \item{fig.opt}{an optional argument to draw the ovate leaf-shape curve.}
  \item{deform.fun}{the deformation function used to describe the deviation 
from a theoretical ovate leaf-shape curve.}
  \item{Par}{the parameter(s) of the deformation function.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the ovate leaf-shape curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the ovate leaf-shape curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the ovate leaf-shape curve.}
  \item{main}{the main title of the figure.}
}
\details{
\code{P} has two types of elements: three location parameters, and model parameters. 
This means that \code{expr} is limited to be the simplified version 1 (where \eqn{x_{\mathrm{min}} = 0})  
in \code{\link{MbetaE}}, \code{\link{MBriereE}}, \code{\link{MLRFE}}, and \code{\link{MPerformanceE}}. 
The first three elements of \code{P} are location parameters, among which the first two 
are the planar coordinates of the transferred origin, 
and the third is the angle between the major axis of the curve and the \eqn{x}-axis. 
\code{deform.fun} should take the form as: \code{deform.fun <- function(Par, z){\dots}}, where \code{z} is 
a two-dimensional matrix related to the \eqn{x} and \eqn{y} values. 
And the return value of \code{deform.fun} should be a \code{list} with two variables \code{x} and \code{y}.
}
\value{
  \item{x}{the \eqn{x} coordinates of the ovate leaf-shape curve.}
  \item{y}{the \eqn{y} coordinates of the ovate leaf-shape curve.} 
}
\note{
The number of elements in \code{P} here has additional three location parameters than that 
in \code{\link{MbetaE}}, \code{\link{MBriereE}}, \code{\link{MLRFE}}, \code{\link{MPerformanceE}}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Jin, J., Quinn, B.K., Shi, P. (2022) The modified Brière equation and its 
applications. \emph{Plants} 11, 1769. \doi{10.3390/plants11131769}

Huey, R.B., Stevenson, R.D. (1979) Integrating thermal physiology and ecology of ectotherms: 
a discussion of approaches. \emph{American Zoologist} 19, 357\eqn{-}366. \doi{10.1093/icb/19.1.357}

Li, Y., Zheng, Y., Ratkowsky, D.A., Wei, H., Shi, P. (2022) Application of an ovate leaf shape model 
to evaluate leaf bilateral asymmetry and calculate lamina centroid location. 
\emph{Frontiers in Plant Science} 12, 822907. \doi{10.3389/fpls.2021.822907}

Lian, M., Shi, P., Zhang, L., Yao, W., Gielis, J., Niklas, K.J. (2023) A generalized performance equation 
and its application in measuring the Gini index of leaf size inequality. 
\emph{Trees - Structure and Function} 37, 1555\eqn{-}1565. \doi{10.1007/s00468-023-02448-8}

Shi, P., Fan, M., Ratkowsky, D.A., Huang, J., Wu, H., Chen, L., Fang, S., 
Zhang, C. (2017) Comparison of two ontogenetic growth equations for animals and plants. 
\emph{Ecological Modelling} 349, 1\eqn{-}10. \doi{10.1016/j.ecolmodel.2017.01.012}

Shi, P., Ge, F., Sun, Y., Chen, C. (2011) A simple model for describing 
the effect of temperature on insect developmental rate. \emph{Journal of Asia-Pacific Entomology} 
14, 15\eqn{-}20. \doi{10.1016/j.aspen.2010.11.008} 

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Yu, K., Niklas, K.J., Schrader, J., Song, Y., Zhu, R., Li, Y., Wei, H., Ratkowsky, D.A. (2021)  
A general model for describing the ovate leaf shape. \emph{Symmetry} 13, 1524. \doi{10.3390/sym13081524}
}
\seealso{
\code{\link{areaovate}}, \code{\link{fitovate}}, \code{\link{MbetaE}}, 
\code{\link{MBriereE}}, \code{\link{MLRFE}}, \code{\link{MPerformanceE}}
}
\examples{
P1  <- c(1, 1, pi/4, 2, 3, 10, 4)
RE1 <- curveovate(MLRFE, P=P1, x=seq(0, 10, by=0.1), fig.opt=TRUE)
RE2 <- curveovate(MbetaE, P=P1, x=seq(0, 10, by=0.1), fig.opt=TRUE)

dev.new()
plot(RE1$x, RE1$y, cex.lab=1.5, cex.axis=1.5, type="l", 
  xlab=expression(italic(x)), ylab=expression(italic(y))) 
lines(RE2$x, RE2$y, col=4)

P3  <- c(1, 1, pi/4, 2.4, 0.96, 0.64, 7.75, 1.76, 3.68)
RE3 <- curveovate(MPerformanceE, P=P3, x=seq(0, 7.75, by=0.01), fig.opt=TRUE)

dev.new()
plot(RE3$x, RE3$y, cex.lab=1.5, cex.axis=1.5, type="l", 
  xlab=expression(italic(x)), ylab=expression(italic(y))) 

graphics.off()
}

\name{lmTE}
\encoding{UTF-8}
\alias{lmTE}
\title{
Parameter Estimation for the Troscianko Equation
}
\description{
\code{lmTE} is used to estimate the parameters of the Troscianko equation using the multiple linear regression, 
and the estimated values of the parameters are only used as the initial values for using the \code{\link{fitETE}} function
}
\usage{
lmTE(x, y, dev.angle = NULL, weights = NULL, fig.opt = TRUE, 
     prog.opt = TRUE, xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of the edge of an egg's boundary.}
  \item{y}{the \eqn{y} coordinates of the edge of an egg's boundary.}
  \item{dev.angle}{the angle of deviation for the axis associated with the maximum distance between two points 
on an egg's profile from the mid-line of the egg's profile.}
  \item{weights}{the weights for the multiple linear regression.}
  \item{fig.opt}{an optional argument to draw the observed and predicted egg's boundaries.}
  \item{prog.opt}{an optional argument to show the running progress for different values of \code{dev.angle}, when \code{dev.angle} is not \code{NULL}.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Troscianko curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Troscianko curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Troscianko curve.}
  \item{main}{the main title of the figure.}
}
\details{
The estimated values of the parameters using the \code{\link{lmTE}} function tend to be NOT globally optimal, and the values 
are only used as the initial values for using the \code{\link{fitETE}} function. 
There are two methods to obtain the major axis (i.e., the mid-line) of an egg's profile: the maximum distance method, and 
the longest axis adjustment method. In the first method, the straight line through two points forming the maximum distance 
on the egg's boundary is defined as the major axis. In the second method, we assume that there is an angle 
of deviation for the longest axis (i.e., the axis associated with the maximum distance between two points on an egg's profile) 
from the mid-line of the egg's profile. That is to say, 
the mid-line of an egg's profile is not the axis associated with the maximum distance between two points on the egg's profile. 
When \code{dev.angle = NULL}, the maximum distance method is used; when \code{dev.angle} is a numerical value or a numerical vector, 
the longest axis adjustment method is used. Here, the numerical value of \code{dev.angle} is not 
the angle of deviation for the major axis of an egg's profile from the \eqn{x}-axis, and instead it is the angle of deviation  
for the longest axis (associated with the maximum distance between two points on the egg's profile) from the mid-line of the egg's profile. 
The planar coordinate data of an egg's profile are extracted using the protocols proposed by Shi et al. (2015, 2018) 
(and also see Su et al. (2019)). For the planar coordinate data extracted using the protocols of Shi et al. (2015, 2018), 
the data points are more regularly distributed on the egg's profile (perimeter), 
although the \eqn{x} values of the data points along the mid-line are not equidistant. 
}
\value{
  \item{lm.te}{the fitted results of the multiple linear regression.}
  \item{par}{the estimates of the four model parameters in the Troscianko equation.}
  \item{theta}{the angle between the longest axis of an egg's profile (i.e., 
the axis associated with the maximum distance between two points on the egg's profile) and the \eqn{x}-axis.}
  \item{epsilon}{the optimal angle of deviation for the longest axis (associated with the maximum distance between two points on an egg's profile) 
from the mid-line of the egg's profile, when \code{dev.angle} is not \code{NULL}.}
  \item{RSS.vector}{the vector of residual sum of squares corresponding to \code{dev.angle}, when \code{dev.angle} is not \code{NULL}.}
  \item{x.obs}{the observed \eqn{x} coordinates.}
  \item{y.obs}{the observed \eqn{y} coordinates.}
  \item{y.pred}{the predicted \eqn{y} coordinates corresponding to the the observed \eqn{x} coordinates.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates when the egg length is fixed to be 2 ranging from -1 to 1.}
  \item{y.stand.obs}{the observed \eqn{y} coordinates when the egg length is fixed to be 2 ranging from -1 to 1.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates corresponding to the the observed \eqn{x} coordinates, 
when the egg length is fixed to be 2 ranging from -1 to 1.}
  \item{scan.length}{the length of the egg's boundary. The default is the maximum distance between two points on 
the egg's boundary.}
  \item{scan.width}{the maximum width of the egg's boundary.}
  \item{scan.area}{the area of the egg's boundary.}
  \item{scan.perimeter}{the perimeter of the egg's boundary based on all data points on the egg's boundary.}
  \item{RSS.scaled}{the residual sum of squares between the observed and predicted \eqn{y} values for a scaled egg's profile whose length equals 2.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points used in the numerical calculation.}
  \item{RMSE.scaled}{the root-mean-square errors between the observed and predicted \eqn{y} values for a scaled egg's profile whose length equals 2.}      
  \item{RMSE}{the root-mean-square errors between the observed and predicted \eqn{y} values.}       
}
\note{
\code{theta} is the calculated angle between the longest axis (i.e., the axis associated with the maximum distance 
between two points on an egg's profile) and the \eqn{x}-axis, and \code{epsilon} is the calculated angle of deviation for the longest 
axis from the mid-line of the egg's profile. This means that the angle between the mid-line and the \eqn{x}-axis is equal to 
\code{theta} + \code{epsilon}. 
Here, \code{RSS}, and \code{RMSE} are for the observed and predicted \eqn{y} coordinates of the egg's profile, not for those 
when the egg's length is scaled to 2. There are two figures when \code{fig.opt = TRUE}: (i) the observed 
and predicted egg's boundaries when the egg's length is scaled to 2, and (ii) the observed 
and predicted egg's boundaries at their actual scales. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston’s universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Nelder, J.A., Mead, R. (1965). A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Huang, J., Hui, C., Grissino-Mayer, H.D., Tardif, J., Zhai, L., Wang, F., Li, B. (2015) 
Capturing spiral radial growth of conifers using the superellipse to model tree-ring geometric shape. 
\emph{Frontiers in Plant Science} 6, 856. \doi{10.3389/fpls.2015.00856}

Shi, P., Ratkowsky, D.A., Li, Y., Zhang, L., Lin, S., Gielis, J. (2018) General leaf-area geometric 
formula exists for plants - Evidence from the simplified Gielis equation. 
\emph{Forests} 9, 714. \doi{10.3390/f9110714}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Su, J., Niklas, K.J., Huang, W., Yu, X., Yang, Y., Shi, P. (2019) 
Lamina shape does not correlate with lamina surface area: An analysis based on the simplified Gielis equation. 
\emph{Global Ecology and Conservation} 19, e00666. \doi{10.1016/j.gecco.2019.e00666}

Troscianko, J. (2014). A simple tool for calculating egg shape, volume and surface area from digital images. 
\emph{Ibis}, 156, 874\eqn{-}878. \doi{10.1111/ibi.12177} 
}
\seealso{
\code{\link{fitETE}}, \code{\link{TE}} 
}
\examples{
data(eggs)

uni.C <- sort( unique(eggs$Code) )
ind   <- 8
Data  <- eggs[eggs$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1  <- adjdata(x0, y0, ub.np=3000, len.pro=1/20)
x1    <- Res1$x
y1    <- Res1$y

dev.new()
plot( Res1$x, Res1$y, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic("x")), ylab=expression(italic("y")) ) 

\donttest{
  Res2 <- lmTE(x1, y1, dev.angle=NULL, unit="cm")
  summary( Res2$lm.te )
  Res2$RMSE.scaled / 2

  if(FALSE){
    dev.new()
    xg1 <- seq(-1, 1, len=1000)
    yg1 <- TE(P=Res2$par, x=xg1)
    xg2 <- seq(1, -1, len=1000)
    yg2 <- -TE(P=Res2$par, x=xg2)
    plot(xg1, yg1, asp=1, type="l", col=2, ylim=c(-1,1), cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(x)), ylab=expression(italic(y)))
    lines(xg2, yg2, col=4)

    dev.new()
    plot(Res2$x.obs, Res2$y.obs, asp=1, cex.lab=1.5, cex.axis=1.5,  
      xlab=expression(italic(x)), ylab=expression(italic(y)), type="l")
    lines(Res2$x.obs, Res2$y.pred, col=2)

    dev.new()
    plot(Res2$x.stand.obs, Res2$y.stand.obs, asp=1, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(x)), ylab=expression(italic(y)), type="l")
    lines(Res2$x.stand.obs, Res2$y.stand.pred, col=2)
  }

  Res3 <- lmTE(x1, y1, dev.angle=seq(-0.05, 0.05, by=0.0001), unit="cm")
  summary( Res3$lm.te )
  Res3$epsilon
  Res3$RMSE.scaled / 2

}

graphics.off()
}

\name{VolumeNRGE}
\encoding{UTF-8}
\alias{VolumeNRGE}
\title{
Calculation of the Volume of An Egg Based on the Narushin-Romanov-Griffin Equation
}
\description{
\code{VolumeNRGE} is used to calculate the volume of an egg that follows the Narushin-Romanov-Griffin equation.
}
\usage{
VolumeNRGE(P, subdivisions = 100L,
         rel.tol = .Machine$double.eps^0.25, abs.tol = rel.tol,
         stop.on.error = TRUE, keep.xy = FALSE, aux = NULL)
}
\arguments{
  \item{P}{the parameters of the Narushin-Romanov-Griffin equation.}
  \item{subdivisions}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{rel.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{abs.tol}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{stop.on.error}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{keep.xy}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
  \item{aux}{please see the arguments for the \code{\link[stats]{integrate}} function in package \pkg{stats}.}
}
\details{
The formula of the volume (\eqn{V}) of an egg based on the Narushin-Romanov-Griffin equation is:
\deqn{V(x)=\pi\int_{-A/2}^{A/2}y^2\,dx,}
where \eqn{y} denotes the Narushin-Romanov-Griffin equation (i.e., \code{\link{NRGE}}), and 
\eqn{A} denotes the egg's length, which is the first element in the parameter vector, \code{P}.  
}
\note{
The argument \code{P} in the \code{\link{VolumeNRGE}} function has the same parameters, as those in the 
\code{\link{NRGE}} function.  
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Narushin, V.G., Romanov, M.N., Mishra, B., Griffin, D.K. (2022) Mathematical progression of 
avian egg shape with associated area and volume determinations. 
\emph{Annals of the New York Academy of Sciences} 1513, 65\eqn{-}78. \doi{10.1111/nyas.14771}

Shi, P., Chen, L., Quinn, B.K., Yu, K., Miao, Q., Guo, X., Lian, M., Gielis, J., Niklas, K.J. (2023) 
A simple way to calculate the volume and surface area of avian eggs. 
\emph{Annals of the New York Academy of Sciences} 1524, 118\eqn{-}131. \doi{10.1111/nyas.15000}
}
\seealso{
\code{\link{curveNRGE}}, \code{\link{fitNRGE}}, \code{\link{NRGE}}, \code{\link{SurfaceAreaNRGE}}
}
\examples{
  Par6 <- c(4.51, 3.18, 0.1227, 2.2284)
  VolumeNRGE(P=Par6)

  myfun <- function(x){
    pi*NRGE(P=Par6, x=x)^2
  }
  integrate(myfun, -4.51/2, 4.51/2)$value
}

\name{fitGS}
\encoding{UTF-8}
\alias{fitGS}
\title{
Data-Fitting Function for the Geometric Series of Size Distribution Measurements
}
\description{
\code{fitGS} is used to estimate the model parameters of a geometric series, i.e., the first term and common ratio.
}
\usage{
fitGS(A, ini.val = NULL, control = list(), par.list = FALSE, fig.opt = TRUE)
}
\arguments{
  \item{A}{A sequence of size distribution measurements, e.g., the temporal or spatial progression of leaf area in an individual plant.}
  \item{ini.val}{the list of initial values for the model parameters.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{fig.opt}{an optional argument to draw (i) the observed and predicted \eqn{y} values 
(size distribution measurements) sorted in ascending order, and (ii) the the observed and predicted \eqn{z} values 
(cumulative size distribution measurements) sorted in ascending order.}
}
\details{
In general, there is no need to set the initial values for model parameters by users (i.e., \code{ini.val = NULL}). 
The approach proposed by Yan et al. (2025) is used to find the suitable initial values for model parameters. 
The Nelder-Mead algorithm (Nelder and Mead, 1965) is used to carry out the optimization of minimizing the 
residual sum of squares (RSS) between the observed and predicted \eqn{y} values (Deng et al., 2025; Yan et al. 2025). 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
\code{fig.opt = TRUE} generates two panels (i.e., \eqn{y} vs. \eqn{\hat{y}}, and \eqn{z} vs. \eqn{\hat{z}}) in a figure.
}
\value{
  \item{x}{the ascending number from 1 to \code{length(A)}.}
  \item{y}{the observed size distribution measurements (\eqn{y} values) sorted in ascending order.}
  \item{y.theo}{the predicted size distribution measurements (\eqn{y} values) sorted in ascending order by the geometric seires.}
  \item{z}{the observed cumulative size distribution measurements (\eqn{z} values) sorted in ascending order.}
  \item{z.theo}{the predicted cumulative size distribution measurements (\eqn{z} values) sorted in ascending order by the geometric seires.}
  \item{par}{the estimates of the model parameters corresponding to the first term and common ratio, respectively.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{RMSE1}{the root mean square error between the observed and predicted \eqn{y} values.}
  \item{MAPE1}{the mean absolute percent error between the observed and predicted \eqn{y} values (in \%).}
  \item{RMSE2}{the root mean square error between the observed and predicted \eqn{z} values.}
  \item{MAPE2}{the mean absolute percent error between the observed and predicted \eqn{z} values (in \%).}
}
\note{
In the outputs, the parameter vector \code{par} was estimated based on the observed 
and predicted \eqn{y} values rather than the observed and predicted \eqn{z} values.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{

Deng, L., Wang, J., Zhang, L., Hölscher, D., Shi, P. (2025) Testing the validity of 
the Koyama-Smith equation and the power-law equation using 3231 tepals of a \emph{Magnolia} 
species. \emph{Trees \eqn{-} Structure and Function} 39, 74. \doi{10.1007/s00468-025-02645-7}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Yan, C., Shi, P., Yao, W., Yu, K., Niinemets, Ü. (2025) A nonlinear fitting method provides 
strong support for geometric series of stomatal area in 12 Magnoliaceae species. 
\emph{Plants} 14, 893. \doi{10.3390/plants14060893}
}
\examples{
  # A sequence of tepal area measurements of a Magnolia flower (Deng et al., 2025)
  A   <- c(56.65, 43.37, 49.61, 56.27, 56.66, 49.45, 46.56, 43.42, 44.80)
  ReS <- fitGS(A)
  names( ReS)

  graphics.off()
}

\name{bilat}
\encoding{UTF-8}
\alias{bilat}
\title{
Measure of the Extent of Bilateral Symmetry of A Polygon
}
\description{
\code{bilat} is used to measure the extent of bilateral (a)symmetry and other measures for a polygon (e.g., a leaf).
}
\usage{
bilat(x, y, strip.num = 200, peri.np = NULL, n.loop = 60,
      auto.search = TRUE, animation.fig = TRUE, time.interval = 0.001,   
      unit = "cm", main = NULL, diff.fig = TRUE, angle = NULL,  
      ratiox = 0.02, ratioy = 0.08, fd.opt = TRUE, frac.fig = TRUE,
      denomi.range = seq(8, 30, by = 1))
}
\arguments{
  \item{x}{the \eqn{x} coordinates of a polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of a polygon's boundary.}
  \item{strip.num}{the number of equidistant strips intersecting with 
the polygon that are horizontally placed. See Shi et al. (2018, 2020) for details.}  
  \item{peri.np}{the number of data points on the boundary retained for calculating the perimeter of the polygon.}
  \item{n.loop}{the number of data points to randomly sample for calculating the mean perimeter of the polygon.}
  \item{auto.search}{an optional argument to automatically search the maximum distance between two points on the polygon's boundary.}
  \item{animation.fig}{the option of showing the data points on the polygon's boundary in an animation.}
  \item{time.interval}{the time interval at which to suspend execution, in seconds.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the polygon.}
  \item{main}{the main title of the figure.}  
  \item{diff.fig}{an optional argument to draw the differences in areas between the intersections of the strips 
with the upper part of the polygon and the intersections of the strips with the lower part of the polygon. 
The polygon is divided into the upper and lower parts by the \eqn{x}-axis. See Shi et al. (2018, 2020) for details.}
  \item{angle}{the angle between the major axis (i.e., the leaf length axis) and the \eqn{x}-axis, which can be defined by the user.}
  \item{fd.opt}{An optional argument to use the box-counting method to calculate the fractal
dimension of the polygon's boundary on a log-log scale.}
  \item{ratiox}{the \eqn{x} coordinate of the location parameter for positioning the legend in the plot of the linear fitting.}
  \item{ratioy}{the \eqn{y} coordinate of the location parameter for positioning the legend in the plot of the linear fitting.}
  \item{frac.fig}{an optional argument to draw the results of the linear fitting using the box-counting method to calculate the fractal
dimension of the polygon's boundary on a log-log scale.}
  \item{denomi.range}{the number of equidistant segments of the maximum range 
between the range of the \eqn{x} coordinates and that of the \eqn{y} coordinates.}

}
\details{
The data of \code{x} and \code{y} should be the coordinates adjusted using the \code{\link{adjdata}} function. 
If \code{peri.np = NULL}, the number of \code{length(x)} is used to calculate the perimeter of the polygon; 
if \code{peri.np} is a positive integer, the number of data points retained on the polygon's boundary  
is equal to \code{peri.np} and random sampling for retaining \code{peri.np} data points is carried out 
\code{n.loop} times for calculating the mean perimeter of the polygon. That is to say, the final output for 
the perimeter is the mean of the \code{n.loop} perimeters (i.e., replicates). If the user wants to get a consistent result 
for the mean perimeter, the \code{\link{set.seed}} function can be used. In addition, if \code{length(x) < peri.np}, 
\code{peri.np} then becomes \code{length(x)} rather than the specified value in Arguments. 
If the polygon apparently has a major axis (e.g., the leaf length axis for an ovate leaf), \code{auto.search} 
is appropriate. If the major axis of the polygon is not the straight line through two points on the polygon's 
boundary having the maximum distance, the user can define the major axis using the \code{\link[graphics]{locator}} 
function in \pkg{graphics} by clicking two points on or near the polygon's boundary. The location of the first click 
should be northeast of the location of the second click. This means that the angle between the straight line 
through the locations of the two clicks and the \eqn{x}-axis should range from 0 to \eqn{\pi}/2. The locations of the 
clicks can be on the boundary or be approximate to the boundary. The function will automatically find the nearest 
data point on the boundary to the location of each click. 
When \code{angle = NULL}, the observed polygon will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, it indicates that the major axis 
is rotated \eqn{\pi/4} counterclockwise from the \eqn{x}-axis. 
}
\value{
  \item{x}{the \eqn{x} coordinates retained on the polygon's boundary.}
  \item{y}{the \eqn{y} coordinates retained on the polygon's boundary.}
   \item{phi}{the angle between the length axis (i.e., the major axis) of the polygon and the \eqn{x}-axis.}
  \item{n1}{the number of data points on the upper boundary of the polygon.}
  \item{n2}{the number of data points on the lower boundary of the polygon.}
  \item{n}{the number of data points on the whole polygon's boundary.}
  \item{total.poly}{an object of class "ppp" representing a point pattern dataset 
in the two-dimensional plane, representing the polygon's boundary.}
  \item{upper.poly}{an object of class "ppp" representing a point pattern dataset 
in the two-dimensional plane, representing the upper boundary of the polygon along the \eqn{x}-axis.}
  \item{lower.poly}{an object of class "ppp" representing a point pattern dataset 
in the two-dimensional plane, representing the lower boundary of the polygon along the \eqn{x}-axis.}
  \item{D}{the differences in areas between the upper and lower boundaries of the polygon.}
  \item{par.upper.area}{the area of the upper boundary of the polygon along the \eqn{x}-axis.}
  \item{par.lower.area}{the area of the lower boundary of the polygon along the \eqn{x}-axis.}
  \item{SI}{the standardized index for bilateral (a)symmetry for the polygon.}
  \item{AR}{the ratio of the areas of the upper to the lower parts of the polygon.}
  \item{scan.length}{the length of the polygon. The default is the maximum distance between two points on 
the polygon's boundary.}
  \item{scan.width}{the maximum width of the polygon.}
  \item{scan.area}{the area of the polygon.}
  \item{scan.perimeter}{the perimeter of the polygon 
based on all data points or a mean of \code{n.loop} 
replicates of perimeters using the \code{peri.np} data points retained on the polygon's boundary.}
  \item{x.width}{distance from the base to a point on the major axis 
associated with the maximum width of the polygon.}
  \item{width.1e}{the width associated with 1/8 of \code{scan.length} (starting from the base of the polygon).} 
  \item{width.2e}{the width associated with 2/8 of \code{scan.length} (starting from the base of the polygon).}
  \item{width.4e}{the width associated with 4/8 of \code{scan.length} (starting from the base of the polygon).}
  \item{width.6e}{the width associated with 6/8 of \code{scan.length} (starting from the base of the polygon).}
  \item{width.7e}{the width associated with 7/8 of \code{scan.length} (starting from the base of the polygon).}
  \item{bi.test}{the testing results for \code{D} using the Wilcoxon signed rank test with continuity correction. 
See the \code{\link[stats]{wilcox.test}} function in \pkg{stats}.}
  \item{a}{the estimate of the intercept obtained using the box-counting method to calculate the fractal dimension of the polygon's boundary.}
  \item{sd.a}{the standard deviation of the estimated intercept.}
  \item{lci.a}{the lower bound of the 95\% confidence interval of the estimated intercept.}
  \item{uci.a}{the upper bound of the 95\% confidence interval of the estimated intercept.}
  \item{b}{the estimate of the slope obtained using the box-counting method to calculate the fractal dimension of the polygon's boundary.}
  \item{sd.b}{the standard deviation of the estimated slope.}
  \item{lci.a}{the lower bound of the 95\% confidence interval of the estimated slope.}
  \item{uci.a}{the upper bound of the 95\% confidence interval of the estimated slope.}
  \item{r.sq}{the coefficient of determination obtained when using the box-counting method to calculate the fractal dimension of the polygon's boundary.}
  \item{delta}{the vector of box sizes used in the box-counting method to calculate the fractal dimension of the polygon's boundary.}
  \item{N}{the number of boxes that include at least one pixel of the polygon's boundary.}
}
\note{
The polygon is expected to have an apparent major axis (e.g., the straight line through two points 
on the polygon's boundary having the maximum distance or one that can be clearly defined to pass by 
two landmarks on the polygon's boundary [i.e., the leaf length axis, the egg length axis, etc.]). 
The polygon is placed with its major axis overlapping the \eqn{x}-axis; the base of the polygon is 
located at the origin; the apex of the polygon is located to the right of the base. 
\code{phi} is equal to \code{angle} when \code{angle} is not null. 
In theory, \code{n1 + n2 = n}, but in most cases \code{n1 + n2} is slightly smaller than \code{n}. 
The reason is that very few boundary points fall outside the the lower and upper boundaries of the polygon 
when using the \code{\link[spatstat.geom]{intersect.owin}} function in \pkg{spatstat.geom}. 
However, this does not considerably affect the results. The log-transformed \code{SI} and 
the log-transformed \code{AR} are demontrated to have a more symmetrical frequency distribution than their original forms. 
This is important when performing an analysis of variance between (or among) groups to compared 
their extents of bilateral (a)symmetry. See Shi et al. (2020) for details. 
The box-counting approach uses a group of boxes (squares for simplicity) with different
sizes (\eqn{\delta}) to divide the leaf vein image into different parts. Let \eqn{N} represent the number
of boxes that include at least one pixel of the polygon's boundary. 
The maximum of the range of the \eqn{x} coordinates and the range of the \eqn{y} coordinates 
for the pixels of the polygon's boundary is defined as \eqn{z}. Let \eqn{\delta} represent the vector of 
\eqn{z}/\code{denomi.range}. We then used the following equation to calculate the fractal 
dimension of the polygon's boundary: 
\deqn{\mathrm{ln } N = a + b\, \mathrm{ln} \left(\delta^{-1}\right),}
where \eqn{b} is the theoretical value of the fractal dimension. We can use its estimate as the 
numerical value of the fractal dimension for the polygon's boundary. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Niinemets, Ü., Hui, C., Niklas, K.J., Yu, X., Hölscher, D. (2020) 
Leaf bilateral symmetry and the scaling of the perimeter vs. the surface area in 15 vine species. 
\emph{Forests} 11, 246. \doi{10.3390/f11020246}

Shi, P., Zheng, X., Ratkowsky, D.A., Li, Y., Wang, P., Cheng, L. (2018)  
A simple method for measuring the bilateral symmetry of leaves. 
\emph{Symmetry} 10, 118. \doi{10.3390/sym10040118}
}
\seealso{
\code{\link{adjdata}}, \code{\link{fracdim}}
}
\examples{
data(bambooleaves)

uni.C <- sort( unique(bambooleaves$Code) )
ind   <- 3
Data  <- bambooleaves[bambooleaves$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

dev.new()
plot( x0, y0, asp=1, type="l", cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(x)), ylab=expression(italic(y)) )

Res1 <- adjdata(x0, y0, ub.np=2000, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y


\donttest{
  Res2 <- bilat( x=x1, y=y1, time.interval=0.00045, 
                 peri.np=NULL, auto.search=TRUE, 
                 fd.opt=TRUE )
  Res2$scan.perimeter

  set.seed(123)
  Res3 <- bilat( x=x1, y=y1, time.interval=0.00045, 
                 peri.np=500, n.loop=30,
                 auto.search=TRUE, fd.opt=FALSE )
  Res3$scan.perimeter

  set.seed(123)
  Res4 <- bilat( x=x1, y=y1, time.interval=0.00045, 
                 peri.np=500, n.loop=30,
                 auto.search=TRUE, fd.opt=FALSE, angle=pi/4 )
  Res4$scan.perimeter

  set.seed(123)  
  Res5 <- bilat( x=x1, y=y1, time.interval=0.00045, 
                 peri.np=500, n.loop=30,
                 auto.search=TRUE, fd.opt=FALSE, angle=0 )
  Res5$scan.perimeter
  
  if(interactive()){
    # The angle between the leaf length axis (namely the straight 
    # line through the leaf apex and base) and the horizontal axis 
    # should be between 0 and pi/2 for a scanned leaf's profile. 
    # Here, the user needs to first click the leaf apex, 
    # and then click the leaf base. 
    set.seed(123)  
    Res6 <- bilat( x=x1, y=y1, time.interval=0.00045, 
                 peri.np=500, n.loop=30,
                 auto.search=FALSE, fd.opt=FALSE, angle=NULL )
    Res6$scan.perimeter
  }

  set.seed(NULL)
}

graphics.off()
}

\name{ETE}
\encoding{UTF-8}
\alias{ETE}
\title{
Calculation of the Ordinate For an Arbitrary Point on the Troscianko Curve in the Plane  
}
\description{
\code{ETE} is used to calculate the \emph{y}-value for an arbitrary point on the Troscianko curve 
that was generated by the explicit Troscianko equation.
}
\usage{
ETE(P, x)
}
\arguments{
  \item{P}{the parameters of the explicit Troscianko equation, including \eqn{a}, \eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}}.}
  \item{x}{the \emph{x}-value used in the explicit Troscianko equation.}
}
\details{
The explicit Troscianko equation is recommended as: 
\deqn{ y = a\,\exp\left\{\alpha_{0}+\alpha_{1}\,\left(\frac{x}{a}\right)+\alpha_{2}\, \left(\frac{x}{a}\right)^2\right\}\sqrt{1-\left(\frac{x}{a}\right)^2}, }
where \eqn{x} and \eqn{y} represent the abscissa and ordinate of an arbitrary point on the explicit Troscianko curve; 
\eqn{a}, \eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}} are parameters to be estimated.
}
\value{
The \eqn{y} values predicted by the explicit Troscianko equation.
}
\note{
We only considered the upper part of the egg-shape curve in the above expressions because 
the lower part is symmetrical to the upper part around the \emph{x}-axis.  
The mid-line of an egg's profile in \code{\link{ETE}} is aligned to 
the \emph{x}-axis. The argument, \code{P}, in the \code{\link{ETE}} function has the same parameters, 
\eqn{\alpha_{0}}, \eqn{\alpha_{1}}, and \eqn{\alpha_{2}}, as those in the \code{\link{TE}} function. 
However, the former has an additional parameter \eqn{a} than the latter, which represents half 
the egg's length. The \code{\link{lmTE}} function is based on the \code{\link{TE}} function, while 
the \code{\link{fitETE}} function is based on the \code{\link{ETE}} function here. 
In addition, the values in \code{x} > \eqn{a} (i.e., the first element in \code{P}) 
are forced to be \eqn{a}, and the values in \code{x} < \eqn{-a} will be forced to be \eqn{-a}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston’s universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Troscianko, J. (2014). A simple tool for calculating egg shape, volume and surface area from digital images. 
\emph{Ibis}, 156, 874\eqn{-}878. \doi{10.1111/ibi.12177} 
}
\seealso{
\code{\link{curveETE}}, \code{\link{fitETE}}, \code{\link{SurfaceAreaETE}}, \code{\link{VolumeETE}}
}
\examples{
  Par5 <- c(2.25, -0.38, -0.29, -0.16)
  xx2  <- seq(-2.25, 2.25, len=2000)
  yy3  <- ETE(P=Par5, x=xx2)
  yy4  <- -ETE(P=Par5, x=xx2)

  dev.new()
  plot(xx2, yy3, asp=1, type="l", col=4, cex.lab=1.5, cex.axis=1.5,
       xlim=c(-3, 3), ylim=c(-3, 3), 
       xlab=expression(italic(x)), ylab=expression(italic(y)))
  lines(xx2, yy4, col=2)  

  graphics.off()
}

\name{NRGE}
\encoding{UTF-8}
\alias{NRGE}
\title{
The Narushin-Romanov-Griffin Equation (NRGE)
}
\description{
\code{NRGE} is used to calculate \eqn{y} values at given \eqn{x} values using 
the Narushin-Romanov-Griffin equation (NRGE).
}
\usage{
NRGE(P, x)
}
\arguments{
  \item{P}{the four parameters (i.e., \eqn{A}, \eqn{B}, \eqn{C}, and \eqn{D}) of the Narushin-Romanov-Griffin equation.}
  \item{x}{the given \eqn{x} values.}
}
\details{
The Narushin-Romanov-Griffin equation (Narushin et al., 2021) has four parameters in total, 
among which three parameters have clear geometric meanings. 
\deqn{f_{1}(x)=\frac{B}{2}\sqrt{\frac{A^2-4x^2}{A^2+8Cx+4C^2}},}
\deqn{E = \frac{\sqrt{5.5A^{2}+11AC+4C^{2}} \cdot \left(\sqrt{3}AB-2D\sqrt{A^{2}+2AC+4C^{2
}}\right)}{\sqrt{3}AB\left(\sqrt{5.5A^{2}+11AC+4C^{2}}-2\sqrt{A^{2}+2AC+4C^{2}}\right)},}
\deqn{f_{2}(x)=\sqrt{\frac{A\left(A^{2}+8Cx+4C^{2}\right)}{2(A-2C)x^{2}+\left(A^{2}+8AC-4C^{2}\right)x+2AC^{2}+A^{2}C+A^{3}}},}
\deqn{f(x)=\pm f_{1}(x) \cdot \left\{1-E \cdot \left[1-f_{2}(x)\right]\right\}.}
Here, \eqn{f(x)} is the Narushin-Romanov-Griffin equation, which is used to predict the \eqn{y} coordinates 
at the given \eqn{x} coordinates; 
\eqn{A} represents the egg's length; \eqn{B} represents the egg's maximum breadth; \eqn{C} is a parameter 
to be estimated, and it can be expressed as \eqn{\left(A-B\right)/(2q)}, where \eqn{q} is a parameter to 
be estimated; \eqn{D} represents the egg's breadth associated with \eqn{(3/4)L} from the egg base (to the egg tip) 
on the egg length axis (which can be regarded as the major axis of the egg shape).
}
\value{
The \eqn{y} values predicted by the Narushin-Romanov-Griffin equation.
}
\note{
Here, parameter \code{C} is a parameter to be estimated, which can be directly calculated numerically based on the egg-shape data.
}
\references{
Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Narushin, V.G., Romanov, M.N., Griffin, D.K. (2021) Egg and math: introducing a universal formula for egg shape. 
\emph{Annals of the New York Academy of Sciences} 1505, 169\eqn{-}177. \doi{10.1111/nyas.14680}

Shi, P., Gielis, J., Niklas, K.J. (2022) Comparison of a universal (but complex) model for avian egg 
shape with a simpler model. \emph{Annals of the New York Academy of Sciences} 1514, 34\eqn{-}42. \doi{10.1111/nyas.14799}

Tian, F., Wang, Y., Sandhu, H.S., Gielis, J., Shi, P. (2020) Comparison of seed morphology of two ginkgo cultivars. 
\emph{Journal of Forestry Research} 31, 751\eqn{-}758. \doi{10.1007/s11676-018-0770-y}
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\seealso{
\code{\link{curveNRGE}}, \code{\link{fitNRGE}}, \code{\link{SurfaceAreaNRGE}}, \code{\link{VolumeNRGE}}
}
\examples{

P0 <- c(11.5, 7.8, 1.1, 5.6)
x  <- seq(-11.5/2, 11.5/2, len=2000)
y1 <- NRGE(P=P0, x=x)
y2 <- -NRGE(P=P0, x=x)

dev.new()
plot(x, y1, cex.lab=1.5, cex.axis=1.5, type="l", 
     col=4, ylim=c(-4, 4), asp=1, 
     xlab=expression(italic(x)), ylab=expression(italic(y)) )
lines(x, y2, col=2)

graphics.off()
}

\name{fitSuper}
\encoding{UTF-8}
\alias{fitSuper}
\title{
Data-Fitting Function for the Superellipse Equation
}
\description{
\code{fitSuper} is used to estimate the parameters of the superellipse equation.
}
\usage{
fitSuper(x, y, ini.val, control = list(), par.list = FALSE, 
         stand.fig = TRUE, angle = NULL, fig.opt = FALSE, np = 2000,
         xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of a polygon's boundary.}
  \item{y}{the \eqn{y} coordinates of a polygon's boundary.}
  \item{ini.val}{the list of initial values for the model parameters.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{stand.fig}{the option of drawing the observed and predicted polygons at the standard state 
(i.e., the polar point is located at (0, 0), and the major axis overlaps with the \eqn{x}-axis).}
  \item{angle}{the angle between the major axis and the \eqn{x}-axis, which can be defined by the user.}
  \item{fig.opt}{an optional argument to draw the observed and predicted polygons at arbitrary angle 
between the major axis and the \eqn{x}-axis.}
  \item{np}{the number of data points on the predicted superellipse curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the superellipse curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the superellipse curve.}
  \item{unit}{the unit of the \eqn{x}-axis and the \eqn{y}-axis when showing the superellipse curve.}
  \item{main}{the main title of the figure.}
}
\details{
The superellipse equation has its mathematical expression: 
\deqn{r\left(\varphi\right) = a\left(\left|\mathrm{cos}\left(\varphi\right)\right|^{n}+
\left|\frac{1}{k}\,\mathrm{sin}\left(\varphi\right)\right|^{n}\right)^{-\frac{1}{n}},}
where \eqn{r} represents the polar radius at the polar angle \eqn{\varphi}. 
\eqn{a} represents the semi-major axis of the superellipse; 
\eqn{k} is the ratio of the semi-minor axis to the semi-major axis of the superellipse; and \eqn{n} determines 
the curvature of the superellipse curve. This function is basically equal to the \code{\link{fitGE}} 
function with the arguments \code{m = 4} and \code{simpver = 9}. 
However, this function can make the estimated value of the parameter \eqn{k} be smaller than or equal to 1. 
Apart from the above three model parameters, there are three additional location parameters, i.e., the 
planar coordinates of the polar point (\eqn{x_{0}} and \eqn{y_{0}}), and the angle between the major axis 
of the superellipse and the \eqn{x}-axis (\eqn{\theta}). The input order of \code{ini.val} is \eqn{x_{0}}, \eqn{y_{0}}, 
\eqn{\theta}, \eqn{a}, \eqn{k}, and \eqn{n}. The fitted parameters will be shown after running this function 
in the same order. The Nelder-Mead algorithm (Nelder and Mead, 1965) 
is used to carry out the optimization of minimizing the residual sum of squares (RSS) between the observed and predicted radii. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
When \code{angle = NULL}, the observed polygon will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, it indicates that the major axis 
is rotated by the amount (\eqn{\pi/4}) counterclockwise from the \eqn{x}-axis.
}
\value{
  \item{par}{the estimated values of the parameters in the superellipse equation.}
  \item{scan.length}{the observed length of the polygon.}
  \item{scan.width}{the observed width of the polygon.}
  \item{scan.area}{the observed area of the polygon.}
  \item{r.sq}{the coefficient of determination between the observed and predicted polar radii.}
  \item{RSS}{the residual sum of squares between the observed and predicted polar radii.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{phi.stand.obs}{the polar angles at the standard state.}
  \item{phi.trans}{the transferred polar angles rotated as defined by the user.}
  \item{r.stand.obs}{the observed polar radii at the standard state.}
  \item{r.stand.pred}{the predicted polar radii at the standard state.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates at the standard state.}
  \item{x.stand.pred}{the predicted \eqn{x} coordinates at the standard state.}
  \item{y.stand.obs}{the observed \eqn{y} coordinates at the standard state.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates at the standard state.} 
  \item{r.obs}{the observed polar radii at the transferred polar angles as defined by the user.}
  \item{r.pred}{the predicted polar radii at the transferred polar angles as defined by the user.}
  \item{x.obs}{the observed \eqn{x} coordinates at the transferred polar angles as defined by the user.}
  \item{x.pred}{the predicted \eqn{x} coordinates at the transferred polar angles as defined by the user.}
  \item{y.obs}{the observed \eqn{y} coordinates at the transferred polar angles as defined by the user.}
  \item{y.pred}{the predicted \eqn{y} coordinates at the transferred polar angles as defined by the user.}       
}
\note{
The output values of running this function can be used as those of running the \code{\link{fitGE}} function. 
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Huang, J., Hui, C., Grissino-Mayer, H.D., Tardif, J., Zhai, L., Wang, F., Li, B. (2015) 
Capturing spiral radial growth of conifers using the superellipse to model tree-ring geometric shape. 
\emph{Frontiers in Plant Science} 6, 856. \doi{10.3389/fpls.2015.00856}

}
\seealso{
\code{\link{areaGE}}, \code{\link{curveGE}}, \code{\link{fitGE}}, \code{\link{GE}} 
}
\examples{
data(whitespruce)

uni.C <- sort( unique(whitespruce$Code) )  
Data  <- whitespruce[whitespruce$Code==uni.C[12], ]
x0    <- Data$x
y0    <- Data$y
Res1  <- adjdata(x0, y0, ub.np=200, len.pro=1/20)
x1    <- Res1$x
y1    <- Res1$y

plot( x1, y1, asp=1, cex.lab=1.5, cex.axis=1.5, type="l", 
      col="grey73", lwd=2,
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

\donttest{
  x0.ini    <- mean( x1 )
  y0.ini    <- mean( y1 )
  theta.ini <- c(0, pi/4, pi/2)
  a.ini     <- mean(c(max(x1)-min(x1), max(y1)-min(y1)))/2
  k.ini     <- 1
  n.ini     <- c(1.5, 2, 2.5)
  ini.val   <- list( x0.ini, y0.ini, theta.ini, a.ini, k.ini, n.ini )
  Res2      <- fitSuper(x=x1, y=y1, ini.val=ini.val, unit="cm", par.list=FALSE,
                        stand.fig=FALSE, angle=NULL, fig.opt=TRUE,  
                        control=list(reltol=1e-20, maxit=20000), np=2000)
  Res2$par
  Res2$r.sq
}

graphics.off()
}

\name{fitETE}
\encoding{UTF-8}
\alias{fitETE}
\title{
Data-Fitting Function for the Explicit Troscianko Equation
}
\description{
\code{fitETE} is used to estimate the parameters of the explicit Troscianko equation.
}
\usage{
fitETE(x, y, ini.val, control = list(), par.list = FALSE, 
      stand.fig = TRUE, angle = NULL, fig.opt = FALSE, np = 2000,
      xlim = NULL, ylim = NULL, unit = NULL, main = NULL)
}
\arguments{
  \item{x}{the \eqn{x} coordinates of an egg's profile.}
  \item{y}{the \eqn{y} coordinates of an egg's profile.}
  \item{ini.val}{the list of initial values for the model parameters.}
  \item{control}{the list of control parameters for using the \code{\link[stats]{optim}} function in package \pkg{stats}.}
  \item{par.list}{an optional argument to show the list of parameters on the screen.}
  \item{stand.fig}{an optional argument to draw the observed and predicted profiles of an egg at the standard state 
(i.e., the egg's centre is located at (0, 0), and the mid-line is aligned to the \eqn{x}-axis).}
  \item{angle}{the angle between the mid-line and the \eqn{x}-axis, which can be defined by the user.}
  \item{fig.opt}{an optional argument to draw the observed and predicted profiles of an egg 
at arbitrary angle between the major axis and the \eqn{x}-axis.}
  \item{np}{the number of data points on the predicted explicit Troscianko curve.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Troscianko curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Troscianko curve.}
  \item{unit}{the unit of the \eqn{x}-axis and the \eqn{y}-axis when showing the Troscianko curve.}
  \item{main}{the main title of the figure.}
}
\details{
Here, the major axis (i.e., the mid-line of an egg's profile) is the straight line trhough the two ends of 
the egg's length. The Nelder-Mead algorithm (Nelder and Mead, 1965) is used to carry out the optimization 
of minimizing the residual sum of squares (RSS) between the observed and predicted \eqn{y} values. 
The \code{\link[stats]{optim}} function in package \pkg{stats} was used to carry out the Nelder-Mead algorithm. 
When \code{angle = NULL}, the observed egg's profile will be shown at its initial angle in the scanned image; 
when \code{angle} is a numerical value (e.g., \eqn{\pi/4}) defined by the user, it indicates that the major axis 
is rotated by the amount (\eqn{\pi/4}) counterclockwise from the \eqn{x}-axis.
}
\value{
  \item{par}{the estimates of the model parameters.}
  \item{scan.length}{the observed length of the egg's profile.}
  \item{scan.width}{the observed width of the egg's profile.}
  \item{scan.area}{the observed area of the egg's profile.}
  \item{scan.perimeter}{the observed perimeter of the egg's profile.}
  \item{r.sq}{the coefficient of determination between the observed and predicted \eqn{y} values 
on the Troscianko curve.}
  \item{RSS}{the residual sum of squares between the observed and predicted \eqn{y} values 
on the Troscianko curve.}
  \item{sample.size}{the number of data points used in the data fitting.}
  \item{x.stand.obs}{the observed \eqn{x} coordinates of the points 
on the Troscianko curve at the standard state.}
  \item{y.stand.obs}{the observed \eqn{y} coordinates of the points 
on the Troscianko curve at the standard state.}
  \item{y.stand.pred}{the predicted \eqn{y} coordinates of the points 
on the Troscianko curve at the standard state.} 
  \item{x.obs}{the observed \eqn{x} coordinates of the points on the Troscianko curve 
at the transferred polar angles as defined by the user.}
  \item{y.obs}{the observed \eqn{y} coordinates of the points on the Troscianko curve 
at the transferred polar angles as defined by the user.}
  \item{y.pred}{the predicted \eqn{y} coordinates of the points on the Troscianko curve 
at the transferred polar angles as defined by the user.}       
}
\note{
In the outputs, there are no \code{x.stand.pred} and \code{x.pred}, because \code{y.stand.obs} and 
\code{y.stand.pred} share the same \eqn{x} values (i.e., \code{x.stand.obs}), and \code{y.obs} and 
\code{y.pred} share the same \eqn{x} values (i.e., \code{x.obs}).
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Biggins, J.D., Montgomeries, R.M., Thompson, J.E., Birkhead, T.R. (2022) 
Preston’s universal formula for avian egg shape. \emph{Ornithology} 
139, ukac028. \doi{10.1093/ornithology/ukac028}

Biggins, J.D., Thompson, J.E., Birkhead, T.R. (2018) Accurately quantifying 
the shape of birds' eggs. \emph{Ecology and Evolution} 8, 9728\eqn{-}9738. \doi{10.1002/ece3.4412}

Lian, M., He, K., Ratkowsky, D.A., Chen, L., Wang, J., Wang, L., Yao, W., Shi, P. (2024) 
Comparison of egg-shape equations using relative curvature measures of nonlinearity. 
\emph{Poultry Science} 103, 104069. \doi{10.1016/j.psj.2024.104069}

Nelder, J.A., Mead, R. (1965) A simplex method for function minimization. 
\emph{Computer Journal} 7, 308\eqn{-}313. \doi{10.1093/comjnl/7.4.308}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Wang, L., Quinn, B.K., Gielis, J. (2023) A new program to estimate the parameters 
of Preston's equation, a general formula for describing the egg shape of birds. \emph{Symmetry} 
15, 231. \doi{10.3390/sym15010231}

Troscianko, J. (2014). A simple tool for calculating egg shape, volume and surface area from digital images. 
\emph{Ibis}, 156, 874\eqn{-}878. \doi{10.1111/ibi.12177} 
}
\seealso{
\code{\link{curveETE}}, \code{\link{TE}}, \code{\link{lmTE}}
}
\examples{
data(eggs)

uni.C <- sort( unique(eggs$Code) )
ind   <- 8
Data  <- eggs[eggs$Code==uni.C[ind], ]
x0    <- Data$x
y0    <- Data$y

Res1 <- adjdata(x0, y0, ub.np=2000, times=1.2, len.pro=1/20)
x1   <- Res1$x
y1   <- Res1$y

dev.new()
plot( x1, y1, asp=1, cex.lab=1.5, cex.axis=1.5,  type="l", col=4,  
      xlab=expression(italic("x")), ylab=expression(italic("y")) )

\donttest{
  res1      <- lmTE( x1, y1, unit="cm", fig.opt=FALSE )
  
  if(FALSE){
    P0  <- c(res1$scan.length/2, res1$par)
    xx  <- seq(-res1$scan.length/2, res1$scan.length/2, len=2000)
    yy1 <- ETE(P0, xx)
    yy2 <- -ETE(P0, xx)
    dev.new()
    plot( xx, yy1, cex.lab=1.5, cex.axis=1.5, asp=1, col=2, 
          ylim=c(-res1$scan.length/2, res1$scan.length/2),
          type="l", xlab=expression(x), ylab=expression(y) )
    lines( xx, yy2, col=4 )
  }

  x0.ini    <- mean( x1 )
  y0.ini    <- mean( y1 )
  theta.ini <- res1$theta
  a.ini     <- res1$scan.length / 2
  alpha0.ini <- res1$par[1] 
  alpha1.ini <- res1$par[2]
  alpha2.ini <- res1$par[3]

  ini.val <- list(x0.ini, y0.ini, theta.ini, a.ini, alpha0.ini, alpha1.ini, alpha2.ini)

  res0 <- fitETE( x=x1, y=y1, ini.val=ini.val, 
                 unit="cm", par.list=FALSE, 
                 stand.fig=FALSE, angle=NULL, fig.opt=FALSE, 
                 control=list(reltol=1e-30, maxit=50000), 
                 np=2000 ) 

  n.loop <- 12
  Show   <- FALSE
  for(i in 1:n.loop){
    ini.val <- res0$par
    if(i==n.loop) Show <- TRUE
    print(paste(i, "/", n.loop, sep=""))
    res0 <- fitETE( x=x1, y=y1, ini.val=ini.val, 
                   unit="cm", par.list=FALSE, 
                   stand.fig=Show, angle=pi/4, fig.opt=Show,  
                   control=list(reltol=1e-30, maxit=50000), 
                   np=2000 )    
  }

  # The numerical values of the location and model parameters
  res0$par

  # The root-mean-square error (RMSE) between 
  #   the observed and predicted y values
  sqrt(res0$RSS/res0$sample.size)

  sqrt(sum((res0$y.stand.obs-res0$y.stand.pred)^2)/length(res0$y.stand.obs))

  # To calculate the volume of the egg
  VolumeETE(P=res0$par[4:7])

  # To calculate the surface area of the egg
  SurfaceAreaETE(P=res0$par[4:7])
}

graphics.off()
}

\name{curveGE}
\encoding{UTF-8}
\alias{curveGE}
\title{
Drawing the Gielis Curve
}
\description{
\code{curveGE} is used to draw the Gielis curve.
}
\usage{
curveGE(expr, P, phi = seq(0, 2*pi, len = 2000),
        m = 1, simpver = NULL, nval = 1,
        fig.opt = FALSE, deform.fun = NULL, Par = NULL,
        xlim = NULL, ylim = NULL, unit = NULL, main="")
}
\arguments{
  \item{expr}{the original (or twin) Gielis equation or one of its simplified versions.}
  \item{P}{the three location parameters and the parameters of the original (or twin) 
Gielis equation or one of its simplified versions.}
  \item{phi}{the given polar angles at which we want to draw the Gielis curve.}
  \item{m}{the given \eqn{m} value that determines the number of angles of the Gielis curve within \eqn{[0, 2\pi)}.}
  \item{simpver}{an optional argument to use the simplfied version of the original (or twin) Gielis equation.}
  \item{nval}{the specified value for \eqn{n_{1}} or \eqn{n_{2}} or \eqn{n_{3}} in the simplified versions.}
  \item{fig.opt}{an optional argument to draw the Gielis curve.}
  \item{deform.fun}{the deformation function used to describe the deviation from a theoretical Gielis curve.}
  \item{Par}{the parameter(s) of the deformation function.}
  \item{xlim}{the range of the \eqn{x}-axis over which to plot the Gielis curve.}
  \item{ylim}{the range of the \eqn{y}-axis over which to plot the Gielis curve.}
  \item{unit}{the units of the \eqn{x}-axis and the \eqn{y}-axis when showing the Gielis curve.}
  \item{main}{the main title of the figure.}
}
\details{
The first three elements of \code{P} are location parameters. The first two are the planar coordinates of the transferred polar point, 
and the third is the angle between the major axis of the curve and the \eqn{x}-axis. The other arguments in \code{P} 
(except these first three location parameters), \code{m}, \code{simpver}, and \code{nval} should correspond 
to \code{expr} (i.e., \code{GE} or \code{TGE}).  
Please note the differences in the simplified version number and the 
number of parameters between \code{GE} and \code{TGE}. 
\code{deform.fun} should take the form as: \code{deform.fun <- function(Par, z){\dots}}, where \code{z} is 
a two-dimensional matrix related to the \eqn{x} and \eqn{y} values. 
And the return value of \code{deform.fun} should be a \code{list} with two variables \code{x} and \code{y}.
}
\value{
  \item{x}{the \eqn{x} coordinates of the Gielis curve corresponding to the given polar angles \code{phi}.}
  \item{y}{the \eqn{y} coordinates of the Gielis curve corresponding to the given polar angles \code{phi}.}
  \item{r}{the polar radii of the Gielis curve corresponding to the given polar angles \code{phi}.}
}
\note{
\code{simpver} in \code{GE} is different from that in \code{TGE}.
}
\author{
Peijian Shi \email{pjshi@njfu.edu.cn}, Johan Gielis \email{johan.gielis@uantwerpen.be}, 
Brady K. Quinn \email{Brady.Quinn@dfo-mpo.gc.ca}.
}
\references{
Gielis, J. (2003) A generic geometric transformation that unifies a wide range of natural 
and abstract shapes. \emph{American Journal of Botany} 90, 333-338. \doi{10.3732/ajb.90.3.333}

Li, Y., Quinn, B.K., Gielis, J., Li, Y., Shi, P. (2022) Evidence that supertriangles exist 
in nature from the vertical projections of \emph{Koelreuteria paniculata} fruit. \emph{Symmetry} 
14, 23. \doi{10.3390/sym14010023}

Shi, P., Gielis, J., Niklas, K.J. (2022) Comparison of a universal (but complex) model for avian egg 
shape with a simpler model. \emph{Annals of the New York Academy of Sciences} 1514, 34\eqn{-}42. \doi{10.1111/nyas.14799}

Shi, P., Gielis, J., Quinn, B.K., Niklas, K.J., Ratkowsky, D.A., Schrader, J., Ruan, H., 
Wang, L., Niinemets, Ü. (2022) 'biogeom': An R package for simulating and fitting natural 
shapes. \emph{Annals of the New York Academy of Sciences} 1516, 123\eqn{-}134. \doi{10.1111/nyas.14862}

Shi, P., Ratkowsky, D.A., Gielis, J. (2020) The generalized Gielis geometric
equation and its application. \emph{Symmetry} 12, 645. \doi{10.3390/sym12040645}

Shi, P., Xu, Q., Sandhu, H.S., Gielis, J., Ding, Y., Li, H., Dong, X. (2015) Comparison
of dwarf bamboos (\emph{Indocalamus} sp.) leaf parameters to determine relationship
between spatial density of plants and total leaf area per plant. \emph{Ecology and Evolution} 5,
4578-4589. \doi{10.1002/ece3.1728}
}
\seealso{
\code{\link{areaGE}}, \code{\link{fitGE}}, \code{\link{GE}}, \code{\link{TGE}}
}
\examples{
GE.par  <- c(2, 1, 4, 6, 3)
phi.vec <- seq(0, 2*pi, len=2000)
r.theor <- GE(P=GE.par, phi=phi.vec, m=5)

dev.new()
plot( phi.vec, r.theor, cex.lab=1.5, cex.axis=1.5, 
      xlab=expression(italic(phi)), ylab=expression(italic("r")),
      type="l", col=4 ) 

curve.par <- c(1, 1, pi/4, GE.par)
GE.res    <- curveGE(GE, P=curve.par, fig.opt=TRUE, deform.fun=NULL, Par=NULL, m=5)
# GE.res$r

GE.res    <- curveGE( GE, P=c(0, 0, 0, 2, 4, 20), m=1, simpver=1, fig.opt=TRUE )
# GE.res$r

GE.res    <- curveGE( GE, P=c(1, 1, pi/4, 2, 1, 3), m=5, simpver=1, fig.opt=TRUE )
# GE.res$r

GE.res    <- curveGE( GE, P=c(1, 1, pi/4, 2, 1, 3), m=2, simpver=1, fig.opt=TRUE )
# GE.res$r

GE.res    <- curveGE( GE, P=c(1, 1, pi/4, 2, 0.05), m=1, simpver=2, fig.opt=TRUE )
# GE.res$r

GE.res    <- curveGE( GE, P=c(1, 1, pi/4, 2), m=4, simpver=3, nval=2, fig.opt=TRUE )
# GE.res$r

GE.res    <- curveGE( GE, P=c(1, 1, pi/4, 2, 0.6), m=4, simpver=8, nval=2, fig.opt=TRUE )
# GE.res$r

graphics.off()
}
